/*! jQuery v1.8.2 -ajax,-ajax/jsonp,-ajax/script,-ajax/xhr jquery.com | jquery.org/license */

/**
 * The 'bind ( )' function extension from Prototype.js, extracted for general use
 *
 * @author Richard Harrison, http://www.pluggable.co.uk
 * @author Sam Stephenson ( Modified from Prototype Javascript framework )
 * @license MIT-style license @see http://www.prototypejs.org/
 */

/*
 * Sweet Justice: beautiful justified text.
 * AKA 90% Hyphenator.
 *
 * Modified by Tyler Vano <tvano@> to remove the
 * quirky language and support our hyphenation
 * paradigm.
 *
 * Supports most latin-based languages well-enough.
 * Really need a more robust solution before we go
 * to asian countries.
 *
 * DEPRECATED ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Include this file at the bottom of your pages
 * and it will hyphenate and justify your text.
 * The script pays attention to elements with
 * any of these three CSS classes:
 *
 *   sweet-justice:  Hyphenated and justified
 *   sweet-hypens:   Hyphenation only
 *   justice-denied: No hypens or justification.
 *                   This is useful for child nodes.
 *
 * Hyphenation is accomplished by inserting soft
 * hyphen characters (0x00AD) into long words.
 *
 * Requires either jQuery or YUI3.
 *
 * BSD license: Share and enjoy.
 * @author carlos@bueno.org 23 April 2010
 * github.com/aristus/sweet-justice
 *
 */

/*
 *  Copyright 2011 Twitter, Inc.
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

function Hyphenator(){this.MIN_WORD=6,this.whitespace=/[ \s\n\r\v\t]+/,this.vowels="aeiouyAEIOUYẚÁáÀàĂăẮắẰằẴẵẲẳÂâẤấẦầẪẫẨẩǍǎÅåǺǻÄäǞǟÃãȦȧǠǡĄąĀāẢảȀȁȂȃẠạẶặẬậḀḁȺⱥǼǽǢǣÉƏƎǝéÈèĔĕÊêẾếỀềỄễỂểĚěËëẼẽĖėȨȩḜḝĘęĒēḖḗḔḕẺẻȄȅȆȇẸẹỆệḘḙḚḛɆɇɚɝÍíÌìĬĭÎîǏǐÏïḮḯĨĩİiĮįĪīỈỉȈȉȊȋỊịḬḭIıƗɨÓóÒòŎŏÔôỐốỒồỖỗỔổǑǒÖöȪȫŐőÕõṌṍṎṏȬȭȮȯȰȱØøǾǿǪǫǬǭŌōṒṓṐṑỎỏȌȍȎȏƠơỚớỜờỠỡỞởỢợỌọỘộƟɵÚúÙùŬŭÛûǓǔŮůÜüǗǘǛǜǙǚǕǖŰűŨũṸṹŲųŪūṺṻỦủȔȕȖȗƯưỨứỪừỮữỬửỰựỤụṲṳṶṷṴṵɄʉÝýỲỳŶŷY̊ẙŸÿỸỹẎẏȲȳỶỷỴỵʏɎɏƳƴ",this.c="[^"+this.vowels+"]",this.v="["+this.vowels+"]",this.vccv=new RegExp("("+this.v+this.c+")("+this.c+this.v+")","g"),this.simple=new RegExp("(.{2,4}"+this.v+")"+"("+this.c+")","g"),this.dumb=/\u00AD(.?)|$\u00AD(.{0,2}\w+)$/,this.presuf=/^(\W*)(anti|auto|ab|an|ax|al|as|bi|bet|be|contra|cat|cath|cir|cum|cog|col|com|con|cor|could|co|desk|de|dis|did|dif|di|eas|every|ever|extra|ex|end|en|em|epi|evi|func|fund|fin|hyst|hy|han|il|in|im|ir|just|jus|loc|lig|lit|li|mech|manu|man|mal|mis|mid|mono|multi|mem|micro|non|nano|ob|oc|of|opt|op|over|para|per|post|pre|peo|pro|retro|rea|re|rhy|should|some|semi|sen|sol|sub|suc|suf|super|sup|sur|sus|syn|sym|syl|tech|trans|tri|typo|type|uni|un|van|vert|with|would|won)?(.*?)(weens?|widths?|icals?|ables?|ings?|tions?|ions?|ies|isms?|ists?|ful|ness|ments?|ly|ify|ize|ise|ity|en|ers?|ences?|tures?|ples?|als?|phy|puts?|phies|ry|ries|cy|cies|mums?|ous|cents?)?(\W*)$/i,this.hyphenate=function(e,t){var n=e.split(this.whitespace);for(var r=0;r<n.length;r++)this.breakable(n[r])&&(n[r]=this.break_word_en(n[r]));return n.join(" ")},this.breakable=function(e){return e.length>this.MIN_WORD},this.break_word_default=function(e){return e.replace(this.vccv,"$1­$2").replace(this.simple,"$1­$2").replace(this.dumb,"$1")},this.break_word_en=function(e){var t=this.presuf.exec(e),n=[];return t[2]&&n.push(t[2]),t[3]&&n.push(t[3].replace(this.vccv,"$1­$2")),t[4]&&n.push(t[4]),(t[1]||"")+n.join("­")+(t[5]||"")}}(function(e,t){function n(e){var t=ut[e]={};return X.each(e.split(J),function(e,n){t[n]=!0}),t}function r(e,n,r){if(r===t&&e.nodeType===1){var i="data-"+n.replace(ft,"-$1").toLowerCase();r=e.getAttribute(i);if(typeof r=="string"){try{r=r==="true"?!0:r==="false"?!1:r==="null"?null:+r+""===r?+r:at.test(r)?X.parseJSON(r):r}catch(s){}X.data(e,n,r)}else r=t}return r}function i(e){var t;for(t in e){if(t==="data"&&X.isEmptyObject(e[t]))continue;if(t!=="toJSON")return!1}return!0}function s(){return!1}function o(){return!0}function u(e){return!e||!e.parentNode||e.parentNode.nodeType===11}function a(e,t){do e=e[t];while(e&&e.nodeType!==1);return e}function f(e,t,n){t=t||0;if(X.isFunction(t))return X.grep(e,function(e,r){var i=!!t.call(e,r,e);return i===n});if(t.nodeType)return X.grep(e,function(e,r){return e===t===n});if(typeof t=="string"){var r=X.grep(e,function(e){return e.nodeType===1});if(At.test(t))return X.filter(t,r,!n);t=X.filter(t,r)}return X.grep(e,function(e,r){return X.inArray(e,t)>=0===n})}function l(e){var t=_t.split("|"),n=e.createDocumentFragment();if(n.createElement)while(t.length)n.createElement(t.pop());return n}function c(e,t){return e.getElementsByTagName(t)[0]||e.appendChild(e.ownerDocument.createElement(t))}function h(e,t){if(t.nodeType!==1||!X.hasData(e))return;var n,r,i,s=X._data(e),o=X._data(t,s),u=s.events;if(u){delete o.handle,o.events={};for(n in u)for(r=0,i=u[n].length;r<i;r++)X.event.add(t,n,u[n][r])}o.data&&(o.data=X.extend({},o.data))}function p(e,t){var n;if(t.nodeType!==1)return;t.clearAttributes&&t.clearAttributes(),t.mergeAttributes&&t.mergeAttributes(e),n=t.nodeName.toLowerCase(),n==="object"?(t.parentNode&&(t.outerHTML=e.outerHTML),X.support.html5Clone&&e.innerHTML&&!X.trim(t.innerHTML)&&(t.innerHTML=e.innerHTML)):n==="input"&&Ut.test(e.type)?(t.defaultChecked=t.checked=e.checked,t.value!==e.value&&(t.value=e.value)):n==="option"?t.selected=e.defaultSelected:n==="input"||n==="textarea"?t.defaultValue=e.defaultValue:n==="script"&&t.text!==e.text&&(t.text=e.text),t.removeAttribute(X.expando)}function d(e){return typeof e.getElementsByTagName!="undefined"?e.getElementsByTagName("*"):typeof e.querySelectorAll!="undefined"?e.querySelectorAll("*"):[]}function v(e){Ut.test(e.type)&&(e.defaultChecked=e.checked)}function m(e,t){if(t in e)return t;var n=t.charAt(0).toUpperCase()+t.slice(1),r=t,i=cn.length;while(i--){t=cn[i]+n;if(t in e)return t}return r}function g(e,t){return e=t||e,X.css(e,"display")==="none"||!X.contains(e.ownerDocument,e)}function y(e,t){var n,r,i=[],s=0,o=e.length;for(;s<o;s++){n=e[s];if(!n.style)continue;i[s]=X._data(n,"olddisplay"),t?(!i[s]&&n.style.display==="none"&&(n.style.display=""),n.style.display===""&&g(n)&&(i[s]=X._data(n,"olddisplay",S(n.nodeName)))):(r=Kt(n,"display"),!i[s]&&r!=="none"&&X._data(n,"olddisplay",r))}for(s=0;s<o;s++){n=e[s];if(!n.style)continue;if(!t||n.style.display==="none"||n.style.display==="")n.style.display=t?i[s]||"":"none"}return e}function b(e,t,n){var r=rn.exec(t);return r?Math.max(0,r[1]-(n||0))+(r[2]||"px"):t}function w(e,t,n,r){var i=n===(r?"border":"content")?4:t==="width"?1:0,s=0;for(;i<4;i+=2)n==="margin"&&(s+=X.css(e,n+ln[i],!0)),r?(n==="content"&&(s-=parseFloat(Kt(e,"padding"+ln[i]))||0),n!=="margin"&&(s-=parseFloat(Kt(e,"border"+ln[i]+"Width"))||0)):(s+=parseFloat(Kt(e,"padding"+ln[i]))||0,n!=="padding"&&(s+=parseFloat(Kt(e,"border"+ln[i]+"Width"))||0));return s}function E(e,t,n){var r=t==="width"?e.offsetWidth:e.offsetHeight,i=!0,s=X.support.boxSizing&&X.css(e,"boxSizing")==="border-box";if(r<=0||r==null){r=Kt(e,t);if(r<0||r==null)r=e.style[t];if(sn.test(r))return r;i=s&&(X.support.boxSizingReliable||r===e.style[t]),r=parseFloat(r)||0}return r+w(e,t,n||(s?"border":"content"),i)+"px"}function S(e){if(un[e])return un[e];var t=X("<"+e+">").appendTo(P.body),n=t.css("display");t.remove();if(n==="none"||n===""){Qt=P.body.appendChild(Qt||X.extend(P.createElement("iframe"),{frameBorder:0,width:0,height:0}));if(!Gt||!Qt.createElement)Gt=(Qt.contentWindow||Qt.contentDocument).document,Gt.write("<!doctype html><html><body>"),Gt.close();t=Gt.body.appendChild(Gt.createElement(e)),n=Kt(t,"display"),P.body.removeChild(Qt)}return un[e]=n,n}function x(e,t,n,r){var i;if(X.isArray(t))X.each(t,function(t,i){n||dn.test(e)?r(e,i):x(e+"["+(typeof i=="object"?t:"")+"]",i,n,r)});else if(!n&&X.type(t)==="object")for(i in t)x(e+"["+i+"]",t[i],n,r);else r(e,t)}function T(){return setTimeout(function(){yn=t},0),yn=X.now()}function N(e,t){X.each(t,function(t,n){var r=(Tn[t]||[]).concat(Tn["*"]),i=0,s=r.length;for(;i<s;i++)if(r[i].call(e,t,n))return})}function C(e,t,n){var r,i=0,s=0,o=xn.length,u=X.Deferred().always(function(){delete a.elem}),a=function(){var t=yn||T(),n=Math.max(0,f.startTime+f.duration-t),r=1-(n/f.duration||0),i=0,s=f.tweens.length;for(;i<s;i++)f.tweens[i].run(r);return u.notifyWith(e,[f,r,n]),r<1&&s?n:(u.resolveWith(e,[f]),!1)},f=u.promise({elem:e,props:X.extend({},t),opts:X.extend(!0,{specialEasing:{}},n),originalProperties:t,originalOptions:n,startTime:yn||T(),duration:n.duration,tweens:[],createTween:function(t,n,r){var i=X.Tween(e,f.opts,t,n,f.opts.specialEasing[t]||f.opts.easing);return f.tweens.push(i),i},stop:function(t){var n=0,r=t?f.tweens.length:0;for(;n<r;n++)f.tweens[n].run(1);return t?u.resolveWith(e,[f,t]):u.rejectWith(e,[f,t]),this}}),l=f.props;k(l,f.opts.specialEasing);for(;i<o;i++){r=xn[i].call(f,e,l,f.opts);if(r)return r}return N(f,l),X.isFunction(f.opts.start)&&f.opts.start.call(e,f),X.fx.timer(X.extend(a,{anim:f,queue:f.opts.queue,elem:e})),f.progress(f.opts.progress).done(f.opts.done,f.opts.complete).fail(f.opts.fail).always(f.opts.always)}function k(e,t){var n,r,i,s,o;for(n in e){r=X.camelCase(n),i=t[r],s=e[n],X.isArray(s)&&(i=s[1],s=e[n]=s[0]),n!==r&&(e[r]=s,delete e[n]),o=X.cssHooks[r];if(o&&"expand"in o){s=o.expand(s),delete e[r];for(n in s)n in e||(e[n]=s[n],t[n]=i)}else t[r]=i}}function L(e,t,n){var r,i,s,o,u,a,f,l,c=this,h=e.style,p={},d=[],v=e.nodeType&&g(e);n.queue||(f=X._queueHooks(e,"fx"),f.unqueued==null&&(f.unqueued=0,l=f.empty.fire,f.empty.fire=function(){f.unqueued||l()}),f.unqueued++,c.always(function(){c.always(function(){f.unqueued--,X.queue(e,"fx").length||f.empty.fire()})})),e.nodeType===1&&("height"in t||"width"in t)&&(n.overflow=[h.overflow,h.overflowX,h.overflowY],X.css(e,"display")==="inline"&&X.css(e,"float")==="none"&&(!X.support.inlineBlockNeedsLayout||S(e.nodeName)==="inline"?h.display="inline-block":h.zoom=1)),n.overflow&&(h.overflow="hidden",X.support.shrinkWrapBlocks||c.done(function(){h.overflow=n.overflow[0],h.overflowX=n.overflow[1],h.overflowY=n.overflow[2]}));for(r in t){s=t[r];if(wn.exec(s)){delete t[r];if(s===(v?"hide":"show"))continue;d.push(r)}}o=d.length;if(o){u=X._data(e,"fxshow")||X._data(e,"fxshow",{}),v?X(e).show():c.done(function(){X(e).hide()}),c.done(function(){var t;X.removeData(e,"fxshow",!0);for(t in p)X.style(e,t,p[t])});for(r=0;r<o;r++)i=d[r],a=c.createTween(i,v?u[i]:0),p[i]=u[i]||X.style(e,i),i in u||(u[i]=a.start,v&&(a.end=a.start,a.start=i==="width"||i==="height"?1:0))}}function A(e,t,n,r,i){return new A.prototype.init(e,t,n,r,i)}function O(e,t){var n,r={height:e},i=0;t=t?1:0;for(;i<4;i+=2-t)n=ln[i],r["margin"+n]=r["padding"+n]=e;return t&&(r.opacity=r.width=e),r}function M(e){return X.isWindow(e)?e:e.nodeType===9?e.defaultView||e.parentWindow:!1}var _,D,P=e.document,H=e.location,B=e.navigator,j=e.jQuery,F=e.$,I=Array.prototype.push,q=Array.prototype.slice,R=Array.prototype.indexOf,U=Object.prototype.toString,z=Object.prototype.hasOwnProperty,W=String.prototype.trim,X=function(e,t){return new X.fn.init(e,t,_)},V=/[\-+]?(?:\d*\.|)\d+(?:[eE][\-+]?\d+|)/.source,$=/\S/,J=/\s+/,K=/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,Q=/^(?:[^#<]*(<[\w\W]+>)[^>]*$|#([\w\-]*)$)/,G=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,Y=/^[\],:{}\s]*$/,Z=/(?:^|:|,)(?:\s*\[)+/g,et=/\\(?:["\\\/bfnrt]|u[\da-fA-F]{4})/g,tt=/"[^"\\\r\n]*"|true|false|null|-?(?:\d\d*\.|)\d+(?:[eE][\-+]?\d+|)/g,nt=/^-ms-/,rt=/-([\da-z])/gi,it=function(e,t){return(t+"").toUpperCase()},st=function(){P.addEventListener?(P.removeEventListener("DOMContentLoaded",st,!1),X.ready()):P.readyState==="complete"&&(P.detachEvent("onreadystatechange",st),X.ready())},ot={};X.fn=X.prototype={constructor:X,init:function(e,n,r){var i,s,o,u;if(!e)return this;if(e.nodeType)return this.context=this[0]=e,this.length=1,this;if(typeof e=="string"){e.charAt(0)==="<"&&e.charAt(e.length-1)===">"&&e.length>=3?i=[null,e,null]:i=Q.exec(e);if(i&&(i[1]||!n)){if(i[1])return n=n instanceof X?n[0]:n,u=n&&n.nodeType?n.ownerDocument||n:P,e=X.parseHTML(i[1],u,!0),G.test(i[1])&&X.isPlainObject(n)&&this.attr.call(e,n,!0),X.merge(this,e);s=P.getElementById(i[2]);if(s&&s.parentNode){if(s.id!==i[2])return r.find(e);this.length=1,this[0]=s}return this.context=P,this.selector=e,this}return!n||n.jquery?(n||r).find(e):this.constructor(n).find(e)}return X.isFunction(e)?r.ready(e):(e.selector!==t&&(this.selector=e.selector,this.context=e.context),X.makeArray(e,this))},selector:"",jquery:"1.8.2 -ajax,-ajax/jsonp,-ajax/script,-ajax/xhr",length:0,size:function(){return this.length},toArray:function(){return q.call(this)},get:function(e){return e==null?this.toArray():e<0?this[this.length+e]:this[e]},pushStack:function(e,t,n){var r=X.merge(this.constructor(),e);return r.prevObject=this,r.context=this.context,t==="find"?r.selector=this.selector+(this.selector?" ":"")+n:t&&(r.selector=this.selector+"."+t+"("+n+")"),r},each:function(e,t){return X.each(this,e,t)},ready:function(e){return X.ready.promise().done(e),this},eq:function(e){return e=+e,e===-1?this.slice(e):this.slice(e,e+1)},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},slice:function(){return this.pushStack(q.apply(this,arguments),"slice",q.call(arguments).join(","))},map:function(e){return this.pushStack(X.map(this,function(t,n){return e.call(t,n,t)}))},end:function(){return this.prevObject||this.constructor(null)},push:I,sort:[].sort,splice:[].splice},X.fn.init.prototype=X.fn,X.extend=X.fn.extend=function(){var e,n,r,i,s,o,u=arguments[0]||{},a=1,f=arguments.length,l=!1;typeof u=="boolean"&&(l=u,u=arguments[1]||{},a=2),typeof u!="object"&&!X.isFunction(u)&&(u={}),f===a&&(u=this,--a);for(;a<f;a++)if((e=arguments[a])!=null)for(n in e){r=u[n],i=e[n];if(u===i)continue;l&&i&&(X.isPlainObject(i)||(s=X.isArray(i)))?(s?(s=!1,o=r&&X.isArray(r)?r:[]):o=r&&X.isPlainObject(r)?r:{},u[n]=X.extend(l,o,i)):i!==t&&(u[n]=i)}return u},X.extend({noConflict:function(t){return e.$===X&&(e.$=F),t&&e.jQuery===X&&(e.jQuery=j),X},isReady:!1,readyWait:1,holdReady:function(e){e?X.readyWait++:X.ready(!0)},ready:function(e){if(e===!0?--X.readyWait:X.isReady)return;if(!P.body)return setTimeout(X.ready,1);X.isReady=!0;if(e!==!0&&--X.readyWait>0)return;D.resolveWith(P,[X]),X.fn.trigger&&X(P).trigger("ready").off("ready")},isFunction:function(e){return X.type(e)==="function"},isArray:Array.isArray||function(e){return X.type(e)==="array"},isWindow:function(e){return e!=null&&e==e.window},isNumeric:function(e){return!isNaN(parseFloat(e))&&isFinite(e)},type:function(e){return e==null?String(e):ot[U.call(e)]||"object"},isPlainObject:function(e){if(!e||X.type(e)!=="object"||e.nodeType||X.isWindow(e))return!1;try{if(e.constructor&&!z.call(e,"constructor")&&!z.call(e.constructor.prototype,"isPrototypeOf"))return!1}catch(n){return!1}var r;for(r in e);return r===t||z.call(e,r)},isEmptyObject:function(e){var t;for(t in e)return!1;return!0},error:function(e){throw new Error(e)},parseHTML:function(e,t,n){var r;return!e||typeof e!="string"?null:(typeof t=="boolean"&&(n=t,t=0),t=t||P,(r=G.exec(e))?[t.createElement(r[1])]:(r=X.buildFragment([e],t,n?null:[]),X.merge([],(r.cacheable?X.clone(r.fragment):r.fragment).childNodes)))},parseJSON:function(t){if(!t||typeof t!="string")return null;t=X.trim(t);if(e.JSON&&e.JSON.parse)return e.JSON.parse(t);if(Y.test(t.replace(et,"@").replace(tt,"]").replace(Z,"")))return(new Function("return "+t))();X.error("Invalid JSON: "+t)},parseXML:function(n){var r,i;if(!n||typeof n!="string")return null;try{e.DOMParser?(i=new DOMParser,r=i.parseFromString(n,"text/xml")):(r=new ActiveXObject("Microsoft.XMLDOM"),r.async="false",r.loadXML(n))}catch(s){r=t}return(!r||!r.documentElement||r.getElementsByTagName("parsererror").length)&&X.error("Invalid XML: "+n),r},noop:function(){},globalEval:function(t){t&&$.test(t)&&(e.execScript||function(t){e.eval.call(e,t)})(t)},camelCase:function(e){return e.replace(nt,"ms-").replace(rt,it)},nodeName:function(e,t){return e.nodeName&&e.nodeName.toLowerCase()===t.toLowerCase()},each:function(e,n,r){var i,s=0,o=e.length,u=o===t||X.isFunction(e);if(r){if(u){for(i in e)if(n.apply(e[i],r)===!1)break}else for(;s<o;)if(n.apply(e[s++],r)===!1)break}else if(u){for(i in e)if(n.call(e[i],i,e[i])===!1)break}else for(;s<o;)if(n.call(e[s],s,e[s++])===!1)break;return e},trim:W&&!W.call("﻿ ")?function(e){return e==null?"":W.call(e)}:function(e){return e==null?"":(e+"").replace(K,"")},makeArray:function(e,t){var n,r=t||[];return e!=null&&(n=X.type(e),e.length==null||n==="string"||n==="function"||n==="regexp"||X.isWindow(e)?I.call(r,e):X.merge(r,e)),r},inArray:function(e,t,n){var r;if(t){if(R)return R.call(t,e,n);r=t.length,n=n?n<0?Math.max(0,r+n):n:0;for(;n<r;n++)if(n in t&&t[n]===e)return n}return-1},merge:function(e,n){var r=n.length,i=e.length,s=0;if(typeof r=="number")for(;s<r;s++)e[i++]=n[s];else while(n[s]!==t)e[i++]=n[s++];return e.length=i,e},grep:function(e,t,n){var r,i=[],s=0,o=e.length;n=!!n;for(;s<o;s++)r=!!t(e[s],s),n!==r&&i.push(e[s]);return i},map:function(e,n,r){var i,s,o=[],u=0,a=e.length,f=e instanceof X||a!==t&&typeof a=="number"&&(a>0&&e[0]&&e[a-1]||a===0||X.isArray(e));if(f)for(;u<a;u++)i=n(e[u],u,r),i!=null&&(o[o.length]=i);else for(s in e)i=n(e[s],s,r),i!=null&&(o[o.length]=i);return o.concat.apply([],o)},guid:1,proxy:function(e,n){var r,i,s;return typeof n=="string"&&(r=e[n],n=e,e=r),X.isFunction(e)?(i=q.call(arguments,2),s=function(){return e.apply(n,i.concat(q.call(arguments)))},s.guid=e.guid=e.guid||X.guid++,s):t},access:function(e,n,r,i,s,o,u){var a,f=r==null,l=0,c=e.length;if(r&&typeof r=="object"){for(l in r)X.access(e,n,l,r[l],1,o,i);s=1}else if(i!==t){a=u===t&&X.isFunction(i),f&&(a?(a=n,n=function(e,t,n){return a.call(X(e),n)}):(n.call(e,i),n=null));if(n)for(;l<c;l++)n(e[l],r,a?i.call(e[l],l,n(e[l],r)):i,u);s=1}return s?e:f?n.call(e):c?n(e[0],r):o},now:function(){return(new Date).getTime()}}),X.ready.promise=function(t){if(!D){D=X.Deferred();if(P.readyState==="complete")setTimeout(X.ready,1);else if(P.addEventListener)P.addEventListener("DOMContentLoaded",st,!1),e.addEventListener("load",X.ready,!1);else{P.attachEvent("onreadystatechange",st),e.attachEvent("onload",X.ready);var n=!1;try{n=e.frameElement==null&&P.documentElement}catch(r){}n&&n.doScroll&&function i(){if(!X.isReady){try{n.doScroll("left")}catch(e){return setTimeout(i,50)}X.ready()}}()}}return D.promise(t)},X.each("Boolean Number String Function Array Date RegExp Object".split(" "),function(e,t){ot["[object "+t+"]"]=t.toLowerCase()}),_=X(P);var ut={};X.Callbacks=function(e){e=typeof e=="string"?ut[e]||n(e):X.extend({},e);var r,i,s,o,u,a,f=[],l=!e.once&&[],c=function(t){r=e.memory&&t,i=!0,a=o||0,o=0,u=f.length,s=!0;for(;f&&a<u;a++)if(f[a].apply(t[0],t[1])===!1&&e.stopOnFalse){r=!1;break}s=!1,f&&(l?l.length&&c(l.shift()):r?f=[]:h.disable())},h={add:function(){if(f){var t=f.length;(function n(t){X.each(t,function(t,r){var i=X.type(r);i==="function"&&(!e.unique||!h.has(r))?f.push(r):r&&r.length&&i!=="string"&&n(r)})})(arguments),s?u=f.length:r&&(o=t,c(r))}return this},remove:function(){return f&&X.each(arguments,function(e,t){var n;while((n=X.inArray(t,f,n))>-1)f.splice(n,1),s&&(n<=u&&u--,n<=a&&a--)}),this},has:function(e){return X.inArray(e,f)>-1},empty:function(){return f=[],this},disable:function(){return f=l=r=t,this},disabled:function(){return!f},lock:function(){return l=t,r||h.disable(),this},locked:function(){return!l},fireWith:function(e,t){return t=t||[],t=[e,t.slice?t.slice():t],f&&(!i||l)&&(s?l.push(t):c(t)),this},fire:function(){return h.fireWith(this,arguments),this},fired:function(){return!!i}};return h},X.extend({Deferred:function(e){var t=[["resolve","done",X.Callbacks("once memory"),"resolved"],["reject","fail",X.Callbacks("once memory"),"rejected"],["notify","progress",X.Callbacks("memory")]],n="pending",r={state:function(){return n},always:function(){return i.done(arguments).fail(arguments),this},then:function(){var e=arguments;return X.Deferred(function(n){X.each(t,function(t,r){var s=r[0],o=e[t];i[r[1]](X.isFunction(o)?function(){var e=o.apply(this,arguments);e&&X.isFunction(e.promise)?e.promise().done(n.resolve).fail(n.reject).progress(n.notify):n[s+"With"](this===i?n:this,[e])}:n[s])}),e=null}).promise()},promise:function(e){return e!=null?X.extend(e,r):r}},i={};return r.pipe=r.then,X.each(t,function(e,s){var o=s[2],u=s[3];r[s[1]]=o.add,u&&o.add(function(){n=u},t[e^1][2].disable,t[2][2].lock),i[s[0]]=o.fire,i[s[0]+"With"]=o.fireWith}),r.promise(i),e&&e.call(i,i),i},when:function(e){var t=0,n=q.call(arguments),r=n.length,i=r!==1||e&&X.isFunction(e.promise)?r:0,s=i===1?e:X.Deferred(),o=function(e,t,n){return function(r){t[e]=this,n[e]=arguments.length>1?q.call(arguments):r,n===u?s.notifyWith(t,n):--i||s.resolveWith(t,n)}},u,a,f;if(r>1){u=new Array(r),a=new Array(r),f=new Array(r);for(;t<r;t++)n[t]&&X.isFunction(n[t].promise)?n[t].promise().done(o(t,f,n)).fail(s.reject).progress(o(t,a,u)):--i}return i||s.resolveWith(f,n),s.promise()}}),X.support=function(){var t,n,r,i,s,o,u,a,f,l,c,h=P.createElement("div");h.setAttribute("className","t"),h.innerHTML="  <link/><table></table><a href='/a'>a</a><input type='checkbox'/>",n=h.getElementsByTagName("*"),r=h.getElementsByTagName("a")[0],r.style.cssText="top:1px;float:left;opacity:.5";if(!n||!n.length)return{};i=P.createElement("select"),s=i.appendChild(P.createElement("option")),o=h.getElementsByTagName("input")[0],t={leadingWhitespace:h.firstChild.nodeType===3,tbody:!h.getElementsByTagName("tbody").length,htmlSerialize:!!h.getElementsByTagName("link").length,style:/top/.test(r.getAttribute("style")),hrefNormalized:r.getAttribute("href")==="/a",opacity:/^0.5/.test(r.style.opacity),cssFloat:!!r.style.cssFloat,checkOn:o.value==="on",optSelected:s.selected,getSetAttribute:h.className!=="t",enctype:!!P.createElement("form").enctype,html5Clone:P.createElement("nav").cloneNode(!0).outerHTML!=="<:nav></:nav>",boxModel:P.compatMode==="CSS1Compat",submitBubbles:!0,changeBubbles:!0,focusinBubbles:!1,deleteExpando:!0,noCloneEvent:!0,inlineBlockNeedsLayout:!1,shrinkWrapBlocks:!1,reliableMarginRight:!0,boxSizingReliable:!0,pixelPosition:!1},o.checked=!0,t.noCloneChecked=o.cloneNode(!0).checked,i.disabled=!0,t.optDisabled=!s.disabled;try{delete h.test}catch(p){t.deleteExpando=!1}!h.addEventListener&&h.attachEvent&&h.fireEvent&&(h.attachEvent("onclick",c=function(){t.noCloneEvent=!1}),h.cloneNode(!0).fireEvent("onclick"),h.detachEvent("onclick",c)),o=P.createElement("input"),o.value="t",o.setAttribute("type","radio"),t.radioValue=o.value==="t",o.setAttribute("checked","checked"),o.setAttribute("name","t"),h.appendChild(o),u=P.createDocumentFragment(),u.appendChild(h.lastChild),t.checkClone=u.cloneNode(!0).cloneNode(!0).lastChild.checked,t.appendChecked=o.checked,u.removeChild(o),u.appendChild(h);if(h.attachEvent)for(f in{submit:!0,change:!0,focusin:!0})a="on"+f,l=a in h,l||(h.setAttribute(a,"return;"),l=typeof h[a]=="function"),t[f+"Bubbles"]=l;return X(function(){var n,r,i,s,o="padding:0;margin:0;border:0;display:block;overflow:hidden;",u=P.getElementsByTagName("body")[0];if(!u)return;n=P.createElement("div"),n.style.cssText="visibility:hidden;border:0;width:0;height:0;position:static;top:0;margin-top:1px",u.insertBefore(n,u.firstChild),r=P.createElement("div"),n.appendChild(r),r.innerHTML="<table><tr><td></td><td>t</td></tr></table>",i=r.getElementsByTagName("td"),i[0].style.cssText="padding:0;margin:0;border:0;display:none",l=i[0].offsetHeight===0,i[0].style.display="",i[1].style.display="none",t.reliableHiddenOffsets=l&&i[0].offsetHeight===0,r.innerHTML="",r.style.cssText="box-sizing:border-box;-moz-box-sizing:border-box;-webkit-box-sizing:border-box;padding:1px;border:1px;display:block;width:4px;margin-top:1%;position:absolute;top:1%;",t.boxSizing=r.offsetWidth===4,t.doesNotIncludeMarginInBodyOffset=u.offsetTop!==1,e.getComputedStyle&&(t.pixelPosition=(e.getComputedStyle(r,null)||{}).top!=="1%",t.boxSizingReliable=(e.getComputedStyle(r,null)||{width:"4px"}).width==="4px",s=P.createElement("div"),s.style.cssText=r.style.cssText=o,s.style.marginRight=s.style.width="0",r.style.width="1px",r.appendChild(s),t.reliableMarginRight=!parseFloat((e.getComputedStyle(s,null)||{}).marginRight)),typeof r.style.zoom!="undefined"&&(r.innerHTML="",r.style.cssText=o+"width:1px;padding:1px;display:inline;zoom:1",t.inlineBlockNeedsLayout=r.offsetWidth===3,r.style.display="block",r.style.overflow="visible",r.innerHTML="<div></div>",r.firstChild.style.width="5px",t.shrinkWrapBlocks=r.offsetWidth!==3,n.style.zoom=1),u.removeChild(n),n=r=i=s=null}),u.removeChild(h),n=r=i=s=o=u=h=null,t}();var at=/(?:\{[\s\S]*\}|\[[\s\S]*\])$/,ft=/([A-Z])/g;X.extend({cache:{},deletedIds:[],uuid:0,expando:"jQuery"+(X.fn.jquery+Math.random()).replace(/\D/g,""),noData:{embed:!0,object:"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000",applet:!0},hasData:function(e){return e=e.nodeType?X.cache[e[X.expando]]:e[X.expando],!!e&&!i(e)},data:function(e,n,r,i){if(!X.acceptData(e))return;var s,o,u=X.expando,a=typeof n=="string",f=e.nodeType,l=f?X.cache:e,c=f?e[u]:e[u]&&u;if((!c||!l[c]||!i&&!l[c].data)&&a&&r===t)return;c||(f?e[u]=c=X.deletedIds.pop()||X.guid++:c=u),l[c]||(l[c]={},f||(l[c].toJSON=X.noop));if(typeof n=="object"||typeof n=="function")i?l[c]=X.extend(l[c],n):l[c].data=X.extend(l[c].data,n);return s=l[c],i||(s.data||(s.data={}),s=s.data),r!==t&&(s[X.camelCase(n)]=r),a?(o=s[n],o==null&&(o=s[X.camelCase(n)])):o=s,o},removeData:function(e,t,n){if(!X.acceptData(e))return;var r,s,o,u=e.nodeType,a=u?X.cache:e,f=u?e[X.expando]:X.expando;if(!a[f])return;if(t){r=n?a[f]:a[f].data;if(r){X.isArray(t)||(t in r?t=[t]:(t=X.camelCase(t),t in r?t=[t]:t=t.split(" ")));for(s=0,o=t.length;s<o;s++)delete r[t[s]];if(!(n?i:X.isEmptyObject)(r))return}}if(!n){delete a[f].data;if(!i(a[f]))return}u?X.cleanData([e],!0):X.support.deleteExpando||a!=a.window?delete a[f]:a[f]=null},_data:function(e,t,n){return X.data(e,t,n,!0)},acceptData:function(e){var t=e.nodeName&&X.noData[e.nodeName.toLowerCase()];return!t||t!==!0&&e.getAttribute("classid")===t}}),X.fn.extend({data:function(e,n){var i,s,o,u,a,f=this[0],l=0,c=null;if(e===t){if(this.length){c=X.data(f);if(f.nodeType===1&&!X._data(f,"parsedAttrs")){o=f.attributes;for(a=o.length;l<a;l++)u=o[l].name,u.indexOf("data-")||(u=X.camelCase(u.substring(5)),r(f,u,c[u]));X._data(f,"parsedAttrs",!0)}}return c}return typeof e=="object"?this.each(function(){X.data(this,e)}):(i=e.split(".",2),i[1]=i[1]?"."+i[1]:"",s=i[1]+"!",X.access(this,function(n){if(n===t)return c=this.triggerHandler("getData"+s,[i[0]]),c===t&&f&&(c=X.data(f,e),c=r(f,e,c)),c===t&&i[1]?this.data(i[0]):c;i[1]=n,this.each(function(){var t=X(this);t.triggerHandler("setData"+s,i),X.data(this,e,n),t.triggerHandler("changeData"+s,i)})},null,n,arguments.length>1,null,!1))},removeData:function(e){return this.each(function(){X.removeData(this,e)})}}),X.extend({queue:function(e,t,n){var r;if(e)return t=(t||"fx")+"queue",r=X._data(e,t),n&&(!r||X.isArray(n)?r=X._data(e,t,X.makeArray(n)):r.push(n)),r||[]},dequeue:function(e,t){t=t||"fx";var n=X.queue(e,t),r=n.length,i=n.shift(),s=X._queueHooks(e,t),o=function(){X.dequeue(e,t)};i==="inprogress"&&(i=n.shift(),r--),i&&(t==="fx"&&n.unshift("inprogress"),delete s.stop,i.call(e,o,s)),!r&&s&&s.empty.fire()},_queueHooks:function(e,t){var n=t+"queueHooks";return X._data(e,n)||X._data(e,n,{empty:X.Callbacks("once memory").add(function(){X.removeData(e,t+"queue",!0),X.removeData(e,n,!0)})})}}),X.fn.extend({queue:function(e,n){var r=2;return typeof e!="string"&&(n=e,e="fx",r--),arguments.length<r?X.queue(this[0],e):n===t?this:this.each(function(){var t=X.queue(this,e,n);X._queueHooks(this,e),e==="fx"&&t[0]!=="inprogress"&&X.dequeue(this,e)})},dequeue:function(e){return this.each(function(){X.dequeue(this,e)})},delay:function(e,t){return e=X.fx?X.fx.speeds[e]||e:e,t=t||"fx",this.queue(t,function(t,n){var r=setTimeout(t,e);n.stop=function(){clearTimeout(r)}})},clearQueue:function(e){return this.queue(e||"fx",[])},promise:function(e,n){var r,i=1,s=X.Deferred(),o=this,u=this.length,a=function(){--i||s.resolveWith(o,[o])};typeof e!="string"&&(n=e,e=t),e=e||"fx";while(u--)r=X._data(o[u],e+"queueHooks"),r&&r.empty&&(i++,r.empty.add(a));return a(),s.promise(n)}});var lt,ct,ht,pt=/[\t\r\n]/g,dt=/\r/g,vt=/^(?:button|input)$/i,mt=/^(?:button|input|object|select|textarea)$/i,gt=/^a(?:rea|)$/i,yt=/^(?:autofocus|autoplay|async|checked|controls|defer|disabled|hidden|loop|multiple|open|readonly|required|scoped|selected)$/i,bt=X.support.getSetAttribute;X.fn.extend({attr:function(e,t){return X.access(this,X.attr,e,t,arguments.length>1)},removeAttr:function(e){return this.each(function(){X.removeAttr(this,e)})},prop:function(e,t){return X.access(this,X.prop,e,t,arguments.length>1)},removeProp:function(e){return e=X.propFix[e]||e,this.each(function(){try{this[e]=t,delete this[e]}catch(n){}})},addClass:function(e){var t,n,r,i,s,o,u;if(X.isFunction(e))return this.each(function(t){X(this).addClass(e.call(this,t,this.className))});if(e&&typeof e=="string"){t=e.split(J);for(n=0,r=this.length;n<r;n++){i=this[n];if(i.nodeType===1)if(!i.className&&t.length===1)i.className=e;else{s=" "+i.className+" ";for(o=0,u=t.length;o<u;o++)s.indexOf(" "+t[o]+" ")<0&&(s+=t[o]+" ");i.className=X.trim(s)}}}return this},removeClass:function(e){var n,r,i,s,o,u,a;if(X.isFunction(e))return this.each(function(t){X(this).removeClass(e.call(this,t,this.className))});if(e&&typeof e=="string"||e===t){n=(e||"").split(J);for(u=0,a=this.length;u<a;u++){i=this[u];if(i.nodeType===1&&i.className){r=(" "+i.className+" ").replace(pt," ");for(s=0,o=n.length;s<o;s++)while(r.indexOf(" "+n[s]+" ")>=0)r=r.replace(" "+n[s]+" "," ");i.className=e?X.trim(r):""}}}return this},toggleClass:function(e,t){var n=typeof e,r=typeof t=="boolean";return X.isFunction(e)?this.each(function(n){X(this).toggleClass(e.call(this,n,this.className,t),t)}):this.each(function(){if(n==="string"){var i,s=0,o=X(this),u=t,a=e.split(J);while(i=a[s++])u=r?u:!o.hasClass(i),o[u?"addClass":"removeClass"](i)}else if(n==="undefined"||n==="boolean")this.className&&X._data(this,"__className__",this.className),this.className=this.className||e===!1?"":X._data(this,"__className__")||""})},hasClass:function(e){var t=" "+e+" ",n=0,r=this.length;for(;n<r;n++)if(this[n].nodeType===1&&(" "+this[n].className+" ").replace(pt," ").indexOf(t)>=0)return!0;return!1},val:function(e){var n,r,i,s=this[0];if(!arguments.length){if(s)return n=X.valHooks[s.type]||X.valHooks[s.nodeName.toLowerCase()],n&&"get"in n&&(r=n.get(s,"value"))!==t?r:(r=s.value,typeof r=="string"?r.replace(dt,""):r==null?"":r);return}return i=X.isFunction(e),this.each(function(r){var s,o=X(this);if(this.nodeType!==1)return;i?s=e.call(this,r,o.val()):s=e,s==null?s="":typeof s=="number"?s+="":X.isArray(s)&&(s=X.map(s,function(e){return e==null?"":e+""})),n=X.valHooks[this.type]||X.valHooks[this.nodeName.toLowerCase()];if(!n||!("set"in n)||n.set(this,s,"value")===t)this.value=s})}}),X.extend({valHooks:{option:{get:function(e){var t=e.attributes.value;return!t||t.specified?e.value:e.text}},select:{get:function(e){var t,n,r,i,s=e.selectedIndex,o=[],u=e.options,a=e.type==="select-one";if(s<0)return null;n=a?s:0,r=a?s+1:u.length;for(;n<r;n++){i=u[n];if(i.selected&&(X.support.optDisabled?!i.disabled:i.getAttribute("disabled")===null)&&(!i.parentNode.disabled||!X.nodeName(i.parentNode,"optgroup"))){t=X(i).val();if(a)return t;o.push(t)}}return a&&!o.length&&u.length?X(u[s]).val():o},set:function(e,t){var n=X.makeArray(t);return X(e).find("option").each(function(){this.selected=X.inArray(X(this).val(),n)>=0}),n.length||(e.selectedIndex=-1),n}}},attrFn:{},attr:function(e,n,r,i){var s,o,u,a=e.nodeType;if(!e||a===3||a===8||a===2)return;if(i&&X.isFunction(X.fn[n]))return X(e)[n](r);if(typeof e.getAttribute=="undefined")return X.prop(e,n,r);u=a!==1||!X.isXMLDoc(e),u&&(n=n.toLowerCase(),o=X.attrHooks[n]||(yt.test(n)?ct:lt));if(r!==t){if(r===null){X.removeAttr(e,n);return}return o&&"set"in o&&u&&(s=o.set(e,r,n))!==t?s:(e.setAttribute(n,r+""),r)}return o&&"get"in o&&u&&(s=o.get(e,n))!==null?s:(s=e.getAttribute(n),s===null?t:s)},removeAttr:function(e,t){var n,r,i,s,o=0;if(t&&e.nodeType===1){r=t.split(J);for(;o<r.length;o++)i=r[o],i&&(n=X.propFix[i]||i,s=yt.test(i),s||X.attr(e,i,""),e.removeAttribute(bt?i:n),s&&n in e&&(e[n]=!1))}},attrHooks:{type:{set:function(e,t){if(vt.test(e.nodeName)&&e.parentNode)X.error("type property can't be changed");else if(!X.support.radioValue&&t==="radio"&&X.nodeName(e,"input")){var n=e.value;return e.setAttribute("type",t),n&&(e.value=n),t}}},value:{get:function(e,t){return lt&&X.nodeName(e,"button")?lt.get(e,t):t in e?e.value:null},set:function(e,t,n){if(lt&&X.nodeName(e,"button"))return lt.set(e,t,n);e.value=t}}},propFix:{tabindex:"tabIndex",readonly:"readOnly","for":"htmlFor","class":"className",maxlength:"maxLength",cellspacing:"cellSpacing",cellpadding:"cellPadding",rowspan:"rowSpan",colspan:"colSpan",usemap:"useMap",frameborder:"frameBorder",contenteditable:"contentEditable"},prop:function(e,n,r){var i,s,o,u=e.nodeType;if(!e||u===3||u===8||u===2)return;return o=u!==1||!X.isXMLDoc(e),o&&(n=X.propFix[n]||n,s=X.propHooks[n]),r!==t?s&&"set"in s&&(i=s.set(e,r,n))!==t?i:e[n]=r:s&&"get"in s&&(i=s.get(e,n))!==null?i:e[n]},propHooks:{tabIndex:{get:function(e){var n=e.getAttributeNode("tabindex");return n&&n.specified?parseInt(n.value,10):mt.test(e.nodeName)||gt.test(e.nodeName)&&e.href?0:t}}}}),ct={get:function(e,n){var r,i=X.prop(e,n);return i===!0||typeof i!="boolean"&&(r=e.getAttributeNode(n))&&r.nodeValue!==!1?n.toLowerCase():t},set:function(e,t,n){var r;return t===!1?X.removeAttr(e,n):(r=X.propFix[n]||n,r in e&&(e[r]=!0),e.setAttribute(n,n.toLowerCase())),n}},bt||(ht={name:!0,id:!0,coords:!0},lt=X.valHooks.button={get:function(e,n){var r;return r=e.getAttributeNode(n),r&&(ht[n]?r.value!=="":r.specified)?r.value:t},set:function(e,t,n){var r=e.getAttributeNode(n);return r||(r=P.createAttribute(n),e.setAttributeNode(r)),r.value=t+""}},X.each(["width","height"],function(e,t){X.attrHooks[t]=X.extend(X.attrHooks[t],{set:function(e,n){if(n==="")return e.setAttribute(t,"auto"),n}})}),X.attrHooks.contenteditable={get:lt.get,set:function(e,t,n){t===""&&(t="false"),lt.set(e,t,n)}}),X.support.hrefNormalized||X.each(["href","src","width","height"],function(e,n){X.attrHooks[n]=X.extend(X.attrHooks[n],{get:function(e){var r=e.getAttribute(n,2);return r===null?t:r}})}),X.support.style||(X.attrHooks.style={get:function(e){return e.style.cssText.toLowerCase()||t},set:function(e,t){return e.style.cssText=t+""}}),X.support.optSelected||(X.propHooks.selected=X.extend(X.propHooks.selected,{get:function(e){var t=e.parentNode;return t&&(t.selectedIndex,t.parentNode&&t.parentNode.selectedIndex),null}})),X.support.enctype||(X.propFix.enctype="encoding"),X.support.checkOn||X.each(["radio","checkbox"],function(){X.valHooks[this]={get:function(e){return e.getAttribute("value")===null?"on":e.value}}}),X.each(["radio","checkbox"],function(){X.valHooks[this]=X.extend(X.valHooks[this],{set:function(e,t){if(X.isArray(t))return e.checked=X.inArray(X(e).val(),t)>=0}})});var wt=/^(?:textarea|input|select)$/i,Et=/^([^\.]*|)(?:\.(.+)|)$/,St=/(?:^|\s)hover(\.\S+|)\b/,xt=/^key/,Tt=/^(?:mouse|contextmenu)|click/,Nt=/^(?:focusinfocus|focusoutblur)$/,Ct=function(e){return X.event.special.hover?e:e.replace(St,"mouseenter$1 mouseleave$1")};X.event={add:function(e,n,r,i,s){var o,u,a,f,l,c,h,p,d,v,m;if(e.nodeType===3||e.nodeType===8||!n||!r||!(o=X._data(e)))return;r.handler&&(d=r,r=d.handler,s=d.selector),r.guid||(r.guid=X.guid++),a=o.events,a||(o.events=a={}),u=o.handle,u||(o.handle=u=function(e){return typeof X=="undefined"||!!e&&X.event.triggered===e.type?t:X.event.dispatch.apply(u.elem,arguments)},u.elem=e),n=X.trim(Ct(n)).split(" ");for(f=0;f<n.length;f++){l=Et.exec(n[f])||[],c=l[1],h=(l[2]||"").split(".").sort(),m=X.event.special[c]||{},c=(s?m.delegateType:m.bindType)||c,m=X.event.special[c]||{},p=X.extend({type:c,origType:l[1],data:i,handler:r,guid:r.guid,selector:s,needsContext:s&&X.expr.match.needsContext.test(s),namespace:h.join(".")},d),v=a[c];if(!v){v=a[c]=[],v.delegateCount=0;if(!m.setup||m.setup.call(e,i,h,u)===!1)e.addEventListener?e.addEventListener(c,u,!1):e.attachEvent&&e.attachEvent("on"+c,u)}m.add&&(m.add.call(e,p),p.handler.guid||(p.handler.guid=r.guid)),s?v.splice(v.delegateCount++,0,p):v.push(p),X.event.global[c]=!0}e=null},global:{},remove:function(e,t,n,r,i){var s,o,u,a,f,l,c,h,p,d,v,m=X.hasData(e)&&X._data(e);if(!m||!(h=m.events))return;t=X.trim(Ct(t||"")).split(" ");for(s=0;s<t.length;s++){o=Et.exec(t[s])||[],u=a=o[1],f=o[2];if(!u){for(u in h)X.event.remove(e,u+t[s],n,r,!0);continue}p=X.event.special[u]||{},u=(r?p.delegateType:p.bindType)||u,d=h[u]||[],l=d.length,f=f?new RegExp("(^|\\.)"+f.split(".").sort().join("\\.(?:.*\\.|)")+"(\\.|$)"):null;for(c=0;c<d.length;c++)v=d[c],(i||a===v.origType)&&(!n||n.guid===v.guid)&&(!f||f.test(v.namespace))&&(!r||r===v.selector||r==="**"&&v.selector)&&(d.splice(c--,1),v.selector&&d.delegateCount--,p.remove&&p.remove.call(e,v));d.length===0&&l!==d.length&&((!p.teardown||p.teardown.call(e,f,m.handle)===!1)&&X.removeEvent(e,u,m.handle),delete h[u])}X.isEmptyObject(h)&&(delete m.handle,X.removeData(e,"events",!0))},customEvent:{getData:!0,setData:!0,changeData:!0},trigger:function(n,r,i,s){if(!i||i.nodeType!==3&&i.nodeType!==8){var o,u,a,f,l,c,h,p,d,v,m=n.type||n,g=[];if(Nt.test(m+X.event.triggered))return;m.indexOf("!")>=0&&(m=m.slice(0,-1),u=!0),m.indexOf(".")>=0&&(g=m.split("."),m=g.shift(),g.sort());if((!i||X.event.customEvent[m])&&!X.event.global[m])return;n=typeof n=="object"?n[X.expando]?n:new X.Event(m,n):new X.Event(m),n.type=m,n.isTrigger=!0,n.exclusive=u,n.namespace=g.join("."),n.namespace_re=n.namespace?new RegExp("(^|\\.)"+g.join("\\.(?:.*\\.|)")+"(\\.|$)"):null,c=m.indexOf(":")<0?"on"+m:"";if(!i){o=X.cache;for(a in o)o[a].events&&o[a].events[m]&&X.event.trigger(n,r,o[a].handle.elem,!0);return}n.result=t,n.target||(n.target=i),r=r!=null?X.makeArray(r):[],r.unshift(n),h=X.event.special[m]||{};if(h.trigger&&h.trigger.apply(i,r)===!1)return;d=[[i,h.bindType||m]];if(!s&&!h.noBubble&&!X.isWindow(i)){v=h.delegateType||m,f=Nt.test(v+m)?i:i.parentNode;for(l=i;f;f=f.parentNode)d.push([f,v]),l=f;l===(i.ownerDocument||P)&&d.push([l.defaultView||l.parentWindow||e,v])}for(a=0;a<d.length&&!n.isPropagationStopped();a++)f=d[a][0],n.type=d[a][1],p=(X._data(f,"events")||{})[n.type]&&X._data(f,"handle"),p&&p.apply(f,r),p=c&&f[c],p&&X.acceptData(f)&&p.apply&&p.apply(f,r)===!1&&n.preventDefault();return n.type=m,!s&&!n.isDefaultPrevented()&&(!h._default||h._default.apply(i.ownerDocument,r)===!1)&&(m!=="click"||!X.nodeName(i,"a"))&&X.acceptData(i)&&c&&i[m]&&(m!=="focus"&&m!=="blur"||n.target.offsetWidth!==0)&&!X.isWindow(i)&&(l=i[c],l&&(i[c]=null),X.event.triggered=m,i[m](),X.event.triggered=t,l&&(i[c]=l)),n.result}return},dispatch:function(n){n=X.event.fix(n||e.event);var r,i,s,o,u,a,f,l,c,h,p=(X._data(this,"events")||{})[n.type]||[],d=p.delegateCount,v=q.call(arguments),m=!n.exclusive&&!n.namespace,g=X.event.special[n.type]||{},y=[];v[0]=n,n.delegateTarget=this;if(g.preDispatch&&g.preDispatch.call(this,n)===!1)return;if(d&&(!n.button||n.type!=="click"))for(s=n.target;s!=this;s=s.parentNode||this)if(s.disabled!==!0||n.type!=="click"){u={},f=[];for(r=0;r<d;r++)l=p[r],c=l.selector,u[c]===t&&(u[c]=l.needsContext?X(c,this).index(s)>=0:X.find(c,this,null,[s]).length),u[c]&&f.push(l);f.length&&y.push({elem:s,matches:f})}p.length>d&&y.push({elem:this,matches:p.slice(d)});for(r=0;r<y.length&&!n.isPropagationStopped();r++){a=y[r],n.currentTarget=a.elem;for(i=0;i<a.matches.length&&!n.isImmediatePropagationStopped();i++){l=a.matches[i];if(m||!n.namespace&&!l.namespace||n.namespace_re&&n.namespace_re.test(l.namespace))n.data=l.data,n.handleObj=l,o=((X.event.special[l.origType]||{}).handle||l.handler).apply(a.elem,v),o!==t&&(n.result=o,o===!1&&(n.preventDefault(),n.stopPropagation()))}}return g.postDispatch&&g.postDispatch.call(this,n),n.result},props:"attrChange attrName relatedNode srcElement altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),fixHooks:{},keyHooks:{props:"char charCode key keyCode".split(" "),filter:function(e,t){return e.which==null&&(e.which=t.charCode!=null?t.charCode:t.keyCode),e}},mouseHooks:{props:"button buttons clientX clientY fromElement offsetX offsetY pageX pageY screenX screenY toElement".split(" "),filter:function(e,n){var r,i,s,o=n.button,u=n.fromElement;return e.pageX==null&&n.clientX!=null&&(r=e.target.ownerDocument||P,i=r.documentElement,s=r.body,e.pageX=n.clientX+(i&&i.scrollLeft||s&&s.scrollLeft||0)-(i&&i.clientLeft||s&&s.clientLeft||0),e.pageY=n.clientY+(i&&i.scrollTop||s&&s.scrollTop||0)-(i&&i.clientTop||s&&s.clientTop||0)),!e.relatedTarget&&u&&(e.relatedTarget=u===e.target?n.toElement:u),!e.which&&o!==t&&(e.which=o&1?1:o&2?3:o&4?2:0),e}},fix:function(e){if(e[X.expando])return e;var t,n,r=e,i=X.event.fixHooks[e.type]||{},s=i.props?this.props.concat(i.props):this.props;e=X.Event(r);for(t=s.length;t;)n=s[--t],e[n]=r[n];return e.target||(e.target=r.srcElement||P),e.target.nodeType===3&&(e.target=e.target.parentNode),e.metaKey=!!e.metaKey,i.filter?i.filter(e,r):e},special:{load:{noBubble:!0},focus:{delegateType:"focusin"},blur:{delegateType:"focusout"},beforeunload:{setup:function(e,t,n){X.isWindow(this)&&(this.onbeforeunload=n)},teardown:function(e,t){this.onbeforeunload===t&&(this.onbeforeunload=null)}}},simulate:function(e,t,n,r){var i=X.extend(new X.Event,n,{type:e,isSimulated:!0,originalEvent:{}});r?X.event.trigger(i,null,t):X.event.dispatch.call(t,i),i.isDefaultPrevented()&&n.preventDefault()}},X.event.handle=X.event.dispatch,X.removeEvent=P.removeEventListener?function(e,t,n){e.removeEventListener&&e.removeEventListener(t,n,!1)}:function(e,t,n){var r="on"+t;e.detachEvent&&(typeof e[r]=="undefined"&&(e[r]=null),e.detachEvent(r,n))},X.Event=function(e,t){if(!(this instanceof X.Event))return new X.Event(e,t);e&&e.type?(this.originalEvent=e,this.type=e.type,this.isDefaultPrevented=e.defaultPrevented||e.returnValue===!1||e.getPreventDefault&&e.getPreventDefault()?o:s):this.type=e,t&&X.extend(this,t),this.timeStamp=e&&e.timeStamp||X.now(),this[X.expando]=!0},X.Event.prototype={preventDefault:function(){this.isDefaultPrevented=o;var e=this.originalEvent;if(!e)return;e.preventDefault?e.preventDefault():e.returnValue=!1},stopPropagation:function(){this.isPropagationStopped=o;var e=this.originalEvent;if(!e)return;e.stopPropagation&&e.stopPropagation(),e.cancelBubble=!0},stopImmediatePropagation:function(){this.isImmediatePropagationStopped=o,this.stopPropagation()},isDefaultPrevented:s,isPropagationStopped:s,isImmediatePropagationStopped:s},X.each({mouseenter:"mouseover",mouseleave:"mouseout"},function(e,t){X.event.special[e]={delegateType:t,bindType:t,handle:function(e){var n,r=this,i=e.relatedTarget,s=e.handleObj,o=s.selector;if(!i||i!==r&&!X.contains(r,i))e.type=s.origType,n=s.handler.apply(this,arguments),e.type=t;return n}}}),X.support.submitBubbles||(X.event.special.submit={setup:function(){if(X.nodeName(this,"form"))return!1;X.event.add(this,"click._submit keypress._submit",function(e){var n=e.target,r=X.nodeName(n,"input")||X.nodeName(n,"button")?n.form:t;r&&!X._data(r,"_submit_attached")&&(X.event.add(r,"submit._submit",function(e){e._submit_bubble=!0}),X._data(r,"_submit_attached",!0))})},postDispatch:function(e){e._submit_bubble&&(delete e._submit_bubble,this.parentNode&&!e.isTrigger&&X.event.simulate("submit",this.parentNode,e,!0))},teardown:function(){if(X.nodeName(this,"form"))return!1;X.event.remove(this,"._submit")}}),X.support.changeBubbles||(X.event.special.change={setup:function(){if(wt.test(this.nodeName)){if(this.type==="checkbox"||this.type==="radio")X.event.add(this,"propertychange._change",function(e){e.originalEvent.propertyName==="checked"&&(this._just_changed=!0)}),X.event.add(this,"click._change",function(e){this._just_changed&&!e.isTrigger&&(this._just_changed=!1),X.event.simulate("change",this,e,!0)});return!1}X.event.add(this,"beforeactivate._change",function(e){var t=e.target;wt.test(t.nodeName)&&!X._data(t,"_change_attached")&&(X.event.add(t,"change._change",function(e){this.parentNode&&!e.isSimulated&&!e.isTrigger&&X.event.simulate("change",this.parentNode,e,!0)}),X._data(t,"_change_attached",!0))})},handle:function(e){var t=e.target;if(this!==t||e.isSimulated||e.isTrigger||t.type!=="radio"&&t.type!=="checkbox")return e.handleObj.handler.apply(this,arguments)},teardown:function(){return X.event.remove(this,"._change"),!wt.test(this.nodeName)}}),X.support.focusinBubbles||X.each({focus:"focusin",blur:"focusout"},function(e,t){var n=0,r=function(e){X.event.simulate(t,e.target,X.event.fix(e),!0)};X.event.special[t]={setup:function(){n++===0&&P.addEventListener(e,r,!0)},teardown:function(){--n===0&&P.removeEventListener(e,r,!0)}}}),X.fn.extend({on:function(e,n,r,i,o){var u,a;if(typeof e=="object"){typeof n!="string"&&(r=r||n,n=t);for(a in e)this.on(a,n,r,e[a],o);return this}r==null&&i==null?(i=n,r=n=t):i==null&&(typeof n=="string"?(i=r,r=t):(i=r,r=n,n=t));if(i===!1)i=s;else if(!i)return this;return o===1&&(u=i,i=function(e){return X().off(e),u.apply(this,arguments)},i.guid=u.guid||(u.guid=X.guid++)),this.each(function(){X.event.add(this,e,i,r,n)})},one:function(e,t,n,r){return this.on(e,t,n,r,1)},off:function(e,n,r){var i,o;if(e&&e.preventDefault&&e.handleObj)return i=e.handleObj,X(e.delegateTarget).off(i.namespace?i.origType+"."+i.namespace:i.origType,i.selector,i.handler),this;if(typeof e=="object"){for(o in e)this.off(o,n,e[o]);return this}if(n===!1||typeof n=="function")r=n,n=t;return r===!1&&(r=s),this.each(function(){X.event.remove(this,e,r,n)})},bind:function(e,t,n){return this.on(e,null,t,n)},unbind:function(e,t){return this.off(e,null,t)},live:function(e,t,n){return X(this.context).on(e,this.selector,t,n),this},die:function(e,t){return X(this.context).off(e,this.selector||"**",t),this},delegate:function(e,t,n,r){return this.on(t,e,n,r)},undelegate:function(e,t,n){return arguments.length===1?this.off(e,"**"):this.off(t,e||"**",n)},trigger:function(e,t){return this.each(function(){X.event.trigger(e,t,this)})},triggerHandler:function(e,t){if(this[0])return X.event.trigger(e,t,this[0],!0)},toggle:function(e){var t=arguments,n=e.guid||X.guid++,r=0,i=function(n){var i=(X._data(this,"lastToggle"+e.guid)||0)%r;return X._data(this,"lastToggle"+e.guid,i+1),n.preventDefault(),t[i].apply(this,arguments)||!1};i.guid=n;while(r<t.length)t[r++].guid=n;return this.click(i)},hover:function(e,t){return this.mouseenter(e).mouseleave(t||e)}}),X.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu".split(" "),function(e,t){X.fn[t]=function(e,n){return n==null&&(n=e,e=null),arguments.length>0?this.on(t,null,e,n):this.trigger(t)},xt.test(t)&&(X.event.fixHooks[t]=X.event.keyHooks),Tt.test(t)&&(X.event.fixHooks[t]=X.event.mouseHooks)}),function(e,t){function n(e,t,n,r){n=n||[],t=t||L;var i,s,o,u,a=t.nodeType;if(a!==1&&a!==9)return[];if(!e||typeof e!="string")return n;o=w(t);if(!o&&!r)if(i=Q.exec(e))if(u=i[1]){if(a===9){s=t.getElementById(u);if(!s||!s.parentNode)return n;if(s.id===u)return n.push(s),n}else if(t.ownerDocument&&(s=t.ownerDocument.getElementById(u))&&E(t,s)&&s.id===u)return n.push(s),n}else{if(i[2])return _.apply(n,M.call(t.getElementsByTagName(e),0)),n;if((u=i[3])&&at&&t.getElementsByClassName)return _.apply(n,M.call(t.getElementsByClassName(u),0)),n}return d(e,t,n,r,o)}function r(e){return function(t){var n=t.nodeName.toLowerCase();return n==="input"&&t.type===e}}function i(e){return function(t){var n=t.nodeName.toLowerCase();return(n==="input"||n==="button")&&t.type===e}}function s(e,t,n){if(e===t)return n;var r=e.nextSibling;while(r){if(r===t)return-1;r=r.nextSibling}return 1}function o(e,t,r,i){var s,o,u,a,f,l,c,h,p,d,v=!r&&t!==L,m=(v?"<s>":"")+e.replace(V,"$1<s>"),g=B[k][m];if(g)return i?0:M.call(g,0);f=e,l=[],h=0,p=y.preFilter,d=y.filter;while(f){if(!s||(o=$.exec(f)))o&&(f=f.slice(o[0].length),u.selector=c),l.push(u=[]),c="",v&&(f=" "+f);s=!1;if(o=J.exec(f))c+=o[0],f=f.slice(o[0].length),s=u.push({part:o.pop().replace(V," "),string:o[0],captures:o});for(a in d)(o=rt[a].exec(f))&&(!p[a]||(o=p[a](o,t,r)))&&(c+=o[0],f=f.slice(o[0].length),s=u.push({part:a,string:o.shift(),captures:o}));if(!s)break}return c&&(u.selector=c),i?f.length:f?n.error(e):M.call(B(m,l),0)}function u(e,t,n,r){var i=t.dir,s=O++;return e||(e=function(e){return e===n}),t.first?function(t){while(t=t[i])if(t.nodeType===1)return e(t)&&t}:r?function(t){while(t=t[i])if(t.nodeType===1&&e(t))return t}:function(t){var n,r=s+"."+v,o=r+"."+m;while(t=t[i])if(t.nodeType===1){if((n=t[k])===o)return t.sizset;if(typeof n=="string"&&n.indexOf(r)===0){if(t.sizset)return t}else{t[k]=o;if(e(t))return t.sizset=!0,t;t.sizset=!1}}}}function a(e,t){return e?function(n){var r=t(n);return r&&e(r===!0?n:r)}:t}function f(e,t,n){var r,i,s=0;for(;r=e[s];s++)y.relative[r.part]?i=u(i,y.relative[r.part],t,n):i=a(i,y.filter[r.part].apply(null,r.captures.concat(t,n)));return i}function l(e){return function(t){var n,r=0;for(;n=e[r];r++)if(n(t))return!0;return!1}}function c(e,t,r,i){var s=0,o=t.length;for(;s<o;s++)n(e,t[s],r,i)}function h(e,t,r,i,s,o){var u,a=y.setFilters[t.toLowerCase()];return a||n.error(t),(e||!(u=s))&&c(e||"*",i,u=[],s),u.length>0?a(u,r,o):[]}function p(e,r,i,s){var o,u,a,f,l,p,d,v,m,g,y,b,w,E=0,S=e.length,x=rt.POS,T=new RegExp("^"+x.source+"(?!"+F+")","i"),N=function(){var e=1,n=arguments.length-2;for(;e<n;e++)arguments[e]===t&&(m[e]=t)};for(;E<S;E++){o=e[E],u="",v=s;for(a=0,f=o.length;a<f;a++){l=o[a],p=l.string;if(l.part==="PSEUDO"){x.exec(""),d=0;while(m=x.exec(p)){g=!0,y=x.lastIndex=m.index+m[0].length;if(y>d){u+=p.slice(d,m.index),d=y,b=[r],J.test(u)&&(v&&(b=v),v=s);if(w=Z.test(u))u=u.slice(0,-5).replace(J,"$&*"),d++;m.length>1&&m[0].replace(T,N),v=h(u,m[1],m[2],b,v,w)}u=""}}g||(u+=p),g=!1}u?J.test(u)?c(u,v||[r],i,s):n(u,r,i,s?s.concat(v):v):_.apply(i,v)}return S===1?i:n.uniqueSort(i)}function d(e,t,n,r,i){e=e.replace(V,"$1");var s,u,a,f,l,c,h,d,g,b,w=o(e,t,i),E=t.nodeType;if(rt.POS.test(e))return p(w,t,n,r);if(r)s=M.call(r,0);else if(w.length===1){if((c=M.call(w[0],0)).length>2&&(h=c[0]).part==="ID"&&E===9&&!i&&y.relative[c[1].part]){t=y.find.ID(h.captures[0].replace(nt,""),t,i)[0];if(!t)return n;e=e.slice(c.shift().string.length)}g=(w=Y.exec(c[0].string))&&!w.index&&t.parentNode||t,d="";for(l=c.length-1;l>=0;l--){h=c[l],b=h.part,d=h.string+d;if(y.relative[b])break;if(y.order.test(b)){s=y.find[b](h.captures[0].replace(nt,""),g,i);if(s==null)continue;e=e.slice(0,e.length-d.length)+d.replace(rt[b],""),e||_.apply(n,M.call(s,0));break}}}if(e){u=S(e,t,i),v=u.dirruns++,s==null&&(s=y.find.TAG("*",Y.test(e)&&t.parentNode||t));for(l=0;f=s[l];l++)m=u.runs++,u(f)&&n.push(f)}return n}var v,m,g,y,b,w,E,S,x,T,N=!0,C="undefined",k=("sizcache"+Math.random()).replace(".",""),L=e.document,A=L.documentElement,O=0,M=[].slice,_=[].push,D=function(e,t){return e[k]=t||!0,e},P=function(){var e={},t=[];return D(function(n,r){return t.push(n)>y.cacheLength&&delete e[t.shift()],e[n]=r},e)},H=P(),B=P(),j=P(),F="[\\x20\\t\\r\\n\\f]",I="(?:\\\\.|[-\\w]|[^\\x00-\\xa0])+",q=I.replace("w","w#"),R="([*^$|!~]?=)",U="\\["+F+"*("+I+")"+F+"*(?:"+R+F+"*(?:(['\"])((?:\\\\.|[^\\\\])*?)\\3|("+q+")|)|)"+F+"*\\]",z=":("+I+")(?:\\((?:(['\"])((?:\\\\.|[^\\\\])*?)\\2|([^()[\\]]*|(?:(?:"+U+")|[^:]|\\\\.)*|.*))\\)|)",W=":(nth|eq|gt|lt|first|last|even|odd)(?:\\(((?:-\\d)?\\d*)\\)|)(?=[^-]|$)",V=new RegExp("^"+F+"+|((?:^|[^\\\\])(?:\\\\.)*)"+F+"+$","g"),$=new RegExp("^"+F+"*,"+F+"*"),J=new RegExp("^"+F+"*([\\x20\\t\\r\\n\\f>+~])"+F+"*"),K=new RegExp(z),Q=/^(?:#([\w\-]+)|(\w+)|\.([\w\-]+))$/,G=/^:not/,Y=/[\x20\t\r\n\f]*[+~]/,Z=/:not\($/,et=/h\d/i,tt=/input|select|textarea|button/i,nt=/\\(?!\\)/g,rt={ID:new RegExp("^#("+I+")"),CLASS:new RegExp("^\\.("+I+")"),NAME:new RegExp("^\\[name=['\"]?("+I+")['\"]?\\]"),TAG:new RegExp("^("+I.replace("w","w*")+")"),ATTR:new RegExp("^"+U),PSEUDO:new RegExp("^"+z),CHILD:new RegExp("^:(only|nth|last|first)-child(?:\\("+F+"*(even|odd|(([+-]|)(\\d*)n|)"+F+"*(?:([+-]|)"+F+"*(\\d+)|))"+F+"*\\)|)","i"),POS:new RegExp(W,"ig"),needsContext:new RegExp("^"+F+"*[>+~]|"+W,"i")},it=function(e){var t=L.createElement("div");try{return e(t)}catch(n){return!1}finally{t=null}},st=it(function(e){return e.appendChild(L.createComment("")),!e.getElementsByTagName("*").length}),ot=it(function(e){return e.innerHTML="<a href='#'></a>",e.firstChild&&typeof e.firstChild.getAttribute!==C&&e.firstChild.getAttribute("href")==="#"}),ut=it(function(e){e.innerHTML="<select></select>";var t=typeof e.lastChild.getAttribute("multiple");return t!=="boolean"&&t!=="string"}),at=it(function(e){return e.innerHTML="<div class='hidden e'></div><div class='hidden'></div>",!e.getElementsByClassName||!e.getElementsByClassName("e").length?!1:(e.lastChild.className="e",e.getElementsByClassName("e").length===2)}),ft=it(function(e){e.id=k+0,e.innerHTML="<a name='"+k+"'></a><div name='"+k+"'></div>",A.insertBefore(e,A.firstChild);var t=L.getElementsByName&&L.getElementsByName(k).length===2+L.getElementsByName(k+0).length;return g=!L.getElementById(k),A.removeChild(e),t});try{M.call(A.childNodes,0)[0].nodeType}catch(lt){M=function(e){var t,n=[];for(;t=this[e];e++)n.push(t);return n}}n.matches=function(e,t){return n(e,null,null,t)},n.matchesSelector=function(e,t){return n(t,null,null,[e]).length>0},b=n.getText=function(e){var t,n="",r=0,i=e.nodeType;if(i){if(i===1||i===9||i===11){if(typeof e.textContent=="string")return e.textContent;for(e=e.firstChild;e;e=e.nextSibling)n+=b(e)}else if(i===3||i===4)return e.nodeValue}else for(;t=e[r];r++)n+=b(t);return n},w=n.isXML=function(e){var t=e&&(e.ownerDocument||e).documentElement;return t?t.nodeName!=="HTML":!1},E=n.contains=A.contains?function(e,t){var n=e.nodeType===9?e.documentElement:e,r=t&&t.parentNode;return e===r||!!(r&&r.nodeType===1&&n.contains&&n.contains(r))}:A.compareDocumentPosition?function(e,t){return t&&!!(e.compareDocumentPosition(t)&16)}:function(e,t){while(t=t.parentNode)if(t===e)return!0;return!1},n.attr=function(e,t){var n,r=w(e);return r||(t=t.toLowerCase()),y.attrHandle[t]?y.attrHandle[t](e):ut||r?e.getAttribute(t):(n=e.getAttributeNode(t),n?typeof e[t]=="boolean"?e[t]?t:null:n.specified?n.value:null:null)},y=n.selectors={cacheLength:50,createPseudo:D,match:rt,order:new RegExp("ID|TAG"+(ft?"|NAME":"")+(at?"|CLASS":"")),attrHandle:ot?{}:{href:function(e){return e.getAttribute("href",2)},type:function(e){return e.getAttribute("type")}},find:{ID:g?function(e,t,n){if(typeof t.getElementById!==C&&!n){var r=t.getElementById(e);return r&&r.parentNode?[r]:[]}}:function(e,n,r){if(typeof n.getElementById!==C&&!r){var i=n.getElementById(e);return i?i.id===e||typeof i.getAttributeNode!==C&&i.getAttributeNode("id").value===e?[i]:t:[]}},TAG:st?function(e,t){if(typeof t.getElementsByTagName!==C)return t.getElementsByTagName(e)}:function(e,t){var n=t.getElementsByTagName(e);if(e==="*"){var r,i=[],s=0;for(;r=n[s];s++)r.nodeType===1&&i.push(r);return i}return n},NAME:function(e,t){if(typeof t.getElementsByName!==C)return t.getElementsByName(name)},CLASS:function(e,t,n){if(typeof t.getElementsByClassName!==C&&!n)return t.getElementsByClassName(e)}},relative:{">":{dir:"parentNode",first:!0}," ":{dir:"parentNode"},"+":{dir:"previousSibling",first:!0},"~":{dir:"previousSibling"}},preFilter:{ATTR:function(e){return e[1]=e[1].replace(nt,""),e[3]=(e[4]||e[5]||"").replace(nt,""),e[2]==="~="&&(e[3]=" "+e[3]+" "),e.slice(0,4)},CHILD:function(e){return e[1]=e[1].toLowerCase(),e[1]==="nth"?(e[2]||n.error(e[0]),e[3]=+(e[3]?e[4]+(e[5]||1):2*(e[2]==="even"||e[2]==="odd")),e[4]=+(e[6]+e[7]||e[2]==="odd")):e[2]&&n.error(e[0]),e},PSEUDO:function(e,t,n){var r,i;if(rt.CHILD.test(e[0]))return null;if(e[3])e[2]=e[3];else if(r=e[4])K.test(r)&&(i=o(r,t,n,!0))&&(i=r.indexOf(")",r.length-i)-r.length)&&(r=r.slice(0,i),e[0]=e[0].slice(0,i)),e[2]=r;return e.slice(0,3)}},filter:{ID:g?function(e){return e=e.replace(nt,""),function(t){return t.getAttribute("id")===e}}:function(e){return e=e.replace(nt,""),function(t){var n=typeof t.getAttributeNode!==C&&t.getAttributeNode("id");return n&&n.value===e}},TAG:function(e){return e==="*"?function(){return!0}:(e=e.replace(nt,"").toLowerCase(),function(t){return t.nodeName&&t.nodeName.toLowerCase()===e})},CLASS:function(e){var t=H[k][e];return t||(t=H(e,new RegExp("(^|"+F+")"+e+"("+F+"|$)"))),function(e){return t.test(e.className||typeof e.getAttribute!==C&&e.getAttribute("class")||"")}},ATTR:function(e,t,r){return t?function(i){var s=n.attr(i,e),o=s+"";if(s==null)return t==="!=";switch(t){case"=":return o===r;case"!=":return o!==r;case"^=":return r&&o.indexOf(r)===0;case"*=":return r&&o.indexOf(r)>-1;case"$=":return r&&o.substr(o.length-r.length)===r;case"~=":return(" "+o+" ").indexOf(r)>-1;case"|=":return o===r||o.substr(0,r.length+1)===r+"-"}}:function(t){return n.attr(t,e)!=null}},CHILD:function(e,t,n,r){if(e==="nth"){var i=O++;return function(e){var t,s,o=0,u=e;if(n===1&&r===0)return!0;t=e.parentNode;if(t&&(t[k]!==i||!e.sizset)){for(u=t.firstChild;u;u=u.nextSibling)if(u.nodeType===1){u.sizset=++o;if(u===e)break}t[k]=i}return s=e.sizset-r,n===0?s===0:s%n===0&&s/n>=0}}return function(t){var n=t;switch(e){case"only":case"first":while(n=n.previousSibling)if(n.nodeType===1)return!1;if(e==="first")return!0;n=t;case"last":while(n=n.nextSibling)if(n.nodeType===1)return!1;return!0}}},PSEUDO:function(e,t,r,i){var s,o=y.pseudos[e]||y.pseudos[e.toLowerCase()];return o||n.error("unsupported pseudo: "+e),o[k]?o(t,r,i):o.length>1?(s=[e,e,"",t],function(e){return o(e,0,s)}):o}},pseudos:{not:D(function(e,t,n){var r=S(e.replace(V,"$1"),t,n);return function(e){return!r(e)}}),enabled:function(e){return e.disabled===!1},disabled:function(e){return e.disabled===!0},checked:function(e){var t=e.nodeName.toLowerCase();return t==="input"&&!!e.checked||t==="option"&&!!e.selected},selected:function(e){return e.parentNode&&e.parentNode.selectedIndex,e.selected===!0},parent:function(e){return!y.pseudos.empty(e)},empty:function(e){var t;e=e.firstChild;while(e){if(e.nodeName>"@"||(t=e.nodeType)===3||t===4)return!1;e=e.nextSibling}return!0},contains:D(function(e){return function(t){return(t.textContent||t.innerText||b(t)).indexOf(e)>-1}}),has:D(function(e){return function(t){return n(e,t).length>0}}),header:function(e){return et.test(e.nodeName)},text:function(e){var t,n;return e.nodeName.toLowerCase()==="input"&&(t=e.type)==="text"&&((n=e.getAttribute("type"))==null||n.toLowerCase()===t)},radio:r("radio"),checkbox:r("checkbox"),file:r("file"),password:r("password"),image:r("image"),submit:i("submit"),reset:i("reset"),button:function(e){var t=e.nodeName.toLowerCase();return t==="input"&&e.type==="button"||t==="button"},input:function(e){return tt.test(e.nodeName)},focus:function(e){var t=e.ownerDocument;return e===t.activeElement&&(!t.hasFocus||t.hasFocus())&&(!!e.type||!!e.href)},active:function(e){return e===e.ownerDocument.activeElement}},setFilters:{first:function(e,t,n){return n?e.slice(1):[e[0]]},last:function(e,t,n){var r=e.pop();return n?e:[r]},even:function(e,t,n){var r=[],i=n?1:0,s=e.length;for(;i<s;i+=2)r.push(e[i]);return r},odd:function(e,t,n){var r=[],i=n?0:1,s=e.length;for(;i<s;i+=2)r.push(e[i]);return r},lt:function(e,t,n){return n?e.slice(+t):e.slice(0,+t)},gt:function(e,t,n){return n?e.slice(0,+t+1):e.slice(+t+1)},eq:function(e,t,n){var r=e.splice(+t,1);return n?e:r}}},x=A.compareDocumentPosition?function(e,t){return e===t?(T=!0,0):(!e.compareDocumentPosition||!t.compareDocumentPosition?e.compareDocumentPosition:e.compareDocumentPosition(t)&4)?-1:1}:function(e,t){if(e===t)return T=!0,0;if(e.sourceIndex&&t.sourceIndex)return e.sourceIndex-t.sourceIndex;var n,r,i=[],o=[],u=e.parentNode,a=t.parentNode,f=u;if(u===a)return s(e,t);if(!u)return-1;if(!a)return 1;while(f)i.unshift(f),f=f.parentNode;f=a;while(f)o.unshift(f),f=f.parentNode;n=i.length,r=o.length;for(var l=0;l<n&&l<r;l++)if(i[l]!==o[l])return s(i[l],o[l]);return l===n?s(e,o[l],-1):s(i[l],t,1)},[0,0].sort(x),N=!T,n.uniqueSort=function(e){var t,n=1;T=N,e.sort(x);if(T)for(;t=e[n];n++)t===e[n-1]&&e.splice(n--,1);return e},n.error=function(e){throw new Error("Syntax error, unrecognized expression: "+e)},S=n.compile=function(e,t,n){var r,i,s,u=j[k][e];if(u&&u.context===t)return u;r=o(e,t,n);for(i=0,s=r.length;i<s;i++)r[i]=f(r[i],t,n);return u=j(e,l(r)),u.context=t,u.runs=u.dirruns=0,u},L.querySelectorAll&&function(){var e,t=d,r=/'|\\/g,i=/\=[\x20\t\r\n\f]*([^'"\]]*)[\x20\t\r\n\f]*\]/g,s=[":focus"],u=[":active",":focus"],a=A.matchesSelector||A.mozMatchesSelector||A.webkitMatchesSelector||A.oMatchesSelector||A.msMatchesSelector;it(function(e){e.innerHTML="<select><option selected=''></option></select>",e.querySelectorAll("[selected]").length||s.push("\\["+F+"*(?:checked|disabled|ismap|multiple|readonly|selected|value)"),e.querySelectorAll(":checked").length||s.push(":checked")}),it(function(e){e.innerHTML="<p test=''></p>",e.querySelectorAll("[test^='']").length&&s.push("[*^$]="+F+"*(?:\"\"|'')"),e.innerHTML="<input type='hidden'/>",e.querySelectorAll(":enabled").length||s.push(":enabled",":disabled")}),s=new RegExp(s.join("|")),d=function(e,n,i,u,a){if(!u&&!a&&(!s||!s.test(e)))if(n.nodeType===9)try{return _.apply(i,M.call(n.querySelectorAll(e),0)),i}catch(f){}else if(n.nodeType===1&&n.nodeName.toLowerCase()!=="object"){var l,c,h,p=n.getAttribute("id"),d=p||k,v=Y.test(e)&&n.parentNode||n;p?d=d.replace(r,"\\$&"):n.setAttribute("id",d),l=o(e,n,a),d="[id='"+d+"']";for(c=0,h=l.length;c<h;c++)l[c]=d+l[c].selector;try{return _.apply(i,M.call(v.querySelectorAll(l.join(",")),0)),i}catch(f){}finally{p||n.removeAttribute("id")}}return t(e,n,i,u,a)},a&&(it(function(t){e=a.call(t,"div");try{a.call(t,"[test!='']:sizzle"),u.push(rt.PSEUDO.source,rt.POS.source,"!=")}catch(n){}}),u=new RegExp(u.join("|")),n.matchesSelector=function(t,r){r=r.replace(i,"='$1']");if(!w(t)&&!u.test(r)&&(!s||!s.test(r)))try{var o=a.call(t,r);if(o||e||t.document&&t.document.nodeType!==11)return o}catch(f){}return n(r,null,null,[t]).length>0})}(),y.setFilters.nth=y.setFilters.eq,y.filters=y.pseudos,n.attr=X.attr,X.find=n,X.expr=n.selectors,X.expr[":"]=X.expr.pseudos,X.unique=n.uniqueSort,X.text=n.getText,X.isXMLDoc=n.isXML,X.contains=n.contains}(e);var kt=/Until$/,Lt=/^(?:parents|prev(?:Until|All))/,At=/^.[^:#\[\.,]*$/,Ot=X.expr.match.needsContext,Mt={children:!0,contents:!0,next:!0,prev:!0};X.fn.extend({find:function(e){var t,n,r,i,s,o,u=this;if(typeof e!="string")return X(e).filter(function(){for(t=0,n=u.length;t<n;t++)if(X.contains(u[t],this))return!0});o=this.pushStack("","find",e);for(t=0,n=this.length;t<n;t++){r=o.length,X.find(e,this[t],o);if(t>0)for(i=r;i<o.length;i++)for(s=0;s<r;s++)if(o[s]===o[i]){o.splice(i--,1);break}}return o},has:function(e){var t,n=X(e,this),r=n.length;return this.filter(function(){for(t=0;t<r;t++)if(X.contains(this,n[t]))return!0})},not:function(e){return this.pushStack(f(this,e,!1),"not",e)},filter:function(e){return this.pushStack(f(this,e,!0),"filter",e)},is:function(e){return!!e&&(typeof e=="string"?Ot.test(e)?X(e,this.context).index(this[0])>=0:X.filter(e,this).length>0:this.filter(e).length>0)},closest:function(e,t){var n,r=0,i=this.length,s=[],o=Ot.test(e)||typeof e!="string"?X(e,t||this.context):0;for(;r<i;r++){n=this[r];while(n&&n.ownerDocument&&n!==t&&n.nodeType!==11){if(o?o.index(n)>-1:X.find.matchesSelector(n,e)){s.push(n);break}n=n.parentNode}}return s=s.length>1?X.unique(s):s,this.pushStack(s,"closest",e)},index:function(e){return e?typeof e=="string"?X.inArray(this[0],X(e)):X.inArray(e.jquery?e[0]:e,this):this[0]&&this[0].parentNode?this.prevAll().length:-1},add:function(e,t){var n=typeof e=="string"?X(e,t):X.makeArray(e&&e.nodeType?[e]:e),r=X.merge(this.get(),n);return this.pushStack(u(n[0])||u(r[0])?r:X.unique(r))},addBack:function(e){return this.add(e==null?this.prevObject:this.prevObject.filter(e))}}),X.fn.andSelf=X.fn.addBack,X.each({parent:function(e){var t=e.parentNode;return t&&t.nodeType!==11?t:null},parents:function(e){return X.dir(e,"parentNode")},parentsUntil:function(e,t,n){return X.dir(e,"parentNode",n)},next:function(e){return a(e,"nextSibling")},prev:function(e){return a(e,"previousSibling")},nextAll:function(e){return X.dir(e,"nextSibling")},prevAll:function(e){return X.dir(e,"previousSibling")},nextUntil:function(e,t,n){return X.dir(e,"nextSibling",n)},prevUntil:function(e,t,n){return X.dir(e,"previousSibling",n)},siblings:function(e){return X.sibling((e.parentNode||{}).firstChild,e)},children:function(e){return X.sibling(e.firstChild)},contents:function(e){return X.nodeName(e,"iframe")?e.contentDocument||e.contentWindow.document:X.merge([],e.childNodes)}},function(e,t){X.fn[e]=function(n,r){var i=X.map(this,t,n);return kt.test(e)||(r=n),r&&typeof r=="string"&&(i=X.filter(r,i)),i=this.length>1&&!Mt[e]?X.unique(i):i,this.length>1&&Lt.test(e)&&(i=i.reverse()),this.pushStack(i,e,q.call(arguments).join(","))}}),X.extend({filter:function(e,t,n){return n&&(e=":not("+e+")"),t.length===1?X.find.matchesSelector(t[0],e)?[t[0]]:[]:X.find.matches(e,t)},dir:function(e,n,r){var i=[],s=e[n];while(s&&s.nodeType!==9&&(r===t||s.nodeType!==1||!X(s).is(r)))s.nodeType===1&&i.push(s),s=s[n];return i},sibling:function(e,t){var n=[];for(;e;e=e.nextSibling)e.nodeType===1&&e!==t&&n.push(e);return n}});var _t="abbr|article|aside|audio|bdi|canvas|data|datalist|details|figcaption|figure|footer|header|hgroup|mark|meter|nav|output|progress|section|summary|time|video",Dt=/ jQuery\d+="(?:null|\d+)"/g,Pt=/^\s+/,Ht=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,Bt=/<([\w:]+)/,jt=/<tbody/i,Ft=/<|&#?\w+;/,It=/<(?:script|style|link)/i,qt=/<(?:script|object|embed|option|style)/i,Rt=new RegExp("<(?:"+_t+")[\\s/>]","i"),Ut=/^(?:checkbox|radio)$/,zt=/checked\s*(?:[^=]|=\s*.checked.)/i,Wt=/\/(java|ecma)script/i,Xt=/^\s*<!(?:\[CDATA\[|\-\-)|[\]\-]{2}>\s*$/g,Vt={option:[1,"<select multiple='multiple'>","</select>"],legend:[1,"<fieldset>","</fieldset>"],thead:[1,"<table>","</table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],area:[1,"<map>","</map>"],_default:[0,"",""]},$t=l(P),Jt=$t.appendChild(P.createElement("div"));Vt.optgroup=Vt.option,Vt.tbody=Vt.tfoot=Vt.colgroup=Vt.caption=Vt.thead,Vt.th=Vt.td,X.support.htmlSerialize||(Vt._default=[1,"X<div>","</div>"]),X.fn.extend({text:function(e){return X.access(this,function(e){return e===t?X.text(this):this.empty().append((this[0]&&this[0].ownerDocument||P).createTextNode(e))},null,e,arguments.length)},wrapAll:function(e){if(X.isFunction(e))return this.each(function(t){X(this).wrapAll(e.call(this,t))});if(this[0]){var t=X(e,this[0].ownerDocument).eq(0).clone(!0);this[0].parentNode&&t.insertBefore(this[0]),t.map(function(){var e=this;while(e.firstChild&&e.firstChild.nodeType===1)e=e.firstChild;return e}).append(this)}return this},wrapInner:function(e){return X.isFunction(e)?this.each(function(t){X(this).wrapInner(e.call(this,t))}):this.each(function(){var t=X(this),n=t.contents();n.length?n.wrapAll(e):t.append(e)})},wrap:function(e){var t=X.isFunction(e);return this.each(function(n){X(this).wrapAll(t?e.call(this,n):e)})},unwrap:function(){return this.parent().each(function(){X.nodeName(this,"body")||X(this).replaceWith(this.childNodes)}).end()},append:function(){return this.domManip(arguments,!0,function(e){(this.nodeType===1||this.nodeType===11)&&this.appendChild(e)})},prepend:function(){return this.domManip(arguments,!0,function(e){(this.nodeType===1||this.nodeType===11)&&this.insertBefore(e,this.firstChild)})},before:function(){if(!u(this[0]))return this.domManip(arguments,!1,function(e){this.parentNode.insertBefore(e,this)});if(arguments.length){var e=X.clean(arguments);return this.pushStack(X.merge(e,this),"before",this.selector)}},after:function(){if(!u(this[0]))return this.domManip(arguments,!1,function(e){this.parentNode.insertBefore(e,this.nextSibling)});if(arguments.length){var e=X.clean(arguments);return this.pushStack(X.merge(this,e),"after",this.selector)}},remove:function(e,t){var n,r=0;for(;(n=this[r])!=null;r++)if(!e||X.filter(e,[n]).length)!t&&n.nodeType===1&&(X.cleanData(n.getElementsByTagName("*")),X.cleanData([n])),n.parentNode&&n.parentNode.removeChild(n);return this},empty:function(){var e,t=0;for(;(e=this[t])!=null;t++){e.nodeType===1&&X.cleanData(e.getElementsByTagName("*"));while(e.firstChild)e.removeChild(e.firstChild)}return this},clone:function(e,t){return e=e==null?!1:e,t=t==null?e:t,this.map(function(){return X.clone(this,e,t)})},html:function(e){return X.access(this,function(e){var n=this[0]||{},r=0,i=this.length;if(e===t)return n.nodeType===1?n.innerHTML.replace(Dt,""):t;if(typeof e=="string"&&!It.test(e)&&(X.support.htmlSerialize||!Rt.test(e))&&(X.support.leadingWhitespace||!Pt.test(e))&&!Vt[(Bt.exec(e)||["",""])[1].toLowerCase()]){e=e.replace(Ht,"<$1></$2>");try{for(;r<i;r++)n=this[r]||{},n.nodeType===1&&(X.cleanData(n.getElementsByTagName("*")),n.innerHTML=e);n=0}catch(s){}}n&&this.empty().append(e)},null,e,arguments.length)},replaceWith:function(e){return u(this[0])?this.length?this.pushStack(X(X.isFunction(e)?e():e),"replaceWith",e):this:X.isFunction(e)?this.each(function(t){var n=X(this),r=n.html();n.replaceWith(e.call(this,t,r))}):(typeof e!="string"&&(e=X(e).detach()),this.each(function(){var t=this.nextSibling,n=this.parentNode;X(this).remove(),t?X(t).before(e):X(n).append(e)}))},detach:function(e){return this.remove(e,!0)},domManip:function(e,n,r){e=[].concat.apply([],e);var i,s,o,u,a=0,f=e[0],l=[],h=this.length;if(!X.support.checkClone&&h>1&&typeof f=="string"&&zt.test(f))return this.each(function(){X(this).domManip(e,n,r)});if(X.isFunction(f))return this.each(function(i){var s=X(this);e[0]=f.call(this,i,n?s.html():t),s.domManip(e,n,r)});if(this[0]){i=X.buildFragment(e,this,l),o=i.fragment,s=o.firstChild,o.childNodes.length===1&&(o=s);if(s){n=n&&X.nodeName(s,"tr");for(u=i.cacheable||h-1;a<h;a++)r.call(n&&X.nodeName(this[a],"table")?c(this[a],"tbody"):this[a],a===u?o:X.clone(o,!0,!0))}o=s=null,l.length&&X.each(l,function(e,t){t.src?X.ajax?X.ajax({url:t.src,type:"GET",dataType:"script",async:!1,global:!1,"throws":!0}):X.error("no ajax"):X.globalEval((t.text||t.textContent||t.innerHTML||"").replace(Xt,"")),t.parentNode&&t.parentNode.removeChild(t)})}return this}}),X.buildFragment=function(e,n,r){var i,s,o,u=e[0];return n=n||P,n=!n.nodeType&&n[0]||n,n=n.ownerDocument||n,e.length===1&&typeof u=="string"&&u.length<512&&n===P&&u.charAt(0)==="<"&&!qt.test(u)&&(X.support.checkClone||!zt.test(u))&&(X.support.html5Clone||!Rt.test(u))&&(s=!0,i=X.fragments[u],o=i!==t),i||(i=n.createDocumentFragment(),X.clean(e,n,i,r),s&&(X.fragments[u]=o&&i)),{fragment:i,cacheable:s}},X.fragments={},X.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(e,t){X.fn[e]=function(n){var r,i=0,s=[],o=X(n),u=o.length,a=this.length===1&&this[0].parentNode;if((a==null||a&&a.nodeType===11&&a.childNodes.length===1)&&u===1)return o[t](this[0]),this;for(;i<u;i++)r=(i>0?this.clone(!0):this).get(),X(o[i])[t](r),s=s.concat(r);return this.pushStack(s,e,o.selector)}}),X.extend({clone:function(e,t,n){var r,i,s,o;X.support.html5Clone||X.isXMLDoc(e)||!Rt.test("<"+e.nodeName+">")?o=e.cloneNode(!0):(Jt.innerHTML=e.outerHTML,Jt.removeChild(o=Jt.firstChild));if((!X.support.noCloneEvent||!X.support.noCloneChecked)&&(e.nodeType===1||e.nodeType===11)&&!X.isXMLDoc(e)){p(e,o),r=d(e),i=d(o);for(s=0;r[s];++s)i[s]&&p(r[s],i[s])}if(t){h(e,o);if(n){r=d(e),i=d(o);for(s=0;r[s];++s)h(r[s],i[s])}}return r=i=null,o},clean:function(e,t,n,r){var i,s,o,u,a,f,c,h,p,d,m,g,y=t===P&&$t,b=[];if(!t||typeof t.createDocumentFragment=="undefined")t=P;for(i=0;(o=e[i])!=null;i++){typeof o=="number"&&(o+="");if(!o)continue;if(typeof o=="string")if(!Ft.test(o))o=t.createTextNode(o);else{y=y||l(t),c=t.createElement("div"),y.appendChild(c),o=o.replace(Ht,"<$1></$2>"),u=(Bt.exec(o)||["",""])[1].toLowerCase(),a=Vt[u]||Vt._default,f=a[0],c.innerHTML=a[1]+o+a[2];while(f--)c=c.lastChild;if(!X.support.tbody){h=jt.test(o),p=u==="table"&&!h?c.firstChild&&c.firstChild.childNodes:a[1]==="<table>"&&!h?c.childNodes:[];for(s=p.length-1;s>=0;--s)X.nodeName(p[s],"tbody")&&!p[s].childNodes.length&&p[s].parentNode.removeChild(p[s])}!X.support.leadingWhitespace&&Pt.test(o)&&c.insertBefore(t.createTextNode(Pt.exec(o)[0]),c.firstChild),o=c.childNodes,c.parentNode.removeChild(c)}o.nodeType?b.push(o):X.merge(b,o)}c&&(o=c=y=null);if(!X.support.appendChecked)for(i=0;(o=b[i])!=null;i++)X.nodeName(o,"input")?v(o):typeof o.getElementsByTagName!="undefined"&&X.grep(o.getElementsByTagName("input"),v);if(n){m=function(e){if(!e.type||Wt.test(e.type))return r?r.push(e.parentNode?e.parentNode.removeChild(e):e):n.appendChild(e)};for(i=0;(o=b[i])!=null;i++)if(!X.nodeName(o,"script")||!m(o))n.appendChild(o),typeof o.getElementsByTagName!="undefined"&&(g=X.grep(X.merge([],o.getElementsByTagName("script")),m),b.splice.apply(b,[i+1,0].concat(g)),i+=g.length)}return b},cleanData:function(e,t){var n,r,i,s,o=0,u=X.expando,a=X.cache,f=X.support.deleteExpando,l=X.event.special;for(;(i=e[o])!=null;o++)if(t||X.acceptData(i)){r=i[u],n=r&&a[r];if(n){if(n.events)for(s in n.events)l[s]?X.event.remove(i,s):X.removeEvent(i,s,n.handle);a[r]&&(delete a[r],f?delete i[u]:i.removeAttribute?i.removeAttribute(u):i[u]=null,X.deletedIds.push(r))}}}}),function(){var e,t;X.uaMatch=function(e){e=e.toLowerCase();var t=/(chrome)[ \/]([\w.]+)/.exec(e)||/(webkit)[ \/]([\w.]+)/.exec(e)||/(opera)(?:.*version|)[ \/]([\w.]+)/.exec(e)||/(msie) ([\w.]+)/.exec(e)||e.indexOf("compatible")<0&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(e)||[];return{browser:t[1]||"",version:t[2]||"0"}},e=X.uaMatch(B.userAgent),t={},e.browser&&(t[e.browser]=!0,t.version=e.version),t.chrome?t.webkit=!0:t.webkit&&(t.safari=!0),X.browser=t,X.sub=function(){function e(t,n){return new e.fn.init(t,n)}X.extend(!0,e,this),e.superclass=this,e.fn=e.prototype=this(),e.fn.constructor=e,e.sub=this.sub,e.fn.init=function(n,r){return r&&r instanceof X&&!(r instanceof e)&&(r=e(r)),X.fn.init.call(this,n,r,t)},e.fn.init.prototype=e.fn;var t=e(P);return e}}();var Kt,Qt,Gt,Yt=/alpha\([^)]*\)/i,Zt=/opacity=([^)]*)/,en=/^(top|right|bottom|left)$/,tn=/^(none|table(?!-c[ea]).+)/,nn=/^margin/,rn=new RegExp("^("+V+")(.*)$","i"),sn=new RegExp("^("+V+")(?!px)[a-z%]+$","i"),on=new RegExp("^([-+])=("+V+")","i"),un={},an={position:"absolute",visibility:"hidden",display:"block"},fn={letterSpacing:0,fontWeight:400},ln=["Top","Right","Bottom","Left"],cn=["Webkit","O","Moz","ms"],hn=X.fn.toggle;X.fn.extend({css:function(e,n){return X.access(this,function(e,n,r){return r!==t?X.style(e,n,r):X.css(e,n)},e,n,arguments.length>1)},show:function(){return y(this,!0)},hide:function(){return y(this)},toggle:function(e,t){var n=typeof e=="boolean";return X.isFunction(e)&&X.isFunction(t)?hn.apply(this,arguments):this.each(function(){(n?e:g(this))?X(this).show():X(this).hide()})}}),X.extend({cssHooks:{opacity:{get:function(e,t){if(t){var n=Kt(e,"opacity");return n===""?"1":n}}}},cssNumber:{fillOpacity:!0,fontWeight:!0,lineHeight:!0,opacity:!0,orphans:!0,widows:!0,zIndex:!0,zoom:!0},cssProps:{"float":X.support.cssFloat?"cssFloat":"styleFloat"},style:function(e,n,r,i){if(!e||e.nodeType===3||e.nodeType===8||!e.style)return;var s,o,u,a=X.camelCase(n),f=e.style;n=X.cssProps[a]||(X.cssProps[a]=m(f,a)),u=X.cssHooks[n]||X.cssHooks[a];if(r===t)return u&&"get"in u&&(s=u.get(e,!1,i))!==t?s:f[n];o=typeof r,o==="string"&&(s=on.exec(r))&&(r=(s[1]+1)*s[2]+parseFloat(X.css(e,n)),o="number");if(r==null||o==="number"&&isNaN(r))return;o==="number"&&!X.cssNumber[a]&&(r+="px");if(!u||!("set"in u)||(r=u.set(e,r,i))!==t)try{f[n]=r}catch(l){}},css:function(e,n,r,i){var s,o,u,a=X.camelCase(n);return n=X.cssProps[a]||(X.cssProps[a]=m(e.style,a)),u=X.cssHooks[n]||X.cssHooks[a],u&&"get"in u&&(s=u.get(e,!0,i)),s===t&&(s=Kt(e,n)),s==="normal"&&n in fn&&(s=fn[n]),r||i!==t?(o=parseFloat(s),r||X.isNumeric(o)?o||0:s):s},swap:function(e,t,n){var r,i,s={};for(i in t)s[i]=e.style[i],e.style[i]=t[i];r=n.call(e);for(i in t)e.style[i]=s[i];return r}}),e.getComputedStyle?Kt=function(t,n){var r,i,s,o,u=e.getComputedStyle(t,null),a=t.style;return u&&(r=u[n],r===""&&!X.contains(t.ownerDocument,t)&&(r=X.style(t,n)),sn.test(r)&&nn.test(n)&&(i=a.width,s=a.minWidth,o=a.maxWidth,a.minWidth=a.maxWidth=a.width=r,r=u.width,a.width=i,a.minWidth=s,a.maxWidth=o)),r}:P.documentElement.currentStyle&&(Kt=function(e,t){var n,r,i=e.currentStyle&&e.currentStyle[t],s=e.style;return i==null&&s&&s[t]&&(i=s[t]),sn.test(i)&&!en.test(t)&&(n=s.left,r=e.runtimeStyle&&e.runtimeStyle.left,r&&(e.runtimeStyle.left=e.currentStyle.left),s.left=t==="fontSize"?"1em":i,i=s.pixelLeft+"px",s.left=n,r&&(e.runtimeStyle.left=r)),i===""?"auto":i}),X.each(["height","width"],function(e,t){X.cssHooks[t]={get:function(e,n,r){if(n)return e.offsetWidth===0&&tn.test(Kt(e,"display"))?X.swap(e,an,function(){return E(e,t,r)}):E(e,t,r)},set:function(e,n,r){return b(e,n,r?w(e,t,r,X.support.boxSizing&&X.css(e,"boxSizing")==="border-box"):0)}}}),X.support.opacity||(X.cssHooks.opacity={get:function(e,t){return Zt.test((t&&e.currentStyle?e.currentStyle.filter:e.style.filter)||"")?.01*parseFloat(RegExp.$1)+"":t?"1":""},set:function(e,t){var n=e.style,r=e.currentStyle,i=X.isNumeric(t)?"alpha(opacity="+t*100+")":"",s=r&&r.filter||n.filter||"";n.zoom=1;if(t>=1&&X.trim(s.replace(Yt,""))===""&&n.removeAttribute){n.removeAttribute("filter");if(r&&!r.filter)return}n.filter=Yt.test(s)?s.replace(Yt,i):s+" "+i}}),X(function(){X.support.reliableMarginRight||(X.cssHooks.marginRight={get:function(e,t){return X.swap(e,{display:"inline-block"},function(){if(t)return Kt(e,"marginRight")})}}),!X.support.pixelPosition&&X.fn.position&&X.each(["top","left"],function(e,t){X.cssHooks[t]={get:function(e,n){if(n){var r=Kt(e,t);return sn.test(r)?X(e).position()[t]+"px":r}}}})}),X.expr&&X.expr.filters&&(X.expr.filters.hidden=function(e){return e.offsetWidth===0&&e.offsetHeight===0||!X.support.reliableHiddenOffsets&&(e.style&&e.style.display||Kt(e,"display"))==="none"},X.expr.filters.visible=function(e){return!X.expr.filters.hidden(e)}),X.each({margin:"",padding:"",border:"Width"},function(e,t){X.cssHooks[e+t]={expand:function(n){var r,i=typeof n=="string"?n.split(" "):[n],s={};for(r=0;r<4;r++)s[e+ln[r]+t]=i[r]||i[r-2]||i[0];return s}},nn.test(e)||(X.cssHooks[e+t].set=b)});var pn=/%20/g,dn=/\[\]$/,vn=/\r?\n/g,mn=/^(?:color|date|datetime|datetime-local|email|hidden|month|number|password|range|search|tel|text|time|url|week)$/i,gn=/^(?:select|textarea)/i;X.fn.extend({serialize:function(){return X.param(this.serializeArray())},serializeArray:function(){return this.map(function(){return this.elements?X.makeArray(this.elements):this}).filter(function(){return this.name&&!this.disabled&&(this.checked||gn.test(this.nodeName)||mn.test(this.type))}).map(function(e,t){var n=X(this).val();return n==null?null:X.isArray(n)?X.map(n,function(e,n){return{name:t.name,value:e.replace(vn,"\r\n")}}):{name:t.name,value:n.replace(vn,"\r\n")}}).get()}}),X.param=function(e,n){var r,i=[],s=function(e,t){t=X.isFunction(t)?t():t==null?"":t,i[i.length]=encodeURIComponent(e)+"="+encodeURIComponent(t)};n===t&&(n=X.ajaxSettings&&X.ajaxSettings.traditional);if(X.isArray(e)||e.jquery&&!X.isPlainObject(e))X.each(e,function(){s(this.name,this.value)});else for(r in e)x(r,e[r],n,s);return i.join("&").replace(pn,"+")};var yn,bn,wn=/^(?:toggle|show|hide)$/,En=new RegExp("^(?:([-+])=|)("+V+")([a-z%]*)$","i"),Sn=/queueHooks$/,xn=[L],Tn={"*":[function(e,t){var n,r,i=this.createTween(e,t),s=En.exec(t),o=i.cur(),u=+o||0,a=1,f=20;if(s){n=+s[2],r=s[3]||(X.cssNumber[e]?"":"px");if(r!=="px"&&u){u=X.css(i.elem,e,!0)||n||1;do a=a||".5",u/=a,X.style(i.elem,e,u+r);while(a!==(a=i.cur()/o)&&a!==1&&--f)}i.unit=r,i.start=u,i.end=s[1]?u+(s[1]+1)*n:n}return i}]};X.Animation=X.extend(C,{tweener:function(e,t){X.isFunction(e)?(t=e,e=["*"]):e=e.split(" ");var n,r=0,i=e.length;for(;r<i;r++)n=e[r],Tn[n]=Tn[n]||[],Tn[n].unshift(t)},prefilter:function(e,t){t?xn.unshift(e):xn.push(e)}}),X.Tween=A,A.prototype={constructor:A,init:function(e,t,n,r,i,s){this.elem=e,this.prop=n,this.easing=i||"swing",this.options=t,this.start=this.now=this.cur(),this.end=r,this.unit=s||(X.cssNumber[n]?"":"px")},cur:function(){var e=A.propHooks[this.prop];return e&&e.get?e.get(this):A.propHooks._default.get(this)},run:function(e){var t,n=A.propHooks[this.prop];return this.options.duration?this.pos=t=X.easing[this.easing](e,this.options.duration*e,0,1,this.options.duration):this.pos=t=e,this.now=(this.end-this.start)*t+this.start,this.options.step&&this.options.step.call(this.elem,this.now,this),n&&n.set?n.set(this):A.propHooks._default.set(this),this}},A.prototype.init.prototype=A.prototype,A.propHooks={_default:{get:function(e){var t;return e.elem[e.prop]==null||!!e.elem.style&&e.elem.style[e.prop]!=null?(t=X.css(e.elem,e.prop,!1,""),!t||t==="auto"?0:t):e.elem[e.prop]},set:function(e){X.fx.step[e.prop]?X.fx.step[e.prop](e):e.elem.style&&(e.elem.style[X.cssProps[e.prop]]!=null||X.cssHooks[e.prop])?X.style(e.elem,e.prop,e.now+e.unit):e.elem[e.prop]=e.now}}},A.propHooks.scrollTop=A.propHooks.scrollLeft={set:function(e){e.elem.nodeType&&e.elem.parentNode&&(e.elem[e.prop]=e.now)}},X.each(["toggle","show","hide"],function(e,t){var n=X.fn[t];X.fn[t]=function(r,i,s){return r==null||typeof r=="boolean"||!e&&X.isFunction(r)&&X.isFunction(i)?n.apply(this,arguments):this.animate(O(t,!0),r,i,s)}}),X.fn.extend({fadeTo:function(e,t,n,r){return this.filter(g).css("opacity",0).show().end().animate({opacity:t},e,n,r)},animate:function(e,t,n,r){var i=X.isEmptyObject(e),s=X.speed(t,n,r),o=function(){var t=C(this,X.extend({},e),s);i&&t.stop(!0)};return i||s.queue===!1?this.each(o):this.queue(s.queue,o)},stop:function(e,n,r){var i=function(e){var t=e.stop;delete e.stop,t(r)};return typeof e!="string"&&(r=n,n=e,e=t),n&&e!==!1&&this.queue(e||"fx",[]),this.each(function(){var t=!0,n=e!=null&&e+"queueHooks",s=X.timers,o=X._data(this);if(n)o[n]&&o[n].stop&&i(o[n]);else for(n in o)o[n]&&o[n].stop&&Sn.test(n)&&i(o[n]);for(n=s.length;n--;)s[n].elem===this&&(e==null||s[n].queue===e)&&(s[n].anim.stop(r),t=!1,s.splice(n,1));(t||!r)&&X.dequeue(this,e)})}}),X.each({slideDown:O("show"),slideUp:O("hide"),slideToggle:O("toggle"),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(e,t){X.fn[e]=function(e,n,r){return this.animate(t,e,n,r)}}),X.speed=function(e,t,n){var r=e&&typeof e=="object"?X.extend({},e):{complete:n||!n&&t||X.isFunction(e)&&e,duration:e,easing:n&&t||t&&!X.isFunction(t)&&t};r.duration=X.fx.off?0:typeof r.duration=="number"?r.duration:r.duration in X.fx.speeds?X.fx.speeds[r.duration]:X.fx.speeds._default;if(r.queue==null||r.queue===!0)r.queue="fx";return r.old=r.complete,r.complete=function(){X.isFunction(r.old)&&r.old.call(this),r.queue&&X.dequeue(this,r.queue)},r},X.easing={linear:function(e){return e},swing:function(e){return.5-Math.cos(e*Math.PI)/2}},X.timers=[],X.fx=A.prototype.init,X.fx.tick=function(){var e,t=X.timers,n=0;for(;n<t.length;n++)e=t[n],!e()&&t[n]===e&&t.splice(n--,1);t.length||X.fx.stop()},X.fx.timer=function(e){e()&&X.timers.push(e)&&!bn&&(bn=setInterval(X.fx.tick,X.fx.interval))},X.fx.interval=13,X.fx.stop=function(){clearInterval(bn),bn=null},X.fx.speeds={slow:600,fast:200,_default:400},X.fx.step={},X.expr&&X.expr.filters&&(X.expr.filters.animated=function(e){return X.grep(X.timers,function(t){return e===t.elem}).length});var Nn=/^(?:body|html)$/i;X.fn.offset=function(e){if(arguments.length)return e===t?this:this.each(function(t){X.offset.setOffset(this,e,t)});var n,r,i,s,o,u,a,f={top:0,left:0},l=this[0],c=l&&l.ownerDocument;if(!c)return;return(r=c.body)===l?X.offset.bodyOffset(l):(n=c.documentElement,X.contains(n,l)?(typeof l.getBoundingClientRect!="undefined"&&(f=l.getBoundingClientRect()),i=M(c),s=n.clientTop||r.clientTop||0,o=n.clientLeft||r.clientLeft||0,u=i.pageYOffset||n.scrollTop,a=i.pageXOffset||n.scrollLeft,{top:f.top+u-s,left:f.left+a-o}):f)},X.offset={bodyOffset:function(e){var t=e.offsetTop,n=e.offsetLeft;return X.support.doesNotIncludeMarginInBodyOffset&&(t+=parseFloat(X.css(e,"marginTop"))||0,n+=parseFloat(X.css(e,"marginLeft"))||0),{top:t,left:n}},setOffset:function(e,t,n){var r=X.css(e,"position");r==="static"&&(e.style.position="relative");var i=X(e),s=i.offset(),o=X.css(e,"top"),u=X.css(e,"left"),a=(r==="absolute"||r==="fixed")&&X.inArray("auto",[o,u])>-1,f={},l={},c,h;a?(l=i.position(),c=l.top,h=l.left):(c=parseFloat(o)||0,h=parseFloat(u)||0),X.isFunction(t)&&(t=t.call(e,n,s)),t.top!=null&&(f.top=t.top-s.top+c),t.left!=null&&(f.left=t.left-s.left+h),"using"in t?t.using.call(e,f):i.css(f)}},X.fn.extend({position:function(){if(!this[0])return;var e=this[0],t=this.offsetParent(),n=this.offset(),r=Nn.test(t[0].nodeName)?{top:0,left:0}:t.offset();return n.top-=parseFloat(X.css(e,"marginTop"))||0,n.left-=parseFloat(X.css(e,"marginLeft"))||0,r.top+=parseFloat(X.css(t[0],"borderTopWidth"))||0,r.left+=parseFloat(X.css(t[0],"borderLeftWidth"))||0,{top:n.top-r.top,left:n.left-r.left}},offsetParent:function(){return this.map(function(){var e=this.offsetParent||P.body;while(e&&!Nn.test(e.nodeName)&&X.css(e,"position")==="static")e=e.offsetParent;return e||P.body})}}),X.each({scrollLeft:"pageXOffset",scrollTop:"pageYOffset"},function(e,n){var r=/Y/.test(n);X.fn[e]=function(i){return X.access(this,function(e,i,s){var o=M(e);if(s===t)return o?n in o?o[n]:o.document.documentElement[i]:e[i];o?o.scrollTo(r?X(o).scrollLeft():s,r?s:X(o).scrollTop()):e[i]=s},e,i,arguments.length,null)}}),X.each({Height:"height",Width:"width"},function(e,n){X.each({padding:"inner"+e,content:n,"":"outer"+e},function(r,i){X.fn[i]=function(i,s){var o=arguments.length&&(r||typeof i!="boolean"),u=r||(i===!0||s===!0?"margin":"border");return X.access(this,function(n,r,i){var s;return X.isWindow(n)?n.document.documentElement["client"+e]:n.nodeType===9?(s=n.documentElement,Math.max(n.body["scroll"+e],s["scroll"+e],n.body["offset"+e],s["offset"+e],s["client"+e])):i===t?X.css(n,r,i,u):X.style(n,r,i,u)},n,o?i:t,o,null)}})}),e.jQuery=e.$=X,typeof define=="function"&&define.amd&&define.amd.jQuery&&define("jquery",[],function(){return X})})(window),function(){var e=!1,t=/xyz/.test(function(){xyz})?/\b_super\b/:/.*/;this.Class=function(){},Class.extend=function(n){function o(){!e&&this.init&&this.init.apply(this,arguments)}var r=this.prototype;e=!0;var i=new this;e=!1;for(var s in n)i[s]=typeof n[s]=="function"&&typeof r[s]=="function"&&t.test(n[s])?function(e,t){return function(){var n=this._super;this._super=r[e];var i=t.apply(this,arguments);return this._super=n,i}}(s,n[s]):n[s];return o.prototype=i,o.prototype.constructor=o,o.extend=arguments.callee,o}}(),Function.prototype.bind||(Function.prototype.bind=function(e){if(typeof this!="function")throw new TypeError("Function.prototype.bind - what is trying to be bound is not callable");var t=Array.prototype.slice.call(arguments,1),n=this,r=function(){},i=function(){return n.apply(this instanceof r?this:e||window,t.concat(Array.prototype.slice.call(arguments)))};return r.prototype=this.prototype,i.prototype=new r,i}),define("lib/classframework",[],function(){});var Class,Appstore;prof.markTime("^define_api/appstore"),define("api/appstore",{_toUriInner:function(e,t,n,r){var i={string:"S",bool:"B","byte":"b","char":"c","double":"d","float":"f","int":"i","long":"l","short":"s"},s=null,o=null,u=null,a=null;n&&t.push("scheme="+n+";"),e.action&&t.push("action="+encodeURI(e.action)+";");if(e.categories)for(s=0;s<e.categories.length;s+=1)t.push("category="+encodeURI(e.categories[s])+";");e.type&&t.push("type="+encodeURI(e.type,"/")+";"),e.flags&&t.push("launchFlags=0x"+e.flags.toString(16)+";"),e.packageName&&t.push("package="+encodeURI(e.packageName)+";"),e.className&&(e.packageName||(e.packageName="com.amazon.venezia"),t.push("component="+e.packageName+"/"+e.className+";"));if(e.extras)for(o in e.extras)e.extras.hasOwnProperty(o)&&(u=e.extras[o],a=u.type||"string",t.push(i[a]+"."+encodeURI(o)+"="+encodeURI(typeof u=="string"?u:String(u.value))+";"))},toUri:function(e,t){var n,r,i,s=e.data,o=[],u=null;if(window.ActivityBridge)return JSON.stringify(e);if(s){if(t){n=s.length;for(i=0;i<n;i+=1){r=s.charAt(i);if(!(r>="a"&&r<="z"||r>="A"&&r<="Z"||r==="."||r==="-")){if(r===":"&&i>0){u=s.substring(0,i),o.push("intent:"),s=s.substring(i+1);break}i=n}}}o.push(s)}else t&&o.push("intent:");return o.push("#Intent;"),Appstore._toUriInner(e,o,u),o.push("end"),o.join("")},Error:Class.extend({init:function(e,t){this.type=e,this.reason=t}}),LocalDetails:Class.extend({init:function(){this.androidVersionName=null,this.androidPackageName=null,this.isPurchased=null,this.isDownloaded=null,this.isInstalled=null,this.state="none",this.percentage=null,this.pausedReason=null,this.installedContentId=null,this.installedVersion=null,this.downloadFilePath=null,this.hasUpdate=null,this.isAutoUpdateEnabled=null,this.isSavedForLater=null,this.appState="UNKNOWN"}}),CustomerReviewSummary:Class.extend({init:function(){this.averageRating=null,this.numberOfReviews=null}}),App:Class.extend({init:function(){this.local=null,this.packageName=null,this.applicationName=null,this.asin=null,this.iconUrl=null,this.mainProductImageUrl=null,this.developerName=null,this.category=null,this.listPrice=null,this.currentPrice=null,this.currentVersion=null,this.latestVersion=null,this.latestContentId=null,this.customerReviewSummary=null,this.developerId=null,this.isCompatible=null,this.contentType=null,this.deliveryType=null,this.purchaseDate=null,this.isTestDriveEnabled=null}}),Pager:Class.extend({init:function(){this.data=null,this.cursor=null}}),Page:Class.extend({init:function(){this.isLast=!1,this.result=null}})}),prof.markTime("$define_api/appstore"),define("api/bridge",["jquery","api/appstore"],function(e,t){prof.markTime("^define_api/bridge");var n={requestMap:{},persistentCallbackMap:{},onRequestComplete:function(e){var n,r,i;if(!e||!e.requestId){console.log("onRequestComplete called with no response or requestid");return}i=this.requestMap[e.requestId];if(!i){console.log("No requestcallback found for the given requestId"),window.MultiplexedSocketBridge&&window.MultiplexedSocketBridge.sendResponse(JSON.stringify({evaluateResponse:e}));return}delete this.requestMap[e.requestId];if(!i.deferred){console.log("No deferred for given requestCallback");return}e.error?i.deferred.reject(new t.Error(e.errorCode,e.errorReason)):(i.deferred.resolve(e.response),i.cache&&(console.log("Caching bridge response for: "+e.requestId),n=t.Caching,r=typeof i.cache=="object"?i.cache:{},n.setItem(this._getCacheKey(i.request),e.response,r)))},registerPersistentCallback:function(e){var t=e.name+(new Date).getTime(),n=1;while(this.persistentCallbackMap[t]!==undefined)t=e.name+(new Date).getTime()+"-"+n,n+=1;return this.persistentCallbackMap[t]=e,t},onPersistentCallback:function(e){var t,n;console.log("onPersistentCallback: "+e);if(!e||!e.response.id){console.log("onPersistentCallback called with no response or callback id");return}t=e.response.id,console.log("Looking up persistent callback with ID "+t),n=this.persistentCallbackMap[t];if(!n){console.log("No function registered for given id");return}n(e.response)},invoke:function(n,r,i){var s,o,u,a,f,l;f={},f.requestId=(new Date).getTime(),s=typeof n,o=typeof r;if("object"===s&&"function"===o){a=r,f.args=n||{},u=i||e.Deferred();if(this._hasPrefetch(n,u)){console.log("hasPrefetch for: "+JSON.stringify(n));return}f.args.cache?(l=t.Caching.getItem(this._getCacheKey(f)),l?(console.log("Bridge cache hit for: "+f.requestId),u.resolve(l)):(console.log("Bridge cache miss for: "+f.requestId),this._bridgeInvoke(a,f,u,!0,f.args.cache))):this._bridgeInvoke(a,f,u,!0)}else{if("function"!==s||"object"!==o)throw"Invoke call does not match any known configuration";a=n,f.args={},u=r,this._bridgeInvoke(a,f,u,!1)}},_hasPrefetch:function(e,t){var n=this,r=window.WebRequestPrefetch,i=r.Pages,s,o,u,a,f;if(!r||!e||JSON.stringify(e)==="{}"||!t)return!1;if(e.body&&e.body.prefetch===!1)return!1;f=function(e){n._prefetchCallback(t,e)};for(s in i)if(i.hasOwnProperty(s)){o=i[s];if(o===undefined)return!1;for(u in o)if(o.hasOwnProperty(u)){a=o[u];if(a&&a.request&&a.request.args.URI===e.URI&&n._isRequestArgsEqual.call(n,a.request.args,e))return console.log("Retrieving deferred for prefetched ["+s+"]::'"+u+"' request"),a.response===undefined?(a.callbacks=a.callbacks||[],a.callbacks.push(f)):n._prefetchCallback(t,a.response),!0}}return!1},_isRequestArgsEqual:function(e,t){var n=this,r=Object.getOwnPropertyNames(t),i;for(i in t)if(t.hasOwnProperty(i)){if(!e.hasOwnProperty(i))return!1;if(typeof e[i]=="object"&&e[i]!==null&&typeof t[i]=="object"&&t[i]!==null){if(!n._isRequestArgsEqual(e[i],t[i]))return!1}else if(e[i]!==t[i])return!1}return!0},_prefetchCallback:function(e,n){n.error?e.reject(new t.Error(n.errorCode,n.errorReason)):e.resolve(n.response)},_getCacheKey:function(e){if(!e||!e.args||!e.args.cache)return;var t=e.args.cache;return typeof t=="object"&&t.key?t.key:e.args},_bridgeInvoke:function(e,t,n,r,i){this.requestMap[t.requestId]={request:t,deferred:n,cache:i},r&&(t=JSON.stringify(t)),e(t)}};return prof.markTime("$define_api/bridge"),n});var Class,AccountBridge;define("api/account",["jquery","api/appstore","api/bridge"],function(e,t,n){var r=function(){this.AccountDetails=Class.extend({init:function(e,t){this.name=e,this.ecid=t}}),this.getAccountDetails=function(t,r){var i=new e.Deferred;return t&&i.done(t),r&&i.fail(r),window.AccountBridge&&n.invoke(function(e){AccountBridge.getAccountDetails(JSON.stringify(e))},i),i}};return new r});var Class,AuthenticationBridge;define("api/authentication",["jquery","api/appstore","api/bridge"],function(e,t,n){prof.markTime("^define_api/authentication.js");var r,i=function(){this.Error={MISSING_CREDENTIALS:"Appstore.Authentication.MissingCredentials",INVALID_CREDENTIALS:"Appstore.Authentication.InvalidCredentials",DEVICE_NOT_REGISTERED:"Appstore.Authentication.DeviceNotRegistered",DEVICE_ALREADY_REGISTERED:"Appstore.Authentication.DeviceAlreadyRegistered",DEVICE_ALREADY_DEREGISTERED:"Appstore.Authentication.DeviceAlreadyDeregistered",UNKNOWN_ERROR:"Appstore.Authentication.UnknownError",BRIDGE_UNAVAILABLE:"Appstore.Authentication.BridgeUnavailable",SERVICE_EXCEPTION:"Appstore.Authentication.ServiceException",MALFORMED_JSON:"Appstore.Authentication.MalformedJsonException",INVALID_COUNTRY:"Appstore.Authentication.InvalidPFMCOR",MAX_REGISTERED_DEVICES:"Appstore.Authentication.MaxRegisteredDevices",IDENTITY_EXCEPTION:"Appstore.Authentication.IdentityException",UNSUPPORTED_LOCALE:"Appstore.Authentication.UnsupportedLocale"},this.Credentials=Class.extend({init:function(e,t){this.uid=e,this.password=t}}),this.register=function(e,r,i){var s=this.createDeferred(r,i);return!e.uid||!e.password?(s.reject(new t.Error(t.Authentication.Error.MISSING_CREDENTIALS,"Missing user credentials")),s):(window.AuthenticationBridge?n.invoke(function(t){t.args.uid=e.uid,t.args.pwd=e.password,AuthenticationBridge.register(JSON.stringify(t))},s):s.reject(new t.Error(t.Authentication.Error.BRIDGE_UNAVAILABLE,"AuthenticationBridge not available")),s)},this.isRegistered=function(){if(!window.AuthenticationBridge)throw new t.Error(t.Authentication.Error.BRIDGE_UNAVAILABLE,"AuthenticationBridge not available");return AuthenticationBridge.isRegistered()},this.isDcpRegistered=function(){if(!window.AuthenticationBridge)throw new t.Error(t.Authentication.Error.BRIDGE_UNAVAILABLE,"AuthenticationBridge not available");return AuthenticationBridge.isDcpRegistered()},this.deregister=function(e,r){var i=this.createDeferred(e,r);return window.AuthenticationBridge?n.invoke(function(e){AuthenticationBridge.deregister(JSON.stringify(e))},i):i.reject(new t.Error(t.Authentication.Error.BRIDGE_UNAVAILABLE,"AuthenticationBridge not available")),i},this.authenticate=function(e,r,i){var s=this.createDeferred(r,i);return e?(window.AuthenticationBridge?n.invoke(function(t){t.args.pwd=e,AuthenticationBridge.authenticate(JSON.stringify(t))},s):s.reject(new t.Error(t.Authentication.Error.BRIDGE_UNAVAILABLE,"AuthenticationBridge not available")),s):(s.reject(new t.Error(t.Authentication.Error.MISSING_CREDENTIALS,"Missing user credentials")),s)},this.Sso=function(){this.register=function(r,i){var s=new e.Deferred;return r&&s.done(r),i&&s.fail(i),window.AuthenticationBridge?n.invoke(function(e){AuthenticationBridge.ssoRegister(JSON.stringify(e))},s):s.reject(new t.Error(t.Authentication.Error.BRIDGE_UNAVAILABLE,"AuthenticationBridge not available")),s},this.isSupported=function(){if(!window.AuthenticationBridge)throw new t.Error(t.Authentication.Error.BRIDGE_UNAVAILABLE,"AuthenticationBridge not available");return AuthenticationBridge.isSSOSupported()}},this.Sso=new this.Sso,this.createDeferred=function(t,n){var r=new e.Deferred;return t&&r.done(t),n&&r.fail(n),r}};return r=new i,prof.markTime("$define_api/authentication.js"),r});var Class;define("config/mock-config",[],function(){prof.markTime("^define_config/mock-config");var e=Class.extend({init:function(){var e=window.hasOwnProperty("localStorage")&&window.localStorage!==null},SETTINGS_NS:"AppstoreMockSettings.",Settings:{IS_AUTHENTICATED:"IsRegistered",LOCALE:"Locale",ORIENTATION:"Orientation",SCREEN_SIZE:"ScreenSize",SCREEN_DENSITY:"ScreenDensity",IS_SSO_SUPPORTED:"IsSsoSupported",APP_STATUS:"AppStatus",INSTALL_QUEUE:"InstallQueue"},getConfig:function(e){return localStorage.getItem(this.SETTINGS_NS+e)},setConfig:function(e,t){return localStorage.setItem(this.SETTINGS_NS+e,t)}});prof.markTime("$define_config/mock-config")}),define("api/mock",["jquery","config/mock-config"],function(e,t){prof.markTime("^define_api/mock");var n={getConfig:function(e){return(new t).getConfig(e)},setConfig:function(e,n){(new t).setConfig(e,n)},createDeferred:function(t,n){var r=new e.Deferred;return t&&r.done(t),n&&r.fail(n),r},callLater:function(e){setTimeout(e,0)}};return prof.markTime("$define_api/mock"),n});var Class,RecorderBridge;define("api/recorder",["jquery","api/bridge"],function(e,t){prof.markTime("^define_api/recorder");var n,r=function(){var n="AmazonAppStore.";this.Android=Class.extend({init:function(){},i:function(e,t){RecorderBridge.i(e,t)},w:function(e,t){RecorderBridge.w(e,t)},e:function(e,t){RecorderBridge.e(e,t)},d:function(e,t){RecorderBridge.d(e,t)},v:function(e,t){RecorderBridge.v(e,t)},wtf:function(e,t){RecorderBridge.wtf(e,t)}}),this.Android=new this.Android,this.Java=function(){this.Logger=Class.extend({init:function(e){this.loggerName=n+e},entering:function(e,t,n){RecorderBridge.entering(e,t,this.loggerName+":"+n)},exiting:function(e,t,n){RecorderBridge.exiting(e,t,this.loggerName+":"+n)},fine:function(e){RecorderBridge.fine(this.loggerName+":"+e)},finer:function(e){RecorderBridge.finer(this.loggerName+":"+e)},finest:function(e){RecorderBridge.finest(this.loggerName+":"+e)},info:function(e){RecorderBridge.info(this.loggerName+":"+e)},warning:function(e){RecorderBridge.warning(this.loggerName+":"+e)},severe:function(e){RecorderBridge.severe(this.loggerName+":"+e)},log:function(e){RecorderBridge.log(this.loggerName+":"+e)}});var e=this.Logger;this.getLogger=function(e){return new this.Logger(e)}},this.Java=new this.Java,this.Metrics=Class.extend({init:function(){},recordDuration:function(e,t){RecorderBridge.recordDuration(e,t)},recordCount:function(e,t){RecorderBridge.recordCount(e,t)},recordMessage:function(e,t){RecorderBridge.recordMessage(e,t)},recordEvent:function(e,t){t===undefined&&(t={}),RecorderBridge.recordEvent(e,JSON.stringify(t))},recordClickStreamMetric:function(e,t){RecorderBridge.recordClickStreamMetric(e,JSON.stringify(t))},addTracker:function(e,t,n,r,i,s){RecorderBridge.addTracker(e,t,n,r,i,s)},flushLogs:function(){var n=e.Deferred();return t.invoke(function(e){RecorderBridge.flushLogs(JSON.stringify(e))},n),n}}),this.Metrics=new this.Metrics};return n=new r,prof.markTime("$define_api/recorder"),n});var Class;define("api/web-invoker",["require","jquery","api/bridge"],function(e){prof.markTime("^define_api/web-invoker");var t=e("jquery"),n=e("api/bridge"),r,i,s;return i=Class.extend({baseInvoke:{},dsname:{},init:function(e){this.baseInvoke=e.invoke,this.dsname=e.MAS_DEVICE_SERVICE},requiresDeviceInfoMap:{getRankedAsins:{requiresSimpleDeviceInfo:!0},getAsinDetails:{requiresSimpleDeviceInfo:!0},getMappedAsinDetails:{requiresSimpleDeviceInfo:!0},getFeaturedApplication:{requiresSimpleDeviceInfo:!0},getRecommendations:{requiresSimpleDeviceInfo:!0,requiresCustomerId:!0},search:{requiresSimpleDeviceInfo:!0},checkForMASClientUpdate:{requiresSimpleDeviceInfo:!0},getGiftCardBalance:{requiresSimpleDeviceInfo:!0},redeemCode:{requiresSimpleDeviceInfo:!0},createReview:{requiresSimpleDeviceInfo:!0},getCategories:{requiresSimpleDeviceInfo:!0},getNavigationCategories:{requiresSimpleDeviceInfo:!0},submitFeedback:{requiresDeviceInfo:!0}},invoke:function(e,n,r,i,s){console.log("device service invoke "+e+" called.");var o={retryCount:5,backoffRetry:5e3,timeout:2e3,httpMethodType:"POST",cache:!1},u={requiresAuthentication:!0},a,f;return a=t.extend(o,r,u,this.requiresDeviceInfoMap&&this.requiresDeviceInfoMap[e]),f=this.baseInvoke(this.dsname,e,n,a,i,s),f}}),r=Class.extend({MAS_DEVICE_SERVICE:"mas-device-service",IAP_SERVICE:"iap",deviceService:{},init:function(){console.log("webinvoker obj created"),this.deviceService=new i(this)},invoke:function(e,r,i,s,o,u){console.log("invoke "+e+", "+r+" called.");var a,f={},l={},c={};return s&&s.useDeferred?(a=s.useDeferred,delete s.useDeferred):a=t.Deferred(),a.done(o).fail(u),t.extend(c,f),t.extend(c,s),t.extend(c,l),c.service=e,c.relativePath="/"+r,c.body=i,n.invoke(c,function(e){window.WebInvokerBridge.webInvoke(e)},a),a}}),s=new r,prof.markTime("$define_api/web-invoker"),s}),define("api/cor-pfm",["jquery"],function(e){var t=function(){var e=["US","UK","DE","FR","IT","ES","JP","CN"];this.CorPfmMap={US:"ATVPDKIKX0DER",UK:"A1F83G8C2ARO7P",GB:"A1F83G8C2ARO7P",DE:"A1PA6795UKMFR9",FR:"A13V1IB3VIYZZH",ES:"A1RKKUPIHCS9HS",IN:"A21TJRUUN4KGV",IT:"APJ6JRA9NG5V4",JP:"A1VC38T7YXB528",CA:"A2EUQ1WTGCTBG2",CN:"AAHKV2X7AFYLW"},this.corDoesNotMatchPfm=function(e,t){return this.CorPfmMap[e]!==t}};return new t});var Class;define("api/search",["jquery","api/appstore","api/bridge","api/web-invoker","api/cor-pfm"],function(e,t,n,r,i){prof.markTime("^define_api/search");var s,o=function(){this.Error={MISSING_QUERY_TERM:"Appstore.Search.MissingQueryTerm"},this.SortCriteria={RELEVANCE:"relevance",BEST_SELLING:"bestselling",PRICE_LOW_TO_HIGH:"price_low_to_high",PRICE_HIGH_TO_LOW:"price_high_to_low",AVG_CUSTOMER_REVIEW:"avg_customer_review",RELEASE_DATE:"release_date"};var s="allCategories",o="allCategoriesMap",u={},a=i.CorPfmMap;u[a.FR]={parent:{description:"Jeux",id:40,isCarrierNode:!1,name:"b_jeux"},categories:[{description:"Action",id:129,isCarrierNode:!1,name:"b_action"},{description:"Arcade et plate-forme",id:130,isCarrierNode:!1,name:"b_arcade_et_plate_forme"},{description:"Puzzle",id:140,isCarrierNode:!1,name:"b_puzzle"}]},u[a.DE]={parent:{description:"Spiele",id:102,isCarrierNode:!1,name:"b_spiele"},categories:[{description:"Action",id:131,isCarrierNode:!1,name:"b_action"},{description:"Jump & Run",id:135,isCarrierNode:!1,name:"b_jump_run"},{description:"Denkspiele",id:134,isCarrierNode:!1,name:"b_denkspiele"}]},u[a.ES]={parent:{description:"Juegos",id:57,isCarrierNode:!1,name:"b_juegos"},categories:[{description:"Acci&#243;n",id:129,isCarrierNode:!1,name:"b_acci_n"},{description:"Arcade y plataformas",id:130,isCarrierNode:!1,name:"b_arcade_y_plataformas"},{description:"Puzles y concursos",id:141,isCarrierNode:!1,name:"b_puzles_y_concursos"}]},u[a.UK]={parent:{description:"Games",id:26,isCarrierNode:!1,name:"b_games"},categories:[{description:"Action",id:129,isCarrierNode:!1,name:"b_action"},{description:"Arcade",id:131,isCarrierNode:!1,name:"b_arcade"},{description:"Puzzles & Trivia",id:138,isCarrierNode:!1,name:"b_puzzles_trivia"}]},u[a.US]={parent:{description:"Games",id:8,isCarrierNode:!1,name:"b_games"},categories:[{description:"Action",id:801,isCarrierNode:!1,name:"b_games_act"},{description:"Arcade",id:803,isCarrierNode:!1,name:"b_games_arc"},{description:"Casual",id:808,isCarrierNode:!1,name:"b_games_casual"},{description:"Puzzles & Trivia",id:805,isCarrierNode:!1,name:"b_games_puzz"}]},u[a.JP]={parent:{description:"ゲーム",id:26,isCarrierNode:!1,name:"b_games_categories_mobile_apps"},categories:[{description:"アクション",id:27,isCarrierNode:!1,name:"b_action_game_genres_mobile_apps"},{description:"アーケード",id:29,isCarrierNode:!1,name:"b_arcade_game_genres_mobile_apps"},{description:"パズル・クイズ",id:36,isCarrierNode:!1,name:"b_puzzles_and_trivia_game_genres_mobile_apps"}]},u[a.IT]={parent:{description:"Giochi",id:13,isCarrierNode:!1,name:"b_giochi"},categories:[{description:"Azione",id:131,isCarrierNode:!1,name:"b_azione"},{description:"Arcade",id:129,isCarrierNode:!1,name:"b_arcade"},{description:"Rompicapo e Trivia",id:140,isCarrierNode:!1,name:"b_rompicapi_e_trivia"}]},u[a.CN]={parent:{description:"游戏",id:148159071,isCarrierNode:!1,name:"bn_148159071"},categories:[{description:"动作类",id:148751071,isCarrierNode:!1,name:"bn_148751071"},{description:"街机类",id:148753071,isCarrierNode:!1,name:"bn_148753071"},{description:"益智类",id:148760071,isCarrierNode:!1,name:"bn_148760071"}]},this.setSearchHint=function(n){var r=e.Deferred();if(typeof window.SearchBridge=="undefined")throw new t.Error("Error","Could not detect SearchBridge.");return t.Bridge.invoke(function(e){e.args={hint:n},window.SearchBridge.setSearchHint(JSON.stringify(e))},r),r},this.createQuery=function(e,n,r,i){return new t.Search.Query(e,n,r,i)},this.getAllCategoriesMap=function(){var n=e.Deferred(),r=t.Caching.getItem(o);return r?n.resolve(r):t.Search.getCategories({id:0}).done(function(r){var i,s={};i=r.categories,t.TestDrive.shouldShowCategory().always(function(r){r&&r.showTestDrive&&i.push({name:"b_test_drive",id:31,description:t.Resources.getString("test_drive")}),e.map(i,function(e){s[e.name]=e}),t.Caching.setItem(o,s),n.resolve(s)})}).fail(function(e){console.log("getAllCategoriesMap failed"+e),n.reject(e)}),n},this.getCategoryByName=function(t,n,r){var i=e.Deferred();return n&&i.done(n),r&&i.fail(r),this.getAllCategoriesMap().done(function(e){i.resolve(e[t])}).fail(function(e){i.reject(e)}),i},this.getCategories=function(n,i,o){console.log("Entering getCategories with catObj : "+JSON.stringify(n));var u=e.Deferred().done(i).fail(o),a,f;return n.id===0&&(f=t.Caching.getItem(s),f&&(console.log("Fetching allCategories from cache..."),u.resolve(f))),f||(a=r.deviceService.invoke("getCategories",{id:n.id}),a.done(function(e){var r=JSON.parse(e.message);console.log("getCategories response = "+JSON.stringify(e)),t.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Category.Menu.Completed",{categoryName:"all"}),u.resolve(r),n.id===0&&t.Caching.setItem(s,r)}),a.fail(function(e){console.log("getCategories error = "+JSON.stringify(e)),t.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Category.Menu.Failure",{categoryName:"all"}),u.reject(e)})),u},this.getNavigationCategories=function(t,n,i){console.log("Entering getNavigationCategories with catObj : "+JSON.stringify(t));var s=new e.Deferred,o=new e.Deferred;return n&&s.done(n),i&&s.fail(i),o=r.deviceService.invoke("getNavigationCategories",{id:t.id}),o.done(function(e){var t=JSON.parse(e.message);console.log("getNavigationCategories response = "+JSON.stringify(e)),s.resolve(t)}),o.fail(function(e){console.log("getNavigationCategories error = "+JSON.stringify(e)),s.reject(e)}),s},this.getFeaturedCategoriesForCurrentMarketplace=function(t,r){var i=e.Deferred(),s=e.Deferred().done(t).fail(r),o={};return o[a.US]=["b_games","b_news","b_books"],o[a.UK]=["b_games","b_magazines","b_books_comics"],o[a.FR]=["b_jeux","b_magazines","b_livres_et_bandes_dessin_es"],o[a.DE]=["b_spiele","b_zeitschriften","b_b_cher_comics"],o[a.ES]=["b_juegos","b_revistas","b_libros_y_c_mics"],o[a.IT]=["b_giochi","b_riviste","b_libri_e_fumetti"],o[a.JP]=["b_games_categories_mobile_apps","b_magazines_categories_mobile_apps","b_books_and_comics_categories_mobile_apps"],o[a.CN]=["bn_148159071","bn_148165071","bn_148152071"],i.done(function(e){console.log("pfm is "+e);var t=o[e];console.log("categories is "+JSON.stringify(t)),s.resolve(t)}),i.fail(function(e){s.reject()}),n.invoke(function(e){window.CustomerDataBridge.getCustomerPfm(JSON.stringify(e))},i),s},this.getGamesCategoryForCurrentMarketplace=function(t,r){var i=e.Deferred(),s=e.Deferred().done(t).fail(r),o={};return o[a.US]="b_games",o[a.UK]="b_games",o[a.FR]="b_jeux",o[a.DE]="b_spiele",o[a.ES]="b_juegos",o[a.IT]="b_giochi",o[a.JP]="b_games_categories_mobile_apps",o[a.CN]="bn_148159071",i.done(function(e){console.log("pfm is "+e),s.resolve(o[e])}),i.fail(function(e){s.reject()}),n.invoke(function(e){window.CustomerDataBridge.getCustomerPfm(JSON.stringify(e))},i),s},this.getGamesNavigationCategories=function(t,r){var i=e.Deferred(),s=e.Deferred().done(t).fail(r);return i.done(function(e){s.resolve(u[e])}),i.fail(function(e){s.reject(e)}),n.invoke({},function(e){window.CustomerDataBridge.getCustomerPfm(e)},i),s},this.getEntertainmentCategoryForCurrentMarketPlace=function(t,r){var i=e.Deferred(),s=e.Deferred().done(t).fail(r),o={};return o[a.US]="b_ent",o[a.UK]="b_entertainment",o[a.FR]="b_divertissement",o[a.DE]="b_unterhaltung",o[a.ES]="b_entretenimiento",o[a.IT]="b_intrattenimento",o[a.JP]="b_entertainment_categories_mobile_apps",o[a.CN]="bn_148157071",i.done(function(e){console.log("pfm is "+e),s.resolve(o[e])}),i.fail(function(e){s.reject()}),n.invoke(function(e){window.CustomerDataBridge.getCustomerPfm(JSON.stringify(e))},i),s},this.Query=Class.extend({init:function(e,n,r,i,s){if(!e)throw t.Search.Error.MISSING_QUERY_TERM;this.query=e,typeof e=="string"&&(this.terms=e),this.sortApplied=n||t.Search.SortCriteria.RELEVANCE,this.filtersApplied=r||[],this.category=i||{},this.info=s||{},this.sortsAvailable=[t.Search.SortCriteria.RELEVANCE,t.Search.SortCriteria.BEST_SELLING,t.Search.SortCriteria.PRICE_LOW_TO_HIGH,t.Search.SortCriteria.PRICE_HIGH_TO_LOW,t.Search.SortCriteria.AVG_CUSTOMER_REVIEW,t.Search.SortCriteria.RELEASE_DATE],this.filtersAvailable=[],this.start=1,this.cursor="1|"+this.sortApplied},isLastPage:function(){return this.cursor===null||typeof this.cursor=="undefined"},nextPage:function(n,i){var s=new e.Deferred,o,u=this,a,f;return n&&s.done(n),i&&s.fail(i),this.isLastPage()?(s.reject({message:"Next page called on the last page."}),s):(a={terms:[this.terms],cursor:this.cursor,refinementValues:this.filtersApplied,category:this.category,removeIncompatibleApps:!0},o=r.deviceService.invoke("search",a),o.done(function(n){var r,i=JSON.parse(n.message),o=i.results,a=i.refinements,l=i.info;l?console.log("ClickStream-API-Info: "+JSON.stringify(l)):console.log("ClickStream-API-Info: No search info received"),o?console.log("ClickStream-API-Result: "+JSON.stringify(o)):console.log("ClickStream-API-Result: No search results received"),e.isEmptyObject(u.category)||t.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.External.Category.Load.Completed",{categoryName:u.category.name}),u.cursor=i.cursor,u.start+=1,u.filtersAvailable=a,u.info=l,f=new t.Search.Page(o,u.filtersAvailable,u.sortsAvailable,u.category,u.info),f.isLast=u.isLastPage(),s.resolve(f)}),o.fail(function(n){console.log("Query.nextPage.webDeferred.fail; error = "+JSON.stringify(n)),t.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Search.Failure",{pageNumber:u.start}),e.isEmptyObject(u.category)||(t.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Category.Load.Failure",{categoryName:u.category.name}),t.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.External.Category.Load.Failure",{categoryName:u.category.name})),s.reject(n)}),s)},refineQuery:function(e,n,r){return new t.Search.Query(this.query,e||this.sortApplied,n||this.filtersApplied,r||this.category)}}),this.excludeIncompatibleApps=function(t){return e.isArray(t)?e.map(t,function(e){if(e.isCompatible)return e;console.log("Skipped incompatible application: "+e.asin)}):t},this.Page=Class.extend({init:function(e,t,n,r,i){this.apps=e,this.filtersAvailable=t,this.sortsAvailable=n,this.category=r,this.info=i}})};return s=new o,prof.markTime("$define_api/search"),s});var Class;define("api/database",["jquery","api/bridge"],function(e,t){prof.markTime("^define_api/database");var n=Class.extend({init:function(){},execSQL:function(n,r,i,s,o){var u=e.Deferred();return u.done(s),u.fail(o),t.invoke(function(e){e.args={table:n,sql:r,args:i},window.SQLiteDatabaseBridge?SQLiteDatabaseBridge.execSQL(JSON.stringify(e)):u.reject("Running in browser mode.")},u),u},replace:function(n,r,i,s,o){var u,a;return u=e.Deferred(),u.done(s),u.fail(o),a=function(e){if(!window.SQLiteDatabaseBridge){u.reject("Running in browser mode.");return}e.args={table:n,nullColumnHack:r,contentValues:i},SQLiteDatabaseBridge.replace(JSON.stringify(e))},t.invoke(a,u),u},remove:function(n,r,i,s,o){var u,a;return u=e.Deferred(),u.done(s),u.fail(o),a=function(e){if(!window.SQLiteDatabaseBridge){u.reject("Running in browser mode.");return}e.args={table:n,whereClause:r,whereArgs:i},SQLiteDatabaseBridge.remove(JSON.stringify(e))},t.invoke(a,u),u}}),r,i;return r=["?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?","?"],i=r.join(","),n.joinedQuestionMarks=function(e){var t=r.slice(0,e%r.length).join(",");e-=e%r.length;while(e>0)t.length>0&&(t+=","),t+=i,e-=r.length;return t},n.Cursor=Class.extend({init:function(e){this.id=e.id,this.table=e.table,this.sql=e.sql},nextPage:function(n,r,i){var s=e.Deferred().done(n).fail(r),o;return o=function(e){var t,n;e.args={managedQueryId:this.id,table:this.table};if(i){n={offet:"offet",length:"length"};if(i)for(t in i)i.hasOwnProperty(t)&&n.hasOwnProperty(t)&&(e.args[t]=i[t])}window.SQLiteDatabaseBridge?SQLiteDatabaseBridge.nextPage(JSON.stringify(e)):s.reject("Running in browser mode.")},t.invoke(o.bind(this),s),s},close:function(n,r){var i=e.Deferred().done(n).fail(r),s;return s=function(e){e.args={managedQueryId:this.id},window.SQLiteDatabaseBridge?SQLiteDatabaseBridge.closeCursor(JSON.stringify(e)):i.reject("Running in browser mode.")},t.invoke(s.bind(this),i),i}}),prof.markTime("$define_api/database"),n});var Class,LockerBridge;define("api/locker",["jquery","api/mock","api/appstore","api/recorder","api/search","api/database","api/bridge"],function(e,t,n,r,i,s,o){function f(e,t){return function(n){var r=0,i=n.length,s={},o,u;for(r=0;r<i;r+=1)o=n[r],s[o.Asin]=o;for(r=0,i=e.length;r<i;r+=1)o=s[e[r].asin],o&&e[r].version===o.Version&&(e[r].blacklisted=!0);t(e)}}prof.markTime("^define_api/locker");var u=r.Java.getLogger("Locker"),a;return a=Class.extend({init:function(){},clear:function(t,n){var r;return console.log("clear called"),r=e.Deferred(),r.done(t),r.fail(n),o.invoke(function(e){window.LockerBridge?LockerBridge.clearLocker(JSON.stringify(e)):r.reject("Running in browser mode or LockerBridge not available")},r),r},getAppByAsin:function(t,n,r){u.info("getAppByAsin: "+t);if(!t)throw"IllegalArgumentException: asin must be provided";var i=e.Deferred(),s,o;return i.done(n),i.fail(r),s=a.Utils.createAppFromResponse,o="Asin=?",this.queryDB(a.Tables.APPLICATIONS,a.COLUMNS.APP_SUMMARY_COLUMNS,[o],[t],null,function(e){i.resolve(s(e))},function(e){i.reject(e)}),i},getAppByAsinVersion:function(t,n,r,i){u.info("getAppByAsinVersion: "+t);if(!t||!n)throw"IllegalArgumentException: asin and version must be provided";var s=e.Deferred(),o,f;return s.done(r),s.fail(i),o=a.Utils.createAppFromResponse,f=["Asin=?","Version=?"],this.queryDB(a.Tables.APPLICATIONS,a.COLUMNS.APP_SUMMARY_COLUMNS,f,[t,n],null,function(e){s.resolve(o(e))},function(e){s.reject(e)}),s},getAppByPackageName:function(t,n,r){u.info("getAppByPackageName: "+t);if(!t)throw"IllegalArgumentException: packageName must be provided";var i=e.Deferred(),s,o;return i.done(n),i.fail(r),s=a.Utils.createAppFromResponse,o="packageName=?",this.queryDB(a.Tables.APPLICATIONS,a.COLUMNS.APP_SUMMARY_COLUMNS,[o],[t],null,function(e){i.resolve(s(e))},function(e){i.reject(e)}),i},getApps:function(){return new a.LockerQuery(a.Tables.APPLICATIONS,a.COLUMNS.APP_SUMMARY_COLUMNS.concat(a.COLUMNS.LOCAL_DETAILS_COLUMNS),null,null,null)},getLocalDetails:function(e,t,n){u.info("getLocalDetails");if(!e||!e.packageName)throw"IllegalArgumentException";return this.getLocalDetailsByPackageName(e.packageName,t,n)},getLocalDetailsByAsin:function(t,n,r){u.info("getLocalDetailsByAsin: "+t);if(!t)throw"IllegalArgumentException: asin must be provided";var i=e.Deferred(),s=a.Utils.createLocalDetailsFromResponse,o=this,l,c;return i.done(n),i.fail(r),l="Asin=?",c=[t],this.queryDB(a.Tables.APPLICATIONS,a.COLUMNS.LOCAL_DETAILS_COLUMNS,[l],c,null,function(e){var n=s(e);o.getBlacklistedDetailsByAsins([t],f(n,i.resolve),i.reject)},i.reject),i},getLocalDetailsByAsins:function(t,n,r){u.info("getLocalDetailsByAsins: "+t);if(!t||!t.length)throw"IllegalArgumentException: asins must be provided";var i=e.Deferred(),o=this,f=a.Utils.createLocalDetailsMapFromResponse,l;return i.done(n),i.fail(r),l="Asin in ("+s.joinedQuestionMarks(t.length)+")",this.queryDB(a.Tables.APPLICATIONS,a.COLUMNS.LOCAL_DETAILS_COLUMNS,[l],t,null,function(e){var n;n=f(e),o.getBlacklistedDetailsByAsins(t,function(e){var t=0,r=e.length,s={},o,u;for(t=0;t<r;t+=1)o=e[t],s[o.Asin]=o,u=n[o.Asin],u.version===o.Version&&(u.blacklisted=!0);i.resolve(n)},i.reject)},i.reject),i},getLocalDetailsByPackageName:function(t,n,r){u.info("getLocalDetailsByPackageName: "+t);if(!t)throw"IllegalArgumentException: packageName must be provided";var i=e.Deferred(),s=a.Utils.createLocalDetailsFromResponse,o,f;return i.done(n),i.fail(r),o="PackageName=?",f=[t],this.queryDB(a.Tables.APPLICATIONS,a.COLUMNS.LOCAL_DETAILS_COLUMNS,[o],f,null,function(e){i.resolve(s(e))},function(e){i.reject(e)}),i},getBlacklistedDetailsByAsins:function(t,n,r){var i=e.Deferred(),o,u;return i.done(n).fail(r),o="Asin in ("+s.joinedQuestionMarks(t.length)+")",u=t.concat([0]),this.queryDB(a.Tables.BLACKLIST,a.COLUMNS.BLACKLIST_COLUMNS,[o,"BlockedType=?"],u,null,function(e){i.resolve(e)},function(e){i.reject(e)}),i},isAppBlacklisted:function(t,n,r,i){if(!t||!n){i("IllegalArgumentException: asin and version must be provided");return}var s=e.Deferred(),o,u;return s.done(r),s.fail(i),u=["Asin=?","Version=?","BlockedType=?"],this.queryDB(a.Tables.BLACKLIST,a.COLUMNS.BLACKLIST_COLUMNS,u,[t,n,0],null,function(e){var t=e.length>0;s.resolve(t)},function(e){s.reject(e)}),s},isBlacklisted:function(e,t){if(window.LockerBridge)return LockerBridge.isBlacklisted(e,t);throw"Running in browser mode or LockerBridge not available"},queryDB:function(e,t,n,r,i,o,u){console.log("Inside queryDB");var a=function(e){u(e)},f,l;f=this.buildQuery(e,t,n,i),console.log(f),l=new s,l.execSQL(e,f,r,function(e){var t=new s.Cursor(e),n,r;n=[],r=function(e){n.push.apply(n,e.records),e.hasMore==="true"?t.nextPage(r):(o(n),console.log("queryDB Success."),t.close(function(){console.log("Cursor is closed successfully")},a))},t.nextPage(r,a)},a)},buildQuery:function(e,t,n,r){if(!e||!t)throw"Table and columms must be specified";var i="";return i+="SELECT "+this.arrayToString(t,","),i+=" FROM "+this.arrayToString(e,","),n&&(i+=" WHERE "+this.arrayToString(n," and ")),r&&(i+=" ORDER BY "+this.arrayToString(r,",")),i},arrayToString:function(e,t){if(!e)throw"Array is undefined";if(e.constructor!==Array)return e;var n=t,r,i,s;return n||(n=" "),e.join(n)},refresh:function(t,n){console.log("refresh");var r=e.Deferred();return r.done(t),r.fail(n),o.invoke(function(e){window.LockerBridge?LockerBridge.refreshLocker(JSON.stringify(e)):r.reject("Running in browser mode or LockerBridge not available")},r),r},createMockApp:function(e,t,r){var i=null;if(e==="B004SBQGHS"||r==="com.rovio.angryBirds")i=new n.App,i.applicationName="Angry Birds",i.asin="B004SBQGHS",i.category="Games",i.contentType="undefined",i.currentPrice="$0.99",i.currentVersion="0",i.customerReviewSummary=new n.CustomerReviewSummary,i.customerReviewSummary.averageRating=4,i.customerReviewSummary.numberOfReviews=423,i.deliveryType="default",i.developerId="rovio",i.developerName="Rovio",i.iconUrl="http://ecx.images-amazon.com/images/I/61oslpiB2ML._SL500_SS100_.png",i.isCompatible=!0,i.latestContentId="C-1234ANGRYBIRDS1",i.latestVersion=1,i.listPrice="$0.99",i.local=new n.LocalDetails,i.local.androidPackageName="com.rovio.angryBirds",i.local.androidVersionName="1.2.1",i.local.downloadFilePath=null,i.local.hasUpdate=!0,i.local.installedContentId="C-1234ANGRYBIRDS0",i.local.installedVersion=0,i.local.isAutoUpdateEnabled=!1,i.local.isDownloaded=!1,i.local.isInstalled=!0,i.local.isPurchased=!0,i.local.isSavedForLater=!1,i.local.percentage=0,i.local.state="none",i.mainProductImageUrl="http://ecx.images-amazon.com/images/I/61oslpiB2ML._SL500_AA300_.png",i.packageName="com.rovio.angryBirds",i.purchaseDate="Jan 01 2012",1===t&&(i.local.installedContentId="C-1234ANGRYBIRDS1",i.local.installedVersion=1,i.local.hasUpdate=!1);return i}}),a.Tables={APPLICATIONS:"Applications",BLACKLIST:"Blacklist"},a.COLUMNS={LOCAL_DETAILS_COLUMNS:["Asin","VersionCode","Version","InstalledVersion","InstalledContentId","IsUpdateAvailable","IsDownloaded","IsInstalled","IsPurchased","InstallDate","PackageName","LocalState","PausedReason","AutoUpdateStuckFlags","AppState"],APP_SUMMARY_COLUMNS:["Asin","Version","PackageName","Name","Category","DeveloperId","ListPrice","LogoUrl","Price","Rating","ReviewCount","SoldBy","ContentId","IsCompatible","ContentType","DeliveryType","PurchaseDate","MainProductUrl"],BLACKLIST_COLUMNS:["Asin","Version","BlockedType"]},a.STUCK_REASONS=["permissions","signatures","updateError","updateCheckError","sideloaded"],a.STUCK_REASONS_BITS=function(){var e,t,n=1,r={};for(e=0,t=a.STUCK_REASONS.length;e<t;e+=1)r[a.STUCK_REASONS[e]]=n,n*=2;return r}(),a.FilterConfig={app_is_update_available_amzn_filter:{where:"IsUpdateAvailable=1 AND IsCompatible=1"},app_cannot_auto_update_amzn_filter:{where:"IsUpdateAvailable=1 AND AutoUpdateStuckFlags !=0 AND IsCompatible=1"},app_is_update_available_filter:{where:"IsUpdateAvailable=1 AND (AutoUpdateStuckFlags & "+a.STUCK_REASONS_BITS.sideloaded+") = 0 AND IsCompatible=1"},app_cannot_auto_update_filter:{where:"IsUpdateAvailable=1 AND (AutoUpdateStuckFlags & ~"+a.STUCK_REASONS_BITS.sideloaded+") !=0 AND IsCompatible=1"},app_all_available_filter:{where:"AppState = 'AVAILABLE'"},app_is_installed_filter:{where:"IsInstalled=1 AND (AutoUpdateStuckFlags & "+a.STUCK_REASONS_BITS.sideloaded+") = 0"},app_is_not_installed_filter:{where:"IsInstalled!=1 AND AppState = 'AVAILABLE'"},app_name_filter:{whereFn:function(e){return["Name LIKE ? ESCAPE '\\'",["%"+e.keyword.replace(/[\\%_]/g,"\\$&")+"%"]]}}},a.SortConfig={app_sort_name_asc:{orderBy:"Name asc"},app_sort_name_desc:{orderBy:"Name desc"},app_sort_pronunciation_asc:{orderBy:"TitlePronunciation COLLATE LOCALIZED asc"}},a.Utils={createAppFromResponse:function(e){if(!e)return null;var t=[],r,i,s,o;for(r=0;r<e.length;r+=1)i=e[r],s=new n.App,o=new n.CustomerReviewSummary,o.numberOfReviews=i.ReviewCount,s.applicationName=i.Name,s.asin=i.Asin,s.category=i.Category,s.contentType=i.ContentType,s.currentPrice=i.Price,s.currentVersion=i.Version,s.customerReviewSummary=o,s.deliveryType=i.DeliveryType,s.developerId=i.DeveloperId,s.iconUrl=i.LogoUrl,s.isCompatible=i.IsCompatible,s.latestContentId=i.ContentId,s.listPrice=i.ListPrice,s.mainProductImageUrl=i.MainProductUrl,s.packageName=i.PackageName,s.purchaseDate=i.PurchaseDate,s.isTestDriveEnaled=i.isTestDriveEnabled,s.local=a.Utils.createLocalDetailItem(i),t.push(s);return t},createLocalDetailItem:function(e){if(!e)return null;var t=new n.LocalDetails,r,i,s;t.asin=e.Asin,t.androidPackageName=e.PackageName,t.androidVersionName=e.VersionCode,t.hasUpdate=e.IsUpdateAvailable,t.installedContentId=e.InstalledContentId,t.installedVersion=e.InstalledVersion,t.isDownloaded=e.IsDownloaded,t.isInstalled=e.IsInstalled,t.isPurchased=e.IsPurchased,t.installDate=e.InstallDate,t.state=e.LocalState,t.pausedReason=e.PausedReason,t.autoUpdateStuckReasons={},t.appState=e.AppState,t.version=e.Version,t.blacklisted=!1,s=1;for(r=0,i=a.STUCK_REASONS.length;r<i;r+=1)(s&e.AutoUpdateStuckFlags)!==0&&(t.autoUpdateStuckReasons[a.STUCK_REASONS[r]]=a.STUCK_REASONS[r]),s*=2;return t},createLocalDetailsFromResponse:function(e){if(!e)return null;var t=[],n,r,i;for(n=0;n<e.length;n+=1)r=e[n],i=a.Utils.createLocalDetailItem(r),t.push(i);return t},createLocalDetailsMapFromResponse:function(e){var t=a.Utils.createLocalDetailsFromResponse(e),n={},r,i,s,o;if(!t)return null;for(r=0,i=t.length;r<i;r+=1)s=t[r],n[s.asin]=s;return n},getUpdateFilter:function(){var t=e.Deferred();return n.DeviceFeatures.isAmazonDevice().done(function(e){e?n.DeviceFeatures.isNetworkWifi().done(function(e){e?n.DeviceFeatures.isAutoUpdateEnabled().done(function(){t.resolve("app_cannot_auto_update_amzn_filter")}).fail(function(){t.reject("app_is_update_available_amzn_filter")}):t.reject("app_is_update_available_amzn_filter")}):n.DeviceFeatures.isAutoUpdateEnabled().done(function(){t.resolve("app_cannot_auto_update_filter")}).fail(function(){t.reject("app_is_update_available_filter")})}),t}},a.LockerPager=n.Pager.extend({init:function(e){this.cursor=e},nextPage:function(e,t){var r=this.cursor;r.nextPage(function(t){var i=a.Utils.createAppFromResponse(t.records),s;s=new n.Page,s.result=i,s.isLast=t.hasMore!==!0,s.totalCount=t.totalCount,e(s),t.hasMore==="false"&&r.close(null,function(e){console.log("Error closing cursor")}),console.log(JSON.stringify(t))},function(e){console.log(JSON.stringify(e)),t(e)})}}),a.LockerQuery=i.Query.extend({init:function(e,t,n,r,i){this.sortApplied=r||null,this.filtersApplied=i||[],this.table=e||null,this.columns=t||[],this.start=10},refineQuery:function(e,t){return new a.LockerQuery(this.table,this.columns,this.query,e,t)},buildQuery:function(){var e=this.table,t=this.columns,n=this.sortApplied,r=this.filtersApplied,i,s,o,u,f,l,c,h,p,d,v,m,g,y,b;i="SELECT ";if(!e||!t)throw"IllegalArgumentException: the table or columns are null";if(t.length===0)throw"IllegalArgumentException: must specify columns to query";for(f=0;f<t.length;f+=1)l=t[f],f===t.length-1?i+=l:i+=l+", ";i+=" FROM "+e,s="",o=[];if(r){u=a.FilterConfig;for(f=0;f<r.length;f+=1){c=r[f],h=u[c.name].where;if(!h){p=u[c.name].whereFn;if(!p)throw"Filter: "+c.name+" is not configured";h=p(c),o.push.apply(o,h[1]),h=h[0]}f===r.length-1?s+=h:s+=h+" and "}}d="";if(n){v=a.SortConfig;for(m=0;m<n.length;m+=1){g=n[m],y=v[g.name].orderBy;if(!y)throw"Sort: "+g.name+" is not configured";m===n.length-1?d+=y:d+=y+","}}return b=i,s!==""&&(b+=" WHERE "+s),d!==""&&(b+=" ORDER BY "+d),[b,o]},execute:function(t,n){var r=new s,i,o,u,f;return f=this.buildQuery(),this.query=f[0],this.args=f[1],i=e.Deferred(),i.done(t),i.fail(n),r.execSQL(this.table,this.query,this.args,function(e){o=new s.Cursor(e),u=new a.LockerPager(o),i.resolve(u)},function(e){i.reject(e)}),i}}),a.Error={ASIN_NOT_FOUND:"Appstore.Locker.AsinNotFound",ASIN_VERSION_NOT_FOUND:"Appstore.Locker.AsinNotFound",PACKAGE_NOT_FOUND:"Appstore.Locker.PackageNotFound"},a.Instance=new a,prof.markTime("$define_api/locker"),a}),define("api/device-features",["jquery","api/appstore","api/bridge"],function(e,t,n){prof.markTime("^define_api/device-features");var r,i=function(){var r="Mozilla/5.0 (Linux; U; Android 4.0.3; en-us; GT-N7000 Build/IML74K) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30";this.DeviceConstants={VENEZIA_ANDROID_DEVICE_TYPE:"A3GFS040JDOGQR",VENEZIA_OTTER_DEVICE_TYPE:"A12MKLWRTTQEKR",VENEZIA_OTTER2_DEVICE_TYPE:"A3GQ13NO86T9P1",VENEZIA_CANARY_DEVICE_TYPE:"A3DDVBZGFYQ9R9",VENEZIA_GROVER_DEVICE_TYPE:"A1X49L2ICWL61I",VENEZIA_TATE_DEVICE_TYPE:"A2RCJFK4URDQYN",VENEZIA_JEM_DEVICE_TYPE:"A12H34Q8NBY5PA",VENEZIA_JEM_WAN_DEVICE_TYPE:"AEFRIE722DUD5"},this.AmazonDeviceConstants=function(e){var t={},n,r;for(n=0,r=e.length;n<r;n+=1)t[e[n]]=e[n];return t}([this.DeviceConstants.VENEZIA_OTTER_DEVICE_TYPE,this.DeviceConstants.VENEZIA_OTTER2_DEVICE_TYPE,this.DeviceConstants.VENEZIA_TATE_DEVICE_TYPE,this.DeviceConstants.VENEZIA_JEM_DEVICE_TYPE,this.DeviceConstants.VENEZIA_JEM_WAN_DEVICE_TYPE]),this.Keys={CLOUD_LIBRARY:"cloudLibrary",BACKGROUND_INSTALL:"backgroundInstall",IS_WIFI_ONLY:"isWiFiOnly",HANDLE_MARKET_INTENT:"handleMarketIntents",AUTO_APP_UPDATES:"autoAppUpdates",GLOBAL_SETTINGS:"globalSettings",SSO:"sso",PARENTAL_SETTINGS:"parentalSettings",SELF_UPDATE:"selfUpdate"},this.ScreenSize={SMALL:"SMALL",NORMAL:"NORMAL",LARGE:"LARGE",XLARGE:"XLARGE"},this.getAssetLocations=function(t){var r=e.isArray(t)?t:e.makeArray(arguments),i=e.Deferred(),s=e.Deferred();return i.done(function(t){var n=e.map(r,function(e){return t[e]});s.resolve.apply(s,n)}),n.invoke(function(e){e.args=r,window.BootstrapBridge.getAssetLocations(JSON.stringify(e))},i),s},this.getValueOf=function(e){return window.DeviceFeaturesBridge.getValueOf(e)},this.getZeroesTreatment=function(){return window.DeviceFeaturesBridge.getZeroesTreatment()},this.isNetworkConnected=function(){var t=e.Deferred();return window.setTimeout(function(){window.DeviceFeaturesBridge.isNetworkConnected()?t.resolve():t.reject()}),t},this.isAutoUpdateEnabled=function(){var t=e.Deferred();return window.setTimeout(function(){window.DeviceFeaturesBridge.isAutoUpdateEnabled()?t.resolve():t.reject()}),t},this.isWifiOnly=function(){var t=e.Deferred();return window.setTimeout(function(){window.DeviceFeaturesBridge.isWifiOnly()?t.resolve():t.reject()}),t},this.isNotificationSettingsEnabled=function(){var t=e.Deferred(),n=this.isAmazonDevice().pipe(function(e){return!e});return t.resolve(this.getValueOf(this.Keys.BACKGROUND_INSTALL)),e.when(t,n).pipe(function(e,t){return!e||t},function(){return e.Deferred().resolve(!1)})},this.getDeviceType=function(){var t=e.Deferred();return n.invoke(function(e){window.DeviceFeaturesBridge.getDeviceType(JSON.stringify(e))},t),t},this.getDeviceLanguage=function(){var t=e.Deferred();return n.invoke(function(e){window.DeviceFeaturesBridge.getDeviceLanguage(JSON.stringify(e))},t),t},this.isAmazonDevice=function(e,t){var n=this.AmazonDeviceConstants;return this.getDeviceType().pipe(function(e){return Boolean(n[e])}).done(e).fail(t)},this.getCurrentScreenOrientation=function(){var t=e.Deferred();return n.invoke(function(e){window.BootstrapBridge.getCurrentScreenOrientation(JSON.stringify(e))},t),t},this.notifyWebViewDomReady=function(){var t=e.Deferred();return n.invoke(function(e){window.BootstrapBridge.notifyWebViewDomReady(JSON.stringify(e))},t),t},this.getScreenSize=function(){var t=e.Deferred();return n.invoke({},function(e){window.DeviceFeaturesBridge.getScreenSize(e)},t),t},this.getModel=function(){var n=e.Deferred();return t.Bridge.invoke({},function(e){window.DeviceFeaturesBridge.getModel(e)},n),n},this.isNumericKeypadSupported=function(){return navigator.userAgent!==r},this.isTextAreaSupported=function(){return navigator.userAgent!==r},this.isNetworkWifi=function(t,n){var r=e.Deferred().done(t).fail(n);return window.setTimeout(function(){window.DeviceFeaturesBridge?window.DeviceFeaturesBridge.isNetworkWifi()?r.resolve(!0):r.resolve(!1):r.reject()}),r}};return r=new i,prof.markTime("$define_api/device-features"),r}),define("api/get-started",["require","jquery"],function(e){var t=e("jquery"),n=function(){var e=["B008IYS4M6","B0058VW36U","B008K8HLZ6","B007MNV5WU","B0067VKQLE","B0051HNMTI","B008GXHOFW","B004SBX112","B006KSIFLM","B007KQ6XYY","B008LN3DQQ","B005ZKSD5E","B0066T8SDU","B007U8JRWW","B0066T0BTO","B005GMK71E","B008K8H9C6","B007VGXS8M","B0088CT53K","B004N2NWT2","B004SBQGHS","B008245WE0","B0073LWEXK","B007ZTAEZU","B004RJMUJO","B008D2N1ZI","B00874SJJA","B004FOA84A","B004Z92T9W","B0051QAP08","B007MPJQ38","B007SY509M","B004T2QZL8","B0066T8OH0","B005T87QCI","B00884GR0W","B008AKQM4A","B005J0SE54","B007PW1BZY","B008IDU9ZM","B005D9T44G","B0058VCGXU","B005UOK2KY","B008BBCL3E","B005S2FK0U","B004DPC5Y2","B004VMZT6S","B008KBJMVO","B0064XT03U","B0085FECT2","B008LXNHEE","B007XKEXDK","B008I3W1E4","B007N7DB0E","B0066T8M1I","B006C2WLRA","B006C1DH92","B006VW94HQ","B007XKEZ7O","B008J8OH5O","B006P57OEY","B008FC9TEI","B008B0S0XK","B006BDHAX0","B0080JJLBW","B004WGGQPQ","B00768WTXA","B007U7IKVM","B007MT3UCM","B0052UZIFA","B008AM3I72","B007MFY08E","B0081UCIRY","B008H4LBB8","B004SZ1U66","B007R41E8O","B00885MDHM","B006CZ4238","B006RMJ1I2","B007ZRZF8I","B007N5YIOO","B007XWXX3Y","B008JDAC7G","B004VAWWPG","B007MG360G","B008J0FW2Y","B004H2TZTO","B007YT4BX2","B0069TRVWQ","B008K713YC","B005CRRU68","B0074AKEDC"],t=["B007CMROQW","B008JGSM6G","B0086700CM","B008FRA5LY","B008GTV9DO","B008CFVG58","B008GUNBOI","B004SJ3BCI","B007SPMWOM","B00882AZ9I","B008G0HTUU","B005HSL626","B007SYWFRM","B008DGDK64","B0063IH60K","B008G0K9OS","B00820STKI","B007XKEY6Q","B0087TQYUG","B004SJ3AXI","B007ZGO7EM","B008J8MVIE","B008H4MVRG","B007NZV2HK","B004O9G750","B00823EFEY","B0064DBE9I","B007JYI4SU","B007NACZPI","B004UID2LC","B006QC53WG","B008GWPEQ4","B0064TVQ5E","B008CG839O","B00529IOXO","B008FETAQS","B004GVYXTS","B007MTKYQC","B0054JZC6E","B008841TP0","B006VXRNYG","B007Z4AKQI","B004J1OA7K","B004VMUS9G","B005KN4PEE","B00846GKTW","B004H6WTJI","B004GMJKTK","B005K17RU0","B004SVMNXY","B007TBAQCK","B004SOR4H6","B005LIYX5Y","B004SD5GZ4","B004MC8CA2","B004H2MGOU","B007OXASB2","B007KOKIK6","B004N2NWQ0","B004JZBGWI","B005KUHUKS","B0052U1O4Y","B00632HWOG","B00766HXAQ","B0052ZGN18","B0085NVSB4","B007RGPNIY","B0063GORYU","B004K4RY9M","B004HM35RC","B004TI2ZXY","B006UJMHD8","B005KC664W","B007PTJOV0","B006OCM13M","B0089Z3D02","B004IALZTS","B005OYF3BS","B0063GSL60","B00881VLCE","B0064T6LV8","B00769WNK8","B007EUADC4","B0071PARPA","B004KU2JZU","B00846GMHW","B008FF8PT0","B006OCM0G0","B008AVPMLI","B0081UFSGC","B008IE6TY6","B007VUA7VO","B004SIIBGU","B007HGMVIE","B0066W1AZK","B0089M929G","B0062R5GJ0","B004T5R2HQ"];this.getTopPaidAsinsList=function(){return e},this.getTopFreeAsinsList=function(){return t}};return new n}),define("api/catalog",["require","jquery","api/mock","api/appstore","api/locker","api/search","api/device-features","api/bridge","api/get-started","api/web-invoker"],function(e){var t=e("jquery"),n=e("api/mock"),r=e("api/appstore"),i=e("api/locker"),s=e("api/search"),o=e("api/device-features"),u=e("api/bridge"),a=e("api/get-started"),f=e("api/web-invoker"),l=function(){function u(e){return e.results}function l(e){e&&(e.recommendationAsins=e.rankedAsins,e.rankedAsins=[])}var e=this;this.MIN_APPS_TOSHOW=1,this.RANK_TYPE_NEW_RELEASES="NewReleases",this.RANK_TYPE_TOP_SELLERS="TopSellers",this.RANK_TYPE_TOP_FREE="TopFree",this.RANK_TYPE_MOVERS_AND_SHAKERS="MoversAndShakers",this.RECOMMENDATION_TYPES={ASIN:"asin",CATEGORY:"browseNode",NEW:"browseNode"},this.MAS_PAGE_PREFIX="masclient-",this.MAS_PAGE_TYPE=9801,this.Error={UNKNOWN_APP:"Appstore.Catalog.UnknownApp",RANK_TYPE_NOT_FOUND:"Appstore.Catalog.RankTypeNotFound",DEVELOPER_DETAIL_NOT_FOUND:"Appstore.Catalog.DeveloperDetailNotFound",RECOMMENDATION_TYPE_NOT_FOUND:"Appstore.Catalog.RecommendationTypeNotFound"},this.getApp=function(e,t,s){if(!e||!e.packageName)throw"Illegal argument.";var o=n.createDeferred(t,s);return n.callLater(function(){var t=i.createMockApp(null,0,e.packageName);t?o.resolve(t):o.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP))}),o},this.getAppByPackage=function(e,t,s){if(!e)throw"Illegal argument.";var o=n.createDeferred(t,s);return n.callLater(function(){var t=i.createMockApp(null,0,e);t?o.resolve(t):o.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP))}),o},this.getAppDetails=function(n,i,s){var o;return!n||!n.asin?(o=t.Deferred(),s&&o.fail(s),o.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP)),o):(o=e.getAppDetailsByAsin(n.asin,i,s),o)},this.getAppDetailsByAsin=function(e,n,i,s){var o=t.Deferred(),u=t.Deferred().done(n).fail(i),a,l,c={};return e||u.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP)),a=new r.Locker,l=a.getLocalDetailsByAsin(e),o.done(function(e){var t=JSON.parse(e.message);t?t.displayTitle||u.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP)):u.reject(e),l.done(function(e){t.local=e[0],u.resolve(t)})}),o.fail(function(e){u.reject(e)}),s===!0&&(c.prefetch=!1),c.asin=e,f.deviceService.invoke("getAsinDetails",c,{useDeferred:o,cache:!0}),u},this.getGettingStartedApps=function(n,i,s){var o=t.Deferred(),u=t.Deferred().done(i).fail(s),f;if(!n){u.reject(new r.Error(r.Catalog.Error.RANK_TYPE_NOT_FOUND));return}if(n===e.RANK_TYPE_TOP_SELLERS)f=a.getTopPaidAsinsList();else{if(n!==e.RANK_TYPE_TOP_FREE){u.reject(new r.Error(r.Catalog.Error.RANK_TYPE_NOT_FOUND));return}f=a.getTopFreeAsinsList()}return o.done(function(e){var t=JSON.parse(e.message);t?u.resolve(t):u.reject(e)}),o.fail(function(e){u.reject(e)}),r.Bridge.invoke(function(e){e.args.service="mas-device-service",e.args.relativePath="/getAsinListDetails",e.args.body={asins:f},e.args.requiresSimpleDeviceInfo=!0,e.args.retryCount=5,e.args.backoffRetry=5e3,e.args.timeout=2e3,e.args.httpMethodType="POST",window.WebInvokerBridge.webInvoke(JSON.stringify(e))},o),u},this.getGettingStartedApps=function(n,i,s){var o=t.Deferred(),u=t.Deferred().done(i).fail(s),f;if(!n){u.reject(new r.Error(r.Catalog.Error.RANK_TYPE_NOT_FOUND));return}if(n===e.RANK_TYPE_TOP_SELLERS)f=a.getTopPaidAsinsList();else{if(n!==e.RANK_TYPE_TOP_FREE){u.reject(new r.Error(r.Catalog.Error.RANK_TYPE_NOT_FOUND));return}f=a.getTopFreeAsinsList()}return o.done(function(r){var i=JSON.parse(r.message),s;if(!i){u.reject(r);return}if(n===e.RANK_TYPE_TOP_FREE&&t.isArray(i.asinDetails))for(s=i.asinDetails.length-1;s>=0;s-=1)i.asinDetails[s].ourPrice>0&&i.asinDetails.splice(s,1);u.resolve(i)}),o.fail(function(e){u.reject(e)}),r.Bridge.invoke(function(e){e.args.service="mas-device-service",e.args.relativePath="/getAsinListDetails",e.args.body={asins:f},e.args.requiresSimpleDeviceInfo=!0,e.args.retryCount=5,e.args.backoffRetry=5e3,e.args.timeout=2e3,e.args.httpMethodType="POST",window.WebInvokerBridge.webInvoke(JSON.stringify(e))},o),u},this.getAsinByPackageName=function(e,n,i){var s=t.Deferred(),o=t.Deferred().done(n).fail(i);return e||o.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP,i)),s.done(function(e){var t=e&&e.message?JSON.parse(e.message):null;t===null?o.reject(e):t.details.asin||o.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP)),o.resolve({asin:t.details.asin})}),s.fail(function(e){o.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP,e))}),f.deviceService.invoke("getMappedAsinDetails",{externalId:e},{useDeferred:s}),o},this.getIcon=function(e,t,i){if(!e||!e.asin)throw"Illegal argument.";var s=n.createDeferred(t,i);return n.callLater(function(){e.asin!=="B004SBQGHS"?s.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP)):s.resolve("http://ecx.images-amazon.com/images/I/61oslpiB2ML._SL500_SS100_.png")}),s},this.getMainProductImage=function(e,t,i){if(!e||!e.asin)throw"Illegal argument.";var s=n.createDeferred(t,i);return n.callLater(function(){e.asin!=="B004SBQGHS"?s.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP)):s.resolve("http://ecx.images-amazon.com/images/I/61oslpiB2ML._SL500_AA300_.png")}),s},this.getScreenshots=function(e,t,i){if(!e||!e.asin)throw"Illegal argument.";var s=n.createDeferred(t,i),o,u;return n.callLater(function(){if(e.asin!=="B004SBQGHS")s.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP));else{o=[];for(u=1;u<=5;u+=1)o.push("http://screenshot.url."+u);s.resolve(o)}}),s},this.getVideos=function(e,t,i){if(!e||!e.asin)throw"Illegal argument.";var s=n.createDeferred(t,i),o,u;return n.callLater(function(){if(e.asin!=="B004SBQGHS")s.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP));else{o=[];for(u=1;u<=5;u+=1)o.push("http://video.url."+u);s.resolve(o)}}),s},this.getMostHelpfulReviews=function(e,n,r){if(!e)throw"Illegal argument.";var i=t.Deferred(),s=t.Deferred().done(n).fail(r),o;return i.done(function(e){s.resolve(JSON.parse(e.message))}),i.fail(function(e){s.reject(e)}),o={asin:e,pagination:{startOffset:0,pageSize:3},sortBy:{sortBy:"byHelpfulVotesDescending"}},f.deviceService.invoke("getReviews",o,{useDeferred:i}),s},this.getReviews=function(e,n,r){if(!e)throw"Illegal argument.";var i=t.Deferred(),s=t.Deferred().done(n).fail(r),o;return i.done(function(e){s.resolve(JSON.parse(e.message))}),i.fail(function(e){s.reject(e)}),o={asin:e,pagination:{startOffset:0,pageSize:16},sortBy:{sortBy:"bySubmissionDateDescending"}},f.deviceService.invoke("getReviews",o,{useDeferred:i}),s},this.getAppsByCategory=function(e,n,i){var s,o=t.Deferred();return n&&o.done(n),i&&o.fail(i),s=r.Search.createQuery("*",null,null,e),s.nextPage(o.resolve,o.reject),o},this.getFeaturedApps=function(e,n){var i,s=t.Deferred().done(e).fail(n);return i=f.deviceService.invoke("getFeaturedApplication",{}),i.done(function(e){var t=JSON.parse(e.message);t.featuredAsins=r.Search.excludeIncompatibleApps(t.featuredAsins),s.resolve(t)}),i.fail(function(e){s.reject(e)}),s},this.getDeviceSlot=function(e){var n=t.Deferred(),r=o.DeviceConstants;return o.getDeviceType().done(function(t){t===r.VENEZIA_OTTER_DEVICE_TYPE?n.resolve(e+"-0"):t===r.VENEZIA_OTTER2_DEVICE_TYPE?n.resolve(e+"-0"):t===r.VENEZIA_ANDROID_DEVICE_TYPE?n.resolve(e+"-1"):t===r.VENEZIA_CANARY_DEVICE_TYPE?n.resolve(e+"-2"):t===r.VENEZIA_TATE_DEVICE_TYPE?n.resolve(e+"-3"):t===r.VENEZIA_JEM_DEVICE_TYPE?n.resolve(e+"-3"):t===r.VENEZIA_JEM_WAN_DEVICE_TYPE?n.resolve(e+"-3"):n.reject("Error: Unknown device type: "+t)}),n},this.getDynamicWidgets=function(n,r){function u(e){var n=null;return t.map(e,function(e,t){t===o&&(n=e)}),n}var i=t.Deferred(),s=t.Deferred(),o;return e.getDeviceSlot(r).done(function(t){var r={pageId:e.MAS_PAGE_PREFIX+n,pageType:e.MAS_PAGE_TYPE,slotIds:[t]};o=t,f.deviceService.invoke("getDynamicWidgets",r,{useDeferred:i})}).fail(function(e){s.reject(e)}),i.done(function(e){var n=JSON.parse(e.message),r=u(n.widgets),i,o={};try{r.extensions.billboard=r.extensions.billboard.replace(/'/g,'"'),i=JSON.parse(r.extensions.billboard);if(!(t.isArray(i)&&i.length>0))throw new Error("Billboard attribute is not an array");o.asins=r.asins,o.images=r.images,o.billboard=i,s.resolve(o)}catch(a){s.reject(a)}}),i.fail(function(e){s.reject(e)}),s},this.getRankedApps=function(n,i,o,u){var a=t.Deferred(),l,c,h,p=u||10;return console.log("catalog: getRankedApps rankType "+n),h=new s.Query("getRankedApps query"),h.start=0,h.nextPage=function(e,n){var i,s,u,a,f,l,c,d,v=h.results.rankedAsins;l=t.Deferred(),l.done(e),l.fail(n);if(!v)throw console.log("the query returned by getRankedApps is not holding results"),"NullPointerException";i=h.start,s=i*p;if(o&&o<=h.start||s>=v.length)u=new r.Search.Page([]),u.isLast=!0,l.resolve(u);a=Math.min(p,v.length-s),f=[];for(c=0;c<a;c+=1)f.push(v[c+s]);return h.start=i+1,console.log("Debug getRankedApps, tokenInt: "+i+" offset: "+s+" query.start: "+h.start+" pages: "+o),d=new r.Search.Page(f),d.isLast=!1,l.resolve(d),l},c={nodeName:i,removeIncompatibleApps:!0,rank:function(t){if(n===t.RANK_TYPE_NEW_RELEASES)return"new-releases";if(n===t.RANK_TYPE_TOP_SELLERS)return"top-sellers";if(n===t.RANK_TYPE_TOP_FREE)return"top-free";if(n===t.RANK_TYPE_MOVERS_AND_SHAKERS)return"movers-and-shakers"}(e)},u!==undefined&&(c.pageSize=u),c.rank?(l=f.deviceService.invoke("getRankedAsins",c,{cache:!0}),l.done(function(t){h.results=JSON.parse(t.message),h.results.rankedAsins=r.Search.excludeIncompatibleApps(h.results.rankedAsins),h.results.rankedAsins&&console.log("catalog.getRankedApps() rankedAsins.length "+h.results.rankedAsins.length),h.results.rankedAsins&&h.results.rankedAsins.length>=e.MIN_APPS_TOSHOW?a.resolve(h):e.getGettingStartedApps(n,function(e){h.results=e,h.results.rankedAsins=r.Search.excludeIncompatibleApps(h.results.asinDetails),h.results.asinDetails={},a.resolve(h)},function(e){console.log("Error in retrieving getStarted: "+e),a.reject(e)})}),l.fail(function(e){a.reject(e)}),a):a.reject(new r.Error(e.Error.RANK_TYPE_NOT_FOUND))},this.getRecommendedApps=function(e,n,i){var s=t.Deferred(),o=t.Deferred(),u={};return console.log("getRecommendedApps called."),u.type=e,u.removeIncompatibleApps=!0,i!==undefined&&(u.pageSize=i),console.log("getRecommendedApps invoking web method."),o=f.deviceService.invoke("getRecommendations",u,{cache:!0}),o.done(function(e){console.log("getRecommendedApps web method done.");var i=JSON.parse(e.message);i.recommendationAsins=r.Search.excludeIncompatibleApps(i.recommendationAsins),t.isArray(i.recommendationAsins)&&i.recommendationAsins.length?(console.log("getRecommendedApps web method done, resolving."),s.resolve(i)):(console.log("getRecommendedApps web method done, fallback called."),n(s))}),o.fail(function(e){console.log("getRecommendedApps web method failed."),s.reject(e)}),s},this.getRecommendedForYouApps=function(t){function n(n){var r=e.getRankedApps(e.RANK_TYPE_MOVERS_AND_SHAKERS,null,null,t).pipe(u);r.done(function(e){l(e),n.resolve(e)}).fail(function(e){console.log("moversAndShakers: error: "+e),n.reject(e)})}return console.log("getRecommendedForYouApps called!"),e.getRecommendedApps("CATEGORY",n,t)},this.getNewForYouApps=function(t){function n(n){var r=e.getRankedApps(e.RANK_TYPE_NEW_RELEASES,null,null,t).pipe(u);r.done(function(e){l(e),n.resolve(e)}).fail(function(e){console.log("newReleases: error: "+e),n.reject(e)})}return console.log("getNewForYouApps called!"),e.getRecommendedApps("NEW",n,t)},this.getRelatedApps=function(e,n,i){console.log("getRelatedApps called!");var s,o=t.Deferred(),u;return e||o.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP)),n&&o.done(n),i&&o.fail(i),u={asin:e,type:"ASIN",removeIncompatibleApps:!0},s=f.deviceService.invoke("getRecommendations",u),s.done(function(e){var t=JSON.parse(e.message);t.recommendationAsins=r.Search.excludeIncompatibleApps(t.recommendationAsins),o.resolve(t)}),s.fail(function(e){o.reject(e)}),o},this.getDeveloperDetails=function(n,i,s){var o;return!n||!n.asin?(o=t.Deferred(),s&&o.fail(s),o.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP)),o):(o=e.getDeveloperDetailsByAsin(n.asin,i,s),o)},this.getDeveloperDetailsByAsin=function(e,n,i){var s,o=t.Deferred();return e||o.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP)),n&&o.done(n),i&&o.fail(i),s=f.deviceService.invoke("getDeveloperDetails",{asin:e}),s.done(function(e){o.resolve(JSON.parse(e.message))}),s.fail(function(e){o.reject(e)}),o},this.getOtherAppsByDeveloper=function(e,n,i){var s,o,u=t.Deferred();return(!e||!e.asin||!e.developerName)&&u.reject(new r.Error(r.Catalog.Error.UNKNOWN_APP)),n&&u.done(n),i&&u.fail(i),o={refinementValues:[{displayName:"Developer",value:e.developerName,name:"brandtextbin"}]},s=f.deviceService.invoke("search",o),s.done(function(n){var i=JSON.parse(n.message),s=!1;i.results=r.Search.excludeIncompatibleApps(i.results),i.results=t.grep(i.results,function(t){return t.asin!==e.asin}),i.results.length===0&&(s=!0),u.resolve(i,s)}),s.fail(function(e){u.reject(e)}),u}};return new l}),define("api/customer-data",["jquery","api/bridge"],function(e,t){prof.markTime("^define_api/customer-data");var n,r=function(){this.getCustomerPfm=function(){var n=e.Deferred();return t.invoke(function(e){window.CustomerDataBridge.getCustomerPfm(JSON.stringify(e))},n),n},this.getCustomerCor=function(){var n=e.Deferred();return t.invoke(function(e){window.CustomerDataBridge.getCustomerCor(JSON.stringify(e))},n),n},this.getCustomerCorPfm=function(){var n=e.Deferred(),r=e.Deferred();return t.invoke(function(e){window.CustomerDataBridge.getCustomerCorPfm(JSON.stringify(e))},r),r.done(function(e){e!==undefined&&e.cor&&e.pfm?(console.log("CORPFM-API-getCustomerCorPfm: "+JSON.stringify(e)),n.resolve(e.cor,e.pfm)):(console.log("CORPFM-API-getCustomerCorPfm: Invalid COR/PFM returned"),n.reject("Invalid COR/PFM returned"))}).fail(function(){console.log("CORPFM-API-getCustomerCorPfm: something bad happened while retreiving COR/PFM"),n.reject("something bad happened while retreiving CoR/PFM")}),n},this.isUSPfm=function(){var n=e.Deferred();return t.invoke(function(e){window.CustomerDataBridge.isUSPfm(JSON.stringify(e))},n),n},this.isUSPfmSync=function(){return window.CustomerDataBridge.isUSPfmSync()}};return n=new r,prof.markTime("$define_api/customer-data"),n});var Class;define("api/preferences",["jquery","api/bridge"],function(e,t){prof.markTime("^define_api/preferences");var n,r=Class.extend({init:function(){},getValue:function(n,r,i,s,o){var u=e.Deferred();return s&&u.done(s),o&&u.fail(o),window.SharedPreferencesBridge&&t.invoke(function(e){e.args.key=r,e.args.defValue=i,window.SharedPreferencesBridge["get"+n](JSON.stringify(e))},u),u},putValue:function(n,r,i,s,o){var u=e.Deferred();return s&&u.done(s),o&&u.fail(o),window.SharedPreferencesBridge&&t.invoke(function(e){e.args.key=r,e.args.value=i,window.SharedPreferencesBridge["put"+n](JSON.stringify(e))},u),u},getBoolean:function(e,t,n,r){return this.getValue("Boolean",e,t,n,r)},putBoolean:function(e,t,n,r){return this.putValue("Boolean",e,t,n,r)},getString:function(e,t,n,r){return this.getValue("String",e,t,n,r)},putString:function(e,t,n,r){return this.putValue("String",e,t,n,r)},getInteger:function(e,t,n,r){return this.getValue("Integer",e,t,n,r)},putInteger:function(e,t,n,r){return this.putValue("Integer",e,t,n,r)},getFloat:function(e,t,n,r){return this.getValue("Float",e,t,n,r)},putFloat:function(e,t,n,r){return this.putValue("Float",e,t,n,r)},getLong:function(e,t,n,r){return this.getValue("Long",e,t,n,r)},putLong:function(e,t,n,r){return this.putValue("Long",e,t,n,r)}});return n=new r,prof.markTime("$define_api/preferences"),n});var Class;define("api/device",["require","jquery","api/bridge","api/authentication","api/preferences","api/web-invoker"],function(e){prof.markTime("^define_api/device");var t=e("jquery"),n=e("api/bridge"),r=e("api/authentication"),i=e("api/preferences"),s=e("api/web-invoker"),o="com.amazon.mas.client.framework.MyServiceImpl.lastUpdateNotify",u="com.amazon.venezia",a=/[a-z]+-\d+\.\d+/,f,l,c,h;return f=Class.extend({init:function(){},getPackageVersion:function(e,r,i){var s=t.Deferred(),o=t.Deferred();return s.done(r).fail(i),e===u&&c?(s.resolve(c),s):(o.done(function(t){e===u&&(c=t.version),s.resolve(t.version)}),o.fail(function(e){console.log(JSON.stringify(e)),s.reject(e)}),n.invoke(function(t){t.args={packageName:e},window.DeviceBridge.getPackageVersion(JSON.stringify(t))},o),s)},getTrimmedVersionName:function(e){var t=e===u,n;return t&&h?h:(n=a.exec(e)[0],t&&(h=n),n)},getAppstoreVersion:function(e,t){return this.getPackageVersion(u,e,t)},getAppstoreResourcesUpdateVersion:function(e,r){var i=t.Deferred(),s=t.Deferred();return i.done(e).fail(r),s.done(function(e){i.resolve(e.version,e.lastUpdated)}),s.fail(function(e){i.reject(e)}),n.invoke(function(e){window.DeviceBridge.getAppstoreResourcesUpdateVersion(JSON.stringify(e))},s),i},checkForClientUpdate:function(e,n){var i=this;return r.isRegistered()?this.shouldNotifyAboutUpdate().pipe(function(e){var n=t.Deferred();return e?{updateExists:!0,alreadyDownloaded:!0}:(i.getPackageVersion(u,function(e){e=i.getTrimmedVersionName(e);var t={currentVersion:e};s.deviceService.invoke("checkForMASClientUpdate",t,{useDeferred:n})},function(e){n.reject(e)}),n.pipe(function(e){return JSON.parse(e.message)},function(e){return e}))},function(){return"Could not check for update."}).done(e).fail(n):t.Deferred().reject(r.Error.DEVICE_NOT_REGISTERED).fail(n)},shouldNotifyAboutUpdate:function(e,r){var i=t.Deferred(),s=t.Deferred();return i.done(e).fail(r),s.done(function(e){i.resolve(e.notify)}).fail(function(e){i.fail(e)}),n.invoke(function(e){window.DeviceBridge.shouldNotifyAboutUpdate(JSON.stringify(e))},s),i},flagNotifiedAboutUpdate:function(e,r){var i=t.Deferred(),s=t.Deferred();return i.done(e).fail(r),s.done(function(e){i.resolve(e)}).fail(function(e){i.fail(e)}),n.invoke(function(e){window.DeviceBridge.flagNotifiedAboutUpdate(JSON.stringify(e))},s),i},clearNotifiedAboutUpdate:function(e,t){return i.putLong(o,0,e,t)},performUpdate:function(e,r){var i=t.Deferred(),s=t.Deferred();return i.done(e).fail(r),s.done(function(e){i.resolve(e)}).fail(function(e){i.fail(e)}),n.invoke(function(e){window.DeviceBridge.performUpdate(JSON.stringify(e))},s),i},installClientUpdate:function(e,r){var i=t.Deferred(),s=t.Deferred();return i.done(e).fail(r),s.done(function(e){i.resolve(e)}).fail(function(e){i.fail(e)}),n.invoke(function(e){window.DeviceBridge.installClientUdpate(JSON.stringify(e))},s),i}}),l=new f,prof.markTime("$define_api/device"),l}),define("api/parental-controls",["jquery","api/appstore","api/device-features"],function(e,t,n){var r=function(){var r=n.getValueOf(n.Keys.PARENTAL_SETTINGS);this.whichChallengeRequired=function(n){console.log("checking to see if parental controls are on");var i=e.Deferred(),s,o;return r?(console.log("this device has DW parental controls"),s=this.getDeviceParentalControlsSettings(),s.done(function(e){console.log("api: device wide settings are "+JSON.stringify(e)),e.pin&&e.purchaseBlocked?o="pin":n?o="account":o="none",i.resolve(o)}).fail(function(){i.reject("something bad happened when looking up DWPC.")})):(console.log("calling for appstore parental control settings"),t.Settings.get(t.Settings.keys.ParentalControlKey,function(e){console.log("appstore parentalcontrol from settings is "+JSON.stringify(e)),e.value?t.Settings.get(t.Settings.keys.PinEnabledKey,function(e){e.value?o="pin":o="account",i.resolve(o)},function(){i.reject("something bad happened when looking up Appstore pin.")}):n?(o="account",i.resolve(o)):(o="none",i.resolve(o))},function(e){console.log("we got an error retrieving parental controls"),i.reject("something bad happened when looking up Appstore PC.")})),i},this.getDeviceParentalControlsSettings=function(){var n=e.Deferred(),r=e.Deferred();return t.Bridge.invoke(function(e){window.ParentalControlsBridge.getDeviceParentalControlsSettings(JSON.stringify(e))},n),n.done(function(e){r.resolve(e)}).fail(r.reject),r},this.pinChallenge=function(e,n,i){if(r)t.Navigation.Android.startActivityForResult({component:{classname:"com.lab126.parentalcontrols.ParentalPasswordAuthentication",packagename:"com.lab126.parentalcontrols"}},undefined,undefined,function(t){console.log("device-wide password challenge returns: "+JSON.stringify(t)),t.resultCode===-1?e!==undefined&&e():(console.log("blocked by device-wide parental controls."),n!==undefined&&n())},function(e){console.log("something went wrong. abort. "+JSON.stringify(e)),i!==undefined&&i()});else{var s=t.Resources.getString("PinChallengeDialog_PinChallenge");t.Navigation.showDialog("PinChallengeDialog",{pinChallengeDialogTitle:s},function(t){if(t===undefined)return;console.log("PasswordChallengeDialogCallback: "+JSON.stringify(t)),t.isValidated?(console.log("validated"),e!==undefined&&e()):(console.log("did not pass challenge."),n!==undefined&&n())})}},this.accountChallenge=function(e,n,r,i){t.Navigation.showDialog("PasswordChallengeDialog",{passwordChallengeMessage:e},function(e){if(e===undefined)return;console.log("PasswordChallengeDialogCallback: "+JSON.stringify(e)),e.isValidated?(console.log("validated"),n!==undefined&&n()):(console.log("did not pass challenge."),r!==undefined&&r())})},this.navigateToParentalControlsSettings=function(e){n.getValueOf(n.Keys.PARENTAL_SETTINGS)?(console.log("Navigating to device level Parental Control Settings page"),t.Navigation.Android.startActivityForResult({action:"com.lab126.settings.CHECK_PARENTAL_PASSWORD"},{"com.lab126.settings.showParental":!0},undefined,function(){e!==undefined&&e()})):(console.log("navigating to appstore parental control settings page"),t.Navigation.navigate("SettingsPage",{settingsPage:"SettingsParental"},function(){e!==undefined&&e()}))},this.isPurchaseBlocked=function(){var n=e.Deferred();return r?this.getDeviceParentalControlsSettings().done(function(e){console.log("api: device wide settings are "+JSON.stringify(e)),n.resolve(e.purchaseBlocked&&e.pin)}).fail(n.reject):t.Settings.get(t.Settings.keys.ParentalControlKey,function(e){console.log("appstore parentalcontrol from settings is "+JSON.stringify(e)),n.resolve(e.value)},function(e){console.log("we got an error retrieving parental controls"),n.reject("something bad happened when looking up Appstore PC.")}),n}};return new r});var Class;define("api/download",["appstore","jquery"],function(e,t){return{Event:{AppDownloadSucceeded:Class.extend({init:function(e,t){this.apkFile=e,this.app=t}}),AppDownloadFailed:Class.extend({init:function(e,t){this.error=e,this.app=t}})},enqueue:function(n,r,i){var s=t.Deferred(),o;if(!n.status)throw"Status of the app cannot be null";n.status==="download pending"&&(o=new e.Error("Error","the app download request is already in the queue"),i&&i(o),s.reject(o)),n.status==="downloading"?(o=new e.Error("Error","the app is being downloaded"),i&&i(o),s.reject(o)):(r&&r("Download request enqueued for app: "+n.asin),s.resolve("Download request enqueued for app: "+n.asin))},cancel:function(n,r,i){var s=t.Deferred(),o;if(!n.status)throw"Status of the app cannot be null";n.status==="download pending"||n.status==="downloading"?(r&&r("Download request canceled for app: "+n.asin),s.resolve("Download request canceled for app: "+n.asin)):(o=new e.Error("Error","the app download request cannot be canceled because it is in illegal state"),i&&i(o),s.reject(o))},pause:function(n,r,i){var s=t.Deferred(),o;if(!n.status)throw"Status of the app cannot be null";n.status==="download pending"||n.status==="downloading"?(r&&r("Download request paused for app: "+n.asin),s.resolve("Download request paused for app: "+n.asin)):(o=new e.Error("Error","the app download request cannot be paused because it is in illegal state"),i&&i(o),s.reject(o))},resume:function(n,r,i){var s=t.Deferred(),o;if(!n.status)throw"Status of the app cannot be null";n.status==="paused downloading"?(r&&r("Download request resumed for app: "+n.asin),s.resolve("Download request resumed for app: "+n.asin)):(o=new e.Error("Error","the app download request cannot be resumed because it is in illegal state"),i&&i(o),s.reject(o))},Setting:{CELLULAR_DOWNLOAD_LIMIT:"CellularDownloadLimit",DOWNLOAD_BUFFER_SIZE:"DownloadBufferSize"}}}),define("api/event",{});var Class;define("api/feedback",["jquery","./appstore","./authentication","api/web-invoker"],function(e,t,n,r){var i=function(){var n={feedback_recommendation:"Recommendation",feedback_comment:"Comment",feedback_bug:"Bug"};this.AppstoreFeedback=Class.extend({init:function(e,t,n){this.type=e,this.rating=t,this.text=n}}),this.AppFeedback=Class.extend({init:function(e,t,n){this.asin=e,this.type=t,this.text=n}}),this.submit=function(i,s,o){var u=e.Deferred(),a=e.Deferred(),f,l={},c={Text:i.text};return s&&a.done(s),o&&a.fail(o),u.done(function(e){a.resolve(JSON.parse(e.message))}),u.fail(function(e){a.reject(e)}),f=function(){i.rating&&(c.Rating=i.rating.toFixed(1)),c.FeedbackType=n[i.type]===undefined?i.type:n[i.type],c.Time=Math.floor((new Date).getTime()/1e3),l.data=JSON.stringify(c),console.log("Feedback data:"+JSON.stringify(l.data)),r.deviceService.invoke("submitFeedback",l,{useDeferred:u})},t.Account.getAccountDetails().done(function(e){c.CustomerID=e.ecid,t.DeviceFeatures.getDeviceType().done(function(e){c.deviceType=e,t.DeviceFeatures.getModel().done(function(e){c.model=e,t.Device.getAppstoreVersion(function(e){c.clientVersion=e,f()})})})}),a}};return new i});var Class,ResourcesBridge;define("api/resources",["api/appstore","api/bridge","jquery","strings"],function(e,t,n,r){function i(e){var t,r;return n.map(e,function(e,n){t=n,r=e}),{key:t,value:r}}prof.markTime("^define_api/resources");var s,o;return o=Class.extend({init:function(){},getString:function(t,n){var i={formatArgs:n},s,o;if(typeof ResourcesBridge=="undefined")throw new e.Error("RESOURCES","Could not detect native bridge.");o=r&&r[t];if(o!==undefined){if(!n||n.length===0)return o;i.string=o}else i.stringId=t;return s=ResourcesBridge.getText(JSON.stringify(i)),String(s)},formatString:function(t,r){var i=n.Deferred(),s=n.isArray(r)?r:n.makeArray(arguments).slice(1);if(typeof ResourcesBridge=="undefined")throw new e.Error("RESOURCES","Could not detect native bridge.");return e.Bridge.invoke(function(e){e.args={format:t,formatArgs:s},ResourcesBridge.formatString(JSON.stringify(e))},i),i},getStrings:function(t){var s=n.isArray(t)?t:n.makeArray(arguments),o=n.Deferred(),u=n.Deferred(),a=[],f=!1;if(typeof ResourcesBridge=="undefined")throw new e.Error("RESOURCES","Could not detect native bridge.");return a=n.map(s,function(e,t){var n,s;if(typeof e=="string")return n=r&&r[e],n!==undefined?{stringId:e,string:n}:(f=!0,{stringId:e});if(typeof e=="object")return s=i(e),n=r&&r[s.key],n!==undefined?(f=!0,{stringId:s.key,string:n,formatArgs:s.value}):(f=!0,{stringId:s.key,formatArgs:s.value})}),f?(o.done(function(e){var t=n.map(s,function(t,n){if(typeof t=="string")return e[t];if(typeof t=="object"){var r=i(t);return e[r.key]}return""});u.resolve.apply(u,t)}),e.Bridge.invoke(function(e){e.args=a,ResourcesBridge.getTexts(JSON.stringify(e))},o)):u.resolve.apply(u,n.map(a,function(e){return e.string})),u},getQuantityString:function(t,n,i){if(typeof ResourcesBridge=="undefined")throw new e.Error("RESOURCES","Could not detect native bridge.");var s=r&&r[t],o={stringId:t,quantity:n,formatArgs:i};return s!==undefined&&(o.string=s),ResourcesBridge.getText(JSON.stringify(o))},getAssetUrl:function(t){if(typeof ResourcesBridge=="undefined")throw new e.Error("RESOURCES","Could not detect native bridge.");return ResourcesBridge.getAssetLocation(t)},getAssetUrls:function(t){var n=[],r;if(typeof ResourcesBridge=="undefined")throw new e.Error("RESOURCES","Could not detect native bridge.");for(r=0;r<t.length;r+=1)n.push(t[r]);return JSON.parse(ResourcesBridge.getAssetLocations(JSON.stringify(n)))}}),s=new o,prof.markTime("$define_api/resources"),s});var Class,ResourcesBridge;define("api/currency",["api/resources"],function(e){return Class.extend({init:function(e){this.deviceLocale=e||!1},format:function(t,n,r){var i;r===undefined&&(r=!0);if(r&&parseFloat(t)===0)return e.getString("free_price");if(t!==undefined){i=ResourcesBridge.formatCurrency(t,n||null,this.deviceLocale);if(i)return String(i)}return null}})}),define("api/giftcard",["jquery","./appstore","./authentication","./currency","api/web-invoker"],function(e,t,n,r,i){var s=function(){this.getBalance=function(s,o,u){typeof s=="function"&&(u=o,o=s,s=!1);var a=new e.Deferred,f,l=this;return n.isRegistered()?(o&&a.done(o),u&&a.fail(u),f=i.deviceService.invoke("getGiftCardBalance",{}),f.done(function(e){console.log("giftCard.js: response: "+JSON.stringify(e));var t=JSON.parse(e.message),n=t.amount.value,i=t.amount.unit,o,u;console.log("giftcard.js: value = "+n),o=new r(s),u=o.format(n,i,!1),console.log("giftcard.js: localValue = "+u),a.resolve(u)}),f.fail(function(e){console.log("giftCard.js: error = "+JSON.stringify(e)),a.reject(e)}),a):(a.reject(new t.Error(n.Error.DEVICE_NOT_REGISTERED)),a)},this.redeemCode=function(r,s,o){var u=new e.Deferred,a,f=this;return n.isRegistered()?(s&&u.done(s),o&&u.fail(o),a=i.deviceService.invoke("redeemCode",{code:r}),a.done(function(e){console.log("giftCard.js: Redeem response: "+JSON.stringify(e));var t=JSON.parse(e.message),n=t.suceeded;u.resolve(n)}),a.fail(function(e){console.log("giftCard.js: Redeem error = "+JSON.stringify(e)),u.reject(e)}),u):(console.log("giftcard.js: In redeemCode() -- User not authenticated!"),u.reject(new t.Error(n.Error.DEVICE_NOT_REGISTERED)),u)}};return new s});var MASNativeBridge;define("api/navigation",["api/appstore","api/bridge","jquery"],function(e,t,n){prof.markTime("^define_api/navigation");var r,i=function(){function o(e){var t=!1,n,r;return n=new Date,console.log("NewRequesttime: "+n),i!==undefined&&i.jsonExtras!==undefined&&e.page==="Detail"&&i.jsonExtras.page==="Detail"&&e.asin===i.jsonExtras.asin&&(r=n-i.requestTime,console.log("timeDifference: "+r),r!==undefined&&r<s&&(console.log("Same request. Ignore"),t=!0)),i={requestTime:n,jsonExtras:e},t}function u(){var e=MASNativeBridge.getExtras();return console.log("[DEPRECATED] extras: "+e),e?JSON.parse(e):{}}var r=this,i,s=1e3;this.result=null,this.Android=function(r){var i=function(){this.Intent=function(){},this.Intent=new this.Intent,this.startActivityForResult=function(i,s,o,u,a,f){var l=n.Deferred().done(u).fail(a);r.detectNativeBridge()||l.reject(new e.Error("NAVIGATION","Could not detect native bridge.")),(!i||!(i.classname||i.action||i.component))&&l.reject(new e.Error("NAVIGATION","classname, action, or component is required.")),t.invoke(function(e){e.args.intent=i,e.args.extras=s,e.args.data=o,MASNativeBridge.startNativeActivity(JSON.stringify(e))},l)},this.activityExistsForIntent=function(t,i,s,o,u,a,f){var l,c;console.log("activityExistsForIntent, intent = "+r.debugPrint(t)+", extras = "+r.debugPrint(i)+", data = "+s+", unwanted = "+JSON.stringify(o)),l=n.Deferred().done(u).fail(a),r.detectNativeBridge()||l.reject(new e.Error("NAVIGATION","Could not detect native bridge.")),(!t||!t.classname&&!t.action&&!t.packagename)&&l.reject(new e.Error("NAVIGATION","One of classname or action is required.")),c={args:{}},c.args.intent=t,c.args.extras=i,c.args.data=s,c.args.unwanted=o,l.resolve(MASNativeBridge.activityExistsForIntent(JSON.stringify(c)))},this.getEmailIntentAndExtras=function(e){return{intent:{action:"android.intent.action.SEND",type:"plain/text"},extras:{"android.intent.extra.TEXT":e},unwanted:["com.skype.raider.MainApp"]}},this.getSmsIntentAndExtras=function(e){return{intent:{action:"android.intent.action.VIEW",type:"vnd.android-dir/mms-sms"},extras:{sms_body:e}}},this.startActivity=function(e,i,s,o,u,a){console.log("startActivity, intent = "+r.debugPrint(e)+", extras = "+r.debugPrint(i)+", data = "+s);var f=n.Deferred().done(o).fail(u);t.invoke(function(t){t.args.intent=e,t.args.extras=i,t.args.notForValue=!0,t.args.data=s,MASNativeBridge.startNativeActivity(JSON.stringify(t))},f)}};return new i}(this),this.Registration=function(e){var t=function(){this.pageRegistry={},this.nativePageRegistry={},this.registerNativePage=function(t,r,i,s,o){console.log("Registering page "+t+" with intent "+e.debugPrint(r)+", extras "+e.debugPrint(i));var u=n.Deferred().done(s).fail(o),a=this.nativePageRegistry,f={intent:r,extras:i};return a[t]=f,u.resolve(),u}};return new t},this.Registration=new this.Registration(this),this.Chrome=function(e){this.addMenuItem=function(e,r,i,s,o){var u=t.registerPersistentCallback(i),a=n.Deferred().done(s).fail(o);t.invoke(function(t){t.args.name=e,t.args.icon=r,t.args.callback=u,MASNativeBridge.setNativeMenuItem(JSON.stringify(t))},a)}},this.Chrome=new this.Chrome(this),this.DIALOG_BUTTON_INDEX_KEY="button",this.DIALOG_BUTTON_VALUE_KEY="value",this.navigate=function(e,r,i){var s=this.getUrlForName(e),u,a;if(!s){this.nativeNavigate(e,r,i);return}if(this.SSR_URLS[e]){this.navigateToSSRPage(e,this.SSR_URLS[e],r);return}u=this.mergeExtras(this.getDefaultExtras(e),r),a=n.Deferred().done(i),o(u)||t.invoke(function(e){e.args.name=s,e.args.jsonExtras=JSON.stringify(u),MASNativeBridge.startNewPage(JSON.stringify(e))},a)},this.GATEWAY_URL="/gp/masclient/appstore",this.DETAIL_URL="/gp/masclient/dp",this.SEARCH_URL="/gp/masclient/search",this.ALL_CATEGORIES_URL="/gp/masclient/all-categories",this.SSR_URLS={Gateway:this.GATEWAY_URL,Detail:this.DETAIL_URL,Search:this.SEARCH_URL,AllCategories:this.ALL_CATEGORIES_URL},this.navigateToSSRPage=function(t,n,r){var i,s,o={},u;i=this.mergeExtras(this.getDefaultExtras(t),r),t==="Detail"&&i.asin?n=n+"/"+i.asin:t==="Search"&&i.q&&(n=n+"?q="+encodeURIComponent(i.q)),o.className="com.amazon.venezia.HtmlWebviewActivity",o.extras={URL_TO_LOAD:n,jsonExtras:JSON.stringify(i)},u=e.toUri(o),console.log("NavigationRequest with uri: "+u),window.IntentBridge?window.IntentBridge.startActivity(u):console.error("Navigation.js Error. window.IntentBridge is not available.")},this.notifyControllerLoaded=function(e){var r=n.Deferred();return window.BootstrapBridge.notifyControllerLoaded?t.invoke(function(e){window.BootstrapBridge.notifyControllerLoaded(JSON.stringify(e))},r):r.reject("window.BootstrapBridge.notifyControllerLoaded not supported"),r},this.getExtras=function(){var e=n.makeArray(arguments),r=n.Deferred(),i=n.Deferred();return e.length===0?u():(r.done(function(t){var r=n.map(e,function(e){return t[e]});i.resolve.apply(null,r)}),t.invoke(function(t){t.args.params=e,MASNativeBridge.getExtras(JSON.stringify(t))},r),i)},this.finish=function(){MASNativeBridge.finish()},this.finishToRootOrKickStart=function(){MASNativeBridge.finishToRootOrKickStart()},this.restart=function(){MASNativeBridge.restart()},this.setResult=function(e){var r=new n.Deferred;t.invoke(function(t){t.args.extras=JSON.stringify(e),MASNativeBridge.setResult(JSON.stringify(t))},r)},this.showDialog=function(e,r,i,s){var o=this.getChromeForDialog(),u=this.getDefaultExtras(e),a=n.extend({},u,o,r),f=this.getUrlForName(e),l=n.Deferred().done(i).fail(s);t.invoke(function(e){e.args.isDialog=!0,e.args.name=f,e.args.jsonExtras=a,MASNativeBridge.startNewPage(JSON.stringify(e))},l)},this.dismissDialog=function(e,t){var n={button:e};t&&(n.value=t),this.setResult(n),this.finish()},this.showToast=function(e,r,i){var s=n.Deferred().done(r).fail(i);return t.invoke(function(t){t.args.message=e,MASNativeBridge.showToast(JSON.stringify(t))},s),s},this.openInBrowser=function(e,t,n){var r={action:"android.intent.action.VIEW"};this.Android.startActivity(r,null,e,t,n)},this.startApp=function(t,n,r,i){if(!this.detectNativeBridge())throw new e.Error("NAVIGATION","Could not detect native bridge.");var s={};return s.packagename=t.packageName,s.asin=t.asin,this.Android.startActivity(s,null,null,n,r)},this.startAccountManagementExperience=function(e,r,i){var s=n.Deferred().done(r).fail(i);return t.invoke(function(t){t.args.country=e,MASNativeBridge.startAccountManagementExperience(JSON.stringify(t))},s),s},this.getUrlForName=function(e){if(this.Registration.nativePageRegistry[e])return;return"index.html"},this.debugPrint=function(e,t,r){var i,s=t?"\nvar "+t+" = ":"\n";s+="{\n";for(i in e)e.hasOwnProperty(i)&&(r||!n.isFunction(e[i]))&&(s+="    "+i+": ",s+=e[i],s+="\n");return s+="}\n",s},this.getChromeForDialog=function(){return{chrome:{style:"dialog",menu:{showBack:!0,showMenu:!1,showSearch:!1}}}},this.nativeNavigate=function(e,r,i,s){var o=this.Registration.nativePageRegistry[e],u,a;console.log(this.debugPrint(o,"intent"));if(!o||!o.intent||!o.intent.classname&&!o.intent.action)throw"The page <<"+e+">> could not be mapped to any activity, HTML or native.";if(!this.detectNativeBridge())throw"Could not detect native bridge.";return u=this.mergeExtras(this.getDefaultExtras(e),r),a=n.Deferred().done(i),t.invoke(function(e){e.args.intent=o.intent,e.args.data=o.data,!e.args.data&&u.data&&(e.args.data=u.data),e.args.extras=u,MASNativeBridge.startNativeActivity(JSON.stringify(e))},a),a},this.detectNativeBridge=function(){return typeof MASNativeBridge=="undefined"?!1:!0},this.getDefaultExtras=function(e){var t=this.Registration.nativePageRegistry[e],r=t&&t.extras;return n.extend({page:e},r)},this.mergeExtras=function(e,t){var r={},i,s;return e?(n.extend(r,e,t),r):t},this.EXTRAS="extras",this.RESULT="return",this.START="start",this.END="end",this.CALLBACK="callback",this.REFERER="referer"};return r=new i,prof.markTime("$define_api/navigation"),r});var WorkflowBridge;define("api/install",["jquery","appstore","api/bridge","config/mock-config","api/navigation"],function(e,t,n,r,i){return{Event:{APP_INSTALL_SUCCESS:"AppInstallSucceess",APP_INSTALL_FAILED:"AppInstallFailed"},Error:{APP_INSTALL_FAILURE:"AppInstallFailure",APP_INSTALL_CANCEL_FAILURE:"AppInstallCancellationFailure",APP_INSTALL_PAUSE_FAILURE:"AppInstallPauseFailure",APP_INSTALL_RESUME_FAILURE:"AppInstallResumeFailure",APP_INSTALL_NEXT_FAILURE:"AppInstallNextFailure"},installNow:function(n,i,s){var o=new e.Deferred;return setTimeout(function(){if(!n.asin)throw"IllegalArgument";i&&o.done(i),s&&o.fail(s);var e=new r;e.getConfig(e.Settings.APP_STATUS)==="installing"||e.getConfig(e.Settings.APP_STATUS)==="installed"?o.reject(new t.Error(t.Install.Error.APP_INSTALL_FAILURE,"App installation failed because the app is installing or already installed!")):(e.setConfig(e.Settings.APP_STATUS,"installing"),o.resolve("App installation started."))},Math.floor(400+Math.random()*2e3)),o},installNext:function(n,i,s){var o=new e.Deferred;return setTimeout(function(){if(!n.asin)throw"IllegalArgument";i&&o.done(i),s&&o.fail(s);var e=new r;e.getConfig(e.Settings.INSTALL_QUEUE)==="next_installation_started"?o.resolve("Next app installation started!"):o.reject(new t.Error(t.Install.Error.APP_INSTALL_NEXT_FAILURE,"Next app installation failed!"))},Math.floor(400+Math.random()*2e3)),o},cancel:function(n,i,s){var o=new e.Deferred;return setTimeout(function(){if(!n.asin)throw"IllegalArgument";i&&o.done(i),s&&o.fail(s);var e=new r;e.getConfig(e.Settings.APP_STATUS)==="installing"||e.getConfig(e.Settings.APP_STATUS)==="install_pending"?(e.setConfig(e.Settings.APP_STATUS,""),o.resolve("App installation cancelled!")):o.reject(new t.Error(t.Install.Error.APP_INSTALL_CANCEL_FAILURE,"App installation cancel failed because the app is neither installing or nor pending installation!"))},Math.floor(400+Math.random()*2e3)),o},pause:function(n,i,s){var o=new e.Deferred;return setTimeout(function(){if(!n.asin)throw"IllegalArgument";i&&o.done(i),s&&o.fail(s);var e=new r;e.getConfig(e.Settings.APP_STATUS)==="installing"||e.getConfig(e.Settings.APP_STATUS)==="install_pending"?(e.setConfig(e.Settings.APP_STATUS,"install_paused"),o.resolve("App installation paused!")):o.reject(new t.Error(t.Install.Error.APP_INSTALL_PAUSE_FAILURE,"App installation PAUSE failed because the app is neither installing or nor pending installation!"))},Math.floor(400+Math.random()*2e3)),o},resume:function(t,r,i){console.log("asin: "+t.asin+", currentVersion: "+t.currentVersion+", title: "+t.title);if(t.asin===undefined)throw{name:"IllegalArgument",message:"Missing a required value: "+JSON.stringify(t)};var s=e.Deferred().done(r).fail(i),o=e.Deferred();return o.done(function(e){s.resolve(e.resumed)}).fail(function(e){s.reject(e)}),n.invoke(function(n){e.extend(n.args,t),WorkflowBridge.resumeInstallApplication(JSON.stringify(n))},o),s},installApp:function(t,r,i){console.log("asin: "+t.asin+", currentVersion: "+t.currentVersion+", title: "+t.title);if(t.asin===undefined||t.currentVersion===undefined||t.currentPrice===undefined||t.refTag===undefined||t.title===undefined)throw{name:"IllegalArgument",message:"Missing a required value: "+JSON.stringify(t)};var s=e.Deferred().done(r).fail(i);return n.invoke(function(n){e.extend(n.args,t),WorkflowBridge.downloadAndInstallApplication(JSON.stringify(n))},s),s},updateApp:function(t,r,i){console.log("appInfo: "+JSON.stringify(t)),console.log("asin: "+t.asin+", currentVersion: "+t.currentVersion+", title: "+t.title);if(t.asin===undefined||t.currentVersion===undefined||t.currentPrice===undefined||t.refTag===undefined||t.title===undefined)throw{name:"IllegalArgument",message:"Missing a required value: "+JSON.stringify(t)};var s=e.Deferred().done(r).fail(i);return n.invoke(function(n){e.extend(n.args,t),WorkflowBridge.updateApplication(JSON.stringify(n))},s),s},updateAllApps:function(t,r){var i=e.Deferred().done(t).fail(r);return n.invoke(function(e){WorkflowBridge.updateAllApplications(JSON.stringify(e))},i),i},uninstallApp:function(e,t,n){return console.log("Going to uninstall: "+e),i.Android.startActivityForResult({action:"android.intent.action.DELETE"},{},"package:"+e,t,n)}}});var Class,WorkflowBridge;define("api/purchase",["jquery","appstore","api/bridge"],function(e,t,n){return{Error:{ORDER_PLACEMENT_ERROR:"Appstore.Purchase.OrderPlacementError",BILLING_ADDRESS_ERROR:"Appstore.Purchase.BillingAddressError",PAYMENT_INSTRUMENT_ERROR:"Appstore.Purchase.PaymentInstrumentError",VERSION_CONSISTENCY_ERROR:"Appstore.Purchase.VersionConsistencyError",PRICE_CONSISTENCY_ERROR:"Appstore.Purchase.PriceConsistencyError",AVAILABILITY_ERROR:"Appstore.Purchase.AvailabilityError",GEOLOCATION_ERROR:"Appstore.Purchase.GeolocationError",INCONSISTENT_COR_ERROR:"Appstore.Purchase.InconsistentCorError",UNKNOWN:"Appstore.Purchase.Unknown"},AppInfo:Class.extend({init:function(e,t,n,r){this.asin=e,this.currentVersion=t,this.currentPrice=n,this.refTag=r}}),purchaseApp:function(t,r,i){console.log("asin: "+t.asin+", currentVersion: "+t.currentVersion+", currentPrice: "+t.currentPrice+", refTag: "+t.refTag+", title: "+t.title);if(!t.asin||!t.currentVersion||!t.currentPrice||!t.refTag||!t.title)throw{name:"IllegalArgument",message:"Missing a required value: "+JSON.stringify(t)};var s=e.Deferred().done(r).fail(i);n.invoke(function(n){e.extend(n.args,t),WorkflowBridge.purchaseApplication(JSON.stringify(n))},s)}}}),define("api/recently-viewed",["jquery","appstore"],function(e){function r(){return localStorage.recentlyViewed?JSON.parse(localStorage.recentlyViewed):[]}function i(e){var t,n=r();for(t=0;t<n.length;t+=1)if(n[t]&&n[t].displayTitle===e.displayTitle)return t;return-1}function s(e){var t,n=[];for(t=e.length-1;t>=0;t-=1)n.push(e[t]);return n}function o(e){localStorage.recentlyViewed=JSON.stringify(e)}var t=15,n;return n=function(){this.add=function(n,s,u){var a=e.Deferred().done(s).fail(u),f=i(n),l=r();return f>-1&&l.splice(f,1),l.push(n)>t&&l.shift(),o(l),a.resolve(),a},this.clear=function(t,n){var r=e.Deferred().done(t).fail(n);return o([]),r.resolve(),r},this.get=function(t,n,i){var o=e.Deferred().done(n).fail(i),u=[],a=r();return isNaN(t)||t>=a.length?u=s(a):u=s(a.slice(-t)),o.resolve(u),o}},new n});var Class;define("api/review",["jquery","config/mock-config","api/appstore","api/web-invoker"],function(e,t,n,r){var i=function(){function t(t,r,i){var s=e.Deferred(),o=e.Deferred().done(r).fail(i);return s.done(function(e){o.resolve(JSON.parse(e.message))}),s.fail(function(e){o.reject(e)}),n.Bridge.invoke({service:"mas-device-service",relativePath:"/castVote",body:t,retryCount:5,backoffRetry:5e3,timeout:2e3,httpMethodType:"POST",requiresAuthentication:!0},function(e){window.WebInvokerBridge.webInvoke(e)},s),o}this.CustReview=Class.extend({init:function(e,t,n,r){this.asin=e,this.rating=t,this.title=n,this.description=r}}),this.addReview=function(t,n,i){var s,o=e.Deferred(),u;return n&&o.done(n),i&&o.fail(i),u={asin:t.asin,title:t.title,text:t.description,overallRating:t.rating},s=r.deviceService.invoke("createReview",u),s.done(function(e){o.resolve(JSON.parse(e.message))}),s.fail(function(e){o.reject(e)}),o},this.PenName=Class.extend({init:function(e){this.penname=e}}),this.createPenName=function(t,i,s){var o=e.Deferred(),u=e.Deferred(),a;return i&&o.done(i),s&&o.fail(s),a=function(e){var n={customerId:e.ecid,penName:t};r.deviceService.invoke("createReviewPenName",n,{useDeferred:u})},n.Account.getAccountDetails().done(a),u.done(function(e){o.resolve(JSON.parse(e.message))}),u.fail(function(e){o.reject(e)}),o},this.AppInfo=Class.extend({init:function(e){this.asin=e}}),this.checkReviewEligibility=function(t,i,s){var o=e.Deferred(),u=e.Deferred(),a;return i&&o.done(i),s&&o.fail(s),a=function(e){var n={customerId:e.ecid,asin:t.asin};r.deviceService.invoke("checkReviewEligibility",n,{useDeferred:u})},n.Account.getAccountDetails().done(a),u.done(function(e){o.resolve(JSON.parse(e.message))}),u.fail(function(e){o.reject(e)}),o},this.Query=Class.extend({init:function(e,t){if(!e)throw"NPE";this.asin=e,this.start=0,this.pageSize=16,this.sort=t||"byHelpfulVotesDescending"},nextPage:function(t,i){var s=e.Deferred(),o,u,a=this;return t&&s.done(t),i&&s.fail(i),u={asin:a.asin,pagination:{startOffset:a.start,pageSize:a.pageSize},sortBy:{sortBy:a.sort}},o=r.deviceService.invoke("getReviews",u),o.done(function(e){var t=JSON.parse(e.message),r=t.reviews;a.start+=a.pageSize,s.resolve(new n.Review.Page(r))}),o.fail(function(e){console.log("Query.nextPage.webDeferred.fail; error = "+JSON.stringify(e)),s.reject(e)}),s}}),this.getReviews=function(e,t){return new n.Review.Query(e,t)},this.castVote=function(e,n,r){var i={voteDomain:"Reviews",voteDimension:"Helpful",voteEntityName:"Review",voteInstanceId:e.reviewID,voteValue:e.voteValue};return t(i,n,r)},this.reportAbuse=function(e,n,r){var i={voteDomain:"Reviews",voteDimension:"Inappropriate",voteEntityName:"Review",voteInstanceId:e,voteValue:1};return t(i,n,r)},this.Page=Class.extend({init:function(e){this.reviews=e}})};return new i}),define("api/settings",["jquery","appstore","api/preferences","api/bridge"],function(e,t,n,r){var i=function(){var t="com.amazon.mas.client.framework.SettingsService.";this.marketLinkState={AUTO_FORWARD:"AUTO_FORWARD",DONT_FORWARD:"DONT_FORWARD",ASK_BEFORE_FORWARD:"ASK_BEFORE_FORWARD"},this.keys={ProgressNotificationKey:{type:"Boolean",name:t+"notification.DownloadInstallProgress",defaultValue:!1},AppUpdatesNotificationKey:{type:"Boolean",name:t+"notification.AppUpdates",defaultValue:!1},AutomaticUpdatesNotificationKey:{type:"Boolean",name:t+"notification.AutomaticUpdates",defaultValue:!1},FlashInNotificationBarKey:{type:"Boolean",name:t+"notification.FlashInNotificationBar",defaultValue:!1},MarketLinkStateKey:{type:"String",name:"com.amazon.mas.client.framework.MarketLinkSettings.MarketLinkState",defaultValue:"ASK_BEFORE_FORWARD"},AutoUpdateKey:{type:"Boolean",name:t+"autoUpdate",defaultValue:!0},AutomaticUpdatesViaMobileConnKey:{type:"Boolean",name:t+"autoUpdateViaMobileConnection",defaultValue:!1},IapEnabledKey:{type:"Boolean",name:"com.amazon.mas.client.framework.SettingsService.iapEnabled",defaultValue:!0},Collect3pAppUsageEnabledKey:{type:"Boolean",name:"com.amazon.mas.client.framework.SettingsService.Collect3pAppUsage",defaultValue:!0},DownloadBufferSizeKey:{type:"Long",name:"DownloadServiceImpl.downloadBufferSize",defaultValue:16384},PinEnabledKey:{type:"Boolean",name:t+"usePin",defaultValue:!1},PinValueKey:{type:"String",name:t+"pinValue",defaultValue:"1234"},ParentalControlKey:{type:"Boolean",name:t+"parentalControlsEnabled",defaultValue:!1},DontShowSavedDialogKey:{type:"Boolean",name:"dontShowSavedDialog",defaultValue:!1}},this.get=function(e,t,r){return n.getValue(e.type,e.name,e.defaultValue,t,r)},this.set=function(e,t,r,i){if(e.type===undefined||e.name===undefined){console.log("cannot set "+e.name+" with "+e.type+" type");return}return n.putValue(e.type,e.name,t,r,i)},this.setCellularDownloadLimit=function(t){var n=e.Deferred();return r.invoke(function(e){e.args.limit=t,window.DownloadSettingsBridge.setCellularDownloadLimit(JSON.stringify(e))},n),n},this.getCellularDownloadLimit=function(){var t=e.Deferred();return r.invoke(function(e){window.DownloadSettingsBridge.getCellularDownloadLimit(JSON.stringify(e))},t),t}};return new i});var Class;define("api/subscriptions",["jquery","api/bridge","api/currency"],function(e,t,n){var r=Class.extend({init:function(){console.log("subs object created")},getSubscriptions:function(){return console.log("getSubscriptions()"),{nextPage:function(n,r){var i=e.Deferred(),s=e.Deferred(),o=e.Deferred(),u=this,a=[],f=[],l=[],c,h,p,d;return n&&i.done(n),r&&i.fail(r),u.cursor===null?{}:(t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/subscription/getSubscriptions",e.args.body={status:"Active",cursor:u.cursor},e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,window.WebInvokerBridge.webInvoke(JSON.stringify(e))},s),s.done(function(e){if(JSON.parse(e.message).subscriptionItems===null)return{};for(p=0;p<JSON.parse(e.message).subscriptionItems.length;p+=1)f[p]=JSON.parse(e.message).subscriptionItems[p].item.asin,l[p]=JSON.parse(e.message).subscriptionItems[p].item.version;u.cursor=JSON.parse(e.message).cursor,console.log("cursor equals: "+u.cursor)}),s.done(function(){t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/discovery/getProductsByAsin",e.args.body={flavor:"Summary",asinList:f},e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,console.log("request: getProductsByAsin "+JSON.stringify(e)),window.WebInvokerBridge.webInvoke(JSON.stringify(e))},o)}),s.fail(function(e){i.reject(e)}),o.done(function(t){console.log("response: getProductsByAsin "+JSON.stringify(t)),c=JSON.parse(t.message).itemMap;for(d=0;d<f.length;d+=1)h=c[f[d]],a[d]={},a[d].details={asin:f[d],version:l[d],title:h.title,developer:h.developerName};var n={subscriptionItems:a};e.publish("Appstore.Subscriptions.getSubscriptions",[]),console.log("returning subscriptions: "+JSON.stringify(n)),i.resolve(n)}),o.fail(function(e){i.reject(e)}),i)}}},getSubscriptionDetails:function(r,i,s){console.log("get subs details for asin: "+JSON.stringify(r));var o=e.Deferred(),u=e.Deferred(),a=e.Deferred(),f=e.Deferred(),l={},c,h,p,d,v;return d=function(n){var r=e.Deferred();console.log("request: getSubscriptions"),t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/subscription/getSubscriptions",e.args.body={status:"Active"},n!==undefined&&(e.args.body.cursor=n),e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,window.WebInvokerBridge.webInvoke(JSON.stringify(e))},r),r.done(v).fail(a.reject)},v=function(e){var t,n=JSON.parse(e.message),i=n.cursor;console.log("cursor equals: "+i),console.log("response: getSubscriptions"+JSON.stringify(e));for(t=0;t<n.subscriptionItems.length;t+=1)if(n.subscriptionItems[t].item.asin===r.asin){a.resolve(n.subscriptionItems[t]);return}i!==null?(console.log("no luck... but there is more! trying again to find our sub..."),d(i)):a.reject()},i&&f.done(i),s&&f.fail(s),(!r||!r.asin||!r.version)&&f.reject(),l.details={asin:r.asin,version:r.version},t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/preference/getSubscriptionDataShareSettings",e.args.body={item:r},e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,window.WebInvokerBridge.webInvoke(JSON.stringify(e))},o),o.done(function(e){c=JSON.parse(e.message),l.sharing={shareAddress:!c.dataShareOptOutAddress,shareEmail:c.dataShareOptInEmail,email:c.dataShareEmail}}),o.fail(function(e){f.reject(e)}),t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/discovery/getProductsByAsin",e.args.body={flavor:"Details",asinList:[r.asin]},e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,console.log("request: getProductsByAsin "+JSON.stringify(e)),window.WebInvokerBridge.webInvoke(JSON.stringify(e))},u),u.done(function(e){console.log("response: getProductsByAsin "+JSON.stringify(e));var t=JSON.parse(e.message).itemMap[r.asin],i;l.dataSharingAllowed=t.dataSharingAllowed,h=t.childItems,l.details.title=t.title,l.details.developer=t.developerName,t.productId&&(l.details.version=t.productId.version),l.details.logo=t.smallIconUrl,l.details.shortDescription=t.shortDescription,t.available&&(l.details.isAvailable=t.available),l.periods=[];for(i=0;i<h.length;i+=1)l.periods[i]={asin:h[i].productId.asin,version:h[i].productId.version,duration:h[i].subscriptionDuration,ourPrice:{value:h[i].ourPrice.value,currency:h[i].ourPrice.currency,display:(new n).format(h[i].ourPrice.value,h[i].ourPrice.currency,!1)}}}),u.fail(function(e){f.reject(e)}),d(),a.done(function(e){console.log("found our sub: "+JSON.stringify(e)),l.startDate=e.statusStartDate,l.status=e.status,l.nextBillAmount=(new n).format(e.nextBillAmount.value,e.nextBillAmount.currency,!1),l.autorenew=e.autorenew,l.autoRenewToggleAllowed=e.autoRenewToggleAllowed,l.id=e.subscriptionId,l.nextBillDate=e.nextBillDate,l.selectedPeriod=e.termsItem.asin}),a.fail(function(e){f.reject(e)}),e.when(o,u,a).done(function(e,t,n){console.log("resolving subscription details: "+JSON.stringify(l)),f.resolve(l)}).fail(function(){console.log("the conjunction of webdeferrs failed. (ie. at least one of them failed)"),f.reject()}),f},setAutoRenewal:function(n,r,i,s){console.log("setAutoRenewal: asinWithVersion "+JSON.stringify(n)+" autoRenewal: "+r);var o=e.Deferred();return i&&o.done(i),s&&o.fail(s),(!n||!n.asin||!n.version)&&o.reject(),t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/subscription/setSubscriptionAutorenew",e.args.body={autorenew:r,item:n},e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,window.WebInvokerBridge.webInvoke(JSON.stringify(e))},o),o.done(function(e){console.log("response: autoRenew "+JSON.stringify(e))}),o},changePeriod:function(n,r,i,s,o){console.log("change period for subsAsin: "+JSON.stringify(n)+", periodAsinWithVersoin: "+JSON.stringify(r)+", price: "+JSON.stringify(i));var u=e.Deferred();return s&&u.done(s),o&&u.fail(o),(!n||!n.asin||!n.version)&&u.reject(),(!r||!r.asin||!r.version)&&u.reject(),(!i||!i.value||!i.currency)&&u.reject(),t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/subscription/setSubscriptionTerms",e.args.body={item:{asin:n.asin,version:n.version},termsItem:{asin:r.asin,version:r.version},price:i},e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,window.WebInvokerBridge.webInvoke(JSON.stringify(e))},u),u.done(function(e){console.log("response: changePeriod "+JSON.stringify(e))}),u},setPrivacySettings:function(n,r,i,s,o){console.log("setPrivacySettings: asinWithVersion: "+JSON.stringify(n)+" settings: "+JSON.stringify(r)," useAsDefault: "+i);var u=e.Deferred(),a;return s&&u.done(s),o&&u.fail(o),t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/preference/setSubscriptionDataShareSettings",e.args.body={dataShareOptInEmail:r.shareEmail,dataShareOptOutAddress:!r.shareAddress,item:n},r.shareEmail&&(e.args.body.dataShareEmail=r.email),e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,console.log("request: setPrivacy"+JSON.stringify(e)),window.WebInvokerBridge.webInvoke(JSON.stringify(e))},u),u.done(function(e){console.log("response: shareSettings "+JSON.stringify(e)),e.error&&u.reject()}),i&&(a=e.Deferred(),t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/preference/setDefaultSubscriptionDataShareSettings",e.args.body={dataShareOptInEmail:r.shareEmail,dataShareOptOutAddress:!r.shareAddress,item:n},r.shareEmail&&(e.args.body.dataShareEmail=r.email),e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,console.log("request: setPrivacyDefault"+JSON.stringify(e)),window.WebInvokerBridge.webInvoke(JSON.stringify(e))},a)),u},getItemId:function(n,r,i){var s=e.Deferred().done(r).fail(i);return t.invoke(function(e){e.args.iapRequestId=n,window.IapBridge.getCatalogItemId(JSON.stringify(e))},s),s},getItemDetails:function(n,r,i){var s=e.Deferred().done(r).fail(i);return t.invoke(function(e){e.args.iapRequestId=n,window.IapBridge.getSubscriptionItemDetails(JSON.stringify(e))},s),s},setPurchaseItemId:function(n,r){var i=e.Deferred();return t.invoke(function(e){e.args.iapRequestId=n,e.args.iapItemId=r,window.IapBridge.setPurchaseItemId(JSON.stringify(e))},i),i},purchase:function(n,r,i){var s=e.Deferred().done(r).fail(i);return t.invoke(function(e){e.args.iapRequestId=n,window.IapBridge.submitPurchaseRequest(JSON.stringify(e))},s),s.fail(function(e){console.log("submitPurchaseReqest called back with: "+JSON.stringify(e))}),s},getProductsByAsin:function(n,r,i,s){var o=e.Deferred().done(i).fail(s);return t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/discovery/getProductsByAsin",e.args.body={flavor:r,asinList:n},e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,console.log("request: getProductsByAsin "+JSON.stringify(e)),window.WebInvokerBridge.webInvoke(JSON.stringify(e))},o),o},getSharedDataSettings:function(n,r,i){console.log("calling getSharedDataSettings with "+JSON.stringify(n));var s=e.Deferred().done(r).fail(i);return t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/preference/getSubscriptionDataShareSettings",e.args.body={item:n},e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,window.WebInvokerBridge.webInvoke(JSON.stringify(e))},s),s},getAllSubscriptions:function(n,r){var i=e.Deferred().done(n).fail(r);return t.invoke(function(e){e.args.service="iap",e.args.relativePath="/service/subscription/getSubscriptions",e.args.requiresDeviceInfo=!0,e.args.requiresIAPAuthentication=!0,window.WebInvokerBridge.webInvoke(JSON.stringify(e))},i),i}});return new r}),define("api/update",["jquery","appstore","./recorder"],function(e,t,n){return{set:function(t,r,i,s){var o=n.Java.getLogger("AutoUpdates"),u;return o.info("Set called with enabled: "+r),u=new e.Deferred,i&&u.done(i),s&&u.fail(s),setTimeout(function(){u.resolve()},Math.floor(400+Math.random()*2e3)),u}}}),define("api/wishlist",["jquery","api/appstore","api/database"],function(e,t,n){var r=[],i=100,s,o,u,a,f="Wishlist",l=new n,c,h,p;return h=function(){var n=e.Deferred();return p!==undefined?(n.resolve(p),n):(t.Account.getAccountDetails().done(function(e){e?(p=e.ecid,n.resolve(p)):n.reject("Failed getting account details.")}).fail(function(e){n.reject(e)}),n)},s=function(e,t){return e.displayTitle===t.displayTitle?0:e.displayTitle<t.displayTitle?-1:1},o=function(e){var t=[],n;for(n=e.length-1;n>=0;n-=1)t.push(e[n]);return t},c=function(e,t){return function(n){n.asin=e.asin,t.push(n)}},a=t.Pager.extend({init:function(e){this.cursor=e},nextPage:function(n,r){var i=this.cursor;i.nextPage(function(r){var o=[],u=[],a,f,l,h,p;for(l=0,h=r.records.length;l<h;l+=1)p=new t.App,p.asin=r.records[l].Asin,a=t.Catalog.getAppDetails(p),a.done(c(p,o)),u.push(a);e.when.apply(e,u).done(function(){o.sort(s),f=new t.Page,f.result=o,f.isLast=r.hasMore!==!0,f.totalCount=r.totalCount,n(f)}),r.hasMore==="false"&&i.close(null,function(e){console.log("Error closing cursor")}),console.log(JSON.stringify(r))},function(e){console.log(JSON.stringify(e))})}}),u=function(){this.add=function(t,n,r){var i=e.Deferred(),s={},o={},u,a;return i.done(n),i.fail(r),a=function(e){console.error("getAccountDetails failed: "+JSON.stringify(e)),i.reject(e)},u=function(e){o.CustomerId=e,o.Asin=t.asin,o.Version=t.version,l.replace(f,undefined,o,function(e){i.resolve(e)},function(e){console.error("Write to wishlist failed: "+JSON.stringify(e)),a(e)})},h().done(u).fail(a),i},this.existsInList=function(t,r,i){var s=new e.Deferred,o={},u,a=[],c=[],p,d;return s.done(r),s.fail(i),p=function(e){s.reject(e)},d=function(e){var n=e[0];n&&n.Asin===t.asin?s.resolve(!0):s.resolve(!1)},h().done(function(e){u="SELECT Asin FROM Wishlist WHERE CustomerId=? and Asin=?",a.push(e),a.push(t.asin),l.execSQL(f,u,a,function(e){var t=new n.Cursor(e),r;r=function(e){c=c.concat(e.records),e.hasMore==="true"&&console.error("Wishlist expects only one record"),d(c),console.log("queryDB Success: "+JSON.stringify(c)),t.close(function(){console.log("Cursor is closed successfully")},p)},t.nextPage(r,p)},p)}).fail(p),s},this.listByDate=function(t,n){var i=new e.Deferred,s;return s=[],setTimeout(function(){s=o(r),t&&t(s),i.resolve(s)},Math.floor(400+Math.random())),i},this.list=function(t,r){var i=e.Deferred(),s,o,u;return i.done(t),i.fail(r),s=function(e){i.resolve(e)},o=function(e){i.reject(e)},u=function(e){var t="SELECT Asin FROM Wishlist where CustomerId=?",r=[];r.push(e),l.execSQL(f,t,r,function(e){var t=new n.Cursor(e),r;s(new a(t))},o)},h().done(u).fail(o),i},this.remove=function(t,n,r){var i=new e.Deferred,s={},o,u,a;return i.done(n),i.fail(r),u=function(e){console.log("Removed "+e.row+"rows from Wishlist"),i.resolve(e)},a=function(e){console.error("Remove from Wishlist error: "+JSON.stringify(e)),i.fail(e)},o=function(e){var n="CustomerId=? AND Asin=? AND Version=?",r=[];r.push(e),r.push(t.asin),r.push(t.version),l.remove(f,n,r,u,a)},h().done(o).fail(a),i},this.clear=function(t,n){var i=new e.Deferred;return setTimeout(function(){r.splice(0,r.length),t&&t(),i.resolve()},Math.floor(400+Math.random())),i}},new u}),define("api/testdrive",["jquery","api/appstore","api/bridge"],function(e,t,n){var r=function(){function i(t,r,i){var s=e.Deferred();return n.invoke({asin:t.asin,originalColor:r,preNetworkTestCount:i},function(e){window.TestDriveBridge.attemptSessionLaunch(e)},s),s}function s(n,s,o,u){var a=!0,f=e.Deferred();return e.subscribe("com.amazon.venezia.android_lifecycle.onResume",function(){a=!0}),e.subscribe("com.amazon.venezia.android_lifecycle.onPause",function(){a=!1}),i(s,o,u).done(function(e){var i=e.launchInfo;e.sessionType===r?(t.TestDrive.logEvent(n,"sessionId",i.fogSessionId),a?f.resolve(i):(t.TestDrive.logEvent(n,"noSessionReason","ActivityPaused"),f.reject({reason_string:"ActivityPaused"}))):(t.TestDrive.logEvent(n,"noSessionReason",e.UnavailableSessionReason.reason_string),f.reject(e.UnavailableSessionReason))}).fail(function(){t.TestDrive.logEvent(n,"noSessionReason","UnknownError"),f.reject({reason_string:"UnknownError"})}),f}var r="ValidTestDriveSession";this.UnavailableSessionReason={NOT_AVAILABLE:"NOT_AVAILABLE",AT_CAPACITY:"AT_CAPACITY",DEVICE_NOT_SUPPORTED:"DEVICE_NOT_SUPPORTED",INTERNET_CONNECTION_NOT_SUPPORTED:"INTERNET_CONNECTION_NOT_SUPPORTED",INTERNET_CONNECTION_NOT_TESTED:"INTERNET_CONNECTION_NOT_TESTED",INTERNET_QUALITY_NOT_SUPPORTED:"INTERNET_QUALITY_NOT_SUPPORTED",DEVICE_DISABLED:"DEVICE_DISABLED"},this.SubscribeTopics={PUBLISH_JS_LATENCY:"com.amazon.testdrive.TestDriveActivity.LATENCY_LIGHTS",PUBLISH_JS_TIMER:"com.amazon.testdrive.TestDriveActivity.TIMER",PUBLISH_JS_DIALOG:"com.amazon.testdrive.TestDriveActivity.DIALOG"},this.DialogTypes={AT_CAPACITY_DIALOG:"Appstore.TestDrive.showMSTAtCapacity",DEVICE_DISABLED_DIALOG:"Appstore.TestDrive.showMSTDeviceDisabled",ENABLE_WIFI_DIALOG:"Appstore.TestDrive.showMSTEnableWifi",ERROR_DIALOG:"Appstore.TestDrive.showMSTError",INTERRUPTED_DIALOG:"Appstore.TestDrive.showMSTInterrupted",ERROR_DIALOG_IN_SESSION:"Appstore.TestDrive.showMSTErrorInSession",FRE_DIALOG:"Appstore.TestDrive.showMSTFirstRun",BAD_CONNECTION_DIALOG:"Appstore.TestDrive.showMSTBadConnection"},this.DialogNetworkState={TESTING:"Testing",TEST_FAILED:"TestFailed",TEST_PASSED:"TestPassed",RESERVING:"Reserving",RESERVE_PASSED:"ReservePassed",RESERVE_FAILED:"ReserveFailed"},this.QualState={TESTING:"TESTING",BAD:"BAD",UNTESTED:"UNTESTED",GOOD:"GOOD"},this.DialogExtrasKeys={APP_NAME:"AppName",TIME:"time",LIGHTS:"lights",DIALOG_TYPE:"dialogType"},this.LogEventKeys={LOG_EVENT:"LogEventName",LOG_EVENT_TIME:"EventTotalTime"},this.checkNetworkConnection=function(t){var r=e.Deferred();return n.invoke({loggingContext:t},function(e){window.TestDriveBridge.checkNetworkConnection(e)},r),r},this.shouldShowCategory=function(){var t=e.Deferred();return n.invoke({},function(e){window.TestDriveBridge.shouldShowCategory(e)},t),t},this.exitTestDrive=function(){var t=e.Deferred();return n.invoke({},function(e){window.TestDriveActivityBridge.exit(e)},t),t},this.isFirstRunExperience=function(t){var r=e.Deferred().done(t);return n.invoke({},function(e){window.TestDriveActivityBridge.isFirstRunExperience(e)},r),r},this.saveFirstRunFlag=function(){var t=e.Deferred();return n.invoke({},function(e){window.TestDriveActivityBridge.saveFirstRunFlag(e)},t),t},this.logEvent=function(t,r,i){var s=e.Deferred();return t===null?s.reject():n.invoke({contextId:t,key:r,val:i},function(e){window.TestDriveBridge.logEvent(e)},s),s},this.logTimerStart=function(t,r){var i=e.Deferred();return t===null?i.reject():n.invoke({contextId:t,subEventName:r},function(e){window.TestDriveBridge.logTimerStart(e)},i),i},this.logTimerEnd=function(t,r){var i=e.Deferred();return t===null?i.reject():n.invoke({contextId:t,subEventName:r},function(e){window.TestDriveBridge.logTimerEnd(e)},i),i},this.reserveSessionWithFailDialog=function(e,n,r,i){return s(e,n,r,i).fail(function(e){var n;switch(e.reason_string){case t.TestDrive.UnavailableSessionReason.DEVICE_NOT_SUPPORTED:case t.TestDrive.UnavailableSessionReason.DEVICE_DISABLED:n=t.TestDrive.DialogTypes.DEVICE_DISABLED_DIALOG;break;case t.TestDrive.UnavailableSessionReason.AT_CAPACITY:n=t.TestDrive.DialogTypes.AT_CAPACITY_DIALOG;break;default:n=t.TestDrive.DialogTypes.ERROR_DIALOG}t.Navigation.showDialog("MSTDialogs",{dialogType:n})})},this.initializeTestDrive=function(){var t=e.Deferred();return n.invoke({},function(e){window.TestDriveBridge.initializeTestDrive(e)},t),t}};return new r}),define("api/caching",["jquery","api/appstore"],function(e,t){prof.markTime("^define_api/caching");var n={age:18e5},r,i,s,o;return r={frequency:108e5,key:"_cleanup"},i="Appstore.Caching",s=function(e){var t=JSON.stringify(e);return i+t},o={cleanup:function(t){var n=0,s=0,o=0,u,a;this.hasCleaned=!0,t&&console.log("Force cleaning cache"),u=this.getItem(r.key);if(!t&&u)return;console.log("Cache cleanup, total storage size: "+localStorage.length),e.map(localStorage,function(e,r){var u;if(!r||r.length<i.length||r.substring(0,i.length)!==i)return;try{u=JSON.parse(e)}catch(a){console.log("Exception caught while cleaning cache, removing offending entry"),delete localStorage[r];return}if(t||u.expire<=(new Date).getTime())o+=localStorage[r].length,delete localStorage[r],n+=1;s+=1}),a=0,a=n>0?o/n:0,console.log("Cache cleaned "+n+" of "+s+" items, totaling "+o+" average: "+a),this.setItem(r.key,!0,{age:r.frequency})},getItem:function(e){if(!e){console.log("Cache failure: no key specified");return}this.hasCleaned||this.cleanup();var t=localStorage[s(e)];if(!t)return;try{t=JSON.parse(t)}catch(n){console.log("Cache record parse exception, removing offending entry"),this.removeItem(e);return}if(t.expire<=(new Date).getTime()){console.log("Cache record expired: "+t.expire),this.removeItem(e);return}return t.value},setItem:function(e,t,r){this.hasCleaned||this.cleanup();var i=typeof r=="object"?r:{};if(!i.age||i.age<=0)i.age=n.age;try{return localStorage[s(e)]=JSON.stringify({key:e,value:t,settings:i,expire:i.age+(new Date).getTime()}),!0}catch(o){return console.log("Exception caught while setting item into cache"),o.name==="QUOTA_EXCEEDED_ERR"?(console.log("Quota exceeded exception, cleaning up cache"),this.cleanup(!0)):console.log("Unknown exception: "+o.name),!1}},removeItem:function(e){delete localStorage[s(e)]}},prof.markTime("$define_api/caching"),o}),define("api/feature-config",["jquery","api/appstore","api/bridge"],function(e,t,n){prof.markTime("^define_api/feature-config");var r,i=function(){function e(e,t,n,r){return function(i,s,o){return console.log("FeatureConfigBridge: Requesting feature: "+i+" key: "+s+" defaultValue: "+o),typeof i=="string"&&typeof s=="string"&&typeof o===e?n(window.FeatureConfigBridge[t](i,s,o)):r}}this.DIAGNOSE_AND_REPAIR="diagnoseAndRepair",this.isCollectAppUsagePrefFeatureEnabled=function(){return window.FeatureConfigBridge.isCollectAppUsagePrefFeatureEnabled()},this.getBoolean=e("boolean","getBoolean",Boolean,!1),this.getString=e("string","getString",String,null),this.getDouble=e("number","getDouble",Number,0),this.getInt=e("number","getInt",Number,0),this.getLong=e("number","getLong",Number,0),this.getConfig=function(e){var t=window.FeatureConfig.getConfig(e);return t?JSON.parse(String(t)):{}}};return r=new i,prof.markTime("$define_api/feature-config"),r}),define("api/new-bridge",[],function(){var callbacks={},currentId=0,debug=!1,Bridge=function(){};return Bridge.makeRequest=function(name,method,params,deferred){if(!name||!method){debug&&console.log("Invalid request");return}currentId+=1;var request={requestId:currentId,parameters:params||{}};return window[name]&&(debug&&console.log("Executing request: "+name+"."+method+"(...)"),callbacks[currentId]=deferred,eval("window[name][method](JSON.stringify(request));")),deferred},Bridge.completeRequest=function(e,t,n){debug&&console.log([e,JSON.stringify(t),JSON.stringify(n)].join(" , "));if(!e){debug&&console.log("No requestId, ignoring callback");return}var r=callbacks[e]||null;if(!r){debug&&console.log("No deferred, ignoring callback");return}n?r.reject(t.response):r.resolve(t.response),delete callbacks[e]},window.Bridge=Bridge,Bridge}),require(["jquery"],function(e){(function(e){var t={};e.publish=function(n,r){var i=t[n],s;if(i)for(s=0;s<i.length;s++)i[s].apply(e,[].concat(r))},e.subscribe=function(e,n){return t[e]||(t[e]=[]),t[e].push(n),[e,n]},e.unsubscribe=function(n){if(n){var r=n[0];t[r]&&e.each(t[r],function(e){this==n[1]&&t[r].splice(e,1)})}}})(jQuery)}),define("lib/pubsub",[],function(){});var Class,ResourcesBridge;define("api/datetime",[],function(){return Class.extend({init:function(e,t){this.type=e||"MEDIUM",this.deviceLocale=t||!1},formatYMD:function(e,t,n){var r=ResourcesBridge.formatDate(this.type,e,t,n,this.deviceLocale);return r?String(r):null},formatDate:function(e){return this.formatYMD(e.getFullYear(),e.getMonth()+1,e.getDate())},formatDateMs:function(e){var t=new Date(e);return this.formatDate(t)}})});var Class,WebInvokerBridge,WorkflowBridge;define("api/entitlements",["require","api/appstore","api/bridge","jquery"],function(e){var t,n=e("api/appstore"),r=e("api/bridge"),i=e("jquery");return t=Class.extend({State:{AVAILABLE:"AVAILABLE",ARCHIVED:"ARCHIVED"},Error:{ENTITLEMENT_CHANGE_NOT_APPLIED:"Appstore.Entitlements.EntitlementChangeNotApplied"},updateEntitlementState:function(e,t){var r,s;return s={asin:e,newState:t},r=n.WebInvoker.invoke("updateEntitlementState",s),r.pipe(function(e){var t=JSON.parse(e.message),r=i.Deferred();return t.isUpdated?r.resolve():r.reject(new n.Error(this.Error.ENTITLEMENT_CHANGE_NOT_APPLIED)),r})},archiveApp:function(e,t,n){if(e.asin===undefined||e.currentVersion===undefined||e.title===undefined)throw{name:"IllegalArgument",message:"Missing a required value: "+JSON.stringify(e)};var s=i.Deferred().done(t).fail(n);r.invoke(function(t){i.extend(t.args,e),WorkflowBridge.deleteApplication(JSON.stringify(t))},s)}}),new t}),define("appstore",["lib/classframework","api/appstore","api/account","api/authentication","api/catalog","api/cor-pfm","api/customer-data","api/device","api/device-features","api/parental-controls","api/download","api/event","api/feedback","api/get-started","api/giftcard","api/install","api/locker","api/navigation","api/preferences","api/purchase","api/recently-viewed","api/recorder","api/resources","api/review","api/search","api/settings","api/subscriptions","api/update","api/wishlist","api/bridge","api/testdrive","api/database","api/caching","api/feature-config","api/new-bridge","lib/pubsub","api/datetime","api/entitlements"],function(e,t,n,r,i,s,o,u,a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T,N,C,k,L,A,O,M,_,D,P){return prof.markTime("^define_appstore"),t.Account=n,t.Authentication=r,t.Catalog=i,t.CorPfm=s,t.CustomerData=o,t.Device=u,t.DeviceFeatures=a,t.ParentalControls=f,t.Download=l,t.Event=c,t.Feedback=h,t.GetStarted=p,t.GiftCard=d,t.Install=v,t.Locker=m,t.Navigation=g,t.SharedPreferences=y,t.Purchase=b,t.RecentlyViewed=w,t.Recorder=E,t.Recorder.Android=E.Android,t.Recorder.Java=E.Java,t.Recorder.Java.Logger=E.Java.Logger,t.Recorder.Metrics=E.Metrics,t.Resources=S,t.Review=x,t.Search=T,t.Settings=N,t.Subscriptions=C,t.Update=k,t.WishList=L,t.Bridge=A,t.TestDrive=O,t.Database=M,t.Caching=_,t.FeatureConfig=D,t.NewBridge=P,window.Appstore=t,prof.markTime("$define_appstore"),t}),define("widget/Dialog",["require","jquery","appstore"],function(t){var n=t("jquery"),r=t("appstore");return{showNative:function(e){var t,n,i;n=e.noButton||e.button,i=e.noButtonFn||e.buttonFn,console.log("Dialog: title: "+e.title+" text: "+e.text),console.log("Dialog: noButton: "+n+" yesButton: "+e.yesButton),t=r.Resources.getStrings(e.title,e.text,n,e.yesButton),t.done(function(t,s,o,u){var a={dialogType:"Dialog",title:t,message:s,noButton:o};e.translatedText&&(a.message=e.translatedText),e.yesButton&&(a.yesButton=u),e.isNetworkDialog&&(a.isNetworkDialog=e.isNetworkDialog),r.Navigation.showDialog("NativeDialog",a,function(t){n&&t.action==="no/ok"?i&&i(t):e.yesButton&&t.action==="yes"?e.yesButtonFn&&e.yesButtonFn(t):e.noActionFn&&e.noActionFn(t)})})}}}),define("../libs/fastscroll",["require"],function(e){return Function.prototype.hasOwnProperty("bind")||(Function.prototype.bind=function(){var e=function(e){return Array.prototype.slice.call(e)};if(arguments.length<2&&typeof arguments[0]=="undefined")return this;var t=this,n=e(arguments),r=n.shift();return function(){return t.apply(r,n.concat(e(arguments)))}}),function(){this.didScroll=!1,this.origin={x:0,y:0},this.offset={x:0,y:0},this.originScrollY=0,this.carousel=null,this.navbar=null,this.carouselOriginX=0,this.navbarOriginX=0,this.boundTouchMove={},this.boundTouchEnd={},this.boundOnClick={},this.milliseconds=0,this.margin=3,this.navbarMargin=10,this.coordinates={x:0,y:0},this.speed={x:0,y:0},this.updateInterval=0,this.timestep=10,this.fingerOnScreen=!1,this.windowWidth=0,this.uiFreeze=10,this.verticalScroll=null,this.verticalScrollOriginY=0,this.onStart=function(){document.addEventListener("touchstart",this.setupEvents.bind(this)),$(".page-navigation-list").delegate(".page-navigation-list-item a","click",function(){return this.uiFreeze=0,$(".page-navigation-list").data("left",0),setTimeout(function(){this.uiFreeze=10}.bind(this),500),!0}.bind(this))},this.setupEvents=function(e){var t=!1,n;document.addEventListener("touchmove",this.boundTouchMove),document.addEventListener("touchend",this.boundTouchEnd),document.addEventListener("touchcancel",this.boundTouchCancel);var r=e.touches[0].target,i;this.carousel=null,this.carouselWidth=0,$(".detail-stage").length&&$(".detail-header").length&&(n=$(".detail-header"),n.width()<n.height()&&(this.carouselWidth=n.width()+20*window.devicePixelRatio)),this.navbar=null,this.navbarWidth=0,this.verticalScroll=null,this.verticalScrollHeight=0,this.verticalFrameHeight=0;while(r){i=$(r);if(i.hasClass("carousel")&&i.hasClass("horizontal")){this.carousel=r,typeof (this.carouselOriginX=this.carouselDataLeft)=="undefined"&&(this.carouselOriginX=0,this.carouselDataLeft=0),$(".carousel-list .carousel-list-item",this.carousel).each(function(e,t){this.carouselWidth+=$(t).outerWidth(!0)+this.margin*window.devicePixelRatio}.bind(this)),this.carouselBlock=$(".carousel-list",this.carousel);break}i.hasClass("page-navigation-list")?(this.navbar=r,typeof (this.navbarOriginX=$(this.navbar).data("left"))=="undefined"&&(this.navbarOriginX=0,$(this.navbar).data("left",0)),this.navbarWidth=0,$("li",this.navbar).each(function(e,t){this.navbarWidth+=$(t).width()+this.navbarMargin*window.devicePixelRatio}.bind(this))):i.hasClass("popover-inner")&&(this.verticalScroll=r,this.verticalScrollHeight=$(r).height(),this.verticalFrameHeight=$(".popover-frame").height(),typeof (this.verticalScrollOriginY=$(this.verticalScroll).data("top"))=="undefined"&&(this.verticalScrollOriginY=0,$(this.verticalScroll).data("top",0))),r=r.parentNode}clearInterval(this.updateInterval),this.origin=this.coordinates={x:e.touches[0].clientX,y:e.touches[0].clientY},this.originScrollY=window.scrollY,this.milliseconds=(new Date).getTime(),this.firstMove=!0,this.lockVertical=!1,this.lockHorizontal=!1,this.fingerOnScreen=!0,this.offset={x:0,y:0},this.didScroll=!1,this.windowWidth=$(window).width(),this.windowHeight=$(window).height(),this.updateInterval=setInterval(this.idle.bind(this),50)},this.idle=function(){var e,t,n,r,i,s,o,u,a,f,l,c,h;if(this.uiFreeze<10){this.uiFreeze++;return}if(this.fingerOnScreen)i={x:this.coordinates.x-this.origin.x,y:this.coordinates.y-this.origin.y},s={x:i.x-this.offset.x,y:i.y-this.offset.y},s.x!==0&&s.y!==0&&(this.speed=s),this.firstMove&&(this.carousel||this.navbar)&&Math.abs(i.x)>Math.abs(i.y)*.5?this.lockHorizontal=!0:this.firstMove&&Math.abs(i.y)>Math.abs(i.x)*.5&&(this.lockVertical=!0),this.lockHorizontal?this.carouselWidth>this.windowWidth?(u=0,a=-this.carouselWidth+this.windowWidth,this.carousel&&!this.lockVertical&&(e=Math.max(Math.min(this.carouselOriginX+this.offset.x,u),a),this.carouselBlock.css("webkitTransform","translateX("+e+"px) translateZ(0)"),this.carouselDataLeft=e)):this.navbarWidth>this.windowWidth&&(u=0,a=-this.navbarWidth+this.windowWidth,this.navbar&&!this.lockVertical&&(e=Math.max(Math.min(this.navbarOriginX+this.offset.x,u),a),$("li",this.navbar).css("webkitTransform","translateX("+e+"px) translateZ(0)"),$(this.navbar).data("left",e))):(window.scrollTo(0,this.originScrollY-this.offset.y),this.verticalScrollHeight>this.verticalFrameHeight&&(f=0,l=-this.verticalScrollHeight+this.verticalFrameHeight,this.verticalScroll&&(e=Math.max(Math.min(this.verticalScrollOriginY+this.offset.y,f),l),$(".popover-scroller",this.verticalScroll).css("webkitTransform","translateY("+e+"px) translateZ(0)"),$(this.verticalScroll).data("top",e)))),this.offset={x:i.x,y:i.y},i.x>0&&(this.firstMove=!1);else{t=+(new Date),n=t-this.milliseconds,this.speed.x*=.95,this.speed.y*=.95;if(Math.abs(this.speed.x)<3&&Math.abs(this.speed.y)<3||n>1500)clearInterval(this.updateInterval),$(this.carousel).data("left",this.carouselDataLeft);this.lockHorizontal||window.scrollTo(0,window.scrollY-Math.floor(this.speed.y)),this.carousel&&!this.lockVertical?this.carouselWidth>this.windowWidth&&(h=this.carouselDataLeft,u=0,a=-this.carouselWidth+this.windowWidth,e=Math.max(Math.min(h+this.speed.x,u),a),this.carouselBlock.css("webkitTransform","translate3d("+e+"px,0,0)"),this.carouselDataLeft=e):this.navbar&&!this.lockVertical?this.navbarWidth>this.windowWidth&&(h=$(this.navbar).data("left"),u=0,a=-this.navbarWidth+this.windowWidth,e=Math.max(Math.min(h+this.speed.x,u),a),$(this.navbar).data("left",e),$("li",this.navbar).css("webkitTransform","translateX("+e+"px) translateZ(0)")):this.verticalScroll&&this.verticalScrollHeight>this.verticalFrameHeight&&(c=$(this.verticalScroll).data("top"),f=0,l=-this.verticalScrollHeight+this.verticalFrameHeight,e=Math.max(Math.min(c+this.speed.y,f),l),$(this.verticalScroll).data("top",e),$(".popover-scroller",this.verticalScroll).css("webkitTransform","translateY("+e+"px) translateZ(0)"))}},this.onTouchMove=function(e){e.preventDefault(),this.coordinates={x:e.touches[0].clientX,y:e.touches[0].clientY},this.didScroll=!0},this.onTouchEnd=function(e){document.removeEventListener("touchmove",this.boundTouchMove),document.removeEventListener("touchend",this.boundTouchEnd),document.removeEventListener("touchcancel",this.boundTouchCancel),this.fingerOnScreen=!1,this.milliseconds=+(new Date),this.originScrollY=window.scrollY,this.speed.x*=.5},this.onTouchCancel=function(e){this.onTouchEnd(e)},this.boundTouchMove=this.onTouchMove.bind(this),this.boundTouchEnd=this.onTouchEnd.bind(this),this.boundTouchCancel=this.onTouchCancel.bind(this),this.onStart()}}),define("models/InstallProgressModel",["require","api/resources","jquery","api/device-features","api/locker"],function(t){function o(e){var t={checkOwnership:2,deviceChallengeWorkflow:4,enactPurchase:10,requestPurchaseDetails:60,purchaseComplete:100},n;return n=t[e],n===undefined?0:n}function u(e,t){var r={none:"",purchasing:"AppInstallProgress_progress_purchasing",pending_download:"AppInstallProgress_progress_downloading",paused_download:"AppInstallProgress_progress_download_paused",downloading:"AppInstallProgress_progress_downloading",pending_install:"AppInstallProgress_progress_pending_install",installing:"AppInstallProgress_progress_installing",done:"AppInstallProgress_progress_done",downloadLimitReached:"no_wifi_conn_paused",user_input_required:"AppInstallProgress_progress_download_paused",sd_required:"AppInstallProgress_progress_download_paused",externalStorageMediaShared:"AppDownloadPaused_media_shared"};return e==="purchasing"&&t==="purchaseComplete"&&(e="pending_download"),n.getString(r[e])}function a(e){var t={purchase:["AppPurchase.","purchasing",!0,!1,"purchaseGeneralFailure"],download:["AppDownload.","downloading",!0,!1,"downloadGeneralFailure"],install:["Install.","installing",!0,!1,"installGeneralFailure"],pdi:["AppPurchase.",null,!1,!0],di:["AppDownload.",null,!1,!0]};return e?t[e]:t}function f(e){var t={"mas.device.purchase.error.failure_general":{fallback:"purchase_failure_general"},"mas.device.purchase.error.failure_already_owned":{fallback:"purchase_failure_already_owned"},"mas.device.purchase.error.failure_no_default_payment_method":{fallback:"purchase_failure_no_credit_card",sso:{title:"payment_failed_title",message:"purchase_failure_sso_no_credit_card",posButton:"default_okbuttontext"}},"mas.device.purchase.error.failure_no_address":{fallback:"purchase_failure_no_address",sso:{title:"payment_failed_title",message:"purchase_failure_sso_no_address",posButton:"default_okbuttontext"}},"mas.device.purchase.error.failure_offer":{fallback:"purchase_failure_offer"},"mas.device.purchase.error.failure_version_changed":{fallback:"purchase_failure_version_changed"},"mas.device.purchase.error.failure_price_changed":{fallback:"purchase_failure_price_changed"},"mas.device.purchase.error.failure_foreign":{fallback:"purchase_failure_foreign"},"mas.device.purchase.error.failure_marketplace_changed":{fallback:"purchase_failure_inconsistent_cor"},purchaseInsufficientZeroes:{fallback:"purchase_failure_insufficient_zeroes"},purchaseZeroesEligibilityError:{fallback:"purchase_failure_zeroes_eligibility_error"},purchaseZeroesServiceError:{fallback:"purchase_failure_zeroes_service_error"},"POLICY_CHECK::NO_NETWORK":{fallback:"download_failure_no_internet"},"POLICY_CHECK::TOO_LARGE":{fallback:"download_failure_too_large_for_cellular"},"POLICY_CHECK::TOO_LARGE_SETTINGS":{fallback:"download_failure_too_large_for_cellular_with_current_settings"},downloadGeneralFailure:{fallback:"download_failure_general"},shared:{fallback:"download_failure_sd_card"},downloadNoConnection:{fallback:"download_failure_no_internet"},downloadTooLargeForCellular:{fallback:"download_failure_too_large_for_cellular"},downloadTooLargeForCellularWithCurrentSettings:{fallback:"download_failure_too_large_for_cellular_with_current_settings"},installAwaitInstallFailure:{hidden:!0},installAwaitUninstallFailure:{hidden:!0},installGeneralFailure:{fallback:"install_failure_general"},installBadApk:{fallback:{title:"cant_install_title",message:"cant_install_message",negButton:"cant_install_button"}},installSystemHasDifferentSignature:{fallback:{title:"cant_uninstall_system_app_title",message:"cant_uninstall_system_app_message",negButton:"cant_uninstall_system_app_button"}},installApkNotSigned:{fallback:{title:"cant_install_unsigned_app_title",message:"cant_install_unsigned_app_message",negButton:"cant_install_unsigned_app_button"}},installPreInstallVerificationFailure:{fallback:{title:"cant_install_corrupt_app_title",message:"cant_install_corrupt_app_message",negButton:"cant_install_corrupt_app_button"}},installPostInstallVerificationFailure:{},installFailedInsufficientStorage:{fallback:{title:"cant_install_title",message:"cant_install_insufficient_storage_app_message",negButton:"default_okbuttontext"},library:{title:"cant_install_title",message:"cant_install_insufficient_storage_app_message_library",negButton:"default_okbuttontext"}},installFailedDexopt:{fallback:{title:"cant_install_title",message:"cant_install_dexopt_app_message",negButton:"default_okbuttontext"},library:{title:"cant_install_title",message:"cant_install_dexopt_app_message_library",negButton:"default_okbuttontext"}},userNotAuthenticated:{fallback:{title:"signed_out_title",message:"signed_out_message",shouldReload:!0}},customerIdentityError:{fallback:"label_noCountry_code"},installFailedNotPermissible:{fallback:{title:"cant_install_title",message:"app_not_permissible_message",negButton:"default_okbuttontext"}}};return window.appPreloadState.isAmazonDevice&&(t.installFailedInsufficientStorage.fallback.message="cant_install_insufficient_storage_app_message_kindle",t["mas.device.purchase.error.failure_already_owned"].fallback="purchase_failure_already_owned_kindle"),t[e]}function l(e){return e&&e.reason&&(e.reason.messageKey==="purchaseInconsistentCorError"||e.reason.messageKey==="mas.device.purchase.error.failure_marketplace_changed")}function c(e,t){var s;return i.getValueOf(i.Keys.SSO)&&e.sso?s=e.sso:i.getValueOf(i.Keys.CLOUD_LIBRARY)&&e.library?s=e.library:s=e.fallback,typeof s=="string"?s={title:"",message:n.getString(s,[t]),negButton:n.getString("default_okbuttontext")}:r.each(s,function(e,r){s.hasOwnProperty(e)&&(s[e]=n.getString(r,[t]))}),s}function h(e){var t,n;return t="installGeneralFailure",e=-1*e,n={1:t,2:"installBadApk",3:t,4:"installFailedInsufficientStorage",5:t,6:t,7:t,8:t,9:t,10:t,11:"installFailedDexopt",12:t,13:t,14:t,15:t,16:t,17:t,18:t,19:t,20:t,100:t,101:t,102:t,103:"installApkNotSigned",104:"installSystemHasDifferentSignature",105:t,106:t,107:t,108:t,109:t,110:t},n[e]?n[e]:t}function p(e,t,n){var r,i,s,o,a,l,p,d,v,m,g,y,b,w,E,S,x,T,N,C,k,L,A,O,M,_,D,P,H,B,j,F,I,q,R,U,z;return console.log("handleActionEvent: intent = "+JSON.stringify(e)),g={},r=0,i="com.amazon.mas.client.MACS_INTENT_TYPE",k="com.amazon.mas.client.download.DOWNLOAD_STARTED",s="com.amazon.mas.client.download.DOWNLOAD_PROGRESS",o="com.amazon.mas.client.download.DOWNLOAD_COMPLETE",A="com.amazon.mas.client.download.DOWNLOAD_FAILED",B="com.amazon.mas.client.pdiservice.PdiService.downloadUrlFailed",j="com.amazon.mas.client.pdiservice.PdiService.generateApkLocationFailure",I="com.amazon.mas.client.download.DOWNLOAD_PAUSED",a="com.amazon.mas.client.purchaseservice.PurchaseResponse.PURCHASE_RESPONSE",l="com.amazon.mas.client.install.ENQUEUED",L="com.amazon.mas.client.install.INSTALL_STATE_CHANGE",C="com.amazon.mas.client.install.INSTALL_COMPLETED",_="com.amazon.mas.client.install.INSTALL_FAILED",O="com.amazon.mas.client.pdiservice.PdiService.pdiInitiated",M="com.amazon.mas.client.pdiservice.PdiService.pdiComplete",P="MACS.install.result.resultCode",R="POLICY_CHECK::NO_NETWORK",U="POLICY_CHECK::TOO_LARGE",z="POLICY_CHECK::TOO_LARGE_SETTINGS",p="MACS.downloadservice.cumulativeBytes",v="MACS.downloadservice.totalBytes",H="MACS.downloadservice.completionMessage",b="com.amazon.mas.client.purchaseservice.PurchaseResponse.success",w="com.amazon.mas.client.purchaseservice.PurchaseResponse.displayMessageKey",F="com.amazon.mas.client.pdiservice.PdiService.generateApkLocationFailure.reason",T="title",e&&e.extras&&(N=e.extras[T]||"this app",y=e.extras[i],d=Number(e.extras[p]),m=Number(e.extras[v]),y===k?(S="downloading",r=0):y===s?(S="downloading",m&&m!==0&&!isNaN(m)&&(r=Math.floor(100*d/m))):y===O?(S="purchasing",r=5):y===a?(S="purchasing",r=100,!1===e.extras[b]&&(r=0,x=f(e.extras[w]),E=c(x,N),g.errorDetails=E)):y===o?(S="installing",r=5):y===A?(x=f(e.extras[H]),console.log("downloadFailed::raw error is "+JSON.stringify(x)),x||(x=f("downloadGeneralFailure")),E=c(x,N),g.errorDetails=E):y===B?(console.log("Download url failure"),E=c(f("downloadGeneralFailure"),N),g.errorDetails=E):y===j?(console.log("Download apk location failure"),x=f(e.extras[F]),E=c(x,N),g.errorDetails=E,console.log("Download failed!")):y===I?(console.log("download paused"),S="paused_download",m&&m!==0&&!isNaN(m)&&(r=Math.floor(100*d/m)),e.extras["MACS.downloadservice.autoRestart"]||(q=e.extras[H],console.log("download paused, msg is "+q),R===q?(E=c(f("downloadNoConnection"),N),g.errorDetails=E):U===q?(E=c(f("downloadTooLargeForCellular"),N),g.errorDetails=E):z===q&&(E=c(f("downloadTooLargeForCellularWithCurrentSettings"),N),g.errorDetails=E))):y===l?(S="installing",r=40):y===L?(S="installing",r=60):y===C?(S="installing",r=100):y===_?(D=e.extras[P],D||(D=0),D!==-104&&(x=f(h(D)),E=c(x,N),g.errorDetails=E)):y===M&&(S="installing",r=100,g.done=!0)),g.installProgress=u(S,""),console.log("getProgressText("+S+") is "+g.installProgress),g.installPercent=r+"%",n&&!g.errorDetails?null:g}var n=t("api/resources"),r=t("jquery"),i=t("api/device-features"),s=t("api/locker");return{getAsinFromWorkflowEvent:function(e){var t;return t=e.extras,t["com.amazon.mas.client.purchaseservice.PurchaseRequest.asin"]},fromLocalState:function(e,t,n,i){function m(e){a={local:e[0]},c.resolve(a)}var o,a,f,l,c=r.Deferred(),h,p=t&&t.installPercent||"0%",d,v;l=e&&(e.localState||e.state),d=i&&i.expectedAsin,v=e&&e.asin;if(d&&v&&d!==v)return console.log("expectedAsin does not match actualAsin; do not update"),c.reject(),c;if(l){if(l==="Purchasing")o={installProgress:u("purchasing"),installPercent:p},f={isDownloaded:!1,isPurchased:!1};else if(l==="DownloadPaused")o={installPercent:p},f={isPurchased:!0},e.pausedReason==="downloadLimitReached"?o.installProgress=u("downloadLimitReached"):e.pausedReason==="sdCardRequired"?o.installProgress=u("sd_required"):e.pausedReason==="requiresUserInput"?o.installProgress=u("user_input_required"):e.pausedReason==="externalStorageMediaShared"?o.installProgress=u("externalStorageMediaShared"):o.installProgress=u("paused_download");else if(l==="DownloadQueued")o={installProgress:u("pending_download"),installPercent:p},f={isPurchased:!0};else if(l==="Downloading")o={installProgress:u("downloading"),installPercent:p},f={isPurchased:!0};else if(l==="Installing")o={installProgress:u("installing"),installPercent:p},f={isDownloaded:!0,isPurchased:!0};else if(l==="InstallPaused")f={isDownloaded:!0,isPurchased:!0},e.pausedReason!=="awaitingActivity"&&(o=!1);else if(l==="None"&&!n)return h=new s,h.getLocalDetailsByAsin(e.asin).done(m),c;if(o||f)a={},o?a.installDetails=o:o===!1&&(a.installDetails=!1),f&&(a.local=f)}return c.resolve(a),n?a:c},fromWorkflowEvent:function(e,t){var n,r,i,s,o,u,a,f,l;return console.log("fromWorkflowEvent: spec = "+JSON.stringify(t)),l="com.amazon.mas.client.purchaseservice.PurchaseRequest.asin",a=t&&t.expectedAsin,f=t&&t.errorOnly,n=e.extras,a&&(!n[l]||n[l]!==a)?(console.log("ASIN did not match expected ASIN, returning null"),null):p(e,s,f)}}}),define("receiver/FulfillmentErrorReceiver",["require","jquery","templates","api/navigation","models/InstallProgressModel"],function(t){function u(e){var t={dialogType:"FulfillmentErrorDialog",title:e.title,posButton:e.posButton,negButton:e.negButton,message:e.message},n;e.shouldReload?n=i.restart:n=function(){},i.showDialog("NativeDialog",t,n,n)}function a(e){var t=s.fromWorkflowEvent(e,{errorOnly:!0});if(!t)return;u(t.errorDetails)}var n=t("jquery"),r=t("templates"),i=t("api/navigation"),s=t("models/InstallProgressModel"),o;return o=function(){throw{name:"DoNotInstantiate",message:"This function should not be called with new or otherwise."}},o.start=function(){n.subscribe("com.amazon.mas.client.MACS_PDI_CHANGE",a)},o}),window.Hyphenator=new Hyphenator,define("../libs/hyphenator2",[],function(){}),define("plugins/touch",["jquery"],function(e){function i(e){return e.hasOwnProperty("tagName")?e:e.parentNode}function s(){n=null,t.last&&(e(t.target).trigger("longpress"),t={})}function o(){n&&clearTimeout(n),n=null}function u(){o(),t={}}var t={},n,r=750;e(document.body).bind("touchstart",function(e){t={};var o=Date.now();t.target=i(e.originalEvent.touches[0].target),t.x1=e.originalEvent.touches[0].screenX,t.y1=e.originalEvent.touches[0].screenY,t.last=o,t.tapCanceled=!1,n=setTimeout(s,r)}).bind("touchmove",function(e){var n,r;o(),t.x2=e.originalEvent.touches[0].screenX,t.y2=e.originalEvent.touches[0].screenY,n=Math.abs(t.x2-t.x1),r=Math.abs(t.y2-t.y1);if(n>30||r>30)t.tapCanceled=!0}).bind("touchend",function(n){o(),Math.abs(t.x1-t.x2)>30||Math.abs(t.y1-t.y2)>30?t={}:!t.tapCanceled&&t.hasOwnProperty("last")&&e(t.target).trigger("tap"),t={}}).bind("touchcancel",u),["tap","longpress"].forEach(function(t){e.fn[t]=function(e){return this.bind(t,e)}})}),define("plugins/whenUpdated",["jquery"],function(e){return e.whenUpdated=function(t){var n=e.map(arguments,function(t){var n=e.Deferred(),r=t[0];return r.addEventListener("DOMSubtreeModified",function(){n.resolve()}),n});return e.when.apply(e,n)},{}}),define("zeroes/ZeroesLoader",["require","jquery","api/customer-data","api/device-features"],function(t){function f(e){setTimeout(e,0)}function l(e){var r=n.Deferred();return t([e],function(e){r.resolve(e)}),r}function c(){var e=n.Deferred();return l("libs/zeroes-adapters").done(function(t){var r=l("api/appstore"),i=l("api/new-bridge"),s=n.when(r,i);s.done(function(r,i){t.provideDependency("jquery",n),t.provideDependency("api/appstore",r),t.provideDependency("api/Bridge",i),t.provideDependency("bridges/IntentBridge",window.IntentBridge),t.provideDependency("bridges/ActivityBridge",window.ActivityBridge),e.resolve(t)})}),e}function h(e){var t=n.Deferred();return c().done(function(n){var r;for(r=0;r<a.length;r+=1)e.registerAdapter(a[r],n.getAdapter(a[r]));t.resolve()}),t}function p(){var e=r.getCustomerCorPfm();return e.done(function(e,t){s.cor=e,s.pfm=t})}function d(){var e=s.treatment==="T1",t=s.cor==="US"&&s.pfm==="ATVPDKIKX0DER";u=e&&t&&s.isAmazonDevice}function v(e,t){var r=n.Deferred(),i;return e.configure(t),i=h(e),i.done(function(){e.initialize(),f(function(){n.publish("Appstore.Loaded")},0),r.resolve()}),r}function m(e,t){var r=n.Deferred(),i,o;return f(function(){prof.markTime("^zeroes_library_initialize"),i=l("libs/zeroes"),o=l(e),n.when(i,o).done(function(e,n){s.storeConfig=n,s.pageConfig=t,v(e,s).done(function(){prof.markTime("$zeroes_library_initialize"),r.resolve(u)})})}),r.promise()}var n=t("jquery"),r=t("api/customer-data"),i=t("api/device-features"),s={},o=!1,u,a;return a=["BalanceAdapter","ZeroesBundleAdapter","PreviewTaxAdapter","NavigationAdapter","ParentalControlsAdapter","MetricsAdapter","PreferenceAdapter","AjaxAdapter"],{STORE_CONFIG_TYPES:{Generic:"zeroes/config/appstore",Detail:"zeroes/config/appstore-detail",Iap:"zeroes/config/iap"},initializeAsync:function(e,t){if(o)return n.Deferred().resolve(!1);if(!e)throw new Error("[Zeroes] Unable to initialize; A store config type must be given");return u?m(e,t||{}):(console.log("[Zeroes] Zeroes is unavailable; COR = "+s.cor+", PFM = "+s.pfm," Treatment = "+s.treatment),n.Deferred().resolve(!1))},configure:function(){s.treatment=i.getZeroesTreatment(),s.cssLocation="./assets/css/amazon-phoenix/compositions/zeroes.css",s.deviceType=window.appPreloadState.isAmazonDevice,s.isAmazonDevice=Boolean(window.appPreloadState.isAmazonDevice),p().done(d)},isEnabled:function(){return!o&&u},disable:function(){o=!0}}});var WebRequestPrefetch;define("start",["require","jquery","appstore","api/authentication","api/caching","api/cor-pfm","api/customer-data","api/device","api/device-features","widget/Dialog","../libs/fastscroll","api/feature-config","receiver/FulfillmentErrorReceiver","../libs/hyphenator2","api/navigation","api/recorder","api/preferences","templates","plugins/touch","plugins/whenUpdated","zeroes/ZeroesLoader","templatesDS"],function(e){function j(e){function w(){var r,i,s,o,a,f,l;n||(f=c.attr("href").split("/"),i=f[f.length-1].split("-")[2],s={small:.032,medium:.032,large:.025,xlarge:.021},o=Math.floor((document.body.clientWidth+document.body.clientHeight)/2),n=Math.floor(o*s[i]),localStorage.setItem("baseFont",n));if(document.activeElement.tagName==="BODY"){l=parseInt(window.getComputedStyle(document.getElementsByTagName("html")[0]).fontSize,10);if(isNaN(l)||l<10&&n<100)p.html("html { font-size: "+n+"px !important; }"),localStorage&&localStorage.setItem("baseFont",n)}B=String(u.getAssetLocation(v)),console.log("Adding Script: "+B),p.attr("type","text/css"),t("head").append(p),document.body.className+=" loaded",a=document.createElement("script"),a.type="text/javascript",a.src=B,document.body.appendChild(a),e()}var n,r,i,s,o,u=window.BootstrapBridge,a=window.WebkitInspectorBridge,f=window.MASNativeBridge,l=window.AuthenticationBridge,c=t("#page-style"),h,p=t("#base-font"),d,v,m="A3GQ13NO86T9P1",g="A2RCJFK4URDQYN",y="A12H34Q8NBY5PA",b="AEFRIE722DUD5";c.attr("href",window.appPreloadState.cssAssetUri),prof.markTime("first_vars");if(window.appPreloadState.isAmazonDevice){t("body").addClass("amazon-device");switch(window.appPreloadState.isAmazonDevice){case m:n=18;break;case g:n=23;break;case y:case b:n=29}localStorage.baseFont=n}localStorage&&!n&&(n=localStorage.getItem("baseFont")),n&&p.html("html { font-size: "+n+"px !important; }"),prof.markTime("base_font"),a&&(r=a.getWebkitRemoteInspectorUrl(),r&&(i=document.createElement("script"),i.type="text/javascript",i.src=r,document.body.appendChild(i),console.log("Setting Debug Script URL : "+r))),prof.markTime("inspector"),h=window.appPreloadState.extras,h=h?JSON.parse(h):{},v=h.page,console.log("PAGE: "+v),prof.markTime("extras"),!/Dialog/i.test(v)&&l&&!l.isSSOSupported()&&!l.isRegistered()&&(console.log("SSO not supported and not Registered. Show SignIn Page."),v="SignIn"),v=v||"Gateway",prof.markTime("page"),WebRequestPrefetch.invoke(v,h),console.log("PAGE: "+v),prof.markTime("prefetch"),prof.markTime("set_css_href"),n?(w(),prof.markTime("render_page")):(o=setInterval(function(){document.body.setAttribute("data-screensize",(document.body.clientWidth+document.body.clientHeight)/2)},5),s=setInterval(function(){document.readyState==="complete"&&(setTimeout(w,500),clearInterval(s))},50),setTimeout(function(){clearInterval(s)},5e3),setTimeout(function(){clearInterval(o)},500))}function F(){var e=/(\d+\.\d+)/.exec(window.appPreloadState.releaseVersion);return e?parseFloat(e[1]):null}function I(){var e="",n=F();return n<2.3?e="froyo":n<3?e="gb":n<4?e="hc":e="ics",t("body").addClass(e),e}function q(){f.showNative({title:"title_country_changed",text:"body_country_changed",noActionFn:d.restart,button:"AlertDialog_button_AppNotAvailable"})}function R(){a.getAssetLocations("css-portrait","css-landscape").done(function(e,n){var r=window.currentOrientation==="port"?e:n;t("#page-style").attr("href",r),t(".action-buttons").removeClass("full-width"),setTimeout(function(){var e,n,r,i;t.publish("com.amazon.venezia.android_lifecycle.onConfigChange.cssLoaded"),t("body:not(.ics) .popover-scroller").data("top",0).css("webkitTransform","translateX(0) translateZ(0)"),(n=t('.action-buttons:not(".full-width")')).length&&n.each(function(n,s){if((e=t("button",s).get()).length){i=t(e[0]).offset().top;for(r=1;r<e.length;r+=1)if(t(e[r]).offset().top>i){t(".action-buttons").addClass("full-width");break}}})},D)})}function U(){var e={},n="",r={small:2,medium:2,large:6,xlarge:8},i="";t(".carousel").length>0&&(n=t("#page-style").attr("href").split("/"),i=n[n.length-1].split("-")[2],e=t(".horizontal.carousel .asin-list").filter(function(){return t(this).children("li").length<=r[i]}),e.each(function(e,n){var r=t(n).closest(".horizontal.carousel");r.parent().append(r)}))}function z(){window.currentOrientation?R():a.getCurrentScreenOrientation().done(function(e){window.currentOrientation=e,R()})}function W(){var e=i.getItem(A),t=i.getItem(O);g.log("CORPFM-UI-clearCacheIfCorPfmChanged: oldCor = "+e+" oldPfm = "+t);if(!e||!t)i.setItem(A,N),i.setItem(O,C);else if(e!==N||t!==C)g.log("CORPFM-UI-clearCacheIfCorPfmChanged: cor or pfm is different. Clearing cache."),i.cleanup(!0),i.setItem(A,N),i.setItem(O,C)}function X(){var e=i.getItem(M);g.log("CORPFM-UI-clearCacheIfDeviceLanguageChanged: oldLanguage = "+e),e?e!==k&&(g.log("CORPFM-UI-clearCacheIfDeviceLanguageChanged: oldLanguage is different. Clearing cache."),i.cleanup(!0),i.setItem(M,k)):i.setItem(M,k)}function V(){_||(_=!0,g.info("CORPFM-UI-navigateToGateway"),L==="Gateway"&&d.finish(),d.navigateToSSRPage("Gateway",d.GATEWAY_URL))}function $(){g.info("CORPFM-UI-resourcesChanged: navigating to Gateway"),V()}function J(){o.getCustomerCorPfm().done(function(e,t){g.info("CORPFM-UI-checkCorPfm: cor = "+N+" pfm = "+C),g.info("CORPFM-UI-checkCorPfm: currentCor = "+e+" currentPfm = "+t);if(N!==e||C!==t)g.log("CORPFM-UI-checkCorPfm: cor or pfm is different. Navigating to Gateway"),setTimeout(V(),100)})}function K(){o.getCustomerCorPfm().done(function(e,n){N=e,C=n,g.info("CORPFM-UI-setCorPfm: cor = "+N+" pfm = "+C),W(),t.subscribe(H,J)})}function Q(){a.getDeviceLanguage().done(function(e){k=e,g.info("CORPFM-UI-setDeviceLanguage: deviceLanguage = "+k),X()})}function G(e){d.navigate("Search",{q:e})}function Y(r,i){function g(u,f){function c(){var e;!B||B.indexOf("undefined")!==-1||t("#root").html()!==""||t("#root-dialog").html()!==""?(prof.markTime("^start.startPage>load"),s=new u(i),prof.markTime("startPage_createView"),o=new f(s),a.notifyWebViewDomReady(),prof.markTime("startPage_createController"),h.start(),n.Navigation.notifyControllerLoaded({page:r}),prof.markTime("error_rcvr.start"),prof.markTime("$start.startPage>load"),e=t("#stage").hasClass("fastscroll")||t(".popover-inner").length,I()!=="ics"&&e&&(v=new l)):setTimeout(c,5)}e("templatesDS"),c()}var s,o,u="views/"+r+"View",f="controller/"+r+"Controller",c,p,d=!1,v,m=/US|UK|FR|DE|ES|IT|JP|CN|CA/;if(/Settings/.test(r)){B=String(window.BootstrapBridge.getAssetLocation(r)),c=B.match(m),p=window.pathsToTemplates.replace(m,c[0]);if(p!==window.pathsToTemplates){e([u,f,p],function(e,n,r){t.extend(y,r),g(e,n)});return}}e([u,f],g)}function Z(){var e=/AppleWebKit\/([\d.]+)/.exec(navigator.userAgent);return e?parseFloat(e[1]):null}function et(){t(".carousel-block").css({"overflow-x":"none","-webkit-overflow-scrolling":"none"}),setTimeout(function(){t(".carousel-block").css({"overflow-x":"scroll","-webkit-overflow-scrolling":"touch"})},700)}function tt(){f.showNative({title:"title_country_changed",text:"appstore_body_country_changed",button:"AlertDialog_button_AppNotAvailable"})}function nt(e){f.showNative({title:"title_country_changed",text:"purchase_failure_inconsistent_cor",button:"AlertDialog_button_AppNotAvailable",buttonFn:e})}function rt(){function T(){m.putBoolean(P,!0),x.subscribe()}function k(e){var t={title:"AlertDialog_title_AuthFailure",text:"AlertDialog_message_AuthFailureGeneric",button:"AlertDialog_button_AuthFailure",buttonFn:d.finishToRootOrKickStart,noActionFn:d.finishToRootOrKickStart};e.type==="Appstore.Authentication.MaxRegisteredDevices"?t.text="AlertDialog_message_AuthFailureMaxDevices":e.type==="Appstore.Authentication.PfmCorMismatch"&&(t.text="AlertDialog_message_PfmCorMismatch",t.title="AlertDialog_title_MarketplaceIssue",t.button="AlertDialog_button_OK",t.buttonFn=d.restart,t.noActionFn=d.restart),S.unsubscribe(),f.showNative(t),setTimeout(T,1e3)}function A(){x.unsubscribe(),d.finishToRootOrKickStart()}function O(e,n){return{subscribe:function(){this.sub=t.subscribe(e,n)},unsubscribe:function(){t.unsubscribe(this.sub)}}}function M(){h?h=!1:r.Sso.isSupported()&&!r.isRegistered()&&r.Sso.register().fail(k)}prof.markTime("^start.onDocumentReady"),K(),Q(),E.configure();var n="index.html",i=t("#root"),l,h=!0,p=o.getCustomerPfm(),v=window.appPreloadState.extras,g=!1,y=!1,b=!1,w={ATVPDKIKX0DER:"en",A1F83G8C2ARO7P:"en",A1PA6795UKMFR9:"de",A13V1IB3VIYZZH:"fr",A1RKKUPIHCS9HS:"es",AJZF8LZ1EJVJN:"es",APJ6JRA9NG5V4:"it",A3HOBANJMCMD83:"it",A1VC38T7YXB528:"ja",AAHKV2X7AFYLW:"cn",A21TJRUUN4KGV:"en",A2XZLSVIQ0F4JT:"en",A2Q3Y263D00KWC:"pt",AZXD3QD5B39HD:"pt"};v=v?JSON.parse(v):{},d.Registration.registerNativePage("ScreenshotGallery",{classname:"com.amazon.mas.client.gallery.FullScreenGallery",action:"show"}),prof.markTime("register_screenshot_gallery"),d.Registration.registerNativePage("VideoPlayer",{classname:"com.amazon.mas.client.video.VideoPreview",action:"show"}),prof.markTime("register_video_player"),d.Registration.registerNativePage("testdriveActivity",{classname:"com.amazon.testdrive.TestDriveActivity"}),prof.markTime("register_testdrive"),c.getBoolean(c.DIAGNOSE_AND_REPAIR,"enabled",!1)&&d.Registration.registerNativePage("CustomerCare",{classname:"com.amazon.venezia.VeneziaDialog"},{URL_TO_LOAD:"/gp/masclient/customer-service/intro",chrome:{style:"dialog",menu:{showBack:!0,showMenu:!1,showSearch:!1}}}),window.appPreloadState.buildType!=="RELEASE"&&window.appPreloadState.isMonkeySeeEnabled&&(console.log("Loading monkeySee plugin"),e(["plugins/monkeySee"])),t.subscribe(H,z),S=O(H,M),x=O(H,A),prof.markTime("three_functions"),console.log("getting forPfmChange"),console.log("forPfmChange:"+JSON.stringify(v.forPfmChange)),console.log("fromLogin: "+JSON.stringify(v.fromLogin)),console.log("fromPurchaseError: "+JSON.stringify(v.forPurchaseError)),console.log("full extras are "+JSON.stringify(v)),v.forPfmChange&&(v.fromLogin||(v.forPurchaseError?nt(tt):tt())),prof.markTime("^start.onDocumentReady>done"),L=v.page||"Gateway",(!v.chrome||v.chrome.style!=="dialog")&&S.subscribe(),r.isRegistered()?L!=="InstallUpdateDialog"&&u.shouldNotifyAboutUpdate().done(function(e){e&&d.showDialog("InstallUpdateDialog")}):/Dialog/i.test(L)||(r.Sso.isSupported()?r.Sso.register().done(function(){d.navigate(L)}).fail(k):L="SignIn"),console.log("currentPage: "+L),prof.markTime("set_current_page"),Y(L,i),prof.markTime("start_page"),/Search|MyApps|^Games/.test(L)||t.subscribe("com.amazon.venezia.doSearch",G),t.subscribe("com.amazon.venezia.doPurchase",function(e){s.corDoesNotMatchPfm(N,C)&&(console.log("COR: "+N+" does not match PFM: "+C),k({type:"Appstore.Authentication.PfmCorMismatch"}))}),prof.markTime("$start.onDocumentReady>done"),t.subscribe("com.amazon.venezia.android_lifecycle.onConfigChange",function(){a.getCurrentScreenOrientation().done(function(e){window.currentOrientation!==e&&(window.currentOrientation=e,t.publish("com.amazon.venezia.android_lifecycle.onOrientationChange"))})}),t.subscribe("com.amazon.venezia.android_lifecycle.onOrientationChange",z),t.subscribe("com.amazon.venezia.android_lifecycle.onOrientationChange",U),t.subscribe("com.amazon.mas.client.INVALID_PFMCOR",q),t.subscribe("com.amazon.mas.client.PFM_COR_CHANGED",J),t.subscribe("com.amazon.mas.client.framework.RESOURCES_CHANGED",$),t("body").hasClass("ics")?setTimeout(et,200):t("body").on("touchstart","button, div.action-panel",function(){t(this).addClass("pseudo-active")}).on("touchend","button, div.action-panel",function(){t(this).removeClass("pseudo-active")}).on("touchcancel","button, div.action-panel",function(){t(this).removeClass("pseudo-active")}),t.subscribe(H,function(){setTimeout(et,200)}),p.done(function(e){function r(){clearInterval(g),g=!1,t.publish("com.amazon.venezia.DOMChangeEnd")}var n;w.hasOwnProperty(e)?n=w[e]:n=navigator.language.split("-")[0],t("body").addClass("lang-"+n),b=function(){var e,r,i,s,o=t("#page-style"),u,a,f,l,c,h=t("#base-font");if(document.activeElement.tagName==="BODY"){e=document.getElementsByClassName("hyphenate");for(r=0;r<e.length;r+=1)(i=t(e[r])).hasClass("hyphenate")&&i.removeClass("hyphenate").html(window.Hyphenator.hyphenate(i.html(),n));if(!window.appPreloadState.isAmazonDevice){s=o.attr("href").split("/"),u=s[s.length-1].split("-")[2],a={small:.032,medium:.032,large:.025,xlarge:.021},f=Math.floor((document.body.clientWidth+document.body.clientHeight)/2),l=Math.floor(f*a[u]);if(localStorage&&parseInt(l,10)!==parseInt(localStorage.getItem("baseFont"),10)){c=parseInt(window.getComputedStyle(document.getElementsByTagName("html")[0]).fontSize,10);if(isNaN(c)||c<l&&l<100)h.html("html { font-size: "+l+"px !important; }"),localStorage&&localStorage.setItem("baseFont",l)}}}},g=setInterval(b,500),t.publish("com.amazon.venezia.DOMChangeBegin"),y=setTimeout(r,2e3),document.addEventListener("DOMSubtreeModified",function(){clearTimeout(y),y=setTimeout(r,2e3),g||(g=setInterval(b,500),t.publish("com.amazon.venezia.DOMChangeBegin"))})}),setTimeout(function(){var e,n,r,i;(n=t('.action-buttons:not(".full-width")')).length&&n.each(function(n,s){if((e=t("button",s).get()).length){i=t(e[0]).offset().top;for(r=1;r<e.length;r+=1)if(t(e[r]).offset().top>i){t(".action-buttons").addClass("full-width");break}}})},2e3),t("body").on("focus","textarea, input[type=text], input[type=password], input[type=number]",function(e){window.BootstrapBridge.silenceWebViewChatter()}),t("body").on("blur","textarea, input[type=text], input[type=password], input[type=number]",function(e){window.BootstrapBridge.resumeWebViewChatter()}),prof.markTime("$start.onDocumentReady")}prof.markTime("^start.define");var t=e("jquery"),n=e("appstore"),r=e("api/authentication"),i=e("api/caching"),s=e("api/cor-pfm"),o=e("api/customer-data"),u=e("api/device"),a=e("api/device-features"),f=e("widget/Dialog"),l=e("../libs/fastscroll"),c=e("api/feature-config"),h=e("receiver/FulfillmentErrorReceiver"),p=e("../libs/hyphenator2"),d=e("api/navigation"),v=e("api/recorder"),m=e("api/preferences"),g=v.Java.getLogger("HTML5.start"),y=e("templates"),b=e("plugins/touch"),w=e("plugins/whenUpdated"),E=e("zeroes/ZeroesLoader"),S,x,T,N,C,k,L,A="countryOfResidence",O="preferredMarketplace",M="deviceLanguage",_=!1,D=250,P="nonRetryableError",H="com.amazon.venezia.android_lifecycle.onResume",B;window.startController&&j(rt),window.start=function(){j(rt)},prof.markTime("$start.define")});var Hogan={};(function(e,t){function a(e){return String(e===null||e===undefined?"":e)}function f(e){return e=a(e),u.test(e)?e.replace(n,"&amp;").replace(r,"&lt;").replace(i,"&gt;").replace(s,"&#39;").replace(o,"&quot;"):e}e.Template=function(e,n,r,i){this.r=e||this.r,this.c=r,this.options=i,this.text=n||"",this.buf=t?[]:""},e.Template.prototype={r:function(e,t,n){return""},v:f,t:a,render:function(t,n,r){return this.ri([t],n||{},r)},ri:function(e,t,n){return this.r(e,t,n)},rp:function(e,t,n,r){var i=n[e];return i?(this.c&&typeof i=="string"&&(i=this.c.compile(i,this.options)),i.ri(t,n,r)):""},rs:function(e,t,n){var r=e[e.length-1];if(!l(r)){n(e,t,this);return}for(var i=0;i<r.length;i++)e.push(r[i]),n(e,t,this),e.pop()},s:function(e,t,n,r,i,s,o){var u;return l(e)&&e.length===0?!1:(typeof e=="function"&&(e=this.ls(e,t,n,r,i,s,o)),u=e===""||!!e,!r&&u&&t&&t.push(typeof e=="object"?e:t[t.length-1]),u)},d:function(e,t,n,r){var i=e.split("."),s=this.f(i[0],t,n,r),o=null;if(e==="."&&l(t[t.length-2]))return t[t.length-1];for(var u=1;u<i.length;u++)s&&typeof s=="object"&&i[u]in s?(o=s,s=s[i[u]]):s="";return r&&!s?!1:(!r&&typeof s=="function"&&(t.push(o),s=this.lv(s,t,n),t.pop()),s)},f:function(e,t,n,r){var i=!1,s=null,o=!1;for(var u=t.length-1;u>=0;u--){s=t[u];if(s&&typeof s=="object"&&e in s){i=s[e],o=!0;break}}return o?(!r&&typeof i=="function"&&(i=this.lv(i,t,n)),i):r?!1:""},ho:function(e,t,n,r,i){var s=this.c,o=this.options;o.delimiters=i;var u=e.call(t,r,function(e){return s.compile(e,o).render(t,n)});return this.b(s.compile(u.toString(),o).render(t,n)),!1},b:t?function(e){this.buf.push(e)}:function(e){this.buf+=e},fl:t?function(){var e=this.buf.join("");return this.buf=[],e}:function(){var e=this.buf;return this.buf="",e},ls:function(e,t,n,r,i,s,o){var u=t[t.length-1],a=null;if(!r&&this.c&&e.length>0)return this.ho(e,u,n,this.text.substring(i,s),o);a=e.call(u);if(typeof a=="function"){if(r)return!0;if(this.c)return this.ho(a,u,n,this.text.substring(i,s),o)}return a},lv:function(e,t,n){var r=t[t.length-1],i=e.call(r);return typeof i=="function"&&(i=i.call(r)),i=a(i),this.c&&~i.indexOf("{{")?this.c.compile(i,this.options).render(r,n):i}};var n=/&/g,r=/</g,i=/>/g,s=/\'/g,o=/\"/g,u=/[&<>\"\']/,l=Array.isArray||function(e){return Object.prototype.toString.call(e)==="[object Array]"}})(typeof exports!="undefined"?exports:Hogan),function(e){function u(e){e.n.substr(e.n.length-1)==="}"&&(e.n=e.n.substring(0,e.n.length-1))}function a(e){return e.trim?e.trim():e.replace(/^\s*|\s*$/g,"")}function f(e,t,n){if(t.charAt(n)!=e.charAt(0))return!1;for(var r=1,i=e.length;r<i;r++)if(t.charAt(n+r)!=e.charAt(r))return!1;return!0}function l(e,t,n,r){var i=[],s=null,o=null;while(e.length>0){o=e.shift();if(o.tag=="#"||o.tag=="^"||c(o,r))n.push(o),o.nodes=l(e,o.tag,n,r),i.push(o);else{if(o.tag=="/"){if(n.length===0)throw new Error("Closing tag without opener: /"+o.n);s=n.pop();if(o.n!=s.n&&!h(o.n,s.n,r))throw new Error("Nesting error: "+s.n+" vs. "+o.n);return s.end=o.i,i}i.push(o)}}if(n.length>0)throw new Error("missing closing tag: "+n.pop().n);return i}function c(e,t){for(var n=0,r=t.length;n<r;n++)if(t[n].o==e.n)return e.tag="#",!0}function h(e,t,n){for(var r=0,i=n.length;r<i;r++)if(n[r].c==e&&n[r].o==t)return!0}function p(e){return e.replace(s,"\\\\").replace(n,'\\"').replace(r,"\\n").replace(i,"\\r")}function d(e){return~e.indexOf(".")?"d":"f"}function v(e){var t="";for(var n=0,r=e.length;n<r;n++){var i=e[n].tag;i=="#"?t+=m(e[n].nodes,e[n].n,d(e[n].n),e[n].i,e[n].end,e[n].otag+" "+e[n].ctag):i=="^"?t+=g(e[n].nodes,e[n].n,d(e[n].n)):i=="<"||i==">"?t+=y(e[n]):i=="{"||i=="&"?t+=b(e[n].n,d(e[n].n)):i=="\n"?t+=E('"\\n"'+(e.length-1==n?"":" + i")):i=="_v"?t+=w(e[n].n,d(e[n].n)):i===undefined&&(t+=E('"'+p(e[n])+'"'))}return t}function m(e,t,n,r,i,s){return"if(_.s(_."+n+'("'+p(t)+'",c,p,1),'+"c,p,0,"+r+","+i+',"'+s+'")){'+"_.rs(c,p,"+"function(c,p,_){"+v(e)+"});c.pop();}"}function g(e,t,n){return"if(!_.s(_."+n+'("'+p(t)+'",c,p,1),c,p,1,0,0,"")){'+v(e)+"};"}function y(e){return'_.b(_.rp("'+p(e.n)+'",c,p,"'+(e.indent||"")+'"));'}function b(e,t){return"_.b(_.t(_."+t+'("'+p(e)+'",c,p,0)));'}function w(e,t){return"_.b(_.v(_."+t+'("'+p(e)+'",c,p,0)));'}function E(e){return"_.b("+e+");"}var t=/\S/,n=/\"/g,r=/\n/g,i=/\r/g,s=/\\/g,o={"#":1,"^":2,"/":3,"!":4,">":5,"<":6,"=":7,_v:8,"{":9,"&":10};e.scan=function(n,r){function S(){v.length>0&&(m.push(new String(v)),v="")}function x(){var e=!0;for(var n=b;n<m.length;n++){e=m[n].tag&&o[m[n].tag]<o._v||!m[n].tag&&m[n].match(t)===null;if(!e)return!1}return e}function T(e,t){S();if(e&&x())for(var n=b,r;n<m.length;n++)m[n].tag||((r=m[n+1])&&r.tag==">"&&(r.indent=m[n].toString()),m.splice(n,1));else t||m.push({tag:"\n"});g=!1,b=m.length}function N(e,t){var n="="+E,r=e.indexOf(n,t),i=a(e.substring(e.indexOf("=",t)+1,r)).split(" ");return w=i[0],E=i[1],r+n.length-1}var i=n.length,s=0,l=1,c=2,h=s,p=null,d=null,v="",m=[],g=!1,y=0,b=0,w="{{",E="}}";r&&(r=r.split(" "),w=r[0],E=r[1]);for(y=0;y<i;y++)h==s?f(w,n,y)?(--y,S(),h=l):n.charAt(y)=="\n"?T(g):v+=n.charAt(y):h==l?(y+=w.length-1,d=o[n.charAt(y+1)],p=d?n.charAt(y+1):"_v",p=="="?(y=N(n,y),h=s):(d&&y++,h=c),g=y):f(E,n,y)?(m.push({tag:p,n:a(v),otag:w,ctag:E,i:p=="/"?g-E.length:y+w.length}),v="",y+=E.length-1,h=s,p=="{"&&(E=="}}"?y++:u(m[m.length-1]))):v+=n.charAt(y);return T(g,!0),m},e.generate=function(t,n,r){var i='var _=this;_.b(i=i||"");'+v(t)+"return _.fl();";return r.asString?"function(c,p,i){"+i+";}":new e.Template(new Function("c","p","i",i),n,e,r)},e.parse=function(e,t,n){return n=n||{},l(e,"",[],n.sectionTags||[])},e.cache={},e.compile=function(e,t){t=t||{};var n=e+"||"+!!t.asString,r=this.cache[n];return r?r:(r=this.generate(this.parse(this.scan(e,t.delimiters),e,t),e,t),this.cache[n]=r)}}(typeof exports!="undefined"?exports:Hogan),define("hogan",[],function(){}),define("coll/ItemCollection",["jquery"],function(e){var t,n,r,i,s,o,u;return n="insert",r="delete",i="update",s="clear",o=function(e,t,n,r){var i={type:e,start:t,pos:r,count:n};return r===undefined&&delete i.pos,i},u=function(e,t,n,r){var i;i=e.slice(0),i.splice(0,0,n,r),Array.prototype.splice.apply(t,i)},t=function(){var a,f,l,c,h,p,d,v,m,g,y,b;a=[],f=!0,m={add:function(t,r){r===a.length?a[r]=t:a.splice(r,0,t),y(this,o(n,r,1,r))},addAll:function(t,r){u(t,a,r,0),y(this,o(n,r,t.length,r))},remove:function(t,n){a.splice(t,n),y(this,o(r,t,n))},clear:function(){var t=a.length;a=[],e(this).clearQueue("change"),y(this,o(s,0,t,t-1))},replace:function(t,r,s){var f,l;f=a.length,u(r,a,t,r.length),s||(f===a.length?y(this,o(i,t,r.length,t)):(l=f-t,l&&y(this,o(i,t,l,t,t)),y(this,o(n,f,a.length-f,f))))}},g={add:function(t,n){c[n]=c[n]||[],c[n].push(t)},addAll:function(t,n){var r;r=c[n]||[],c[n]=r,u(t,r,r.length,0)},remove:function(t,n){var r,i;console.log("Coalescing delete of "+t+", "+n);for(r=t,i=t+n;r<i;r+=1)l[r]=1},clear:function(){var e;for(e=0;e<a.length;e+=1)l[e]=1},replace:function(t,n,r){var i,s;for(i=0,s=n.length;i<s;i+=1)h[i+t]=n[i]}},v=m,this.size=function(){return a.length},this.at=function(t){return a[t]},this.coalesceChanges=function(){f&&(f=!1,v=g,l=[],c=[],h=[])},this.notify=function(){var n,r,i,s,o,u,a,g,y;if(!f){d=s=0,o=[[-1,0]],u=0,p=[],v=m;for(n=0,r=l.length;n<r;n+=1)l[n]&&i===undefined?i=n:!l[n]&&i!==undefined&&(console.log("Performing coalesced removal of: "+i+", items:"+(n-i)),this.remove(s+i,n-i),d=s-=n-i,o[o.length]=[i,s],i=undefined);i!==undefined&&(this.remove(s+i,l.length-i),d=s-=l.length-i,o[o.length]=[i,s],i=undefined),d=0;for(n=0,r=h.length;n<r;n+=1)h[n]!==undefined&&i===undefined?(o[u+1]&&o[u+1][0]<=n&&(u+=1,d=o[u][1]),i=n):h[n]===undefined&&i!==undefined&&(console.log("Performing coalesced replace of: "+i+", items: "+(n-i)),this.replace(o[u][1]+i,h.slice(i,n)),i=undefined);i!==undefined&&(this.replace(o[u][1]+i,h.slice(i)),i=undefined),d=a=u=0;for(n=0,r=c.length;n<r;n+=1)if(c[n]!==undefined){if(l[n]!==undefined){for(g=n,y=l.length;g<y;g+=1)if(l[g]===undefined)break}else g=n;console.log("Performing coalesced add of: "+g+", items: "+c[n].length),o[u+1]&&o[u+1][0]<=g&&(u+=1,d=o[u][1]+a),this.addAll(c[n],d+g),a+=c[n].length,d=o[u][1]+a}e(this).trigger("change",[p]),f=!0,p=l=c=h=undefined,d=0}},this.withCoalescing=function(t){this.coalesceChanges();try{t(this)}finally{this.notify()}},y=function(n,r){f?e(n).trigger("change",[[r]]):(r.start-=d,p[p.length]=r)},b=function(t,n){var r=n?a.length+1:a.length;if(t<0||t>=r)throw{name:"IndexOutOfBounds",message:"Out of bounds for index: "+t}},this.add=function(t,n){n===undefined&&(n=a.length),b(n,!0),v.add.call(this,t,n)},this.addAll=function(n,r){var i;if(!e.isArray(n)){this.add(n,r);return}r===undefined&&(r=a.length),b(r,!0),v.addAll.call(this,n,r)},this.remove=function(t,n){if(t===undefined)return;n===undefined&&(n=1);if(n<0)return;n>a.length-t&&(n=a.length-t),b(t,!1),v.remove.call(this,t,n)},this.replace=function(n,r,i){if(n===undefined)return;if(r===undefined)return;b(n,!0),e.isArray(r)||(r=[r]),v.replace.call(this,n,r,i)},this.clear=function(){v.clear.call(this)},this.filter=function(e){return a.filter(e)},this.map=function(e){return a.map(e)},this.indexOf=function(e){return a.indexOf(e)}},t.INSERT_TYPE=n,t.DELETE_TYPE=r,t.UPDATE_TYPE=i,t.CLEAR_TYPE=s,t}),define("views/ListView",["jquery","coll/ItemCollection"],function(e,t){var n;return n=function(n,r,i){var s,o,u,a,f,l,c,h,p,d,v;o=!1,i.afterRenderFn=i.afterRenderFn||function(){},typeof n=="string"&&(n=e(n)),n.empty();if(n[0].nodeName.toLowerCase()==="div")s=n,n=e("<ul></ul>").appendTo(s);else{if(n[0].nodeName.toLowerCase()!=="ul")throw{name:"Invalid ListView target",message:"Target must be <div> or <ul>"};s=n.parent()}i.eventFn&&i.eventFn(n,e(this),r.get),p=function(t,n,r){return i.insertAnimFn&&i.insertAnimFn(t,n),t.delay(0).queue(function(){r&&r.apply(this),e(this).dequeue()}),t},a=e.proxy(function(t,s,o){n.delay(0).queue(function(){var n=p(i.renderFn(r.at(t)),s(),o);e(this).append(n),i.afterRenderFn(n),e(this).dequeue()})},this),f=e.proxy(function(t,s,o,u){n.delay(0).queue(function(){var n=p(i.renderFn(r.at(s)),o(),u);t.before(n),i.afterRenderFn(n),e(this).dequeue()})},this),l=e.proxy(function(r,i,s,o){var u,l,c,h,p,d,v;p=new e.Deferred,d=s,v=function(){d-=1,d===0&&p.resolve()},h=n.children()[r];if(h){c=e(h);for(u=i,l=i+s;u<l;u+=1)f(c,u,o,v)}else for(u=i,l=i+s;u<l;u+=1)a(u,o,v);return p},this),d=function(n,r,s){return i.deleteAnimFn&&i.deleteAnimFn(n,r),n.delay(0).queue(function(){s&&s.apply(this),e(this).dequeue()}),n},c=e.proxy(function(r,i,s){var o,u,a,f,l,c;f=new e.Deferred,l=i,c=function(){e(this).remove(),l-=1,l===0&&f.resolve()},a=n.children();for(o=r,u=r+i;o<u;o+=1)d(e(a[o]),s(),c);return f},this),v=function(n,r,s,o){return i.replaceAnimFn?i.replaceAnimFn(n,r,s,function(){n.replaceWith(r)},e.proxy(o,r)):r.delay(0).queue(function(){n.replaceWith(r),o&&o.apply(this),e(this).dequeue()}),r},h=e.proxy(function(s,o,u,a){var f,l,c,h,p,d,m;h=new e.Deferred,p=u,d=function(){e(this).css({position:""}),p-=1,p===0&&h.resolve()},c=n.children();for(f=s,l=s+u;f<l;f+=1)m=i.renderFn(r.at(f-s+o)),v(e(c[f]),m,a(),d),i.afterRenderFn(m);return h.resolve(),h},this),u=e.proxy(function(i,s){var u;s[0].type===t.CLEAR_TYPE&&n.clearQueue("changes"),n.queue("changes",function(r){var i,u,a,f,p,d,v,m,g,y,b;b=e("<div>"),g=0,y=function(){var e=g;return g<175&&(g+=35),e},m=[],b.insertBefore(n),n.detach();for(i=0,u=s.length;i<u;i+=1){a=s[i],f=a.type,p=a.start,d=a.pos,v=a.count,console.log("Received change: "+a+", type: "+f+", start: "+p+", pos: "+d+", count: "+v);switch(f){case t.INSERT_TYPE:m[m.length]=l(p,d,v,y);break;case t.DELETE_TYPE:m[m.length]=c(p,v,y);break;case t.UPDATE_TYPE:m[m.length]=h(p,d,v,y);break;case t.CLEAR_TYPE:n.empty(),m=[]}}b.replaceWith(n),f===t.INSERT_TYPE&&e(n).trigger("insertChange",a),e.when.apply(e,m).done(function(){n.queue("changes").length?n.dequeue("changes"):o=!1})}),o||(o=!0,n.dequeue("changes"))},this),e(r).on("change",u)},n.FadeAnimations={insertAnimFn:function(e,t){e.css({opacity:"0.0"}).delay(t).animate({opacity:"1.0"},{duration:"slow",queue:!0})},deleteAnimFn:function(e,t){e.css({opacity:"1.0"}).delay(t).animate({opacity:"0.0"},{duration:"slow",queue:!0})},replaceAnimFn:function(t,n,r,i,s){t.css({opacity:"1.0"}).delay(r).animate({opacity:"0.0"},{duration:"slow",queue:!0}).queue(function(){i(),n.css({opacity:"0.0"}).delay(0).animate({opacity:"1.0"},{duration:"slow",queue:!0}).queue(function(){s(),e(this).dequeue()}),e(this).dequeue()})}},n.SlideAnimations={insertAnimFn:function(t,n){t.css({height:"0px",padding:"0",position:"relative",left:"-800px"}).delay(n).animate({height:"100px",padding:"0.5em"},{duration:"slow",queue:!0}).animate({left:"0px"},{duration:"slow",queue:!0}).queue(function(){e(this).css("position",""),e(this).dequeue()})},deleteAnimFn:function(e,t){e.css("position","relative").delay(t).animate({left:"-650px"},{duration:"slow",queue:!0}).animate({height:"0px",padding:"0"},{duration:"slow",queue:!0})},replaceAnimFn:function(t,n,r,i,s){t.css("position","relative").delay(r).animate({left:"-650px"},{duration:"slow",queue:!0}).queue(function(){i(),n.css({height:"100px",padding:"0.5em",position:"relative",left:"-650px"}).delay(0).animate({left:"0px"},{duration:"slow",queue:!0}).queue(function(){s(),e(this).dequeue()}),e(this).dequeue()})}},n.NoAnimations={},n}),define("coll/MappedItemCollection",["require","jquery","coll/ItemCollection"],function(t){var n=t("jquery"),r=t("coll/ItemCollection");return function(t){var i={},s;n.extend(this,new r),this.mapAll=function(e,r){var s=this.size();n.map(e,function(e,n){e.index=n+s,i[e[t]]=e}),this.addAll(e,r)},this.mapRemoveAll=function(){this.clear(),i={}},this.get=function(e){return i[e]},this.getIndexOf=function(e){var t;return!e||!i[e]?-1:(t=i[e].index,t)},this.removeFromMap=function(e){var t=i[e],n,r,s;if(!t)return;n=i[e].index,this.remove(n,1),delete i[e];for(r=0,s=this.size();r<s;r+=1)this.at(r).index=r},this.replaceInMap=function(e,n,r){var s=this.at(e),o=!r||!r(s,n);n.index=e,i[n[t]]=n,this.replace(e,[n],o)},this.replaceAll=function(e,t){var n=0,r,i=this.size();if(!e)return;while(n<i&&e.length)r=e.shift(),this.replaceInMap(n,r,t),n+=1;0>=e.length&&n<i&&this.remove(n,i-n),this.mapAll(e)}}}),define("controller/GenericListController",["require","jquery","views/ListView","coll/MappedItemCollection"],function(t){var n=t("jquery"),r=t("views/ListView"),i=t("coll/MappedItemCollection");return function(t,s){function c(e){var t,r,i,o,a;if(!e)return;if(!e[s.deferredKey])return;t=e[s.deferredKey],n.isArray(t)||(t=[t]),o=[],i=t.length,n.map(t,function(e,n){o.push(new s.Model(t[n]))}),u.mapAll(o)}var o,u,a,f,l;if(!s.render||!s.render.mapKey)return console.log("spec.render needs to be defined and have a mapKey"),null;if(!s.Model)return console.log("spec.Model needs to be defined"),null;if(!s.deferred)return console.log("spec.deferred needs to be defined"),null;u=new i(s.render.mapKey),a=new r(t,u,s.render),s.Handler&&(o=new s.Handler,f=Object.keys(o),n.map(f,function(e,t){n(a).on(e,o[e])})),s.deferred.done(n.proxy(c,this))}}),define("models/CategoriesModel",[],function(){return function(t){this.id=t&&t.id,this.name=t&&t.name,t&&t.categoryDescription&&(t.description=t.categoryDescription),this.description=t&&t.description,this.isValid=function(){return typeof this.id!="undefined"&&typeof this.name!="undefined"&&typeof this.description!="undefined"},this.isGroupBillboardCategory=function(){return this.id===999999999}}}),define("handler/RefMarkerBuilder",["require","jquery","api/recorder"],function(t){var n=t("jquery"),r=t("api/recorder"),i=r.Java.getLogger("HTML5.RefMarkerBuilder");return function(t,r,s){function f(e){return typeof e=="string"&&e.length>0}function l(e){return typeof e=="number"&&e>=0}function c(e){return f(e)||l(e)}var o=["apps"],u=!0,a=this;(!f(t)||!f(r)||!f(s))&&i.warning("RefMarkerBuilder-UI-constructor: Expected inputs to be strings. srcPage = "+t+" srcWidget = "+r+" dstPage = "+s),this.PAGES={AllCategories:"ac",AppUpdate:"au",BestSeller:"bsts",BestSellerMoversAndShakers:"ms",BestSellerTopFree:"btpf",BestSellerTopPaid:"btpp",BestSellerTopRated:"btpr",Category:"src",CustomerCare:"cc",Dialog:"dia",Detail:"dp",Feedback:"fd",Games:"gmsf",Gateway:"gwsf",Help:"hlp",Legal:"lgl",MyApps:"mya",NewForYouAll:"nfya",NewReleases:"nr",RecentlyViewed:"rv",RecommendedForYouAll:"rfya",SavedForLater:"sfl",Search:"src",Settings:"set",SettingsGiftCards:"gc",Subscriptions:"sbs",TestDrive:"td",TopFreeGames:"tpfg",TopPaidGames:"tppg",Unknown:"unkn"},this.WIDGETS={Billboard:"blbd",CustomersWhoBought:"cust",FeaturedApps:"feat",NavigationBar:"nb",NewForYou:"nfy",RecommendedForYou:"rfy",SearchResults:"srs",SoftKeyMenu:"sm",TopFree:"tpf",TopPaid:"tpp",TopRated:"tpr",NA:"na"},this.CATEGORIES={b_test_drive:"td",b_uscc:"uc",b_giochi:"g",b_jeux:"g",b_spiele:"g",b_juegos:"g",b_games:"g",b_games_categories_mobile_apps:"g",b_azione:"gac",b_action:"gac",b_acci_n:"gac",b_games_act:"gac",b_arcade:"gar",b_arcade_et_plate_forme:"gar",b_arcade_y_plataformas:"gar",b_games_arc:"gar",b_rompicapi_e_trivia:"gp",b_puzzle:"gp",b_denkspiele:"gp",b_puzles_y_concursos:"gp",b_puzzles_trivia:"gp",b_games_puzz:"gp",b_jump_run:"jr",b_games_casual:"gc"},o[1]=this.PAGES[t]||this.PAGES.Unknown,o[2]=this.WIDGETS[r]||this.WIDGETS.NA,o[3]=this.PAGES[s]||this.PAGES.Unknown,this.addArg=function(e){return c(e)?o.push(e):(u=!1,i.warning("RefMarkerBuilder-UI-addArg: Invalid input into addArg. arg = "+e)),this},this.addArgs=function(e){var t,r;return e instanceof Array?n(e).each(function(e,t){a.addArg(t)}):(u=!1,i.warning("RefMarkerBuilder-UI-addArgs: Invalid input into addArgs, expected input to be an array. args = "+e)),this},this.addCategoryArg=function(e){return this.addArg(this.CATEGORIES[e]||e)},this.build=function(){return u?o.join("_"):o.slice(0,4).join("_")}}}),define("controller/SoftKeysController",["require","jquery","api/navigation","api/resources","handler/RefMarkerBuilder","api/device-features","api/recorder"],function(t){function l(e,t){var r=new s(f,a,e),i=t||{};return n.extend(i,{refMarker:r.build()})}function c(e){if(window.appPreloadState.isAmazonDevice){console.info("starting CS_APP");var t={action:"com.amazon.kindle.otter.csapp.ACTION_LAUNCH_CS_APP"},n={ApplicationName:"AmazonAppStore",ApplicationVersion:"1.0",ApplicationHelpContext:"AmazonOtherApps",Mode:"online",InitialIssue:"issue descriptor"};r.Android.startActivity(t,n);return}if(e==="Help")return;r.navigate("Help",l("Help",{pageTemplate:"Help"}))}var n=t("jquery"),r=t("api/navigation"),i=t("api/resources"),s=t("handler/RefMarkerBuilder"),o=t("api/device-features"),u=t("api/recorder"),a="SoftKeyMenu",f="SoftKeys";return function(t,n){var s=i.getString("saved_for_later"),a=i.getString("my_apps"),f=i.getString("app_update"),h=i.getString("my_subscriptions"),p=i.getString("all_categories"),d=i.getString("leave_feedback"),v=i.getString("help"),m=i.getString("legal"),g=i.getString("settings"),y=i.getString("store_home"),b=i.getString("giftcard_and_promos_short"),w=i.getString("contact_cs"),E=o.getValueOf(o.Keys.CLOUD_LIBRARY),S=o.getValueOf(o.Keys.GLOBAL_SETTINGS);S||r.Chrome.addMenuItem(y,"menu_home",function(){n!=="Gateway"&&r.navigateToSSRPage("Gateway",r.GATEWAY_URL)}),r.Chrome.addMenuItem(p,"menu_browse",function(){n!=="AllCategories"&&r.navigate("AllCategories",l("AllCategories"))}),r.Chrome.addMenuItem(h,"menu_subscriptions",function(){n!=="Subscriptions"&&r.navigate("Subscriptions",l("Subscriptions"))}),E?r.Chrome.addMenuItem(f,"menu_app_updates",function(){n!=="AppUpdate"&&r.navigate("AppUpdate",l("AppUpdate"))}):r.Chrome.addMenuItem(a,"menu_myapps",function(){n!=="MyApps"&&(u.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.MyApps.Load.Initiated"),r.navigate("MyApps",l("MyApps",{description:a})))}),S?(r.Chrome.addMenuItem(b,"menu_giftcard",function(){n!=="SettingsGiftCards"&&r.navigate("SettingsGiftCards",l("SettingsGiftCards"))}),r.Chrome.addMenuItem(s,"menu_saved_for_later",function(){n!=="SavedForLater"&&r.navigate("SavedForLater",l("SavedForLater"))}),r.Chrome.addMenuItem(v,"menu_help",function(){c(n)})):(r.Chrome.addMenuItem(g,"menu_settings",function(){n!=="Settings"&&r.navigate("Settings",l("Settings",{pageTemplate:"Settings"}))}),r.Chrome.addMenuItem(b,"IMAGE NOT IMPLEMENTED",function(){n!=="SettingsGiftCards"&&r.navigate("SettingsGiftCards",l("SettingsGiftCards",{settingsPage:"SettingsGiftCards",forwardRefMarker:!0}))}),r.Chrome.addMenuItem(s,"IMAGE NOT IMPLEMENTED",function(){n!=="SavedForLater"&&r.navigate("SavedForLater",l("SavedForLater"))}),r.Chrome.addMenuItem(w,"IMAGE NOT IMPLEMENTED",function(){n!=="CustomerCare"&&r.navigate("CustomerCare",l("CustomerCare"))}),r.Chrome.addMenuItem(d,"IMAGE NOT IMPLEMENTED",function(){n!=="Feedback"&&r.navigate("Feedback",l("Feedback"))}),r.Chrome.addMenuItem(v,"menu_help",function(){c(n)}),r.Chrome.addMenuItem(m,"IMAGE NOT IMPLEMENTED",function(){n!=="Legal"&&r.navigate("Legal",l("Legal",{pageTemplate:"Legal"}))})),this.update=function(e){}}}),define("handler/ClickStreamHandler",["require","jquery","api/caching","api/recorder"],function(t){var n=t("jquery"),r=t("api/caching"),i=t("api/recorder"),s=i.Java.getLogger("HTML5.ClickStreamHandler");return function(t,o,u){this.record=function(e,r){var a;s.log("ClickStream-UI-record: refMarker = "+e+" args = "+JSON.stringify(r));if(t===undefined){s.log("ClickStream-UI-record: pageType cannot be undefined");return}if(e===undefined){s.log("ClickStream-UI-record: refMarker cannot be undefined");return}a=t,u=u||{},u.refMarker=e,u["page-type"]=t,o&&(u["sub-page-type"]=o,a=a.concat("."+o)),r&&(n.extend(u,r),r.asin&&(u["page-type-id"]=r.asin)),s.log("ClickStream-UI-record: data = "+JSON.stringify(u)),i.Metrics.recordClickStreamMetric(a,u)},this.recordView=function(e,n,i){var o,u,a,f,l,c=[],h=[],p=null;c.A1VC38T7YXB528="https://www.amazon.co.jp/gp/masclient/metrics",c.AAHKV2X7AFYLW="https://www.amazon.cn/gp/masclient/metrics",c.A1F83G8C2ARO7P="https://www.amazon.co.uk/gp/masclient/metrics",c.A1PA6795UKMFR9="https://www.amazon.de/gp/masclient/metrics",c.A13V1IB3VIYZZH="https://www.amazon.fr/gp/masclient/metrics",c.APJ6JRA9NG5V4="https://www.amazon.it/gp/masclient/metrics",c.A1RKKUPIHCS9HS="https://www.amazon.es/gp/masclient/metrics",c.ATVPDKIKX0DER="https://www.amazon.com/gp/masclient/metrics",l=r.getItem("preferredMarketplace"),f=c[l];if(!f)return;f+=e,o=document.createElement("script"),n&&h.push("?ref="+encodeURIComponent(n)),t&&h.push("page-type="+encodeURIComponent(t));if(i)for(p in i)i.hasOwnProperty(p)&&i[p]&&h.push(p+"="+encodeURIComponent(i[p]));f+=h.join("&"),o.src=f,u=document.getElementsByTagName("script")[0],u.parentNode.insertBefore(o,u),s.log("ClickStream-UI-record: hostUrl="+f)}}}),define("controller/AllCategoriesController",["require","jquery","appstore","controller/GenericListController","models/CategoriesModel","controller/SoftKeysController","handler/ClickStreamHandler","zeroes/ZeroesLoader"],function(e){function l(e,t,r){return u.log("Received Category Navigate event: "+t+" "+r),t&&n.Navigation.navigate(t,r),!1}function c(e,r,i){return function(){var e=t(this).attr("id"),i={name:r(e).name,id:r(e).id,description:r(e).description};return n.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Category.Load.Initiated",{categoryName:i.name}),n.Navigation.navigate("Search",{q:"*",category:i}),!1}}var t=e("jquery"),n=e("appstore"),r=e("controller/GenericListController"),i=e("models/CategoriesModel"),s=e("controller/SoftKeysController"),o=e("handler/ClickStreamHandler"),u=n.Recorder.Java.getLogger("HTML5.AllCategoriesController"),a=e("zeroes/ZeroesLoader"),f;return f={mapKey:"id",renderFn:function(e){return t("<li class='action-panel-list-item' data-testid='"+e.id+"' + id='"+e.id+"'><h2 class='action-panel-list-item-heading'>"+e.description+"</h2></li>")},eventFn:function(e,t,n){e.on("tap","li",c(t,n,"selectedCategory"))}},function(c){var h,p,d=t.Deferred(),v,m,g="AllCategories",y=new o(g);c.render(),n.Navigation.getExtras("refMarker").done(function(e){u.log("ClickStream-UI-AllCategoriesController: refMarker = "+e),y.recordView("/ac",e),y.record(e)}).fail(function(e){u.log("ClickStream-UI-AllCategoriesController: failed to get refMarker; eror = "+JSON.stringify(e))}),m=new s(c,"AllCategories"),t(c).on("showCategoryPageClicked",l),t(c).on("navigatePageClicked",l),h=n.Search.getCategories({id:0}),v=new r(c.getAllCategoriesListTarget(),{deferred:h,deferredKey:"categories",render:f,Model:i}),h.done(function(){a.initializeAsync(a.STORE_CONFIG_TYPES.Generic)})}}),define("views/AllCategoriesView",["require","jquery","templates","api/device-features","api/search","api/recorder","zeroes/ZeroesLoader"],function(e){var t=e("jquery"),n=e("templates"),r=e("api/device-features"),i=e("api/search"),s=e("api/recorder"),o=e("zeroes/ZeroesLoader"),u=s.Java.getLogger("HTML5.AllCategoriesView"),a="b_games",f="b_earn_zeroes",l="b_test_drive",c="b_mag",h="b_books",p="b_uscc",d=[{label:"gamesCategoryLabel",id:"b_games"},{label:"magCategoryLabel",id:"b_mag"},{label:"booksCategoryLabel",id:"b_books"}];return function(a){function y(){return function(e){var n=t(this).attr("id"),r=t(this).attr("page"),o,a;u.log("received OnCategoryClicked event: "+n+", "+r);if(r)t(v).trigger("navigatePageClicked",[r]);else{for(m=0;m<d.length;m+=1)if(d[m].id===n){n=d[m].localizedName;break}s.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Category.Load.Initiated",{categoryName:n}),i.getAllCategoriesMap().done(function(e){var r=e[n];o="Search",a={q:"*",category:r},t(v).trigger("showCategoryPageClicked",[o,a])}).fail(function(e){u.warning("onCategoryClicked Error in getAllCategories: "+e),s.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Category.Load.Failure",{categoryName:n})})}return!1}}var c,h,v=this,m,g;this.render=function(){var e,s,c,h;u.log("Rendering AllCategories "),g=a.find('[class="featured-categories"]'),g.on("tap","li",y()),u.log("Getting allCategoriesMap"),i.getAllCategoriesMap().done(function(a){c=i.getFeaturedCategoriesForCurrentMarketplace().done(function(i){s={};if(i)for(e=0;e<i.length&&e<d.length;e+=1)if(i[e]){var c=a[i[e]];c&&(s[d[e].label]=c.description,d[e].localizedName=c.name)}h=a[p],h&&(u.log("b_uscc category is available"),s.usccCategoryLabel=h.description),a[l]&&(s.testDriveCategoryLabel=a[l].description),o.isEnabled()&&a[f]&&(s.earnZeroesCategoryLabel=a[f].description),s.showGamesStorefront=r.getValueOf(r.Keys.GLOBAL_SETTINGS),u.log("Rendering featuredCategories with: "+JSON.stringify(s)),g.html(n.FeaturedCategories.render(s)),t.isEmptyObject(s)&&t("#featured-cats-heading").hide()}).fail(function(e){u.log("Error in getFeaturedCategoriesForCurrentMarketplace: "+e)})}).fail(function(e){u.log("Error in getAllCategoriesMap: "+e),g.html(n.FeaturedCategories.render())}),g.html(n.FeaturedCategories.render(s)),t.isEmptyObject(s)&&t("#featured-cats-heading").hide()},this.getAllCategoriesListTarget=function(){return a.find('[data-class="all-categories-list"]')}}}),define("infiniteScroll",["require","jquery"],function(t){var n=t("jquery"),r=function(e,t){this.selector=e,this.debug=t};return r.prototype.setup=function(){var e=n(document),t=n(window),r=n(this.selector),i=this.debug,s=!1,o=!1,u=1500;t.scroll(function(n){if(!s){var a=function(){if(s){s=!1,clearTimeout(o);var a=e.height()-t.height();Math.abs(a-t.scrollTop())<=u&&(i&&console.log("Dispatching Scroll Event",n),r.trigger("infinite-scroll",[n]))}};o=setInterval(a,250)}s=!0})},r}),define("controller/PagerController",["require","jquery","views/ListView","infiniteScroll","coll/MappedItemCollection"],function(t){var n=t("jquery"),r=t("views/ListView"),i=t("infiniteScroll"),s=t("coll/MappedItemCollection");return function(t,o){function S(e){var t,r,i;return t=e[o.pagerKey]||{},i=[],n.map(t,function(e,t){if(o.maxItems!==undefined&&i.length+f.size()>=o.maxItems)return!1;i.push(new o.Model(e))}),i}function x(){return n("body").outerHeight()>n(window).height()}function T(e){E=e,n(t).trigger("page.totalCount",E)}function N(e){E-=e,n(t).trigger("page.totalCount",E)}function C(){n(t).trigger("page.initiated",d),d.nextPage(function(r){function s(e,r){n(t).trigger("page.completed"),d.hasNext&&!(n(window).height()<n(t).height()||n(window).width()<n(t).width())&&(console.log("Load another page to fill screen"),c=!0,C())}n(t).trigger("page.loading",d);var i=S(r);d.hasNext=r.isLast===!1||i.length,i.length===0&&m&&n(t).trigger("page.empty"),i.length?(n(t).one("insertChange",s),f.mapAll(i)):n(t).trigger("page.completed"),T(r.totalCount),c=!1,m=!1},function(){n(t).trigger("page.failure")})}function k(e){!c&&d.hasNext&&(c=!0,C())}function L(){n.each(y,function(e,t){w.removeItem(t[0])}),n.each(b,function(e,t){w.updateItemFromWorkflow(t[0],t[1])}),y=[],b=[]}var u,a,f,l,c,h,p,d,v,m,g,y=[],b=[],w=this,E;h=new o.Render(!1,o.template),f=new s(h.mapKey),l=new r(t,f,n.extend(h,{})),p=new i(l,!1),p.setup(),u=o.Handlers||[],console.log("Length of Handlers: "+u.length),n.each(u,function(e,t){v=Object.keys(t),n.each(v,function(e,r){console.log("Adding event listener for key: "+r),n(l).on(r,t[r])})}),o.WorkflowHandler&&(a=new o.WorkflowHandler(f,o.Model)),this.setData=function(e){c=!0,m=!0,d=e,f.size()!==0&&f.mapRemoveAll(),C()},this.removeItem=function(e){if(g){y.push(arguments);return}f.removeFromMap(e),N(1)},this.updateItemFromWorkflow=function(e,t){var r,i,s;if(g){b.push(arguments);return}f&&!c&&(r=f.get(e),r&&(i=new o.Model(n.extend({},r,t)),f.replaceInMap(r.index,i,o.showChange)))},n(l).on("infinite-scroll",k),o.pager&&(d=o.pager,this.setData(d)),this.mergeData=function(e){function a(n){t=i.length,i=i.concat(S(n)),e.hasNext=n.isLast===!1||i.length,e&&i.length!==t&&i.length<f.size()?e.nextPage(a):(s.resolve(),T(n.totalCount),L())}var t,r,i=[],s=n.Deferred(),u=n.Deferred();return g=!0,e.nextPage(a),s.done(function(){f.replaceAll(i,o.showChange),d=e,u.resolve(),g=!1}),u}}}),define("render/ImageStyler",["jquery"],function(t){function n(e){return/\.png$/i.test(e)?".png":/\.jpg$/i.test(e)?".jpg":/\.jpeg$/i.test(e)?".jpeg":/\.gif$/i.test(e)?".gif":e.slice(e.lastIndexOf("."),e.length)}return function(r){function d(){var e=[],t=["ecx.images","g-ecx.images"],n=t.length,r=/http:\/\/(\S*)(-amazon\.com\S*)/gi,i=0,s=r.exec(o);return s&&(i=Math.floor(Math.random()*n),o=["http://",t[i],s[2]].join("")),e.push(o),p.length>1&&(p.push(""),e.push(p.join("_"))),e.push(u),e.join("")}var i=!1,s="",o="",u="",a=!1,f=!1,l=!1,c=!1,h=".",p=[];typeof r!="undefined"&&r!==null&&r.substr&&r.length>0&&(i=!0,o=r,u=n(r),o=r.slice(0,-u.length),o.lastIndexOf(".")>o.lastIndexOf("/")&&(h=o.slice(o.lastIndexOf("."),-1),o=o.slice(0,o.lastIndexOf("."))),p.push(h)),this.scaleTo=function(e){var n;return f?this:t.isNumeric(e)?(n=Math.floor(e),n<=0?this:(p.push("SL"+String(n)),f=!0,this)):this},this.addTransparency=function(){return a||(p.push("FMPNG"),a=!0),this},this.reduceQualityTo=function(e){return l||(p.push("QL"+e),l=!0),this},this.addBlackBackground=function(){return c||(p.push("BG0,0,0"),c=!0),this},this.build=function(){return i?d():s}}}),define("util/AppInfoBlockUtil",["require","jquery"],function(t){var n=t("jquery"),r=function(){this.showChange=function(e,t){var n,r,i,s=!0,o=!0,u=!0,a=!0,f=!0,l=!0,c=!0;return e&&!t||!e&&t?!0:(n=e.logo===t.logo,r=e.title===t.title,l=e.isInstalled===t.isInstalled,i=e.developer&&t.developer,t.installDetails?c=e.installDetails&&e.installDetails.installProgress===t.installDetails.installProgress&&e.installDetails.installPercent===t.installDetails.installPercent:(s=e.stars===t.stars&&e.starsDesc===t.starsDesc&&e.reviewCount===t.reviewCount,u=e.listPrice===t.listPrice,o=e.ourPrice===t.ourPrice,a=e.primaryActionButton===t.primaryActionButton,f=e.secondaryActionButton===t.secondaryActionButton,c=!e.installDetails),!(l&&n&&r&&i&&s&&u&&o&&a&&f&&c))},this.trimVersionText=function(e){var t;return e&&(t=e.indexOf("_"),t>=0&&(e=e.substring(0,t))),e},this.truncate=function(e,t){var r=n("#ruler").html(e).width(),i=0,s=t.lines||2,o=t.width||n(".app-title").width()||0;return e&&o&&r>=o*s&&(i=o*s/r*e.length,e=n.trim(e.substr(0,i-4))+"…"),e},this.handleRetruncation=function(){var e=this;setTimeout(function(){var t=0,r="",i="",s=n(".app-title").width(),o=n(".app-title"),u=n(".developer-name");for(t;t<o.length;t+=1)r=n(o[t]).data("text"),i=n(u[t]).data("text"),n(u[t]).text(e.truncate(i,{width:s,lines:1})),n(o[t]).text(e.truncate(r,{width:s,lines:2}))},500)}};return new r}),define("render/AppBlockRender",["require","jquery","appstore","render/ImageStyler","templates","api/currency","util/AppInfoBlockUtil"],function(e){var t=e("jquery"),n=e("appstore"),r=e("render/ImageStyler"),i=e("templates"),s=e("api/currency"),o=e("util/AppInfoBlockUtil"),u=new s,a=150;return function(s,f){var l,c,h=10,p="",d={li:' class="carousel-list-item"'};if(!s||typeof s=="undefined")s="li";d.hasOwnProperty(s)&&(p=d[s]),l="<"+s+p+"></"+s+">",c=function(e,n,r){return function(i){var s;return s=t(this).parents().find("input[name=asin]").val(),e.trigger(r,{app:n(s),target:i.target}),!1}},this.renderFn=function(e){var r,s={};return s=t.extend(s,e),(s.currentPrice>=s.listPrice||s.local&&s.local.isPurchased)&&delete s.listPrice,s.listPrice!==undefined&&(s.listPrice=u.format(s.listPrice,s.listPriceCurrencyCode,!1)),s.ourPrice=u.format(s.currentPrice,s.currentPriceCode,!0),f||(f=i.AppInfoBlock),r=t(f.render(s)),r.find(".app-icon").css("background-color","#000"),n.CustomerData.isUSPfmSync()||r.find('[data-class="app-list-price"]').hide(),t(l).append(r)},this.eventFn=function(e,t,n){e.off("tap"),e.off("longpress"),e.on("tap","div.app-information",c(t,n,"appSelected")),e.on("tap",'[data-class="oneclick-orange"]',c(t,n,"primarySelected")),e.on("tap",'[data-class="oneclick-green"]',c(t,n,"secondarySelected")),e.on("tap",'[data-class="oneclick-uninstall"]',c(t,n,"uninstallSelected")),e.on("longpress","div.app-information",c(t,n,"contextMenuRequested"))},this.afterRenderFn=function(e){var t=e.parent(),n=e.find(".developer-name"),i=e.find(".app-info-details"),s=e.find(".app-title"),u=e.find(".app-icon"),f=u.find("img"),l=f.data("logo"),c=t.data("imgWidth")||f.width()||a,h=i.width(),p,d,v;t.data("imgWidth",c),v=l?(new r(l)).addBlackBackground().scaleTo(c).build():!1,v&&(f.attr("src",v),u.css("background-color","inherit")),s.length&&(s.data("text")?p=s.data("text"):(s.data("text",s.text()),p=s.text()),s.text(window.Hyphenator.hyphenate(o.truncate(p,{width:h,lines:2}),""))),n.length&&(n.data("text")?d=n.data("text"):(n.data("text",n.text()),d=n.text()),n.text(window.Hyphenator.hyphenate(o.truncate(d,{width:h,lines:1}),"")))},t.subscribe("com.amazon.venezia.android_lifecycle.onOrientationChange",function(){o.handleRetruncation()}),this.mapKey="asin"}}),define("rules/ValueAddedTax",["require","api/resources"],function(t){var n=t("api/resources"),r;return r=n.getString("VATInclusive_hack")==="true",{isVATIncluded:function(){return r}}}),define("models/AppBlockModel",["require","jquery","models/InstallProgressModel","api/currency","rules/ValueAddedTax","api/resources","api/recorder"],function(e){function f(e){var t;if(e.sideloaded)return null;if(e.signatures)t="MyApps_label_UpdateStuckSignatures";else if(e.permissions)t="MyApps_label_UpdateStuckPermissions";else if(e.updateError||e.updateCheckError)t="MyApps_label_UpdateStuckError";return t?s.getString(t):null}var t=e("jquery"),n=e("models/InstallProgressModel"),r=e("api/currency"),i=e("rules/ValueAddedTax"),s=e("api/resources"),o=new r,u=e("api/recorder"),a=u.Java.getLogger("HTML5.AppBlockModel");return function(e){var r={},u,l,c=e.averageRating||e.customerReviewSummary&&e.customerReviewSummary.averageRating||e.reviewSummary&&e.reviewSummary.averageRating;return r=t.extend(r,e),e.searchResult!==undefined&&(r.sr=e.searchResult),r.asin=e.asin,r.packageName=e.local&&(e.local.packageName||e.local.androidPackageName),r.logo=e.logo||e.iconUrl||e.displayScreenshot&&e.displayScreenshot.medium,r.title=e.title||e.applicationName||e.displayTitle,r.developer=e.developer||e.developerName||e.publisherName||e.developerId,e.currentVersion!==undefined?r.currentVersion=e.currentVersion:r.currentVersion=e.productVersion,r.refTag="HTML5",e.currentPrice!==undefined?r.currentPrice=e.currentPrice:e.ourPrice!==undefined&&e.ourPrice!==null&&(e.ourPrice.amount!==undefined?(r.currentPrice=e.ourPrice.amount,r.currentPriceCode=e.ourPrice.unit,r.ourPrice=e.ourPrice.amount,r.ourPriceCurrencyCode=e.ourPrice.unit):(r.currentPrice=e.ourPrice,r.currentPriceCode=e.ourPriceCurrencyCode)),e.listPrice!==undefined&&e.listPrice!==null&&e.listPrice.amount!==undefined&&(r.listPrice=e.listPrice.amount,r.listPriceCurrencyCode=e.listPrice.unit),e.reviewCount!==undefined?r.reviewCount=e.reviewCount:e.customerReviewSummary&&e.customerReviewSummary.numberOfReviews!==undefined?r.reviewCount=e.customerReviewSummary.numberOfReviews:e.reviewSummary&&e.reviewSummary.totalReviews!==undefined&&(r.reviewCount=e.reviewSummary.totalReviews),r.reviewCount===0?(r.stars=0,r.starsDesc="0 stars"):(r.stars=Math.floor(c),r.starsDesc=r.stars,u=c-Math.floor(c),u>=.25&&u<.75?(r.stars+="h",r.starsDesc+=" 1/2"):u>=.75&&(r.stars+=1,r.starsDesc+=1),r.starsDesc+=" stars"),a.log("app.title: "+r.title),r.cloudApp=!0,e.local&&e.local.isPurchased?(a.log("data.local: "+JSON.stringify(e.local)),r.isPurchased=!0,e.local.state&&(l=n.fromLocalState(e.local,e.installDetails,!0),l&&(r.installDetails=l.installDetails),l&&l.local&&(r.local=e.local=l.local),a.log("app.installDetails: "+JSON.stringify(r.installDetails))),e.local.isInstalled?(r.cloudApp=!1,e.local.hasUpdate?(r.primaryAction="Update",r.sideloaded=e.local.autoUpdateStuckReasons.sideloaded,r.updateStuckReason=e.local.autoUpdateStuckReasons&&f(e.local.autoUpdateStuckReasons),e.local.autoUpdateStuckReasons&&e.local.autoUpdateStuckReasons.signatures?r.primaryActionButton=s.getString("replace_action_button"):r.primaryActionButton=s.getString("update_action_button")):(delete r.installDetails,r.primaryActionButton=s.getString("open_action_button"),r.primaryAction="Open")):e.local.isDownloaded?(r.primaryActionButton=s.getString("install_action_button"),r.primaryAction="Install"):(r.primaryActionButton=s.getString("download_action_button"),r.primaryAction="Download")):(r.primaryActionButton=o.format(r.currentPrice,r.currentPriceCode,!0),r.primaryAction="Buy",r.ourPrice&&parseFloat(r.ourPrice)>0?r.secondaryActionButton=s.getString("buy_app_action_button"):r.secondaryActionButton=s.getString("get_app_action_button")),r.vatInclusive=i.isVATIncluded(),r.supportedLanguages&&(r.languages=r.supportedLanguages.join(", ")),e.local&&e.local.blacklisted&&(delete r.primaryActionButton,delete r.secondaryActionButton,e.local.isInstalled===1?r.blacklistedActionButton=s.getString("authorize_uninstall_of_corrupt_app_ok_text"):delete r.blacklistedActionButton),r.appBadgeDetails=e.appBadgeDetails,r}}),define("handler/OneClickButtonHandler",["require","jquery","appstore","api/caching","api/currency","api/cor-pfm","api/install","api/navigation","api/purchase","api/resources","widget/Dialog","api/locker","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("appstore"),i=t("api/caching"),s=t("api/currency"),o=t("api/cor-pfm"),u=t("api/install"),a=t("api/navigation"),f=t("api/purchase"),l=t("api/resources"),c=t("widget/Dialog"),h=t("api/locker"),p=t("zeroes/ZeroesLoader"),d={};return function(t){function s(){c.showNative({title:"AlertDialog_title_AppNotCompatible",text:"AlertDialog_message_AppNotCompatible",button:"AlertDialog_button_AppNotCompatible"})}function v(){c.showNative({title:"AlertDialog_title_AppNotAvailable",text:"AlertDialog_message_AppNotAvailable",button:"AlertDialog_button_AppNotAvailable"})}function m(e,t){var r=n(t).parent(),i=r.find('[data-class="oneclick-orange"]');i.is(":visible")?(i.hide(),r.find('[data-class="oneclick-green"]').css("display","inline-block")):(i.css("display","inline-block"),r.find('[data-class="oneclick-green"]').hide())}function g(e){if(!t)return;a.navigate("Detail",{asin:e.asin})}function y(e){return Number(e.zeroesOurPrice)>0}function b(e){n.publish("Zeroes.showPurchaseChoiceDialog")}function w(e){var t,n;r.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.App.Launch.Initiated"),t=function(){r.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.App.Launch.Completed")},n=function(){r.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.App.Launch.Failure")},a.startApp(e,t,n)}function E(e,t){var n=t||e.purchaseVerifications&&e.purchaseVerifications.slice(0)||[],i,s;console.log("RATING: Buying an app with verifications: "+n),i=n.shift(),i!==undefined?(s=d[i],s!==undefined?(console.log("RATING: About to show the confirmation dialog."),r.Navigation.showDialog("NativeDialog",{dialogType:"FulfillmentErrorDialog",title:l.getString(s.title),message:l.getString(s.message,[e.title||e.applicationName||e.displayTitle])},function(t){console.log("back to OneClickButtonHandler"),t&&t.action==="yes"?E(e,n):m(e.asin)})):E(e,n)):(console.log("RATING: about to purchase app: "+e.asin),f.purchaseApp(e),g(e))}t===undefined&&(t=!0),this.primarySelected=function(e,t){var a=t.app,f=a.asin,l=a.primaryAction,c=i.getItem("countryOfResidence"),d=i.getItem("preferredMarketplace");console.log("Clicked: "+f+" action "+l+" -> "+JSON.stringify(e)),n.publish("com.amazon.venezia.doPurchase",[f]);if(o.corDoesNotMatchPfm(c,d))return console.log("COR: "+c+" does not match PFM: "+d+".  Cancelling purchase attempt."),!1;if(!a.isCompatible)return s(),!1;if(l==="Buy"||l==="Download"||l==="Install"||l==="Update")if(h.Instance.isBlacklisted(a.asin,a.currentVersion))return v(),!1;return l==="Buy"?(console.log("Buying: "+f),p.isEnabled()&&y(a)?b(t):m(f,t.target)):l==="Download"?(console.log("Downloading: "+f),a&&(u.installApp(a),g(a)),console.log("Done downloading app.")):l==="Open"?(console.log("Opening: "+f),a&&w(a)):l==="Install"?r.Install.resume(a).done(function(e){console.log("resumed="+e),e||r.Install.updateApp(a)}):l==="Update"&&(console.log("Updating: "+f+" to Current Version: "+a.currentVersion),a&&u.updateApp(a)),!1},this.uninstallSelected=function(e,t,n,r){var i=t.app,s=i.asin;return console.log("Clicked: "+s+" action uninstall -> "+JSON.stringify(e)),u.uninstallApp(i.packageName,n,r),!1},this.secondarySelected=function(e,t){var n=t.app;return n&&(console.log("Purchasing app: "+JSON.stringify(n)),n.isCompatible?E(n):s(),console.log("Done purchasing app.")),!1},this.appSelected=function(e,t){return a.navigate("Detail",{asin:t.app.asin}),!1}}}),define("controller/AppBlockPagerController",["require","jquery","controller/PagerController","render/AppBlockRender","models/AppBlockModel","models/InstallProgressModel","handler/OneClickButtonHandler","util/AppInfoBlockUtil","templates"],function(t){var n=t("jquery"),r=t("controller/PagerController"),i=t("render/AppBlockRender"),s=t("models/AppBlockModel"),o=t("models/InstallProgressModel"),u=t("handler/OneClickButtonHandler"),a=t("util/AppInfoBlockUtil"),f=t("templates");return function(t,o){var l;o=o||{},o.Render=o.Render||i,o.pagerKey=o.pagerKey||"result",o.Model=o.Model||s,o.Handlers=o.Handlers||[new u],o.template=o.template||f.AppInfoBlock,o.showChange=a.showChange,l=new r(t,o),n.extend(this,l)}}),define("controller/MyAppsRemoveController",["require","jquery","templates","appstore","api/resources","api/install","api/entitlements"],function(e){var t=e("jquery"),n=e("templates"),r=e("appstore"),i=e("api/resources"),s=e("api/install"),o=e("api/entitlements");return function(n){this.update=function(e){var t=e.action;n.render(e)},t(n).on("removeSelected",function(e,t){n.dismissDialog(),t.cloudApp?r.Navigation.showDialog("NativeDialog",{dialogType:"FulfillmentErrorDialog",title:i.getString("MyApps_title_RemoveFromCloudQuery"),message:i.getString("MyApps_body_RemoveFromCloudQuery",[t.title]),negButton:i.getString("purchase_confirm_age_no"),posButton:i.getString("purchase_confirm_age_yes")},function(e){console.log("back to MyAppsRemoveController"),e&&e.action&&(console.log("result.action: "+e.action),e.action==="yes"&&o.archiveApp(t))}):s.uninstallApp(t.packageName)})}}),define("views/MyAppsRemoveView",["jquery","templates","api/resources"],function(t,n,r){return function(r,i){var s,o,u=!1,a=this,f=i&&i.pointAt;this.dismissDialog=function(){r.hide(),u=!1,t("body").off("touchstart.outsideDialog"),r.off("tap")},this.render=function(e){var i,o,l,c,h;r.empty(),s=t(n.MyAppsRemoveDialog.render(e)),r.append(s),f&&(i=t(f),o=i.closest("li"),o.length&&(l=o.offset().top+o.outerHeight(),c=l+r.outerHeight(),h=t(window).scrollTop()+t(window).height(),c>h&&(l-=c-h),r.css("top",""),r.offset({top:l}))),r.show("fast"),t("body").on("touchstart.outsideDialog",function(e){u&&!t(e.target).parents().is(r)&&a.dismissDialog()}),r.on("tap",null,e,t.proxy(this.selectRemove,this)),u=!0},this.selectRemove=function(e){var n=e.data;t(this).trigger("removeSelected",[n])}}}),define("handler/MyAppsOneClickButtonHandler",["require","jquery","appstore","controller/MyAppsRemoveController","views/MyAppsRemoveView","api/locker","widget/Dialog"],function(t){var n=t("jquery"),r=t("appstore"),i=t("controller/MyAppsRemoveController"),s=t("views/MyAppsRemoveView"),o=t("api/locker"),u=t("widget/Dialog");return function(t){function f(){u.showNative({title:"AlertDialog_title_AppNotCompatible",text:"AlertDialog_message_AppNotCompatible",button:"AlertDialog_button_AppNotCompatible"})}function l(){u.showNative({title:"AlertDialog_title_AppNotAvailable",text:"AlertDialog_message_AppNotAvailable",button:"AlertDialog_button_AppNotAvailable"})}var n=t?t.removeTarget:undefined,a;this.appSelected=function(e,t){if(a)return a=!1,!1;var n=t.app;return console.log("appSelected: "+JSON.stringify(n)),r.Navigation.navigate("Detail",{asin:n.asin}),!1},this.contextMenuRequested=function(e,t){var r,o,u;u=t.app,n&&(r=new s(n,{pointAt:t.target}),o=new i(r),o.update(u),a=!0)},this.primarySelected=function(e,t){var n=t.app,i=n.asin,s=n.primaryAction,u;console.log("MyAppsOneClickButtonHandler.primarySelected Clicked: "+i+" action "+s+" -> "+JSON.stringify(e));if(!n.isCompatible)return f(),!1;if(s==="Buy"||s==="Download"||s==="Install"||s==="Update")if(o.Instance.isBlacklisted(n.asin,n.currentVersion))return l(),!1;return s==="Download"?(console.log("Downloading: "+i),n&&r.Install.installApp(n),console.log("Done downloading app.")):s==="Open"?(console.log("Opening: "+i),n&&r.Navigation.startApp(n)):s==="Install"?r.Install.resume(n).done(function(e){console.log("resumed="+e),e||r.Install.updateApp(n)}).fail(function(e){console.log("error trying to resume: "+e.reason)}):s==="Update"&&(console.log("Updating: "+i+" to Current Version: "+n.currentVersion),n&&r.Install.updateApp(n)),!1}}}),define("controller/AppUpdateController",["require","jquery","api/navigation","controller/AppBlockPagerController","handler/MyAppsOneClickButtonHandler","handler/ClickStreamHandler","controller/SoftKeysController","models/InstallProgressModel","api/install","api/locker","api/recorder","api/resources","api/device-features","widget/Dialog","templates"],function(e){var t=e("jquery"),n=e("api/navigation"),r=e("controller/AppBlockPagerController"),i=e("handler/MyAppsOneClickButtonHandler"),s=e("handler/ClickStreamHandler"),o=e("controller/SoftKeysController"),u=e("models/InstallProgressModel"),a=e("api/install"),f=e("api/locker"),l=e("api/recorder"),c=e("api/resources"),h=e("api/device-features"),p=e("widget/Dialog"),d,v=l.Metrics.recordEvent,m=e("templates");return d={appUpdate:{init:"Appstore.Recorder.Metrics.Event.AppUpdate.Load.Initiated",done:"Appstore.Recorder.Metrics.Event.AppUpdate.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.AppUpdate.Load.Failure"},page:{init:"Appstore.Recorder.Metrics.Event.AppUpdate.Page.Initiated",done:"Appstore.Recorder.Metrics.Event.AppUpdate.Page.Completed",fail:"Appstore.Recorder.Metrics.Event.AppUpdate.Page.Failure",cancel:"Appstore.Recorder.Metrics.Event.AppUpdate.Page.Cancel"},updateAll:{selected:"Appstore.Metrics.AppUpdate.UpdateAll.Selected"}},function(l){function N(e,t){var n;e?w=w.refineQuery([{name:"app_sort_name_asc"}],[{name:e}]):w=w.refineQuery([{name:"app_sort_name_asc"}]),t||(t=function(e){y.setData(e)}),n=function(e){},w.execute(t,n)}function C(e){var t;w=E.getApps(),t=f.Utils.getUpdateFilter(),t.done(function(t){console.log("Update filter: "+t),N(t,e)}).fail(function(t){console.log("Update filter: "+t),N(t,e)})}function k(){l.getUpdateAllTarget().hide()}function L(){l.getUpdateAllTarget().show()}function A(){l.getLoadingIndicator().hide()}function O(){l.getLoadingIndicator().show(),k(),window.setTimeout(function(){console.log("Failed to load apps"),A()},3e4)}function M(e){v(d.updateAll.selected),h.isNetworkWifi().done(function(e){e?a.updateAllApps():p.showNative({title:"AlertDialog_title_MobileNetworkData",text:"no_wifi_conn_paused",noButton:"CopyAlertDialog_button_Cancel",yesButton:"AlertDialog_button_Offline_WirelessSettings",yesButtonFn:function(){var t={action:"android.settings.WIFI_SETTINGS"};n.Android.startActivity(t,{}),n.finish()},noActionFn:n.finish})})}function _(){C(function(t){y.setData(t),console.log("done refreshing data"),console.log("refreshPagerData: "+JSON.stringify(t))})}function D(e){var t,n=u.getAsinFromWorkflowEvent(e);t=u.fromWorkflowEvent(e,{expectedAsin:n}),t&&y.updateItemFromWorkflow(n,{installDetails:t}),e.extras["com.amazon.mas.client.MACS_INTENT_TYPE"]==="com.amazon.mas.client.install.INSTALL_COMPLETED"&&window.setTimeout(function(){_()},5e3)}function P(e){u.fromLocalState(e.extras).done(function(t){y.updateItemFromWorkflow(e.extras.asin,t)})}function H(e){_(),A()}var g,y,b,w,E,S,x,T=!0;v(d.appUpdate.init),E=f.Instance,l.render(),x=new o(l,"AppUpdate"),n.getExtras("refMarker","page").done(function(e,t){var n=new s(t);e&&n.record(e)}),S=l.getAppUpdateListTarget(),y=new r(S,{Handlers:[new i],template:m.AppUpdateInfoBlock}),t.subscribe("com.amazon.mas.client.framework.UpdateService.updated",H),t.subscribe("com.amazon.mas.client.MACS_PDI_CHANGE",D),t.subscribe("com.amazon.locker.APP_LOCAL_STATE_UPDATED",P),t.subscribe("com.amazon.venezia.android_lifecycle.onPause",function(){v(d.page.cancel),A(),L()}),t(l).on("updateAll",M),t(S).on("page.totalCount",function(e,n){t(l.getTotalCountTarget()).text(c.getQuantityString("my_apps_update",n,[n])),n===0?k():L()}),t(S).on("page.initiated",function(){v(d.page.init)}),t(S).on("page.completed",function(){v(d.page.done),T&&(v(d.appUpdate.done),A(),L(),T=!1)}),t(S).on("page.empty",function(){v(d.page.done),T&&(v(d.appUpdate.done),A(),k(),T=!1)}),t(S).on("page.failure",function(){v(d.page.fail),T&&(v(d.appUpdate.fail),A(),k(),T=!1)}),C(function(n){y.setData(n),t.subscribe("com.amazon.venezia.android_lifecycle.onResume",_)})}}),define("views/AppUpdateView",["jquery","templates"],function(e,t){return function(n){function i(t){return e(r).trigger("updateAll"),!1}var r=this;this.render=function(){var e=n.find("#update-button");e.on("tap",i)},this.getAppUpdateListTarget=function(){return n.find("#app-update-asin-list")},this.getLoadingIndicator=function(){return n.find("#loading")},this.getUpdateAllTarget=function(){return n.find("#update-button")},this.getTotalCountTarget=function(){return n.find("#count-text")}}}),define("controller/BestSellerController",["require","jquery","appstore","controller/AppBlockPagerController","controller/SoftKeysController","handler/ClickStreamHandler","zeroes/ZeroesLoader"],function(t){function l(e){var t=e.data.page;return console.log("Inside bestseller controller navigating to page: "+t),r.Navigation.navigate(t),!1}function c(e){n(e.getTopPaidTarget()).on("page.completed",function(){r.Recorder.Metrics.recordEvent(f.top_paid_load.done),n(e.getTopPaidTarget()).off("page.completed")}),n(e.getTopPaidTarget()).on("page.failure",function(){r.Recorder.Metrics.recordEvent(f.top_paid_load.fail),n(e.getTopPaidTarget()).off("page.failure")}),n(e.getTopFreeTarget()).on("page.completed",function(){r.Recorder.Metrics.recordEvent(f.top_free_load.done),n(e.getTopFreeTarget()).off("page.completed")}),n(e.getTopFreeTarget()).on("page.failure",function(){r.Recorder.Metrics.recordEvent(f.top_free_load.fail),n(e.getTopFreeTarget()).off("page.failure")}),n(e.getTopRatedTarget()).on("page.completed",function(){r.Recorder.Metrics.recordEvent(f.top_rated_load.done),n(e.getTopRatedTarget()).off("page.completed")}),n(e.getTopRatedTarget()).on("page.failure",function(){r.Recorder.Metrics.recordEvent(f.top_rated_load.fail),n(e.getTopRatedTarget()).off("page.failure")}),e.getMoversAndShakersTarget().length>0&&(n(e.getMoversAndShakersTarget()).on("page.completed",function(){r.Recorder.Metrics.recordEvent(f.movers_and_shakers_load.done),n(e.getMoversAndShakersTarget()).off("page.completed")}),n(e.getMoversAndShakersTarget()).on("page.failure",function(){r.Recorder.Metrics.recordEvent(f.movers_and_shakers_load.fail),n(e.getMoversAndShakersTarget()).off("page.failure")}))}var n=t("jquery"),r=t("appstore"),i=t("controller/AppBlockPagerController"),s=t("controller/SoftKeysController"),o=t("handler/ClickStreamHandler"),u=r.Recorder.Java.getLogger("HTML5.BestSellerController"),a=t("zeroes/ZeroesLoader"),f;return f={top_free_load:{done:"Appstore.Recorder.Metrics.Event.Bestsellers.TopFree.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.Bestsellers.TopFree.Load.Failure"},top_paid_load:{done:"Appstore.Recorder.Metrics.Event.Bestsellers.TopPaid.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.Bestsellers.TopPaid.Load.Failure"},top_rated_load:{done:"Appstore.Recorder.Metrics.Event.Bestsellers.TopRated.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.Bestsellers.TopRated.Load.Failure"},movers_and_shakers_load:{done:"Appstore.Recorder.Metrics.Event.Bestsellers.MoversAndShakers.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.Bestsellers.MoversAndShakers.Load.Failure"}},function(t){var f,h,p,d,v,m,g,y,b,w="BestSeller",E=new o(w);t.render(),r.Navigation.getExtras("refMarker").done(function(e){u.log("ClickStream-UI-BestSellerController: refMarker = "+e),E.recordView("/bs",e),E.record(e)}).fail(function(e){u.log("ClickStream-UI-BestSellerController: failed to get refMarker; eror = "+JSON.stringify(e))}),f=new s(t),c(t),d=new i(t.getTopPaidTarget(),{pagerKey:"apps"}),v=r.Catalog.getRankedApps(r.Catalog.RANK_TYPE_TOP_SELLERS,null,1),v.done(function(e){console.log("BestSellerController debug top sellers: "+JSON.stringify(e)),d.setData(e)}),p=new i(t.getTopFreeTarget(),{pagerKey:"apps"}),h=r.Catalog.getRankedApps(r.Catalog.RANK_TYPE_TOP_FREE,null,1),h.done(function(e){console.log("BestSellerController debug top free: "+JSON.stringify(e)),p.setData(e)}),g=r.Search.createQuery("*",r.Search.SortCriteria.AVG_CUSTOMER_REVIEW),m=new i(t.getTopRatedTarget(),{pagerKey:"apps",maxItems:10}),m.setData(g),t.getMoversAndShakersTarget().length>0&&(y=new i(t.getMoversAndShakersTarget(),{pagerKey:"apps"}),b=r.Catalog.getRankedApps(r.Catalog.RANK_TYPE_MOVERS_AND_SHAKERS,null,1),b.done(function(e){console.log("BestSellerController debug movers and shakers: "+JSON.stringify(e)),y.setData(e)})),t.getTopPaidSeeAllTarget().on("tap",{page:"BestSellerTopPaid"},l),t.getTopFreeSeeAllTarget().on("tap",{page:"BestSellerTopFree"},l),t.getTopRatedSeeAllTarget().on("tap",{page:"BestSellerTopRated"},l),t.getMoversAndShakersSeeAllTarget().on("tap",{page:"BestSellerMoversAndShakers"},l),n.when(v,h,b).done(function(){a.initializeAsync(a.STORE_CONFIG_TYPES.Generic)})}}),define("views/BestSellerView",["jquery","templates"],function(e,t){return function(t){this.render=function(e){},this.getTopPaidTarget=function(){return t.find("#top_paid .carousel-list")},this.getTopFreeTarget=function(){return t.find("#top_free .carousel-list")},this.getTopRatedTarget=function(){return t.find("#top_rated .carousel-list")},this.getMoversAndShakersTarget=function(){return t.find('[data-class="best-seller-movers-and-shakers-apps-list"]')},this.getTopPaidSeeAllTarget=function(){return t.find("#topPaidSeeMore")},this.getTopFreeSeeAllTarget=function(){return t.find("#topFreeSeeMore")},this.getTopRatedSeeAllTarget=function(){return t.find("#topRatedSeeMore")},this.getMoversAndShakersSeeAllTarget=function(){return t.find("#moversAndShakersSeeMore")}}}),define("controller/BestSellerTopFreeController",["require","jquery","appstore","controller/AppBlockPagerController","controller/SoftKeysController","zeroes/ZeroesLoader"],function(t){function a(e){n(e.getTopFreeTarget()).on("page.completed",function(){r.Recorder.Metrics.recordEvent(u.top_free_all.done),n(e.getTopFreeTarget()).off("page.completed")}),n(e.getTopFreeTarget()).on("page.failure",function(){r.Recorder.Metrics.recordEvent(u.top_free_all.fail),n(e.getTopFreeTarget()).off("page.failure")})}var n=t("jquery"),r=t("appstore"),i=t("controller/AppBlockPagerController"),s=t("controller/SoftKeysController"),o=t("zeroes/ZeroesLoader"),u;return u={top_free_all:{done:"Appstore.Recorder.Metrics.Event.Bestsellers.TopFreeAll.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.Bestsellers.TopFreeAll.Load.Failure"}},function(t){var n,u,f;t.render(),n=new s(t),a(t),f=new i(t.getTopFreeTarget(),{pagerKey:"apps",maxItems:100}),u=r.Catalog.getRankedApps(r.Catalog.RANK_TYPE_TOP_FREE),u.done(function(e){console.log("BestSellerController debug: "+JSON.stringify(e)),f.setData(e),o.initializeAsync(o.STORE_CONFIG_TYPES.Generic)})}}),define("views/BestSellerTopFreeView",["jquery","templates"],function(e,t){return function(t){this.render=function(e){},this.getTopFreeTarget=function(){return t.find('[data-class="top-free-apps-list"]')}}}),define("controller/BestSellerTopPaidController",["require","jquery","appstore","controller/AppBlockPagerController","controller/SoftKeysController","zeroes/ZeroesLoader"],function(t){function a(e){n(e.getTopPaidTarget()).on("page.completed",function(){r.Recorder.Metrics.recordEvent(u.top_paid_all.done),n(e.getTopPaidTarget()).off("page.completed")}),n(e.getTopPaidTarget()).on("page.failure",function(){r.Recorder.Metrics.recordEvent(u.top_paid_all.fail),n(e.getTopPaidTarget()).off("page.failure")})}var n=t("jquery"),r=t("appstore"),i=t("controller/AppBlockPagerController"),s=t("controller/SoftKeysController"),o=t("zeroes/ZeroesLoader"),u;return u={top_paid_all:{done:"Appstore.Recorder.Metrics.Event.Bestsellers.TopPaidAll.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.Bestsellers.TopPaidAll.Load.Failure"}},function(t){var n,u,f;t.render(),n=new s(t),a(t),u=new i(t.getTopPaidTarget(),{pagerKey:"apps",maxItems:100}),f=r.Catalog.getRankedApps(r.Catalog.RANK_TYPE_TOP_SELLERS),f.done(function(e){console.log("BestSellerController debug top sellers: "+JSON.stringify(e)),u.setData(e),o.initializeAsync(o.STORE_CONFIG_TYPES.Generic)})}}),define("views/BestSellerTopPaidView",["jquery","templates"],function(e,t){return function(t){this.render=function(e){},this.getTopPaidTarget=function(){return t.find('[data-class="top-paid-apps-list"]')}}}),define("widget/Widget",["jquery"],function(e){var t=window.Class.extend({init:function(t,n,r){this.srcNodeRef=e(t),this.template=n,r=r||{},this.properties={};var i;for(i in r)r.hasOwnProperty(i)&&(this.properties[i]=r[i]);this.eventListeners={}},get:function(e){return this.properties[e]},buildRendering:function(){},setup:function(){e(this).trigger("pre-setup",[this]),this.buildRendering(),e(this).trigger("post-setup",[this])},destroy:function(){e(this).trigger("pre-destroy"),this.srcNodeRef.remove(),e(this).trigger("post-destroy")},on:function(e,t){if(typeof t!="function")return;this.eventListeners[e]=this.eventListeners[e]||[],this.eventListeners[e].push(t)},remove:function(e,t){var n=this.eventListeners[e]||[],r;for(r=0;r<n.length;r+=1)t===n[r]&&(n=n.splice(r,1))},trigger:function(e,t){var n=this.eventListeners[e]||[],r;for(r=0;r<n.length;r+=1)n[r].apply(this,[].concat(t))}});return t}),define("widget/SearchResults",["require","jquery","models/AppBlockModel","api/customer-data","infiniteScroll","widget/Widget","api/currency","render/ImageStyler","api/navigation","handler/RefMarkerBuilder","util/AppInfoBlockUtil","templates","api/recorder"],function(t){var n=t("jquery"),r=t("models/AppBlockModel"),i=t("api/customer-data"),s=t("infiniteScroll"),o=t("widget/Widget"),u=t("api/currency"),a=new u,f=t("render/ImageStyler"),l=t("api/navigation"),c=t("handler/RefMarkerBuilder"),h=t("util/AppInfoBlockUtil"),p=t("templates").AppInfoBlockSearchResults,d=null,v="SearchResults",m=t("api/recorder"),g=m.Java.getLogger("HTML5.SearchResults"),y=function(t){return function(){t._retruncate(),t.appsPerRow=t._getAppsPerRow()}},b=o.extend({init:function(e,t,r){this._super(e,null,r),this.queryResponse=t,this.hostDomNode=this.properties.hostDomNode||null;if(!this.hostDomNode||this.hostDomNode.length<=0)this.hostDomNode=null;this.parentPage=this.properties.parentPage,this.maxItems=this.properties.maxItems,this.itemsReceived=0,this.isNextPageRequestPending=!1,this.firstSetOfResultsLoaded=!1,this.appsPerRow=null,this.appsStashed=[],n.subscribe("com.amazon.venezia.android_lifecycle.onConfigChange.cssLoaded",y(this))},buildRendering:function(){var e=this,t=(new s(this.srcNodeRef,!1)).setup();this.srcNodeRef.on("infinite-scroll",null,null,function(t){e._nextPage()}),this._nextPage(),this.srcNodeRef.on("tap","div[data-asin]",null,function(t){var r=n(this),i={},s=new c(e.parentPage,v,"Detail");i.asin=r.attr("data-asin"),i.sr=r.attr("data-sr"),i.qid=r.attr("data-qid"),i.refMarker=s.build(),g.log("ClickStream-UI-SearchResults: navArgs = "+JSON.stringify(i)),l.navigate("Detail",i),t.preventDefault()})},update:function(e){e&&e!==this.queryResponse&&(this.queryResponse=e),this.firstSetOfResultsLoaded=!1,this.srcNodeRef.empty(),this.appsStashed=[],this.itemsReceived=0,this._nextPage()},_getAppsPerRow:function(){var e=0,t=n(this.srcNodeRef.find("li")),r=t.length,i=null,s=null;for(e=0;e<r;e+=1){s=n(t[e]).offset().top;if(i===null)i=s;else if(s>i)return e}return null},_retruncate:function(){var e=0,t="",r=n(this.srcNodeRef.find(".app-title")),i={width:n(".app-info-details").width(),lines:2};for(e;e<r.length;e+=1)t=n(r[e]).data("text"),n(r[e]).text(h.truncate(t,i))},_nextPage:function(){var e=this,t=function(t){e.srcNodeRef.trigger("page.loading");var r,i=t.apps||[],s=t.info||{};e.isNextPageRequestPending=!1,e.maxItems&&(e.itemsReceived+=i.length,e.itemsReceived>e.maxItems&&(i=i.slice(0,i.length-(e.itemsReceived-e.maxItems)),t.isLast=!0));if(i.length===0){if(t.isLast!==!0){e._nextPage();return}e.appsStashed.length>0?i=e.appsStashed:e.srcNodeRef.trigger("page.empty")}else if(e.appsPerRow!==null){r=i.length+e.appsStashed.length;if(!(r>=e.appsPerRow||t.isLast===!0)){e.appsStashed=e.appsStashed.concat(i),e._nextPage();return}i=e.appsStashed.concat(i)}i&&e._render(i,!0,s,t.isLast),e.srcNodeRef.trigger("page.completed",{itemCount:i.length,pageStatus:t.isLast}),e.hostDomNode&&t.isLast===!1&&!e.firstSetOfResultsLoaded&&(e.hostDomNode.height()<n(window).height()?e._nextPage():e.firstSetOfResultsLoaded=!0)},r=function(e){g.log("failed to get the next page; "+JSON.stringify(e))};if(this.maxItems&&this.itemsReceived>=this.maxItems)return;this.srcNodeRef.trigger("page.initiated"),!this.isNextPageRequestPending&&!this.queryResponse.isLastPage()&&(this.isNextPageRequestPending=!0,this.queryResponse.nextPage(t,r))},_render:function(e,t,s,o){var u=0,f=null,l=null,c=n("<ul>"),d=s.queryId,v=0,m=n(this.srcNodeRef.find("li")).length,g={width:n(".app-info-details").width(),lines:2},y=e.length-1;!o&&this.appsPerRow!==null&&(y=Math.floor(e.length/this.appsPerRow)*this.appsPerRow-1,v=m%this.appsPerRow,v!==0&&y>=v&&(y-=v));for(u=0;u<=y;u+=1)f=new r(n.extend({},e[u])),(f.currentPrice>=f.listPrice||f.local&&f.local.isPurchased)&&delete f.listPrice,f.listPrice!==undefined&&(f.listPrice=a.format(f.listPrice,f.listPriceCurrencyCode,!1)),f.ourPrice=a.format(f.currentPrice,f.currentPriceCode,!0),i.isUSPfmSync()||delete f.listPrice,f.queryId=d,f.originalTitle=f.title,f.title=h.truncate(f.title,g),l=this._styleBlock(n(p.render(f))),c.append(n('<li class="carousel-list-item">').append(l));this.appsStashed=e.slice(y+1),t||this.srcNodeRef.empty(),this.srcNodeRef.append(c.html()),this.appsPerRow===null&&(this.appsPerRow=this._getAppsPerRow()),!this.cachedImageWidth&&t&&(this.cachedImageWidth=n(this.srcNodeRef.find(".app-icon")[0]).find("img").width(),this._render(e,!1,s,o))},_styleBlock:function(e){var t,n,r,i;return t=e.find(".app-icon"),n=t.find("img"),r=n.data("logo"),this.cachedImageWidth?(i=r?(new f(r)).addBlackBackground().scaleTo(this.cachedImageWidth).build():!1,i&&n.attr("src",i).css("background-color","inherit")):t.css("background-color","#000"),e}});return b}),define("controller/BestSellerTopRatedController",["require","jquery","appstore","widget/SearchResults","controller/SoftKeysController","zeroes/ZeroesLoader"],function(t){function a(e){n(e.getTopRatedTarget()).on("page.completed",function(){r.Recorder.Metrics.recordEvent(u.top_rated_all.done),n(e.getTopRatedTarget()).off("page.completed")}),n(e.getTopRatedTarget()).on("page.failure",function(){r.Recorder.Metrics.recordEvent(u.top_rated_all.fail),n(e.getTopRatedTarget()).off("page.failure")})}var n=t("jquery"),r=t("appstore"),i=t("widget/SearchResults"),s=t("controller/SoftKeysController"),o=t("zeroes/ZeroesLoader"),u;return u={top_rated_all:{done:"Appstore.Recorder.Metrics.Event.Bestsellers.TopRatedAll.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.Bestsellers.TopRatedAll.Load.Failure"}},function(t){var u,f,l;t.render(),u=new s(t),a(t),l=new r.Search.createQuery("*",r.Search.SortCriteria.AVG_CUSTOMER_REVIEW),f=new i(t.getTopRatedTarget(),l,{hostDomNode:n('ul[data-class="top-rated-apps-list"]'),parentPage:"BestSellerTopRated",maxItems:100}),f.setup(),o.initializeAsync(o.STORE_CONFIG_TYPES.Generic)}}),define("views/BestSellerTopRatedView",["jquery","templates"],function(e,t){return function(t){this.render=function(e){},this.getTopRatedTarget=function(){return t.find('[data-class="top-rated-apps-list"]')}}}),define("controller/BestSellerMoversAndShakersController",["require","jquery","appstore","controller/AppBlockPagerController","controller/SoftKeysController","zeroes/ZeroesLoader","handler/ClickStreamHandler","api/recorder"],function(t){function c(e){n(e.getMoversAndShakersTarget()).on("page.completed",function(){r.Recorder.Metrics.recordEvent(l.movers_and_shakers_all_load.done),n(e.getMoversAndShakersTarget()).off("page.completed")}),n(e.getMoversAndShakersTarget()).on("page.failure",function(){r.Recorder.Metrics.recordEvent(l.movers_and_shakers_all_load.fail),n(e.getMoversAndShakersTarget()).off("page.failure")})}var n=t("jquery"),r=t("appstore"),i=t("controller/AppBlockPagerController"),s=t("controller/SoftKeysController"),o=t("zeroes/ZeroesLoader"),u=t("handler/ClickStreamHandler"),a=t("api/recorder"),f=a.Java.getLogger("HTML5.SearchController"),l;return l={movers_and_shakers_all_load:{done:"Appstore.Recorder.Metrics.Event.Bestsellers.MoversAndShakersAll;.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.Bestsellers.MoversAndShakersAll.Load.Failure"}},function(t){var n,a,l,h="BestSellerMoversAndShakers",p=new u(h);t.render(),n=new s(t),c(t),a=new i(t.getMoversAndShakersTarget(),{pagerKey:"apps",maxItems:100}),l=r.Catalog.getRankedApps(r.Catalog.RANK_TYPE_MOVERS_AND_SHAKERS),l.done(function(e){console.log("BestSellerController debug movers and shakers: "+JSON.stringify(e)),a.setData(e),o.initializeAsync(o.STORE_CONFIG_TYPES.Generic)}),r.Navigation.getExtras("refMarker").done(function(e){f.log("ClickStream-UI-BestSellerMoversAndShakersController: refMarker = "+e),p.recordView("/ms",e),p.record(e)}).fail(function(e){f.log("ClickStream-UI-BestSellerMoversAndShakersController: failed to get refMarker; eror = "+JSON.stringify(e))})}}),define("views/BestSellerMoversAndShakersView",["jquery","templates"],function(e,t){return function(t){this.render=function(e){},this.getMoversAndShakersTarget=function(){return t.find('[data-class="movers-and-shakers-apps-list"]')}}}),define("controller/PagerListController",["models/AppBlockModel"],function(e){return function(n,r,i){var s,o,u;i=i||{},s=i.key||"apps",o=i.maxItems,u=i.Model||e,this.setData=function(e){e.nextPage(function(r){var i,a,f,l;i=r[s],l=[],f=i.length,o&&o<f&&(f=o);for(a=0;f>a;a+=1)l.push(new u(i[a]));n.size()!==0&&n.remove(0,n.size()),n.addAll(l),n.notify();if(e.hasNext)return})},r&&this.setData(r)}}),define("controller/CategoryController",["jquery","appstore","coll/ItemCollection","views/ListView","render/AppBlockRender","controller/PagerListController","zeroes/ZeroesLoader"],function(e,t,n,r,i,s,o){return function(a){var f,l,c,h,p,d,v,m,g;m=function(){console.log("Refine tapped.")},a.render(),f=t.Navigation.getExtras(),l=f.category||"new",h=e.proxy(function(e){console.log("Received page: ",e)},this),g=new t.Search.Category,g.name=l,c=t.Search.createQuery(g),p=new n,d=new r(a.getSearchContentTarget(),p,e.extend(new i,r.SlideAnimations)),v=new s(p,c),e(a).on("refineSelect",e.proxy(m,this)),o.initializeAsync(o.STORE_CONFIG_TYPES.Generic)}}),define("views/CategoryView",["jquery","templates"],function(e,t){return function(n){function i(){return e(r).trigger("refineSelect"),!1}function s(){return e(r).trigger("searchTextSubmit",n.find("input#device-search").val()),!1}var r=this;this.render=function(e){n.find("div.refine-bar button").on("tap",i)},this.getSearchContentTarget=function(){return n.find('[data-class="search-page-list"]')}}}),define("controller/CellularDownloadLimitDialogController",["require","jquery","api/navigation"],function(e){var t=e("jquery"),n=e("api/navigation");return function(r){function i(e,t,r){var i={limit:t,text:r};return n.setResult(i),n.finish(),!1}r.render(),t(r).on("cellularDownloadLimitChanged",i),t(r).on("cancel",n.finish)}}),define("views/DialogView",["jquery","templates"],function(e,t){var n=function(t){var r,i,s,o,u,a,f,l=this;t&&(i=t.renderTarget||e("body div#root-dialog"),s=t.template,o=t.getDataFn||function(){return{}},u=t.isValidFn||function(){return!0},a=t.invalidFn||function(){return{}},f=t.applyOptionalBindings||function(){return{}}),this.render=function(t){i.empty(),r=e(s.render(t)),i.append(r),e("#yes").on("tap",function(){return e(l).trigger("clickedYes"),!1}),e("#no").on("tap",function(){return e(l).trigger("clickedNo"),!1}),e("a").on("click",function(){return e(l).trigger("clickedLink",e(this).attr("href")),!1}),n.handleCancel(l),f()},this.getRenderTarget=function(){return i},this.getData=function(){return o()},this.validate=function(){return u()},this.invalidFn=function(){a()}};return n.handleCancel=function(t){e(".dialog-box-frame").on("tap",function(n){e(n.target).hasClass("dialog-box-frame")&&(console.log("user clicked the dialog frame. triggering a cancel."),e(t).trigger("cancel"))})},n}),define("views/CellularDownloadLimitDialogView",["require","jquery","views/DialogView","api/recorder"],function(t){var n=t("jquery"),r=t("views/DialogView"),i=t("api/recorder");return function(t){var i=this;this.render=function(){n("ul li").on("tap",function(e){var t=n(this).text().trim(),r=n(this).attr("data-class");return n(i).trigger("cellularDownloadLimitChanged",[r,t]),!1}),r.handleCancel(i)}}}),define("controller/DialogController",["jquery","appstore","api/navigation"],function(e,t,n){var r;return r=function(r,i){var s,o,u;i&&(s=i.yesFn,o=i.noFn,u=i.dismissFn),u||(u=function(){console.log("no dismiss function.  noop.")}),this.render=function(n){r.render(n),e(r).on({clickedYes:function(){console.log("User clicked yes.");if(r.validate()){var e=s&&s(r.getData());console.log("Executed yes function."),e&&e.done?e.done(u):u()}else console.log("invalidated.  calling invalidFn"),r.invalidFn();return!1},clickedNo:function(){return console.log("User clicked no."),o&&o(r.getData()),u(),!1},clickedLink:function(e,n){return console.log("User clicked a link."),t.Navigation.openInBrowser(n),!1},cancel:u})}},r}),define("controller/ChangeSubscriptionPeriodController",["require","jquery","appstore","controller/DialogController"],function(e){var t=e("jquery"),n=e("appstore"),r=e("controller/DialogController");return function(i){console.log(JSON.stringify(n.Navigation.getExtras()));var s=[n.Resources.getString("IAPSubscriptions_Weekly"),n.Resources.getString("IAPSubscriptions_Biweekly"),n.Resources.getString("IAPSubscriptions_Monthly"),n.Resources.getString("IAPSubscriptions_Bimonthly"),n.Resources.getString("IAPSubscriptions_Quarterly"),n.Resources.getString("IAPSubscriptions_Semiannually"),n.Resources.getString("IAPSubscriptions_Annually")],o=function(e,t){var n,r;console.log("finding period info");for(n=0,r=e.terms.length;n<r;n+=1)if(t===e.terms[n].asin)return e.terms[n];return{}},u=n.Navigation.getExtras(),a=function(){console.log("successfully set sub period settings."),n.Navigation.setResult({value:!0})},f=function(){console.log("did not set sub period settings."),n.Navigation.setResult({value:!1})},l={yesFn:function(e){console.log("periodAsin is "+e);var t=o(u,e),r={asin:t.asin,version:t.version};return console.log("setting period to "+JSON.stringify(t)),n.Subscriptions.changePeriod({asin:u.asin,version:u.version},r,t.price,a)},noFn:f,dismissFn:n.Navigation.finish},c=i.getDialogView(),h=new r(c,l),p=[],d,v={Weekly:0,BiWeekly:1,Monthly:2,BiMonthly:3,Quarterly:4,SemiAnnual:5,Annual:6};u.terms!==undefined&&(t.each(u.terms,function(e,t){console.log("Term frequency: "+JSON.stringify(t.duration)),d=t.duration,t.duration=s[v[d]],p[v[d]]=t}),u.terms=t.map(p,function(e){return e!==undefined?e:null})),console.log("About to render ChangeSubscriptionPeriodContoller... with "+JSON.stringify(u)),h.render(u)}}),define("views/ChangeSubscriptionPeriodView",["jquery","templates","views/DialogView"],function(e,t,n){return function(i){this.dialogView=new n({renderTarget:i,template:t.ChangeSubscriptionPeriod,getDataFn:function(){return e("input[name=subscription-period]:checked").val()}}),this.render=function(e){console.log("Rendering ChangeSubscriptionPeriodView..."),this.dialogView.render(e)},this.getDialogView=function(){return this.dialogView}}}),define("controller/AppBlockController",["require","jquery","handler/OneClickButtonHandler","models/InstallProgressModel","models/AppBlockModel","api/locker","util/AppInfoBlockUtil","api/recorder","api/resources","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("handler/OneClickButtonHandler"),i=t("models/InstallProgressModel"),s=t("models/AppBlockModel"),o=t("api/locker"),u=t("util/AppInfoBlockUtil"),a=t("api/recorder"),f=t("api/resources"),l=t("zeroes/ZeroesLoader"),c=a.Java.getLogger("HTML5.DetailController");return function(t){function m(e){a.local=e[0],a=new s(a),v=!1,p.update(a,!1)}function g(e){return f.getString("zeroes_currency_option",[String(e)])}function y(e){var t=e.primaryAction==="Buy"&&Number(e.ourPrice)>0&&Number(e.zeroesOurPrice)>0;if(!t||e.zeroesPriceAppended)return;e.zeroesPriceAppended=!0,e.primaryActionButton+=" "+g(e.zeroesOurPrice)}function b(e){if(!a)return;var t=i.fromWorkflowEvent(e,{expectedAsin:a.asin});t&&(t.done?p.update(new s(n.extend({},a,{installDetails:null})),!0):p.update(new s(n.extend({},a,{installDetails:t})),!0))}function w(e){e&&p.update(new s(n.extend({},a,e)),!0)}function E(e){if(!a||!e||!e.extras||e.extras.asin!==a.asin)return;var t=i.fromLocalState(e.extras,a.installDetails,null,{expectedAsin:a.asin});t&&t.done(w)}function S(e,t){function n(e){c.getLocalDetailsByAsin(t.app.asin,function(e){var t=e[0];t.isInstalled!==1&&p.update(t,!1)})}d.uninstallSelected(e,t,n,n)}var a,c,h,p=this,d,v;t.render(),c=o.Instance,this.update=function(e,r){e.hasOwnProperty("local")&&e.local&&e.local.isInstalled&&(e.isInstalled=e.local.isInstalled,e.forceRender=!0);var i;if(!e)return;i=a,a=e,l.isEnabled()&&y(a),v||(!a.installDetails&&r&&(h=c.getLocalDetailsByAsin(e.asin,n.proxy(m,this)),v=!0),u.showChange(a,i)?t.render(a):a.forceRender&&(a.forceRender=!1,t.render(a)))},d=new r(!1),n(t).on("primarySelected",d.primarySelected),n(t).on("secondarySelected",d.secondarySelected),n(t).on("uninstallSelected",S),n.subscribe("com.amazon.mas.client.MACS_PDI_CHANGE",n.proxy(b,this)),n.subscribe("com.amazon.locker.APP_LOCAL_STATE_UPDATED",E),n.subscribe("Zeroes.triggerPurchase",function(e){a.zeroesPaymentActive=e.zeroesPaymentActive,d.secondarySelected("secondarySelected",{app:a})})}}),define("views/AppBlockView",["jquery","render/AppBlockRender"],function(e,t){return function(r){var i,s=new t("div");this.render=function(n){if(!n)return;r.empty(),i=s.renderFn(n),r.append(i),s.afterRenderFn(i),s.eventFn(r,e(this),function(e){return n})},this.getDialogTarget=function(){return e("#dialog-placeholder")}}}),define("controller/CreatePenNameController",["require","jquery","appstore","models/AppBlockModel","controller/AppBlockController","views/AppBlockView"],function(t){var n=t("jquery"),r=t("appstore"),i=t("models/AppBlockModel"),s=t("controller/AppBlockController"),o=t("views/AppBlockView");return function(t){var u,a,f,l,c,h,p,d,v;p=function(){r.Navigation.finish()},d=function(){var e=t.getPenName();e.length>=3&&e.length<=60?(window.BootstrapBridge.resumeWebViewChatter(),f=r.Review.createPenName(e).done(v)):console.log("TODO: Show dialog in case pen name doesn't pass regex validation")},v=function(e){e.status==="SUCCESS"?(r.Navigation.navigate("CreateReview",{asin:u}),r.Navigation.finish()):console.log("TODO: Show something because penName creation failed")},a=function(e){e.asin=u,e=new i(e),h.update(e),t.render()},t.render(),u=r.Navigation.getExtras().asin,f=r.Catalog.getAppDetailsByAsin(u).done(a),c=new o(t.getHeaderTarget()),h=new s(c),n(t).on("cancelPenName",p),n(t).on("submitPenName",d)}}),define("views/CreatePenNameView",["require","jquery","templates"],function(t){var n=t("jquery"),r=t("templates");return function(t){function i(){return n(r).trigger("cancelPenName"),!1}function s(){return n(r).trigger("submitPenName"),!1}var r=this;this.render=function(){n("#save-pen-name").on("tap",s),n("#cancel-pen-name").on("tap",i)},this.getHeaderTarget=function(){return t.find('[data-class="app-header"]')},this.getPenName=function(){return n("#pen-name").val()}}}),define("views/FeedbackStarsView",["require","jquery","templates"],function(t){function i(e,t){return function(r){return n(e).trigger("feedback-"+t,t),!1}}var n=t("jquery"),r=t("templates");return function(t){var s=null,o=this;this.render=function(){var e=0;if(!s){s=n(r.FeedbackStars.render()),t.replaceWith(s);for(e=1;e<7;e+=1)n("#feedback-"+e).on("tap",i(o,e))}}}}),define("controller/FeedbackStarsController",["require","jquery"],function(t){var n=t("jquery");return function(t,r,i){var s,o=i||1;s=function(e,t){n(".feedback-stars").attr("class","feedback-stars feedback-stars-"+t),n(".feedback-stars").attr("count",t*o),r()},t.render(),n(t).on({"feedback-1":s}),n(t).on({"feedback-2":s}),n(t).on({"feedback-3":s}),n(t).on({"feedback-4":s}),n(t).on({"feedback-5":s})}}),define("validator/CreateReviewValidator",["require","api/caching","api/cor-pfm"],function(e){var t=e("api/caching"),n=e("api/cor-pfm");return function(r){var i=t.getItem("preferredMarketplace"),s=30,o=10,u=20,a;this.validate=function(){var e=r.getReviewRating(),t=r.getReviewDescription().trim(),n=r.getReviewTitle().trim().length;return e>0&&n>0&&a(t)?!0:!1},a=function(e){return i===n.CorPfmMap.JP?e.replace(/\s+/g,"").length>=s:i===n.CorPfmMap.CN?e.replace(/\s+/g,"").length>=o:e.split(/\s+/).length>=u}}}),define("controller/CreateReviewContentController",["require","jquery","appstore","views/FeedbackStarsView","controller/FeedbackStarsController","validator/CreateReviewValidator","widget/Dialog"],function(t){var n=t("jquery"),r=t("appstore"),i=t("views/FeedbackStarsView"),s=t("controller/FeedbackStarsController"),o=t("validator/CreateReviewValidator"),u=t("widget/Dialog");return function(t){function y(e){r.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.CreateReview.Completed"),r.Navigation.navigate("ReviewSubmitted",{asin:a}),r.Navigation.finish()}function b(e){r.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.CreateReview.Failure"),u.showNative({title:"AlertDialog_title_CreateReviewError",text:"AlertDialog_message_CreateReviewError",button:"AlertDialog_button_CreateReviewError"})}var a,f,l,c,h,p,d,v,m,g=new o(t);p=function(){r.Navigation.finish()},d=function(){var e={action:"android.intent.action.VIEW"},t=r.Resources.getString("review_guidelines_url");r.Navigation.Android.startActivity(e,{},t)},v=function(){var e={};e.asin=a,e.title=t.getReviewTitle(),e.description=t.getReviewDescription(),e.rating=t.getReviewRating(),r.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.CreateReview.Initiated"),l=r.Review.addReview(e,y,b)},m=function(){g.validate()?t.enableSubmitButton():t.disableSubmitButton()},this.update=function(e){t.render(e),a=e.asin,c=new i(t.getFeedbackStarsTarget()),h=new s(c,m,1)},t.render(),n(t).on("cancelReview",p),n(t).on("viewGuidelines",d),n(t).on("submitReview",v),n(t).on("validateFields",m)}}),define("models/ReviewEligibilityModel",["require","appstore"],function(t){var n=t("appstore"),r=n.Resources,i={NOT_APPROVED_AUTHOR:{title:r.getString("eligible_error_blacklisted_title"),body:r.getString("eligible_error_blacklisted_body")},HAS_EXISTING_REVIEW:{title:r.getString("eligible_error_review_pending_title"),body:r.getString("eligible_error_review_pending_body")},NOT_APPROVED_UNKNOWN:{title:r.getString("eligible_error_unknown_title"),body:r.getString("eligible_error_unknown_body")},NOT_APPROVED_GENERAL:{title:r.getString("eligible_error_general_title"),body:r.getString("eligible_error_general_body")},NOT_PURCHASED:{title:r.getString("eligible_error_purchase_title"),body:r.getString("eligible_error_purchase_body")}};return{getErrorFromStatus:function(e){return i[e]||i.NOT_APPROVED_GENERAL}}}),define("views/CreateReviewContentView",["require","jquery","templates","models/ReviewEligibilityModel"],function(t){var n=t("jquery"),r=t("templates"),i=t("models/ReviewEligibilityModel");return function(t){var s,o=this,u,a,f,l;this.render=function(e){if(!e)return;console.log("CreateReviewView render: "+e.status);if(e.status==="SUCCESS")s=n(r.CreateReviewContent.render()),t.replaceWith(s),n("#cancel-review").on("tap",u),n("#review-guidelines").on("tap",a),n("#review-description").on("keyup",f),n("#review-title").on("keyup",f),n("#submit-review").on("tap",l);else{var o=i.getErrorFromStatus(e.status);s=n(r.CreateReviewFailureContent.render(o)),t.replaceWith(s),n("#cancel-review").on("tap",u),n("#review-guidelines").on("tap",a)}},this.getFeedbackStarsTarget=function(){return s.find(".feedback-stars")},this.getReviewDescription=function(){return n("#review-description").val()},this.getReviewTitle=function(){return n("#review-title").val()},this.getReviewRating=function(){return parseInt(n(".feedback-stars").attr("count"),10)},this.getSubmitButton=function(){return n("#submit-review")},this.getDialogTarget=function(){return s.find("#dialog-placeholder")},this.disableSubmitButton=function(){var e=n("#submit-review");e.attr("disabled","disabled")},this.enableSubmitButton=function(){var e=n("#submit-review");e.removeAttr("disabled")},u=function(){return n(o).trigger("cancelReview"),!1},a=function(){return n(o).trigger("viewGuidelines"),!1},l=function(){return n("#submit-review").is(":disabled")||n(o).trigger("submitReview"),!1},f=function(){n(o).trigger("validateFields")}}}),define("controller/CreateReviewController",["require","jquery","appstore","models/AppBlockModel","views/AppBlockView","controller/CreateReviewContentController","views/CreateReviewContentView","controller/SoftKeysController"],function(t){var n=t("jquery"),r=t("appstore"),i=t("models/AppBlockModel"),s=t("views/AppBlockView"),o=t("controller/CreateReviewContentController"),u=t("views/CreateReviewContentView"),a=t("controller/SoftKeysController"),f=!1;return function(t){function g(e){e.asin=c,e=new i(e),e.installDetails=f,h.render(e),t.render()}function y(e){if(e.status==="SUCCESS"&&!e.penName){r.Navigation.navigate("CreatePenName",{asin:c}),r.Navigation.finish();return}e.asin=c}var l,c,h,p,d,v,m;t.render(),l=new a(t),h=new s(t.getHeaderTarget()),v=new u(t.getContentTarget()),m=new o(v),r.Navigation.getExtras("asin").done(function(e){c=e;var i=r.Catalog.getAppDetailsByAsin(c).done(g),s=r.Review.checkReviewEligibility({asin:c}).done(y);n.when(i,s).done(function(e,n){n.status==="SUCCESS"&&(!e.local||!e.local.isPurchased)&&(n.status="NOT_PURCHASED"),m.update(n),t.render()})})}}),define("views/CreateReviewView",["require","jquery","templates"],function(t){var n=t("jquery"),r=t("templates");return function(t){var r,i,s,o=this;this.render=function(){n("#submit-review").on("tap",s),n("#cancel-review").on("tap",r),n("#review-guidelines").on("tap",i)},this.getHeaderTarget=function(){return t.find('[data-class="create-review-app-header"]')},this.getContentTarget=function(){return t.find('[data-class="create-review-content"]')}}}),define("controller/CustomerCareController",["require","jquery","api/navigation","handler/ClickStreamHandler","controller/SoftKeysController"],function(t){var n=t("jquery"),r=t("api/navigation"),i=t("handler/ClickStreamHandler"),s=t("controller/SoftKeysController");return function(t){function u(){r.finish()}function a(e,t){var n,i;i={action:"android.intent.action.SEND",type:"plain/text"},n={"android.intent.extra.EMAIL":[t]},r.Android.startActivity(i,n)}function f(e,t){var n,i;i={action:"android.intent.action.DIAL"},n="tel:"+t,r.Android.startActivity(i,{},n)}var o;t.render(),o=new s(t,"CustomerCare"),r.getExtras("refMarker","page").done(function(e,t){var n=new i(t);e&&n.record(e)}),n(t).on({cancelCustomerCare:u,emailCustomerCare:a,phoneCustomerCare:f})}}),define("views/CustomerCareView",["require","jquery","templates"],function(t){var n=t("jquery"),r=t("templates");return function(t){function i(){return n(r).trigger("cancelCustomerCare"),!1}function s(e){return e.target.protocol==="tel:"?n(r).trigger("phoneCustomerCare",e.target.pathname):n(r).trigger("emailCustomerCare",e.target.pathname),!1}var r=this;this.render=function(){n("#cancel-customer-care").on("tap",i),n("a").on("tap",s),n("a").on("click",function(){return!1})}}}),define("widget/AppCarousel",["require","jquery","models/AppBlockModel","widget/Widget","api/locker","api/customer-data","api/currency","util/AppInfoBlockUtil","render/ImageStyler","api/navigation","handler/RefMarkerBuilder","templates"],function(t){var n=t("jquery"),r=t("models/AppBlockModel"),i=t("widget/Widget"),s=t("api/locker"),o=t("api/customer-data"),u=t("api/currency"),a=t("util/AppInfoBlockUtil"),f=new u,l=t("render/ImageStyler"),c=t("api/navigation"),h=t("handler/RefMarkerBuilder"),p=t("templates"),d;return d=i.extend({init:function(e,t,n){this._super(e,p.AppCarousel,n),this.apps=t,this.locker=s.Instance,this.items=[],this.clickstreamRef=""},buildRendering:function(){var e=this;this._attachLocalDetails(),this.srcNodeRef.unbind("tap"),this.srcNodeRef.on("tap","div[data-asin]",null,function(t){var r=n(this),i=r.data("ref"),s=r.data("asin");e.trigger("app.selected",[s,r,t]),c.navigate("Detail",{asin:s,refMarker:i}),t.preventDefault()})},_attachLocalDetails:function(){var e=this,t,i,s;if(!e.apps)return;n.isArray(e.apps)||(e.apps=[e.apps]),i=e.apps.length,e.properties.maxItems&&e.properties.maxItems<i&&(i=e.properties.maxItems);if(i===0)return;e.items=e.apps.slice(0,i),s=n.map(e.items,function(e){return e.asin}),e.locker.getLocalDetailsByAsins(s).done(function(n){var s,o;for(t=0,i=e.items.length;t<i;t+=1){s=e.items[t],n[s.asin]&&(s.local=n[s.asin]);if(s.title.length>15){o=s.title.indexOf(" ");if(o<0||o>15)s.title=s.title.substring(0,10)+"-"+s.title.substring(10)}e.items[t]=new r(s)}e._render()})},setClickstreamRef:function(e){this.clickstreamRef=e},_render:function(){var e=0,t=null,r=0,i={lines:2},s={AppInfoBlock:p.AppInfoBlock},u=new h("Gateway","TopFree","Gateway");this.srcNodeRef.append(p.AppCarousel.render({apps:[{}]},s)),r=n(this.srcNodeRef.find(".app-icon")[0]).find("img").width(),i.width=n(this.srcNodeRef.find(".app-info-details")[0]).width(),this.srcNodeRef.empty();for(e=0;e<this.items.length;e+=1)t=this.items[e],(t.currentPrice>=t.listPrice||t.local&&t.local.isPurchased)&&delete t.listPrice,t.listPrice!==undefined&&(t.listPrice=f.format(t.listPrice,t.listPriceCurrencyCode,!1)),t.ourPrice=f.format(t.currentPrice,t.currentPriceCode,!0),o.isUSPfmSync()||delete t.listPrice,t.title=a.truncate(t.title,i),this.clickstreamRef&&(t.ref=this.clickstreamRef+"_"+e),t.installDetails=!1,t.styledImageUrl=(new l(t.logo)).addBlackBackground().reduceQualityTo(80).scaleTo(r).build();this.srcNodeRef.append(p.AppCarousel.render({apps:this.items},s))}}),d}),define("controller/DescriptionController",[],function(){return function(t){t.render(),this.update=function(n){t.render(n)}}}),define("controller/ReviewSummaryController",["jquery","appstore"],function(e,t){return function(r,i,s){function f(){t.Navigation.navigate("CreateReview",{asin:s})}function l(){t.Navigation.navigate("Reviews",{asin:s})}function c(e,n,r){t.Review.castVote({reviewID:n,voteValue:r})}function h(e,n){t.Review.reportAbuse(n)}var o,u,a;this.update=function(e){o=e,r.render(o,u),r.bindVotingButtons()},a=function(e){u=e,this.update(o),i.resolve()},r.render(),t.Catalog.getMostHelpfulReviews(s,e.proxy(a,this),i.reject),e(r).on({createReview:f,reviews:l,castVote:c,reportAbuse:h})}}),define("controller/PermissionsController",["jquery"],function(e){return function(n){n.render(),this.update=function(r){function i(e,t){var n=new RegExp("\\.","g");t&&t.permissionInfo&&(t.permissionInfo=t.permissionInfo.replace(n,"."+String.fromCharCode(8203)))}r&&r.appPermissionsList&&(r.permissionInfo=e.each(r.appPermissionsList,i)),n.render(r)}}}),define("controller/TechnicalDetailsController",["require","jquery","api/navigation","api/recorder"],function(e){var t=e("jquery"),n=e("api/navigation"),r=e("api/recorder"),i=r.Java.getLogger("HTML5.TechnicalDetailsController");return function(r){function s(e,t){return i.log("privacy Policy: "+t),n.openInBrowser(t),!1}this.update=function(e){r.render(e)},r.render(),t(r).on({showDevPrivacyPolicy:s})}}),define("controller/DeveloperDetailsController",["jquery","appstore"],function(e,t){return function(r,i,s){var o,u;i.render(),o=function(t){i.render(t)},u=t.Catalog.getDeveloperDetailsByAsin(r,e.proxy(o,this)),e.when(u).done(s.resolve).fail(s.reject)}}),define("controller/PurchaseDetailsController",["require","jquery","api/navigation","api/resources"],function(t){var n=t("jquery"),r=t("api/navigation"),i=t("api/resources");return function(t){var s=function(e){r.navigate("UriPage",{UriPage:"UriPage",uri:e})},o=function(){return s(i.getString("legal_use_terms_url")),!1},u=function(e,t){return r.openInBrowser(t),!1};t.render(),this.update=function(e){t.render(e)},n(t).on({showReturnPolicy:o,showPrivacyPolicy:u})}}),define("views/DescriptionView",["jquery"],function(e){return function(t){this.render=function(e){var n;if(!e)return;n=e.description;if(!n)return;t.find("p").html(n)}}}),define("models/CustomerReviewModel",["jquery","api/datetime"],function(e,t){function r(e){var t;return e.submissionDateMs&&(t=n.formatDateMs(e.submissionDateMs)),t}var n=new t("MEDIUM");return function(n){var i=r(n);return e.extend({submissionDate:i},n)}}),define("views/ReviewSummaryView",["require","jquery","templates","models/CustomerReviewModel","appstore"],function(e){var t=e("jquery"),n=e("templates"),r=e("models/CustomerReviewModel"),i=e("appstore"),s=i.Recorder.Java.getLogger("HTML5.ReviewSummaryView");return function(i){function l(){t(".review-summary-most-helpful-reviews").on("tap",".vote-abuse",function(){var e=t(this).parent().parent(),r=e.data("id");return t(f).trigger("reportAbuse",[r]),e.html(n.ReviewThankYouStripe.render()),!1})}function c(e,n,r){t(".review-summary-most-helpful-reviews").on("tap",e,function(){var e=t(this).parent().parent(),i=e.data("id"),s;return t(f).trigger("castVote",[i,n]),e.html(r.render({reviewID:i})),!1})}var o,u,a,f=this;this.render=function(e,f){s.log("In Render");var l,c,h,p,d,v,m,g,y;if(!e)return;s.log("data not null"),l=e.reviewSummary.averageRating,c=Math.floor(l),h=c,l-Math.floor(l)>=.5&&(c+="h",h+=" 1/2"),p=e.reviewSummary,v=p.totalReviews,d=t.extend({fiveStarsPercent:Math.floor(100*(p.fiveStars/v)),fourStarsPercent:Math.floor(100*(p.fourStars/v)),threeStarsPercent:Math.floor(100*(p.threeStars/v)),twoStarsPercent:Math.floor(100*(p.twoStars/v)),oneStarsPercent:Math.floor(100*(p.oneStars/v))},p),m=t.extend({stars:c,starsDesc:h,extReviewSummary:d},e),e.reviewSummary.totalReviews>0&&(m=t.extend(m,{totalReviews:e.reviewSummary.totalReviews})),i.empty(),o=t(n.ReviewSummaryBlock.render(m)),f&&(s.log("reviews not null"),g=o.find('[data-class="review-summary-most-helpful-reviews"]'),y=f.reviews,t.map(y,function(e){var i=new r(e);g.append(t(n.ReviewDetailBlock.render(i)))})),i.append(o),t("#view-reviews").on("tap",a),t("#create-review").on("tap",u)},this.bindVotingButtons=function(){c(".vote-yes",1,n.ReviewThankYouStripe),c(".vote-no",-1,n.ReviewThankYouAbuseStripe),l()},u=function(){return t(f).trigger("createReview"),!1},a=function(){return t(f).trigger("reviews"),!1}}}),define("views/PermissionsView",["jquery","templates"],function(e,t){return function(r){var i;this.render=function(n){n&&n.appPermissionsList?(r.css("display",""),r.empty(),i=e(t.Permissions.render(n)),r.append(i)):r.css("display","none")}}}),define("views/TechnicalDetailsView",["require","jquery","templates","api/caching","api/cor-pfm","api/datetime"],function(e){var t=e("jquery"),n=e("templates"),r=e("api/caching"),i=e("api/cor-pfm"),s=e("api/datetime");return function(o){function c(e){return t(f).trigger("showDevPrivacyPolicy",[e.data.url]),!1}var u,a,f=this,l=r.getItem("preferredMarketplace");l===i.CorPfmMap.CN?a=new s("LONG"):a=new s("MEDIUM"),this.render=function(e){var r,i,s;if(!e){o.css("display","none");return}e.releaseDate&&(i=a.formatYMD(e.releaseDate.year,e.releaseDate.month,e.releaseDate.day)),e.filesize&&(s=e.filesize.substring(6)),r=t.extend({releaseDateFormatted:i,fileSize:s},e),o.empty(),o.css("display",""),u=t(n.TechnicalDetails.render(r)),o.append(u),t('[data-class="show-privacy-policy"]').on("tap",{url:e.privacyPolicyUrl},c)}}}),define("views/DeveloperDetailsView",["jquery","templates"],function(e,t){return function(r){var i=null;this.render=function(n){n&&n.details?(r.empty(),r.css("display",""),i=e(t.DeveloperDetails.render(n)),r.append(i)):r.css("display","none")}}}),define("views/PurchaseDetailsView",["require","jquery","templates","api/resources"],function(e){var t=e("jquery"),n=e("templates"),r=e("api/resources"),i={RESELLER:"RESELLER",US_AGENCY:"US_AGENCY",COMMISSIONAIRE:"COMMISSIONAIRE",INTERNATIONAL_AGENCY:"INTERNATIONAL_AGENCY"};return function(s){var o,u,a,f=this;this.getSoldByMessage=function(e){var t,n,s;return e===undefined||e===null?undefined:(s=e.sellerOfRecord,s===undefined||s===null?undefined:(console.log("PurchaseDetailsView: businessModel: "+s.businessModel),t=r.getString("Details_label_SellerOfRecord",[s.legalName]),s.businessModel!==undefined&&(s.businessModel===i.US_AGENCY||s.businessModel===i.COMMISSIONAIRE)&&(n=r.getString("Details_SellerOfRecord_ReinforcementMessage"),t=t+" "+n),t))},this.render=function(e){var r,i=this,u=function(){return t(i).trigger("showReturnPolicy"),!1};e&&e.vatInclusive!==undefined?(s.empty(),s.css("display",""),r=i.getSoldByMessage(e),e.seller=r,o=t(n.PurchaseDetails.render(e)),s.append(o)):s.css("display","none"),t('[data-class="show-return-policy"]').on("tap",u)}}}),define("render/ScreenshotRender",["jquery","appstore","templates","require"],function(e,t,n,r){function o(t,n){return function(r){var i=e(this).find("img").attr("src");return t.trigger(n,i),!1}}var i=r("render/ImageStyler"),s=250*localStorage.baseFont;return function(r){this.renderFn=function(t){var r=n.Screenshot.render(t);return e(r)},this.afterRenderFn=function(e){var t=e.find(".carousel-list-image"),n=t.data("logo"),r=n?(new i(n)).scaleTo(s).reduceQualityTo(80).build():!1;r&&t.attr("src",r)},this.eventFn=function(e,t){e.on("tap",".carousel-list-item",o(t,"screenshotSelected"))}}}),define("controller/ScreenshotController",["require","jquery","coll/ItemCollection","views/ListView","render/ScreenshotRender","appstore"],function(t){var n=t("jquery"),r=t("coll/ItemCollection"),i=t("views/ListView"),s=t("render/ScreenshotRender"),o=t("appstore"),u=o.Recorder.Java.getLogger("ScreenshotController");return function(t,a){var f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T;l=new r,h=new s(t),c=new i(t,l,n.extend({},h)),d=function(t){return t},f=[],x=[],b=function(e){var t,r,i,s;if(!e||!e.videoPreviews)return u.fine("No videoPreviews found in result"),!1;t=e.videoPreviews;if(!n.isArray(t)||t.length===0)return u.fine("VideoPreviews expected to be a non-empty array"),!1;for(i=0;i<t.length;i+=1){s=t[i];if(!s.previewImage||!s.videos)return u.warning("VideoPreview must have previewImage and videos"),!1;if(!n.isArray(s.videos)||s.videos.length===0)return u.warning("VideoPreview must have a non-empty array of videos"),!1}return!0},S=function(e){return n.map(e.videoPreviews,function(e){return new d({medium:e.previewImage,videos:e.videos,name:e.name})})},w=function(e){return!e||!e.screenshots?(u.warning("No screenshots key in result"),!1):!n.isArray(e.screenshots)||e.screenshots.length===0?(u.warning("Screenshots not array or empty"),!1):!0},y=function(e,t){var n,r,i;r=[],n=e.screenshots.length,m&&m<n&&(n=m);for(i=0;n>i;i+=1)r.push(new d(e.screenshots[i]));return r},p=function(e){var t;u.finest("Result dump: "+JSON.stringify(e));if(!w(e)){u.warning("No screenshots were found in the result");return}t=y(e);if(!t){u.warning("Screenshots were found, but were not returned correctly");return}f=t,T=e.screenShotUrls,u.info("ScreenshotController.fullScreenImageUrls: "+T),b(e)&&(u.info("Result has videos, loading previews"),x=S(e),t=x.concat(t)),u.info("Adding "+f.length+" screenshot(s) and "+x.length+" video(s)"),l.addAll(t)},g=function(e,t){var r,i,s;for(s=0;s<x.length;s+=1)if(x[s].medium===t){u.fine("Video preview tapped, navigating to video player"),u.fine("DEBUG: "+JSON.stringify(x[s])),o.Navigation.navigate("VideoPlayer",{videoUrl:x[s].videos[0].url});return}o.DeviceFeatures.isAmazonDevice().done(function(e){if(e){i=n.map(T,function(e,t){return e});for(s=0;s<f.length;s+=1)f[s].large===t&&(r=s)}else i=n.map(f,function(e,n){return e.large===t&&(r=n),e.large});u.info("ScreenshotController: imageUrls="+i+" screenshotIndex="+r),o.Navigation.navigate("ScreenshotGallery",{urls:i,index:r})})},n(c).on("screenshotSelected",g),a.done(p)}}),define("controller/DetailController",["require","jquery","api/navigation","api/wishlist","api/recently-viewed","api/catalog","api/customer-data","api/resources","api/settings","controller/AppBlockController","widget/AppCarousel","controller/DescriptionController","controller/ReviewSummaryController","controller/PermissionsController","controller/TechnicalDetailsController","controller/DeveloperDetailsController","controller/PurchaseDetailsController","models/AppBlockModel","views/AppBlockView","views/DescriptionView","views/ReviewSummaryView","views/PermissionsView","views/TechnicalDetailsView","views/DeveloperDetailsView","views/PurchaseDetailsView","controller/ScreenshotController","controller/SoftKeysController","widget/Dialog","templates","handler/ClickStreamHandler","handler/RefMarkerBuilder","api/recorder","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("api/navigation"),i=t("api/wishlist"),s=t("api/recently-viewed"),o=t("api/catalog"),u=t("api/customer-data"),a=t("api/resources"),f=t("api/settings"),l=t("controller/AppBlockController"),c=t("widget/AppCarousel"),h=t("controller/DescriptionController"),p=t("controller/ReviewSummaryController"),d=t("controller/PermissionsController"),v=t("controller/TechnicalDetailsController"),m=t("controller/DeveloperDetailsController"),g=t("controller/PurchaseDetailsController"),y=t("models/AppBlockModel"),b=t("views/AppBlockView"),w=t("views/DescriptionView"),E=t("views/ReviewSummaryView"),S=t("views/PermissionsView"),x=t("views/TechnicalDetailsView"),T=t("views/DeveloperDetailsView"),N=t("views/PurchaseDetailsView"),C=t("controller/ScreenshotController"),k=t("controller/SoftKeysController"),L=t("widget/Dialog"),A=t("templates"),O,M,_=t("handler/ClickStreamHandler"),D=t("handler/RefMarkerBuilder"),P=t("api/recorder"),H=P.Java.getLogger("HTML5.DetailController"),B=t("zeroes/ZeroesLoader");return O={unknown_app:{title:"AlertDialog_title_AppNotAvailable",text:"AlertDialog_message_AppNotAvailable",button:"AlertDialog_button_AppNotAvailable",buttonFn:r.finish,noActionFn:r.finish},load_failed:{title:"AlertDialog_title_DetailsLoadingError",text:"AlertDialog_message_DetailsLoadingError",button:"AlertDialog_button_DetailsLoadingError",buttonFn:r.restart,noActionFn:r.restart}},M=function(e){function pt(t){t.asin=A,t=new y(t),nt=t.title,M=t,i.existsInList(M,K),s.add(t),F.update(t),q.update(t),R.update(t),U.update(t),z.update(t),W.update(t),e.showItemsHiddenWhileLoading()}function dt(t){st=!0;var r=n.Deferred(),i=n.Deferred(),s,u,a,f=n.Deferred(),y=new b(e.getHeaderTarget()),k=new w(e.getDescriptionTarget()),L=new E(e.getReviewSummaryTarget()),O=new S(e.getPermissionsTarget()),_=new x(e.getTechnicalDetailsTarget()),H=new T(e.getDeveloperDetailsTarget()),j=new N(e.getPurchaseDetailsTarget());F=F||new l(y,{dialogTarget:e.getDialogTarget()}),q=q||new h(k),R=R||new p(L,i,A),U=U||new d(O),z=z||new v(_),W=W||new g(j),X=X||new m(A,H,r),a=o.getAppDetailsByAsin(A,pt,Z,t),I=I||new C(e.getScreenshotListTarget(),a),a.done(function(t){u=o.getOtherAppsByDeveloper({asin:A,developerName:t.publisherName}),u.done(function(t,r){var i=t.results,s;r||n.isArray(i)&&i.length===0?e.getMoreDevAppsDiv().hide():(s=new c(e.getMoreDevAppsTarget(),i),s.setup())}).fail(function(){e.getMoreDevAppsDiv().hide()}),u.done(function(){f.resolve()}).fail(function(){f.reject()})}),s=o.getRelatedApps(A),s.done(function(t){if(!t.recommendationAsins||n.isArray(t.recommendationAsins)&&t.recommendationAsins.length===0)e.hideAlsoBought();else{var r=new c(e.getAlsoBoughtTarget(),t.recommendationAsins),i=new D("Detail","CustomersWhoBought","Detail");r.setClickstreamRef(i.build()),r.setup()}}).fail(e.hideAlsoBought),n.when(a).done(function(){P.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Detail.Load.ATF.Completed",{asin:A}),P.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Detail.Load.CTCF.Completed",{asin:A})}),n.when(a,s,f,i,r).done(function(){P.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Detail.Load.Completed",{asin:A}),B.initializeAsync(B.STORE_CONFIG_TYPES.Detail,{asinDetails:{asin:M.asin,appTitle:M.displayTitle,isPurchased:M.isPurchased,iconUrl:M.logo,ourPrice:M.ourPrice,ourPriceCurrencyCode:M.ourPriceCurrencyCode,zeroesOurPrice:M.zeroesOurPrice,zeroesRewardAmount:M.zeroesRewardAmount}}),st=!1}).fail(function(e){P.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Detail.Load.Failure",{asin:A,message:e}),st=!1,e&&e.type===o.Error.UNKNOWN_APP&&(ot=!0)})}function vt(){!st&&!ot&&(console.log("Lifecycle events: on resume: loading Page data"),window.WebRequestPrefetch.Pages.Detail.getAppDetailsByAsin.response===undefined?dt(!0):dt(),st=!1)}function mt(e){console.log("checkSmsAndEmailAvailability (email): activityExistsForIntent returned "+e),rt=e}function gt(e){console.log("checkSmsAndEmailAvailability: activityExistsForIntent call (email) failed; error.type = "+e.type+", error.reason = "+e.reason)}function yt(e){console.log("checkSmsAndEmailAvailability (sms): activityExistsForIntent returned "+e),it=e}function bt(e){console.log("checkSmsAndEmailAvailability: activityExistsForIntent call (sms) failed; error.type = "+e.type+", error.reason = "+e.reason)}function wt(){var t=r.Android.getEmailIntentAndExtras("");r.Android.activityExistsForIntent(t.intent,t.extras,"",t.unwanted,mt,gt),t=r.Android.getSmsIntentAndExtras(""),r.Android.activityExistsForIntent(t.intent,t.extras,"",t.unwanted,yt,bt),(it||rt)&&u.isUSPfmSync()?e.setShareButtonVisibility(!0):e.setShareButtonVisibility(!1)}function Et(){console.log("Handle onStop"),st=!1}function St(){console.log("log asin: "+A),e.render(),dt(),n(e).on("saveForLater",J),n(e).on("share",tt),n(e).on("reportIssue",Y),wt(),n.subscribe("com.amazon.venezia.android_lifecycle.onResume",vt),n.subscribe("com.amazon.venezia.android_lifecycle.onStop",Et)}var t=new k(e),A,M,j,F,I,q,R,U,z,W,X,V,J,K,Q,G,Y,Z,et,tt,nt,rt=!1,it=!1,st=!1,ot=!1,ut=r.getExtras(),at={},ft="Detail",lt="Glance",ct,ht=new _(ft,lt);tt=function(e){console.log("DetailController: showShareThisAppDialog: "+e),r.showDialog("ShareDialog",{applicationName:nt,asin:A,emailAvailable:rt,smsAvailable:it})},Y=function(){r.showDialog("ReportIssueDialog",{asin:A})},Q=function(e){e.value||r.showDialog("NativeDialog",{dialogType:"SaveForLaterDialog"},function(){console.log("Navigate to NativeDialog complete")})},Z=function(e){var t;if(e&&e.type)switch(e.type){case o.Error.UNKNOWN_APP:t=O.unknown_app;break;default:t=O.load_failed}else t=O.load_failed;L.showNative(t)},J=function(t){e.getSavedButtonText().data("value")==="unsaved"?(j=i.add(M),G(a.getString("Saved"),"saved"),n.when(j).done(function(){f.get(f.keys.DontShowSavedDialogKey,Q)})):(i.remove(M),G(a.getString("SaveForLater"),"unsaved"))},K=function(e){e?G(a.getString("Saved"),"saved"):G(a.getString("SaveForLater"),"unsaved")},G=function(t,n){e.getSavedButtonText().text(t),e.getSavedButtonText().data("value",n)},A=ut.asin,ct=ut.refMarker;if(!A){et=ut.packageName;if(!et){Z({type:o.Error.UNKNOWN_APP});return}V=o.getAsinByPackageName(et),V.done(function(e){A=e.asin,St()}).fail(Z)}else St();ct&&(at.asin=A,at.sr=ut.sr,at.qid=ut.qid,H.log("ClickStream-UI-DetailController: clickStreamArgs = "+JSON.stringify(at)),ht.recordView("/dp/"+A,ct,at),ht.record(ct,at))},M.onViewSaveForLaterList=function(e){e&&f.set(f.keys.DontShowSavedDialogKey,!0),r.navigate("SavedForLater")},M.onCloseSavedDialog=function(e){e&&f.set(f.keys.DontShowSavedDialogKey,!0)},M}),define("views/DetailView",["require","jquery","templates","appstore"],function(e){var t=e("jquery"),n=e("templates"),r=e("appstore"),i=r.Recorder.Java.getLogger("HTML5.DetailView");return function(n){function o(e,n){t(e).on("tap",function(){return i.log("bindEvent: Triggering"+n),t(s).trigger(n),!1})}var r,s=this;this.render=function(){r=t("#detail-share"),o("#detail-save-for-later","saveForLater"),o(r,"share"),o('[data-class="detail-report-issue-button"]',"reportIssue")},this.showItemsHiddenWhileLoading=function(){t(".hidden-while-loading").removeClass("hidden-while-loading")},this.getHeaderTarget=function(){return n.find('[data-class="detail-app-header"]')},this.getScreenshotListTarget=function(){return n.find('[data-class="detail-screenshots-list"]')},this.getDescriptionTarget=function(){return n.find('[data-class="detail-description-block"]')},this.getAlsoBoughtTarget=function(){return n.find('[data-class="detail-similar-apps-list"]')},this.hideAlsoBought=function(){n.find('[data-class="detail-similar-apps"]').hide()},this.getReviewSummaryTarget=function(){return n.find('[data-class="detail-review-summary-block"]')},this.getMoreDevAppsTarget=function(){return n.find('[data-class="detail-developer-apps-list"]')},this.getMoreDevAppsDiv=function(){return n.find('[data-class="developer-apps"]')},this.getPermissionsTarget=function(){return n.find('[data-class="detail-permissions-block"]')},this.getTechnicalDetailsTarget=function(){return n.find('[data-class="detail-technical-details-block"]')},this.getDeveloperDetailsTarget=function(){return n.find('[data-class="detail-developer-block"]')},this.getPurchaseDetailsTarget=function(){return n.find('[data-class="detail-purchase-details-block"]')},this.getSavedButton=function(){return n.find("#detail-save-for-later")},this.getSavedButtonText=function(){return n.find("#detail-save-for-later > h2")},this.getDialogTarget=function(){return n.find("#dialog-placeholder")},this.setShareButtonVisibility=function(e){e?r.show():r.hide()}}}),define("controller/FeedbackTypeDialogController",["require","jquery","api/navigation"],function(e){var t=e("jquery"),n=e("api/navigation");return function(r){function i(e,t,r){var i={feedbackType:t,feedbackText:r};return n.setResult(i),n.finish(),!1}r.render(),t(r).on("fbTypeChanged",i),t(r).on("cancel",n.finish)}}),define("views/FeedbackTypeDialogView",["require","jquery","views/DialogView","api/recorder"],function(t){var n=t("jquery"),r=t("views/DialogView"),i=t("api/recorder");return function(t){var i=this;this.render=function(){n("ul li").on("tap",function(e){var t=n(this).text().trim(),r=n(this).attr("data-class");return n(i).trigger("fbTypeChanged",[r,t]),!1}),r.handleCancel(i)}}}),define("controller/FeedbackController",["require","jquery","api/feedback","api/navigation","handler/ClickStreamHandler","views/FeedbackStarsView","controller/SoftKeysController","controller/FeedbackStarsController"],function(t){var n=t("jquery"),r=t("api/feedback"),i=t("api/navigation"),s=t("handler/ClickStreamHandler"),o=t("views/FeedbackStarsView"),u=t("controller/SoftKeysController"),a=t("controller/FeedbackStarsController");return function(t){function h(){var e=t.getFeedbackRating(),n=t.getFeedbackText().length;e>0&&n>0?t.enableSubmitButton():t.disableSubmitButton()}function p(e){i.showToast(t.getConfirmationMessage()),i.finish()}function d(){i.showDialog("FeedbackTypeDialog",{},function(e){e.feedbackType!==undefined&&e.feedbackText!==undefined&&(t.setSortButtonText(e.feedbackText),t.setFeedbackType(e.feedbackType))})}var f,l,c;t.render(),c=new u(t,"Feedback"),i.getExtras("refMarker","page").done(function(e,t){var n=new s(t);e&&n.record(e)}),f=new o(t.getFeedbackStarsTarget()),l=new a(f,h,1),n(t).on({selectFeedbackTypeClicked:d,submitFeedback:function(e,t){r.submit(t,p)},cancelFeedback:function(e){i.finish()},validateFields:h})}}),define("views/FeedbackView",["jquery","templates","appstore"],function(e,t,n){return function(n){var r=this,i="feedback_recommendation",s;s=function(){return e("#submit-feedback").is(":disabled")?!1:(e(r).trigger("submitFeedback",{rating:parseInt(e(".feedback-stars").attr("count"),10),text:e("#feedback-text").val(),type:i}),!1)},this.render=function(){var t,n=e("#feedback-text");e("#cancel-feedback").on("tap",function(){return e(r).trigger("cancelFeedback"),!1}),n.on("focus",function(){t||(t=setInterval(function(){e(r).trigger("validateFields")},250))}),n.on("blur",function(){t&&(clearInterval(t),t=null)}),e("#feedback-type-button").on("tap",function(){return e(r).trigger("selectFeedbackTypeClicked"),!1})},this.getFeedbackStarsTarget=function(){return n.find(".feedback-stars")},this.getFeedbackRating=function(){return parseInt(e(".feedback-stars").attr("count"),10)},this.getFeedbackText=function(){return e("#feedback-text").val()},this.getConfirmationMessage=function(){return n.find("#confirmation-message").val()},this.getSubmitButton=function(){return e("#submit-feedback")},this.setSortButtonText=function(t){return e("#feedback-type-button").text(t)},this.setFeedbackType=function(e){i=e},this.disableSubmitButton=function(){var t=e("#submit-feedback");t.attr("disabled","disabled")},this.enableSubmitButton=function(){var t=e("#submit-feedback");t.removeAttr("disabled")},e("#submit-feedback").on("tap",s)}}),define("widget/Billboard",["require","jquery","templates","api/recorder","render/ImageStyler","handler/RefMarkerBuilder","api/navigation","models/CategoriesModel","api/resources","api/device-features"],function(t){function p(e,t){var n,r=t.data("src"),i;window.appPreloadState.isAmazonDevice===c?n=512:n=e.data("imgWidth")||t.width(),i=r?(new o(r)).reduceQualityTo(90).scaleTo(n).build():!1,e.data("imgWidth",n),t.attr("src",i)}var n=t("jquery"),r=t("templates"),i=t("api/recorder"),s=i.Java.getLogger("HTML5.Billboard"),o=t("render/ImageStyler"),u=t("handler/RefMarkerBuilder"),a=t("api/navigation"),f=t("models/CategoriesModel"),l=t("api/resources"),c=t("api/device-features").DeviceConstants.VENEZIA_TATE_DEVICE_TYPE,h="Billboard";return function(t,i,o){function v(e,i,a,f){var l={imageSrc:e,fad:a.isFad},d=n(r.BillboardItem.render(l)),v=new u(o,h,i),m;v.addArg(f).addArg(a.isFad?"y":"n"),m=v.build(),a.refMarker=m,s.log("ClickStream-UI-Billboard: refMarker = "+m),d.on("tap",function(){return c.trigger("navigate",[i,a]),!1}),t.append(d),p(t,d.find("img"))}var a={},c=n(this),d;n.map(i.asins,function(e){a[e.asin]=e}),n.map(i.billboard,function(e,t){e.asin?e.image?v(i.images[e.image],"Detail",e,t):a[e.asin]?a[e.asin].promoImage?v(a[e.asin].promoImage,"Detail",e,t):s.log("skipping asin "+e.asin+" because it has no promo image"):s.log("No metadata found for asin "+e.asin+"; skipping."):(e.q=e.q||"*",(new f(e.category)).isGroupBillboardCategory()&&(e.category.categoryDescription=e.category.description,d||(d=l.getString("Appstore_short_name")),e.category.description=d),v(i.images[e.image],"Search",e,t))})}}),define("controller/GamesController",["require","jquery","controller/SoftKeysController","widget/AppCarousel","api/navigation","widget/Billboard","api/search","api/recorder","handler/ClickStreamHandler","handler/RefMarkerBuilder","api/catalog","zeroes/ZeroesLoader"],function(e){function d(e,t,n){return t?(l.log("navigating to: "+t),i.navigate(t,n)):l.log("navigateString undefined"),!1}function v(e){return e.results}function m(e){return function(){e.hide()}}function g(e){return function(n){i.navigate("Search",{q:n,category:e})}}function y(){var e=i.getExtras("page","refMarker").pipe(function(e,t){return{page:e||p,refMarker:t}},function(e){return l.log("Error in fetching page and refMarker from extras: "+e),e});return e}var t=e("jquery"),n=e("controller/SoftKeysController"),r=e("widget/AppCarousel"),i=e("api/navigation"),s=e("widget/Billboard"),o=e("api/search"),u=e("api/recorder"),a=e("handler/ClickStreamHandler"),f=e("handler/RefMarkerBuilder"),l=u.Java.getLogger("HTML5.GamesController"),c=e("api/catalog"),h=e("zeroes/ZeroesLoader"),p="Games";return function(i){function C(e){E=c.getRankedApps(c.RANK_TYPE_TOP_FREE,e,null,m).pipe(v).done(function(e){var t=new r(i.getTopFreeTarget(),e.rankedAsins,b),n=new f("Games","TopFree","Games");t.setClickstreamRef(n.build()),t.setup()}),S=c.getRankedApps(c.RANK_TYPE_TOP_SELLERS,e,null,m).pipe(v).done(function(e){var t=new r(i.getTopPaidTarget(),e.rankedAsins,b),n=new f("Games","TopPaid","Games");t.setClickstreamRef(n.build()),t.setup()}),w=c.getRankedApps(c.RANK_TYPE_NEW_RELEASES,e,null,m).pipe(v).done(function(e){var t=new r(i.getNewReleasesTarget(),e.rankedAsins,b),n=new f("Games","NewForYou","Games");t.setClickstreamRef(n.build()),t.setup()})}var u,p="b_games",m=15,b={maxItems:m},w,E,S,x,T=c.getDynamicWidgets("games","mobile").fail(i.hideBillboard),N=y();i.render(),u=new n(i),o.getGamesCategoryForCurrentMarketplace(function(t){C(t)},function(){C(p)}),t.when(T,N).done(function(e,n){var r=i.getBillboardList(),o=new s(r,e,n.page);t(o).on("navigate",d),h.initializeAsync(h.STORE_CONFIG_TYPES.Generic)}),N.done(function(e){var t=new a(e.page);l.log("ClickStream-UI-GamesController: refMarker = "+e.refMarker),t.recordView("/gm",e.refMarker),t.record(e.refMarker)}),i.updateNavigationBarDetails(),t(i).on("navigatePageClicked",d),t(i).on("setSearchCategory",function(e,n){x&&t.unsubscribe(x),x=t.subscribe("com.amazon.venezia.doSearch",g(n))})}}),define("views/GamesView",["require","jquery","templates","api/recorder","api/search","handler/RefMarkerBuilder"],function(e){var t=e("jquery"),n=e("templates"),r=e("api/recorder"),i=e("api/search"),s=e("handler/RefMarkerBuilder"),o=r.Java.getLogger("HTML5.GamesView"),u="Games",a="NavigationBar";return function(e){function c(e){var n=t(e.target).attr("id"),r=t(e.target).attr("name"),i=t(e.target).text(),a=t(e.target).attr("page"),f="Search",c,h;return o.log("received onNavigationOptionClicked event: "+n+" "+r+" "+i),a?(e.data&&e.data.widgetName&&(c=new s(u,e.data.widgetName,a),c.addArg(t(e.target).parent().prevAll().length-1),h={refMarker:c.build()},o.log("ClickStream-UI-Games: refMarker = "+h.refMarker)),t(l).trigger("navigatePageClicked",[a,h])):(h={q:"*",category:{description:i,id:parseInt(n,10),name:r}},e.data&&e.data.widgetName&&(c=new s(u,e.data.widgetName,f),c.addCategoryArg(r),c.addArg(t(e.target).parent().prevAll().length-1),h.refMarker=c.build(),o.log("ClickStream-UI-Games: refMarker = "+h.refMarker)),o.info("triggering navigatePageClicked event: "+i),t(l).trigger("navigatePageClicked",[f,h])),!1}var r,f,l=this;this.updateNavigationBarDetails=function(){o.log("Getting games navigation categories"),i.getGamesNavigationCategories().done(function(e){o.log("Rendering browseCategories with: "+JSON.stringify(e)),r.html(n.GamesNavigationBar.render(e)),t(l).trigger("setSearchCategory",[e.parent])}).fail(function(e){o.log("Error in getGamesNavigationCategories: "+e),r.html(n.GamesNavigationBar.render()),t(l).trigger("setSearchCategory")}),setTimeout(t(".new .gateway-navigation").css("opacity",0).animate({opacity:1},1e3),500)},this.render=function(){r=e.find(".gateway-navigation"),r.on("tap","li:not(.header) a",{widgetName:a},c),f=e.find(".see-more"),f.on("tap",c),this.updateNavigationBarDetails()},this.hideBillboard=function(){return e.find("#billboard").hide()},this.getBillboardList=function(){return e.find("#billboard .carousel-list")},this.getNewReleasesTarget=function(){return e.find("#new_releases .carousel-list")},this.getTopFreeTarget=function(){return e.find("#top_free .carousel-list")},this.getTopPaidTarget=function(){return e.find("#top_paid .carousel-list")},this.getHighlyRatedTarget=function(){return e.find("#highly_rated .carousel-list")}}}),define("controller/HelpController",["require","jquery","handler/ClickStreamHandler","api/customer-data","api/feature-config","api/navigation","api/resources","controller/SoftKeysController"],function(t){function f(e,t){return t&&o.navigate("UriPage",{UriPage:"UriPage",uri:u.getString(t)}),!1}function l(e,t){return t&&o.navigate(t),!1}var n=t("jquery"),r=t("handler/ClickStreamHandler"),i=t("api/customer-data"),s=t("api/feature-config"),o=t("api/navigation"),u=t("api/resources"),a=t("controller/SoftKeysController");return function(t){var u,c,h;i.isUSPfmSync()&&t.showTestDriveTarget(),u=s.getBoolean(s.DIAGNOSE_AND_REPAIR,"enabled",!1),c=window.appPreloadState.isAmazonDevice,u&&c&&t.showCustomerCareTarget(),t.showParentalControlsTarget(),t.render(),n(t).on("helpItemSelected",f),n(t).on("pageSelected",l),h=new a(t,"Help"),o.getExtras("refMarker","page").done(function(e,t){var n=new r(t);e&&n.record(e)})}}),define("views/HelpView",["jquery","templates","api/customer-data"],function(e,t,n){return function(n){function i(t,n){t.currentTarget.dataset&&t.currentTarget.dataset.page?e(r).trigger("pageSelected",t.currentTarget.dataset.page):e(r).trigger("helpItemSelected",t.currentTarget.id)}var r=this;this.render=function(e){n.find("ul li").on("tap",i)},this.showTestDriveTarget=function(){n.find('[data-class="help_test_drive_url_item"]').show()},this.showParentalControlsTarget=function(){window.appPreloadState.isAmazonDevice?n.find("#help_parental_controls_amazon_devices_url").show():n.find("#help_parental_controls_url").show()},this.showCustomerCareTarget=function(){n.find("#help-customer-care").show()}}}),define("models/IAPItemModel",["jquery","api/appstore"],function(e,t){return function(r){var i={};return i=e.extend(i,r),i.iconUrl=r.iconUrl,i.title=r.title,i.ourPrice=r.ourPrice,i.ourPriceRaw=r.ourPriceRaw,i.ourPriceCurrencyCode=r.ourPriceCurrencyCode,r.listPrice!==undefined&&(i.listPrice=r.listPrice),r.sellerOfRecord.businessModel!=="reseller"?i.sorInfo=t.Resources.getString("IAP_SellerOfRecord",[r.sellerOfRecord.legalName]):i.sorInfo=t.Resources.getString("IAP_SoldBy",[r.sellerOfRecord.legalName]),i.description=r.description,i}}),define("controller/IAPItemController",["require","jquery","appstore","models/IAPItemModel","api/currency","api/cor-pfm","api/parental-controls","api/recorder","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("appstore"),i=t("models/IAPItemModel"),s=t("api/currency"),o=t("api/cor-pfm"),u=t("api/parental-controls"),a=t("api/recorder"),f=t("zeroes/ZeroesLoader"),l=function(e){console.log("recordEvent: "+e),a.Metrics.recordEvent(e,{asin:""})},c={Details:{init:"Appstore.Recorder.Metrics.Event.IAP.Consumable.Detail.Load.Initiated ",done:"Appstore.Recorder.Metrics.Event.IAP.Consumable.Detail.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.IAP.Consumable.Detail.Load.Failure"},Purchase:{init:"Appstore.Recorder.Metrics.Event.IAP.Consumable.Purchase.Initiated",done:"Appstore.Recorder.Metrics.Event.IAP.Consumable.Purchase.Completed",fail:"Appstore.Recorder.Metrics.Event.IAP.Consumable.Purchase.Failure"},ExternalPurchase:{init:"Appstore.Recorder.Metrics.Event.IAP.Consumable.External.Purchase.Initiated",done:"Appstore.Recorder.Metrics.Event.IAP.Consumable.External.Purchase.Completed",fail:"Appstore.Recorder.Metrics.Event.IAP.Consumable.External.Purchase.Failure"}},h={PurchaseChallenge:{init:"IapPurchaseChallengeInitiated",done:"IapPurchaseChallengeSuccess",fail:"IapPurchaseChallengeFailed"}};return function(p){var d=n.Deferred(),v=n.Deferred(),m=r.CustomerData.getCustomerPfm(),g=r.Navigation.getExtras(),y,b,w,E,S=!1,x=null,T=function(){console.log("showing default error");var e=r.Resources.getString("mas_iap_purchase_error");p.render({orderFailureDialog:!0,errorString:e})},N=function(e){var t=new s,n={iconUrl:e.iconUrl,title:e.name,ourPrice:t.format(e.ourPrice,e.currencyCode),ourPriceRaw:e.ourPrice,ourPriceCurrencyCode:e.currencyCode,zeroesOurPrice:e.zeroesOurPrice,description:e.description,sellerOfRecord:e.sellerOfRecord,zeroesRewardAmount:e.zeroesRewardAmount};return e.ourPrice<e.listPrice&&(n.listPrice=t.format(e.listPrice,e.currencyCode)),e.zeroesOurPrice<e.zeroesListPrice&&(n.zeroesListPrice=e.zeroesListPrice),n},C=function(){return f.isEnabled()&&w.zeroesOurPrice},k=function(e){p.render(n.extend({iapItemDetailDialog:!0,isHidden:C()},w,E)),n.publish("Zeroes.injectZeroesElements")},L=function(){l(c.Details.init),r.Bridge.invoke(function(e){e.args.iapRequestId=g.requestId,IapBridge.getCatalogItemDetails(JSON.stringify(e))},v),v.done(function(e){console.log("getCatalogItemDetails returned success"+JSON.stringify(e));var t=N(e);w=new i(t),e.itemType==="consumable"?E={consumable:!0}:E={nonConsumable:!0},m.done(function(e){w.isUSPfm=e===o.CorPfmMap.US,w.isJpPfm=e===o.CorPfmMap.JP,w.isCnPfm=e===o.CorPfmMap.CN,w.displaySellerOfRecord=!w.isCnPfm,w.isVatIncluded=[o.CorPfmMap.UK,o.CorPfmMap.DE,o.CorPfmMap.FR,o.CorPfmMap.ES,o.CorPfmMap.IT].indexOf(e)>=0,f.initializeAsync(f.STORE_CONFIG_TYPES.Iap,{asinDetails:{asin:w.asin,appTitle:w.title,iconUrl:w.iconUrl,ourPrice:w.ourPrice,ourPriceRaw:w.ourPriceRaw,ourPriceCurrencyCode:w.ourPriceCurrencyCode,zeroesOurPrice:w.zeroesOurPrice,zeroesRewardAmount:w.zeroesRewardAmount}}).done(function(e){e||k()})}).fail(T)}),v.fail(function(){console.log("getCatalogItemDetails returned failure"),T()})},A=function(e){console.log("handling purchase failure");var t=r.Resources.getString("enable_one_click_url"),n=r.Resources.getString(e.reason.replace(/\./g,"_"),[w.title,t]);console.log("error string is: "+n),n==="undefined"&&(n=r.Resources.getString("mas_iap_purchase_error"),console.log("using default error string: "+n)),console.log("submitPurchaseRequest returned non-success: "+JSON.stringify(e)),p.render({orderFailureDialog:!0,errorString:n})},O=function(){u.isPurchaseBlocked().done(function(e){w.isPCOn=e,p.render(n.extend({orderSuccessDialog:!0},w)),n.publish("IAP.onPurchaseMade")})},M=function(e){d.done(function(){console.log("submitPurchaseRequest returned success"),O()}),d.fail(function(e){console.log("submitPurchaseRequest returned failure"+JSON.stringify(e)),A(e)}),console.log("calling IAP submitPurchaseRequest"),p.render({loadingDialog:!0,purchasingSpinnerText:!0}),r.Bridge.invoke(function(e){e.args.iapRequestId=g.requestId,e.args.zeroesPaymentActive=S,IapBridge.submitPurchaseRequest(JSON.stringify(e))},d)},_=function(e){r.Bridge.invoke(function(t){t.args.iapRequestId=g.requestId,t.args.iapEvent=h.PurchaseChallenge.init,t.args.iapPurchaseChallengeType=e.challengeType,t.args.iapPurchaseChallengeReason=e.challengeReason,IapBridge.notifyEvent(JSON.stringify(t))},n.Deferred()),r.Bridge.invoke(function(t){t.args.iapRequestId=g.requestId,e.isSuccess?t.args.iapEvent=h.PurchaseChallenge.done:t.args.iapEvent=h.PurchaseChallenge.fail,t.args.iapPurchaseChallengeType=e.challengeType,t.args.iapPurchaseChallengeReason=e.challengeReason,IapBridge.notifyEvent(JSON.stringify(t))},n.Deferred())},D=function(e){var t=e.data.extras;t.challengeType!=="NONE"&&_(t),t.isSuccess&&M()},P=function(){t(["api/new-bridge"],function(e){if(x===null){var t={className:"com.amazon.venezia.iap.PurchaseChallengeActivity",extras:{productType:"DIGITAL",priceValue:w.ourPriceRaw.toString(),priceCurrency:w.ourPriceCurrencyCode}};y&&b&&(t.extras.appAsin=y,t.extras.appVersion=b),x=n.Deferred(),e.makeRequest("ActivityBridge","startActivityForResult",{intent:JSON.stringify(t)},x),x.done(D),x.always(function(){x=null})}})},H=function(){console.log("about to start a purchase"),l(c.Purchase.init),P()},B=function(e){console.log("Closing IAP Consumable dialog"),r.Navigation.finish()},j=function(){var e=n.Deferred();r.Bridge.invoke(function(e){e.args.iapRequestId=g.requestId,IapBridge.getPurchaseRequestInfo(JSON.stringify(e))},e),e.done(function(e){y=e.parentAppAsin,b=e.parentAppVersion}),e.always(function(){L()})},F=function(e){console.log("isIAPEnabled"+JSON.stringify(e)),e.value?j():p.render({iapDisabledDialog:!0})},I=function(){u.navigateToParentalControlsSettings(O)},q=function(){console.log("checking if iap is enabled..."),p.render({loadingDialog:!0}),r.Settings.get(r.Settings.keys.IapEnabledKey,F)},R=function(e){console.log("Navigating to device level IAP Settings page ..."),r.Navigation.navigate("SettingsPage",{settingsPage:"SettingsIAP"},q)},U=function(e){S=e.zeroesPaymentActive,H()},z=function(){B()},W=function(){n.publish("Zeroes.cancelPurchase")},X=function(e,t){console.log("Navigating to an external link: "+t),r.Navigation.openInBrowser(t)};n.subscribe("Zeroes.triggerPurchase",U),n.subscribe("Zeroes.cancelPurchase",z),n.subscribe("Zeroes.purchaseChoiceInjectorAvailable",k),n.subscribe("com.amazon.venezia.android_lifecycle.onResume",function(){x=null}),n(p).on({purchase:H,close:W,pcSettings:I,iapSettings:R,link:X}),a.Metrics.addTracker("Appstore.Metrics.IAP.Consumable.Purchase",c.Purchase.init,c.Purchase.done,c.Purchase.fail,[],3e5),a.Metrics.addTracker("Appstore.Metrics.IAP.Consumable.Details",c.Details.init,c.Details.done,c.Details.fail,[],3e5),a.Metrics.addTracker("Appstore.Metrics.IAP.Consumable.External.Purchase",c.ExternalPurchase.init,c.ExternalPurchase.done,c.ExternalPurchase.fail,[],6e5),l(c.ExternalPurchase.init),p.render({loadingDialog:!0}),q(),n.when(v).then(function(){l(c.Details.done)},function(){l(c.Details.fail)}),n.when(d).then(function(){l(c.Purchase.done)},function(){l(c.Purchase.fail)}),n.when(d,v).then(function(){l(c.ExternalPurchase.done)},function(){l(c.ExternalPurchase.fail)})}}),define("views/IAPItemView",["jquery","templates"],function(e,t){return function(r){function s(t){return e(i).trigger("purchase"),!1}function o(t){return e(i).trigger("close"),!1}function u(t){return e(i).trigger("pcSettings"),!1}function a(t){return e(i).trigger("iapSettings"),!1}var i=this;this.render=function(n){r.empty(),r.append(t.IAPItem.render(n)),console.log("Rendering IAPItemView with the following params:"+JSON.stringify(n)),e("#priceBtn").on("tap",s),e("#closeBtn").on("tap",o),e("#pcSettings").on("tap",u),e("#iapSettings").on("tap",a),e("#okBtn").on("tap",o),e("a").on("click",function(t){return t.preventDefault(),e(i).trigger("link",e(this).attr("href")),!1})}}}),define("models/IAPSubscriptionModel",["jquery","api/currency","api/appstore"],function(e,t,n){return function(){function i(e,t,r){switch(r){case"Days":r=n.Resources.getString("IAPSubscriptions_Trials_Day");break;case"Weeks":t<=2?(r=n.Resources.getString("IAPSubscriptions_Trials_Day"),t*=7):r=n.Resources.getString("IAPSubscriptions_Trials_Week");break;case"Months":r=n.Resources.getString("IAPSubscriptions_Trials_Month");break;case"Years":r=n.Resources.getString("IAPSubscriptions_Trials_Year");break;default:}e.freeTrialOrderSummaryDescription=n.Resources.getString("IAPSubscriptions_Order_Summary_Description",[t,r,e.orderSummaryFrequency]),e.canadaFreeTrialOrderSummaryDescription=n.Resources.getString("Canada_IAPSubscriptions_Order_Summary_Description",[t,r,e.orderSummaryFrequency]),e.freeTrialText=n.Resources.getString("IAPSubscriptions_Free_Trial",[t,r]),e.freeTrialDisclaimer=n.Resources.getString("IAPSubscriptions_Free_Trial_Disclaimer",[t,r]),e.freeTrialStarted=n.Resources.getString("IAPSubscriptions_Free_Trial_Started",[t,r])}function s(e){e.orderSummaryDescription=n.Resources.getString("IAPSubscriptions_Order_Summary_Autorenewal",[e.orderSummaryFrequency]),e.canadaOrderSummaryDescription=n.Resources.getString("Canada_IAPSubscriptions_Order_Summary_Autorenewal",[e.orderSummaryFrequency])}function o(e){switch(e.frequency){case"WEEKLY":e.frequency=n.Resources.getString("IAPSubscriptions_Weekly"),e.orderSummaryFrequency=e.frequency;break;case"BIWEEKLY":e.frequency=n.Resources.getString("IAPSubscriptions_Biweekly"),e.orderSummaryFrequency=e.frequency;break;case"MONTHLY":e.frequency=n.Resources.getString("IAPSubscriptions_Monthly"),e.orderSummaryFrequency=e.frequency;break;case"BIMONTHLY":e.frequency=n.Resources.getString("IAPSubscriptions_Bimonthly"),e.orderSummaryFrequency=e.frequency;break;case"QUARTERLY":e.frequency=n.Resources.getString("IAPSubscriptions_Quarterly"),e.orderSummaryFrequency=e.frequency;break;case"SEMIANNUALLY":e.frequency=n.Resources.getString("IAPSubscriptions_Semiannually"),e.orderSummaryFrequency=n.Resources.getString("IAPSubscriptions_Semiannual");break;case"ANNUALLY":e.frequency=n.Resources.getString("IAPSubscriptions_Annually"),e.orderSummaryFrequency=n.Resources.getString("IAPSubscriptions_Annual");break;default:}}this.termItems={},this.selectedItem=undefined,this.isResubscribed=!1,this.hasFreeTrial=!1,this.isDataSharingAllowed=!0,this.iconUrl=undefined,this.addTermItem=function(e){console.log("model: adding new term item to these termItems: "+JSON.stringify(this.termItems)),this.selectedItem===undefined&&(this.selectedItem=e.itemId,console.log("setting selected item to be "+e.itemId)),this.termItems[e.itemId]={id:e.itemId,price:(new t).format(e.priceAmount,e.currencyCode),priceRaw:e.priceAmount,priceCurrencyCode:e.currencyCode,freeTrialUnit:e.freeTrialUnit,freeTrialAmount:e.freeTrialAmount,universalFrequency:e.frequency,frequency:e.frequency,developer:e.developer,name:e.name,description:e.description,periodHasFreeTrial:e.freeTrialAmount!==undefined&&e.freeTrialUnit!==undefined,purchaseChallengeRequired:e.purchaseChallengeRequired,purchaseChallengeMessage:e.purchaseChallengeKey&&n.Resources.getString(e.purchaseChallengeKey)},o(this.termItems[e.itemId]),e.freeTrialAmount!==undefined&&e.freeTrialUnit!==undefined&&i(this.termItems[e.itemId],e.freeTrialAmount,e.freeTrialUnit),s(this.termItems[e.itemId])},this.setSelectedItem=function(e){console.log("model: changing selected item from "+this.selectedItem+" to "+e),this.selectedItem=e},this.setBillingInfo=function(e){this.nextBillDate=e.nextBillDate,this.startDate=e.startDate,this.nextBillAmount=e.nextBillingAmount},this.setBillingMethod=function(e){this.billingMethod=e},this.setIsResubscribed=function(t){this.isResubscribed=t,e.map(this.termItems,function(e){e.hasFreeTrial=e.periodHasFreeTrial&&!t})},this.setIsDataSharingAllowed=function(e){this.isDataSharingAllowed=e},this.updateSelectedHasFreeTrial=function(e){this.termItems[this.selectedItem].hasFreeTrial=this.termItems[this.selectedItem].hasFreeTrial&&e},this.setSellerOfRecord=function(e){e.businessModel!=="reseller"?this.sorInfo=n.Resources.getString("IAP_SellerOfRecord",[e.legalName]):this.sorInfo=n.Resources.getString("IAP_SoldBy",[e.legalName]),console.log("Seller of record: "+JSON.stringify(this.sorInfo))}}}),define("models/SubscriptionModel",["api/datetime"],function(e){var t=function(e){return e.shareAddress&&e.shareEmail},n=function(e){return!e.shareAddress&&!e.shareEmail},r=function(e,t){if(!e)return[];var n=[],r=e.length,i;for(i=0;i<r;i+=1)n.push({duration:e[i].duration,price:e[i].ourPrice,asin:e[i].asin,version:e[i].version,selected:e[i].asin===t});return n},i=new e("SHORT"),s=new e("LONG");return function(o){var u,a;o.details&&(this.asin=o.details.asin,this.title=o.details.title,this.developer=o.details.developer,this.version=o.details.version,this.description=o.details.shortDescription),o.sharing&&(this.sharing=o.sharing,this.shareEverything=t(o.sharing),this.shareNone=n(o.sharing),!this.shareEverything&&!this.shareNone&&(this.shareAddress=o.sharing.shareAddress,this.shareEmail=o.sharing.shareEmail)),this.dataSharingAllowed=o.dataSharingAllowed,this.terms=r(o.periods,o.selectedPeriod),this.nextBillingAmount=o.nextBillAmount,o.nextBillDate!==undefined&&(this.nextBillDate=s.formatDateMs(o.nextBillDate*1e3),this.shortNextBillDate=i.formatDateMs(o.nextBillDate*1e3)),o.startDate!==undefined&&(this.startDate=s.formatDateMs(o.startDate*1e3)),this.autorenew=o.autorenew,this.autoRenewToggleAllowed=o.autoRenewToggleAllowed,this.getAsinWithVersion=function(){return{asin:this.asin,version:this.version}},this.getPeriodByAsin=function(e){for(u=0,a=this.terms.length;u<a;u+=1)if(e===this.terms[u].asin)return this.terms[u];return{}},this.setShareSettings=function(e){this.sharing=e,this.shareEverything=t(e),this.shareNone=n(e),!this.shareEverything&&!this.shareNone&&(this.shareAddress=e.shareAddress,this.shareEmail=e.shareEmail)}}}),define("controller/IAPSubscriptionController",["require","jquery","api/navigation","api/parental-controls","appstore","api/cor-pfm","models/IAPSubscriptionModel","models/SubscriptionModel","api/recorder"],function(e){var t=e("jquery"),n=e("api/navigation"),r=e("api/parental-controls"),i=e("appstore"),s=e("api/cor-pfm"),o=e("models/IAPSubscriptionModel"),u=e("models/SubscriptionModel"),a=e("api/recorder"),f=function(e){console.log("recordEvent: "+e),a.Metrics.recordEvent(e,{asin:""})},l={Details:{init:"Appstore.Recorder.Metrics.Event.IAP.Subscription.Detail.Load.Initiated ",done:"Appstore.Recorder.Metrics.Event.IAP.Subscription.Detail.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.IAP.Subscription.Detail.Load.Failure"},Purchase:{init:"Appstore.Recorder.Metrics.Event.IAP.Subscription.Purchase.Initiated",done:"Appstore.Recorder.Metrics.Event.IAP.Subscription.Purchase.Completed",fail:"Appstore.Recorder.Metrics.Event.IAP.Subscription.Purchase.Failure"},ExternalPurchase:{init:"Appstore.Recorder.Metrics.Event.IAP.Subscription.External.Purchase.Initiated",done:"Appstore.Recorder.Metrics.Event.IAP.Subscription.External.Purchase.Completed",fail:"Appstore.Recorder.Metrics.Event.IAP.Subscription.External.Purchase.Failure"}},c={PurchaseChallenge:{init:"IapPurchaseChallengeInitiated",done:"IapPurchaseChallengeSuccess",fail:"IapPurchaseChallengeFailed"}};return function(p){var d,v,m,g,y,b=null,w,E,S,x,T,N,C,k,L,A,O,M,_,D,P,H,B,j,F,I,q,R,U,z,W,X,V=n.getExtras(),J=new o,K,Q,G,Y=t.Deferred(),Z=t.Deferred(),et=t.Deferred(),tt=t.Deferred(),nt,rt,it;nt=function(){var e=t.Deferred();i.Bridge.invoke(function(e){e.args.iapRequestId=V.requestId,IapBridge.getPurchaseRequestInfo(JSON.stringify(e))},e),e.done(function(e){rt=e.parentAppAsin,it=e.parentAppVersion}),e.always(function(){k()})},k=function(){f(l.Details.init),Y=i.Subscriptions.getItemId(V.requestId),Y.done(function(e){console.log("getItemId success:"+JSON.stringify(e)),tt=i.Subscriptions.getItemDetails(e.itemId),tt.done(function(t){var n;console.log("getSubscriptionItemDetails response "+JSON.stringify(t)),t.itemType==="subscription"?(U=t.itemId,J.iconUrl=t.iconUrl,z=U.split(":")[1],C(t)):t.itemType==="subscriptionPeriod"&&(console.log("parentItem="+JSON.stringify(t.parentItem)),J.setSelectedItem(e.itemId),U=t.parentItem,z=U.split(":")[1],n=i.Subscriptions.getItemDetails(U),n.done(function(e){J.iconUrl=e.iconUrl,C(e)}),n.fail(function(){console.log("parentItemDetails failure"),L(l.Details.fail)()}))}),tt.fail(function(){console.log("itemDetails failure"),L(l.Details.fail)()})}),Y.fail(function(){console.log("itemId failure"),L(l.Details.fail)()}),t.when(Y).done(function(){f(l.Details.done)})},C=function(e){var n=[F(),I(),R(),q(e)];t.when.apply(t,n).then(function(){J.setIsResubscribed(M),N()},L(l.Details.fail))},q=function(e){console.log("periodItems="+JSON.stringify(e.periodItems));var n=t.parseJSON(e.periodItems),r=[],s=t.Deferred();return t.map(n,function(e){console.log("PeriodItem:="+e),r.push(i.Subscriptions.getItemDetails(e,undefined,L(l.Details.fail)))}),t.when.apply(t,r).done(function(){t.map(arguments,function(e){console.log("Adding term item ..."+JSON.stringify(e)),J.addTermItem(e),J.sorInfo===undefined&&J.setSellerOfRecord(e.sellerOfRecord)}),s.resolve()}),console.log("returning from setChildrenForParent"),s},N=function(){console.log("iapSubscriptionModel = "+JSON.stringify(J)),p.render(t.extend({subscriptionDetailDialog:!0},J))},F=function(){var e=i.Subscriptions.getAllSubscriptions(),n=t.Deferred(),r;return e.done(function(e){console.log("subsHistory: "+JSON.stringify(e));if(JSON.parse(e.message).subscriptionItems===null){n.resolve();return}r=JSON.parse(e.message).subscriptionItems,t.map(r,function(e){if(e.item.asin===U.split(":")[1]){M=!0,console.log("already subscribed before");return}}),console.log("resolving isResubscribed deferred"),n.resolve()}),e.fail(function(){console.log("getSubs failure"),L(l.Purchase.fail)()}),n},I=function(){var e=i.Subscriptions.getProductsByAsin([z],"Summary"),n=t.Deferred();return e.done(function(e){var t=JSON.parse(e.message).itemMap[z];console.log("getProductsByAsin itemMap for "+z+": "+JSON.stringify(t));if(t===undefined){console.log("could not find product info for "+z),n.reject();return}J.setIsDataSharingAllowed(t.dataSharingAllowed),console.log("resolving isDataShareAllowedDfd"),n.resolve(),W=t.productId}),e.fail(function(){console.log("getProductsByAsinDfd failure"),n.reject()}),n},R=function(){var e=i.CustomerData.getCustomerPfm();return e.done(function(e){J.isUSPfm=e===s.CorPfmMap.US,J.isJpPfm=e===s.CorPfmMap.JP,J.isCnPfm=e===s.CorPfmMap.CN,J.isCAPfm=e===s.CorPfmMap.CA,J.displaySellerOfRecord=!J.isCnPfm,J.isVatIncluded=[s.CorPfmMap.UK,s.CorPfmMap.DE,s.CorPfmMap.FR,s.CorPfmMap.ES,s.CorPfmMap.IT].indexOf(e)>=0}).fail(L(l.Details.fail)),e},d=function(){f(l.Purchase.init),w()},w=function(){e(["api/new-bridge"],function(e){if(b===null){var n=J.selectedItem,r=J.termItems[n],i={className:"com.amazon.venezia.iap.PurchaseChallengeActivity",extras:{productType:"DIGITAL",priceValue:r.priceRaw.toString(),priceCurrency:r.priceCurrencyCode}};rt&&it&&(i.extras.appAsin=rt,i.extras.appVersion=it),b=t.Deferred(),e.makeRequest("ActivityBridge","startActivityForResult",{intent:JSON.stringify(i)},b),b.done(E),b.always(function(){b=null})}})},E=function(e){var t=e.data.extras;t.challengeType!=="NONE"&&S(t),t.isSuccess&&y()},S=function(e){i.Bridge.invoke(function(t){t.args.iapRequestId=V.requestId,t.args.iapEvent=c.PurchaseChallenge.init,t.args.iapPurchaseChallengeType=e.challengeType,t.args.iapPurchaseChallengeReason=e.challengeReason,IapBridge.notifyEvent(JSON.stringify(t))},t.Deferred()),i.Bridge.invoke(function(t){t.args.iapRequestId=V.requestId,e.isSuccess?t.args.iapEvent=c.PurchaseChallenge.done:t.args.iapEvent=c.PurchaseChallenge.fail,t.args.iapPurchaseChallengeType=e.challengeType,t.args.iapPurchaseChallengeReason=e.challengeReason,IapBridge.notifyEvent(JSON.stringify(t))},t.Deferred())},y=function(){var e=J.selectedItem;console.log("doing purchase ... "+e),p.render({loadingDialog:!0,purchasingSpinnerText:!0}),Z=i.Subscriptions.setPurchaseItemId(V.requestId,e),Z.fail(function(){console.log("setPurchaseItemId failure"),L(l.Purchase.fail)()}),Z.done(function(){et=i.Subscriptions.purchase(V.requestId),et.done(function(e){console.log("submitPurchaseRequest returned success: "+JSON.stringify(e)),e.billingMethod+="";while(e.billingMethod.length<4)console.log("padding billingMethod with leading zero"),e.billingMethod="0"+e.billingMethod;J.setBillingMethod(e.billingMethod),j(),_()}),et.fail(A)})},A=function(e){console.log("handling purchase failure: "+e.reason.replace(/\./g,"_"));var t=J.termItems[J.selectedItem].name,n=i.Resources.getString("enable_one_click_url"),r=i.Resources.getString(e.reason.replace(/\./g,"_"),[t,n]);console.log("error string is: "+r),r==="undefined"&&(r=i.Resources.getString("mas_iap_purchase_error"),console.log("using default error string: "+r)),console.log("submitPurchaseRequest returned non-success: "+JSON.stringify(e)),p.render({orderFailureDialog:!0,errorString:r}),f(l.Purchase.fail),f(l.ExternalPurchase.fail)},v=function(e){console.log("Closing IAP Subs dialog"),n.finish()},m=function(e,r){console.log("onAbout:event  - "+JSON.stringify(r));var i=J.termItems[J.selectedItem].periodHasFreeTrial;console.log("launching About Subscriptions page"),n.showDialog("IAPSubscriptionAboutDialog",t.extend(J,{hasFreeTrial:i,isIAP:!0,showAboutSubscriptions:r.showAboutSubscriptions,showAboutPrivacy:r.showAboutPrivacy}))},g=function(e){console.log("the sub to put in extras is: "+JSON.stringify(X)),i.Navigation.showDialog("SubscriptionPrivacyPreferences",{subscription:X},H,_)},H=function(e){console.log("result from privacy dialog: "+JSON.stringify(e)),e.value&&(console.log("updating privprefs with a/v: "+JSON.stringify(X.getAsinWithVersion())),i.Subscriptions.getSharedDataSettings(X.getAsinWithVersion(),function(e){console.log("success callback"),console.log("updating sharedDataSettings with "+JSON.parse(e.message));var t=JSON.parse(e.message),n={shareAddress:!t.dataShareOptOutAddress,shareEmail:t.dataShareOptInEmail,email:t.dataShareEmail};console.log("going to update these settings in our subsItem: "+JSON.stringify(n)),X.setShareSettings(n)}))},B=function(){r.isPurchaseBlocked().then(function(e){p.updateIsPCOn(e)})},x=function(e){console.log("Navigating to device level IAP Settings page ..."),i.Navigation.navigate("SettingsPage",{settingsPage:"SettingsIAP"},D)},T=function(){r.navigateToParentalControlsSettings(B)},Q=function(e){n.showDialog("SelectSubscriptionPeriod",{termItems:J.termItems,selectedItem:J.selectedItem},K,G)},K=function(e){console.log("this is what we got back from the select sub dialog: "+JSON.stringify(e)),t.isEmptyObject(e)||(console.log("updateing selected item"),J.setSelectedItem(e.item)),N()},G=function(e){console.log("failure case for subs select "+JSON.stringify(e)),N()},O=function(e){e.value?(console.log("iap is enabled! "+JSON.stringify(e)),nt()):(console.log("iap is disabled! "+JSON.stringify(e)),p.render({iapDisabledDialog:!0}))},_=function(){console.log("showing OrderSuccess"),p.render(t.extend({orderSuccessDialog:!0},J)),r.isPurchaseBlocked().then(function(e){p.updateIsPCOn(e)})},L=function(e){return function(){var t=i.Resources.getString("mas_iap_purchase_error");p.render({orderFailureDialog:!0,errorString:t}),f(e),f(l.ExternalPurchase.fail)}},j=function(){var e=J.selectedItem.split(":")[1],t=i.Subscriptions.getSubscriptionDetails(W);t.done(function(e){console.log("response from subDetails "+JSON.stringify(e)),X=new u(e),J.setBillingInfo(X),_(),f(l.Purchase.done),f(l.ExternalPurchase.done)}),t.fail(function(e){console.log("subdetails failed "+JSON.stringify(e)),L(l.Purchase.fail)})},D=function(){p.render({loadingDialog:!0}),i.Settings.get(i.Settings.keys.IapEnabledKey,O)},P=function(e,t){i.Navigation.openInBrowser(t)},t.subscribe("com.amazon.venezia.android_lifecycle.onResume",function(){b=null}),t(p).on({clickPurchase:d,clickCancel:v,clickAbout:m,clickPrivacyPrefs:g,clickGotoIapSettings:x,clickPcSettings:T,clickSelectSubscriptionPeriod:Q,clickedLink:P}),a.Metrics.addTracker("Appstore.Metrics.IAP.Subscription.Purchase",l.Purchase.init,l.Purchase.done,l.Purchase.fail,[],3e5),a.Metrics.addTracker("Appstore.Metrics.IAP.Subscription.Details",l.Details.init,l.Details.done,l.Details.fail,[],3e5),a.Metrics.addTracker("Appstore.Metrics.IAP.Subscription.External.Purchase",l.ExternalPurchase.init,l.ExternalPurchase.done,l.ExternalPurchase.fail,[],6e5),f(l.ExternalPurchase.init),p.render({loadingDialog:!0}),console.log("checking if iap is enabled..."),D()}}),define("views/IAPSubscriptionView",["jquery","templates","api/resources"],function(e,t,n){return function(i){var s=this,o=function(){return console.log("detected a purchase click"),e(s).trigger("clickPurchase"),!1},u=function(){return console.log("detected a click on Cancel"),e(s).trigger("clickCancel"),!1},a=function(t){return console.log("detected a click on About"+JSON.stringify(t.data)),e(s).trigger("clickAbout",t.data),!1},f=function(){return console.log("detected a click on PrivacyPrefs"),e(s).trigger("clickPrivacyPrefs"),!1},l=function(){return console.log("detected a click on gotoiapsettings"),e(s).trigger("clickGotoIapSettings"),!1},c=function(){return console.log("detected a click on PrivacyPrefs"),e(s).trigger("clickPcSettings"),!1},h=function(){return e('[data-class="subscription-button"]').off("tap",h),console.log("detected a change on subsSelect"),e(s).trigger("clickSelectSubscriptionPeriod"),!1},p=n.getStrings("IAP_PC_ON"),d=n.getStrings("IAP_PC_OFF");this.updateIsPCOn=function(t){console.log("updating isPCOn"),t?p.done(function(t){console.log("pc on string: "+t),e("#isPCOn").text(t)}):d.done(function(t){console.log("pc off string: "+t),e("#isPCOn").text(t)})},this.render=function(n){var r,p;i.empty(),n!==undefined&&(console.log("Rendering IAPSubscriptionView with the following params:"+JSON.stringify(n)),r=n.selectedItem,r&&n.termItems?(p=n.termItems[r],console.log("selectedTerm = "+JSON.stringify(p)),p?(n=e.extend(n,p),i.append(t.IAPSubscription.render(n)),i.find('[data-class="subscription-button"] .subs-button-term').html(p.frequency),i.find('[data-class="subscription-button"] .subs-button-price').html(p.price),console.log("button text = "+i.find('[data-class="subscription-button"]').html())):(console.log("no selected item. . ."),i.append(t.IAPSubscription.render(n)))):i.append(t.IAPSubscription.render(n))),e("#cancel").on("tap",u),e("#about").on("tap",{showAboutSubscriptions:!0,showAboutPrivacy:!0},a),e("#aboutPrivacy").on("tap",{showAboutSubscriptions:!1,showAboutPrivacy:!0},a),e("#aboutSubscriptions").on("tap",{showAboutSubscriptions:!0,showAboutPrivacy:!1},a),e('[data-class="subscribe"]').on("tap",o),e("#privacyPrefs").on("tap",f),e("#gotoIapSettings").on("tap",l),e("#pcSettings").on("tap",c),e('[data-class="subscription-button"]').on("tap",h),e("#okBtn").on("tap",u),e("a").on("click",function(t){return t.preventDefault(),e(s).trigger("clickedLink",e(this).attr("href")),!1})}}}),define("controller/IAPSubscriptionAboutDialogController",["require","jquery","api/navigation"],function(e){var t=e("jquery"),n=e("api/navigation");return function(r){function s(e,t){n.openInBrowser(t)}var i=n.getExtras();console.log("About to render IAPSubscriptionAboutDialogContoller with extras: "+JSON.stringify(n.getExtras())),r.render(i),t(r).on({clickCancel:function(e){console.log("Closing About Subs dialog"),n.finish()},clickManageSubs:function(e){n.navigate("Subscriptions")},linkClicked:s})}}),define("views/IAPSubscriptionAboutDialogView",["jquery","templates"],function(e,t){return function(n){function i(t){return e(r).trigger("linkClicked",t.target.href),!1}var r=this;this.render=function(t){console.log("Rendering IapSubscriptionAboutDialogView..."),t.showAboutSubscriptions?(console.log("Inside showAboutSubscriptions"),e("#aboutSubscriptions").show(),t.hasFreeTrial&&e("#hasFreeTrial").show()):e("#aboutSubscriptions").hide(),t.showAboutPrivacy?(console.log("Inside showAboutPrivacy"),t.showAboutSubscriptions?e("#privacySeparator").show():e("#privacySeparator").hide(),t.isDataSharingAllowed&&e("#isDataSharingAllowed").show()):e("#isDataSharingAllowed").hide(),e("#cancel").on("tap",function(){return console.log("detected a click on Cancel"),e(r).trigger("clickCancel"),!1}),e("#manageSubs").on("tap",function(){return console.log("detected a click on manageSubs"),e(r).trigger("clickManageSubs"),!1}),e("a").not("#manageSubs").on("tap",i),e("a").on("click",function(){return!1})}}}),define("controller/SubscriptionPrivacyPreferencesController",["require","jquery","appstore","controller/DialogController"],function(e){var t=e("jquery"),n=e("appstore"),r=e("controller/DialogController");return function(t){console.log(JSON.stringify(n.Navigation.getExtras()));var i=n.Navigation.getExtras(),s=i.subscription,o=function(){console.log("successfully set privacy settings."),n.Navigation.setResult({value:!0})},u=function(){console.log("did not set privacy settings."),n.Navigation.setResult({value:!1})},a={yesFn:function(e){return console.log("subscription is "+JSON.stringify(s)),console.log("calling back the yes function with "+JSON.stringify(e)),n.Subscriptions.setPrivacySettings({asin:s.asin,version:s.version},e.settings,e.useAsDefault,o,u)},noFn:u,dismissFn:n.Navigation.finish},f=t.getDialogView(),l=new r(f,a);console.log("About to render SubscriptionPrivacyPreferencesContoller... with "+JSON.stringify(s)),l.render(s)}}),define("views/SubscriptionPrivacyPreferencesView",["jquery","templates","views/DialogView"],function(e,t,n){var r=/^[A-Z0-9a-z!#$%&'*+-\/=?\^_`{|}~]+@[A-Z0-9a-z!#$%&'*+-\/=?\^_`{|}~]+\.[A-Z0-9a-z!#$%&'*+-\/=?\^_`{|}~]+$/;return function(s){function u(n){var i=function(){var t={shareAddress:e("#check-name").is(":checked"),shareEmail:e("#check-email").is(":checked"),email:e("#text-email").val()},n=e("#check-reuse-settings").is(":checked");return{settings:t,useAsDefault:n}},s=function(){return console.log("checking emails against the regex"),e("#check-email").is(":checked")?r.test(e("#text-email").val()):!0},o=function(){console.log("showing invalid email..."),e("#invalid-email").show()},u=function(){e("#check-email").on("tap",function(){return e("#invalid-email").hide(),!0}),e("#text-email").focusin(function(){return e("#invalid-email").hide(),e("#check-email").prop("checked",!0),!0}),e("#text-email").keyup(function(){return e("#check-email").prop("checked",!0),!0}),e("#text-email").focusout(function(){return e(this).val()===""&&e("#check-email").prop("checked",!1),!0})};return{renderTarget:n,template:t.SubscriptionPrivacyPreferences,getDataFn:i,isValidFn:s,invalidFn:o,applyOptionalBindings:u}}var o=this;this.dialogView=new n(u(s)),this.render=function(e){console.log("Rendering SubscriptionPrivacyPreferencesView..."),this.dialogView.render(e)},this.getDialogView=function(){return this.dialogView}}}),define("controller/InstallUpdateDialogController",["require","jquery","api/navigation","api/device","api/device-features","api/recorder"],function(e){var t=e("jquery"),n=e("api/navigation"),r=e("api/device"),i=e("api/device-features"),s=e("api/recorder"),o={install:{update:"Appstore.Metrics.Settings.Version.Update.Selected",later:"Appstore.Metrics.Settings.Version.Later.Selected"}};return function(u){function a(e){s.Metrics.recordEvent(o.install.later),console.log("closing UpdateDialog"),n.finish()}function f(e){console.log("Install the update"),s.Metrics.recordEvent(o.install.update),r.installClientUpdate(),n.finish()}u.render({}),u.setBackgroundMessageVisible(i.getValueOf(i.Keys.BACKGROUND_INSTALL)),t(u).on({later:a,update:f,cancel:a}),r.flagNotifiedAboutUpdate()}}),define("views/InstallUpdateDialogView",["require","jquery","views/DialogView"],function(e){var t=e("jquery"),n=e("views/DialogView");return function(r){var i=this;this.render=function(e){t("#later").on("tap",function(){t(i).trigger("later")}),t("#update").on("tap",function(){t(i).trigger("update")}),n.handleCancel(i)},this.setBackgroundMessageVisible=function(e){var n=t("p#not-bg-install"),r=t("p#bg-install");e?(n.css("display","none"),r.css("display","")):(n.css("display",""),r.css("display","none"))}}}),define("controller/LegalController",["require","jquery","api/resources","api/navigation","handler/ClickStreamHandler","controller/SoftKeysController"],function(t){var n=t("jquery"),r=t("api/resources"),i=t("api/navigation"),s=t("handler/ClickStreamHandler"),o=t("controller/SoftKeysController"),u;return u=function(e){return e.data&&i.navigate(e.data.page,{UriPage:e.data.page,uri:e.data.uri}),!1},function(t){t.render(),t.getTermsOfUse().on("tap",{page:"UriPage",uri:r.getString("legal_use_terms_url")},u),t.getPrivacyPolicy().on("tap",{page:"UriPage",uri:r.getString("legal_privacy_url")},u),t.getAdditionalTerms().on("tap",{page:"UriPage",uri:r.getString("help_additional_terms_url")},u);var n=new o(t,"Legal");i.getExtras("refMarker","page").done(function(e,t){var n=new s(t);e&&n.record(e)})}}),define("views/LegalView",["jquery","templates"],function(e,t){return function(n){function i(t,n){e(t).on("tap",function(){return e(r).trigger(n),!1})}var r=this;this.render=function(e){},this.getTermsOfUse=function(){return n.find("#terms-of-use")},this.getPrivacyPolicy=function(){return n.find("#privacy-policy")},this.getAdditionalTerms=function(){return n.find("#additional-terms")}}}),define("controller/MSTDialogsController",["require","jquery","appstore","templates","api/navigation"],function(e){var t=e("jquery"),n=e("appstore"),r=n.Recorder.Java.getLogger("HTML5.MSTDialogsController"),i=e("templates"),s=e("api/navigation");return function(i){var o,u,a=null,f=null,l=null,c;r.log("in MSTDialogsController"),o=n.Navigation.getExtras(),u=o.dialogType;switch(u){case n.TestDrive.DialogTypes.AT_CAPACITY_DIALOG:a=n.Resources.getString("MSTAtCapacityDialog_at_capacity"),l=n.Resources.getString("MSTDialog_ok");break;case n.TestDrive.DialogTypes.DEVICE_DISABLED_DIALOG:a=n.Resources.getString("MSTDeviceDisabledDialog_device_disabled"),l=n.Resources.getString("MSTDialog_ok");break;case n.TestDrive.DialogTypes.ENABLE_WIFI_DIALOG:a=n.Resources.getString("MSTEnableWifiDialog_enable_wifi"),f=n.Resources.getString("MSTEnableWifiDialog_go_to_wifi"),l=n.Resources.getString("MSTEnableWifiDialog_later");break;case n.TestDrive.DialogTypes.ERROR_DIALOG:a=n.Resources.getString("MSTErrorDialog_error"),l=n.Resources.getString("MSTDialog_ok");break;case n.TestDrive.DialogTypes.ERROR_DIALOG_IN_SESSION:a=n.Resources.getString("MSTErrorDialog_error"),l=n.Resources.getString("MSTDialog_ok");break;case n.TestDrive.DialogTypes.INTERRUPTED_DIALOG:a=n.Resources.getString("MSTInterruptedDialog_session_interrupted",[o.AppName]),l=n.Resources.getString("MSTDialog_ok");break;case n.TestDrive.DialogTypes.FRE_DIALOG:a=n.Resources.getString("MSTFirstRunDialog_first_run"),l=n.Resources.getString("MSTDialog_continue");break;case n.TestDrive.DialogTypes.BAD_CONNECTION_DIALOG:a=n.Resources.getString("MSTBadConnectionDialog_bad_connection"),l=n.Resources.getString("MSTDialog_return_to_detail")}c={mstMsg:a,goToWifiBtn:f,dismissBtn:l},i.render(c),t(i).on("cancel",s.finish)}}),define("views/MSTDialogsView",["require","jquery","templates","appstore","views/DialogView"],function(t){var n=t("jquery"),r=t("templates"),i=t("appstore"),s=i.Recorder.Java.getLogger("HTML5.MSTDialogView"),o=t("views/DialogView");return function(t){function f(e){i.Navigation.finish()}function l(e){var t={action:"android.settings.WIFI_SETTINGS",flag:"1073741824"};i.Navigation.dismissDialog(),i.Navigation.Android.startActivity(t)}var s,u,a=this;this.render=function(e){console.log("rendering MSTDialog view"),t.empty(),s=n(r.MSTDialogs.render(e)),t.append(s),t.find("#mstdialog-goto-wifi").on("tap",l),t.find("#mstdialog-dismiss").on("tap",f),o.handleCancel(a)}}}),define("controller/MSTNetworkQualityDialogController",["require","jquery","appstore","templates"],function(e){var t=e("jquery"),n=e("appstore"),r=e("templates");return function(r){function c(e){r.render({showCheckStart:f==="SonarInBackgroundButtonPolicy"&&!e.checkFinished,showPassed:f==="SonarInBackgroundButtonPolicy"&&e.checkFinished&&e.checkPassed,showFailed:e.checkFinished&&!e.checkPassed,showLaunching:f!=="SonarInBackgroundButtonPolicy"&&e.checkFinished===e.checkPassed,showLoadingIndicator:!e.checkFinished||e.checkPassed,showCancel:e.checkFinished===e.checkPassed,showClose:e.checkFinished!==e.checkPassed})}function h(){r.dismissDialog()}function p(e,t,n){var r,i;r={extras:{dialogState:e,isUserClosing:t,metaData:JSON.stringify(n)}},i=-1,window.ActivityBridge&&window.ActivityBridge.setResult(i,JSON.stringify(r))}function d(){p(n.TestDrive.DialogNetworkState.RESERVING,!0),n.TestDrive.logTimerStart(a,"SessionReservationTime"),s={checkPassed:!0,checkFinished:!0},c(s),n.TestDrive.reserveSessionWithFailDialog(a,i.appData,i.lastButtonRenderReason,i.preNetworkTestCount).done(function(e){p(n.TestDrive.DialogNetworkState.RESERVE_PASSED,!1,e)}).fail(function(){p(n.TestDrive.DialogNetworkState.RESERVE_FAILED,!1)}).always(function(){n.TestDrive.logTimerEnd(a,"SessionReservationTime"),h()})}var i,s,o,u,a,f,l=!0;t.subscribe("com.amazon.venezia.android_lifecycle.onResume",function(){l=!0}),t.subscribe("com.amazon.venezia.android_lifecycle.onPause",function(){l=!1}),i=n.Navigation.getExtras(),s=i.templateParams,f=i.currentPolicy,a=i.loggingContext,o=function(e){n.TestDrive.logTimerEnd(a,"QualityDialogOpenTime"),e&&e.testStartTime&&n.TestDrive.logEvent(a,"testStartTime",e.testStartTime),e&&e.result===!0?(p(n.TestDrive.DialogNetworkState.TEST_PASSED,!0),l?d():h()):(p(n.TestDrive.DialogNetworkState.TEST_FAILED,!0),s={checkPassed:!1,checkFinished:!0},c(s))},p(n.TestDrive.DialogNetworkState.TESTING,!0),n.TestDrive.logTimerStart(a,"QualityDialogOpenTime"),c(s),t(r).on("cancel",function(){h()}),n.TestDrive.checkNetworkConnection(a).always(o)}}),define("views/MSTNetworkQualityDialogView",["require","jquery","templates","appstore","views/DialogView"],function(t){var n=t("jquery"),r=t("templates"),i=t("appstore"),s=t("views/DialogView");return function(t){var o,u,a=this;this.dismissDialog=function(e){i.Navigation.finish()},this.render=function(e){t.empty(),o=n(r.MSTNetworkQualityDialog.render(e)),t.append(o),t.find("#close").on("tap",i.Navigation.finish),s.handleCancel(a)}}}),define("models/AppDeleteEventModel",["require"],function(e){return{fromWorkflowEvent:function(e,t){var n,r,i,s,o,u,a;return a=t&&t.expectedAsin,n=e.extras,n.occasion?(r=n.occasion.domain,r!=="Action"&&r!=="Workflow"?null:(i=n.info.type,i!=="delete"?null:(u=n.context["AppDelete.Asin"],a&&a!==u?(console.log("asin: "+u+" did not match expected asin: "+a),null):r!=="Workflow"?null:e.extras.occasion.name==="AfterWorkflow"&&e.extras.complete?{asin:u,done:!0}:null))):(console.log("occasion not defined."),null)}}}),define("controller/MyAppsController",["require","jquery","controller/AppBlockPagerController","handler/MyAppsOneClickButtonHandler","controller/SoftKeysController","models/InstallProgressModel","models/AppBlockModel","models/AppDeleteEventModel","handler/ClickStreamHandler","api/device-features","api/install","api/locker","api/navigation","api/recorder","api/resources","templates"],function(e){var t=e("jquery"),n=e("controller/AppBlockPagerController"),r=e("handler/MyAppsOneClickButtonHandler"),i=e("controller/SoftKeysController"),s=e("models/InstallProgressModel"),o=e("models/AppBlockModel"),u=e("models/AppDeleteEventModel"),a=e("handler/ClickStreamHandler"),f=e("api/device-features"),l=e("api/install"),c=e("api/locker"),h=e("api/navigation"),p=e("api/recorder"),d=e("api/resources"),v,m,g=p.Metrics.recordEvent,y=e("templates");return m=["com.amazon.mas.client.framework.UpdateServiceNEW_UPDATED_WITH_PERMISSIONS_APP_EXTRA","com.amazon.mas.client.framework.UpdateServiceNEW_FLAGGED_APPS_EXTRA","com.amazon.mas.client.framework.UpdateServiceNEW_APPS_EXTRA","com.amazon.mas.client.framework.UpdateServiceREMOVED_APPS_EXTRA","com.amazon.mas.client.framework.UpdateServiceNEW_UPDATED_APPS_EXTRA"],v={myapps:{init:"Appstore.Recorder.Metrics.Event.MyApps.Load.Initiated",done:"Appstore.Recorder.Metrics.Event.MyApps.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.MyApps.Load.Failure"},page:{init:"Appstore.Recorder.Metrics.Event.MyApps.Page.Initiated",done:"Appstore.Recorder.Metrics.Event.MyApps.Page.Completed",fail:"Appstore.Recorder.Metrics.Event.MyApps.Page.Failure",cancel:"Appstore.Recorder.Metrics.Event.MyApps.Page.Cancel"},refresh:{init:"Appstore.Recorder.Metrics.Event.MyApps.Refresh.Initiated",done:"Appstore.Recorder.Metrics.Event.MyApps.Refresh.Completed",fail:"Appstore.Recorder.Metrics.Event.MyApps.Refresh.Failure",cancel:"Appstore.Recorder.Metrics.Events.MyApps.Refresh.Cancel"},tab:{device:"Appstore.Metrics.MyApps.Device.Selected",cloud:"Appstore.Metrics.MyApps.Cloud.Selected",update:"Appstore.Metrics.MyApps.Update.Selected"},updateAll:{selected:"Appstore.Metrics.MyApps.UpdateAll.Selected"}},function(o){function L(e,t){var n,r=[],i,s,u,a;w=E.getApps();if(e.keyword){u=e.keyword.split(/\s+/);for(i=0,s=u.length;i<s;i+=1)u[i]&&r.push({name:"app_name_filter",keyword:u[i]})}b===undefined&&h.getExtras().tab!==undefined&&(a=parseInt(h.getExtras().tab,10),b=["deviceTab","cloudTab","updateTab"][a],o.getNavigationBarView().setSelected(a));switch(b){case"deviceTab":r.push({name:"app_is_installed_filter"}),w=w.refineQuery([{name:"app_sort_pronunciation_asc"}],r);break;case"cloudTab":r.push({name:"app_all_available_filter"}),w=w.refineQuery([{name:"app_sort_pronunciation_asc"}],r);break;case"updateTab":n=c.Utils.getUpdateFilter(),n.done(function(e){r.push({name:e}),w=w.refineQuery([{name:"app_sort_pronunciation_asc"}],r),t(w)}).fail(function(e){r.push({name:e}),w=w.refineQuery([{name:"app_sort_pronunciation_asc"}],r),t(w)});return;default:b="deviceTab",r.push({name:"app_is_installed_filter"}),w=w.refineQuery([{name:"app_sort_pronunciation_asc"}],r)}t(w)}function A(e,n){L({keyword:e},function(e){var r;n||(n=function(e){m.setData(e),t(S).one("page.completed",function(){o.getMyAppsListTarget().show()})}),r=function(e){},e.execute(n,r)})}function O(e){A(null,e)}function M(){o.getLoadingIndicator().hide(),(!f.getValueOf(f.Keys.BACKGROUND_INSTALL)||!b||b!=="updateTab")&&o.getRefreshTarget().show()}function _(){o.getLoadingIndicator().show(),o.getRefreshTarget().hide(),window.setTimeout(function(){console.log("Failed to load apps"),M()},3e4)}function D(e){g(v.refresh.init),E.refresh(),N=!0,_()}function P(e){g(v.updateAll.selected),l.updateAllApps()}function H(e){var t=s.fromWorkflowEvent(e),n=s.getAsinFromWorkflowEvent(e);if(t){m.updateItemFromWorkflow(n,{installDetails:t});return}t=u.fromWorkflowEvent(e),t&&t.done&&m.removeItem(t.asin)}function B(e){s.fromLocalState(e.extras).done(function(t){m.updateItemFromWorkflow(e.extras.asin,t)})}function j(e){A(e)}function F(){O()}function I(e){var t=!1;switch(e){case"deviceTab":case"cloudTab":case"updateTab":t=!0;break;default:}return t}function q(e,n){var r=b;I(n)?(b=n,o.unselectActiveTab(r),console.log("unselect previousTabTarget='"+r+"'"),console.log("received valid navigation navTab='"+n+"'")):console.log("received invalid navigation navTab='"+n+"'"),console.log("refresh page for tabTarget='"+b+"'"),o.selectActiveTab(b),o.getLoadingIndicator().show(),o.getMyAppsListTarget().hide(),o.getTotalCountTarget().hide();switch(b){case"deviceTab":g(v.tab.device),t(o.getUpdateAllTarget()).hide(),t(o.getRefreshTarget()).show();break;case"cloudTab":g(v.tab.cloud),t(o.getUpdateAllTarget()).hide(),t(o.getRefreshTarget()).show();break;case"updateTab":g(v.tab.update),f.getValueOf(f.Keys.BACKGROUND_INSTALL)?(t(o.getUpdateAllTarget()).show(),t(o.getRefreshTarget()).hide()):(t(o.getUpdateAllTarget()).hide(),t(o.getRefreshTarget()).show());break;default:console.log("default case, tabTarget='"+b+"'")}console.log("refreshing page with tabTarget='"+b+"'"),C=!0,k=!0,F()}function R(e){var t=e.extras;N&&(t?g(v.refresh.done):g(v.refresh.fail),N=!1),F(),M()}var p,m,b,w,E,S,x,T,N,C=!0,k=!0;g(v.myapps.init),E=c.Instance,o.render(),S=o.getMyAppsListTarget(),x=new i(o,"MyApps"),h.getExtras("refMarker","page").done(function(e,t){var n=new a(t);e&&n.record(e)}),T=[new r({removeTarget:o.getRemoveDialogTarget()})],m=new n(S,{Handlers:T,template:y.MyAppInfoBlock}),t(o).on("tabSelected",q),t(o).on("refresh",D),t(o).on("updateAll",P),t.subscribe("com.amazon.mas.client.framework.UpdateService.updated",R),t.subscribe("com.amazon.venezia.android_lifecycle.onResume",function(){F()}),t.subscribe("com.amazon.venezia.android_lifecycle.onPause",function(){N&&(g(v.refresh.cancel),g(v.page.cancel),M())}),t.subscribe("com.amazon.mas.client.MACS_PDI_CHANGE",H),t.subscribe("com.amazon.locker.APP_LOCAL_STATE_UPDATED",B),t.subscribe("com.amazon.venezia.doSearch",j),t(S).on("page.totalCount",function(e,n){var r,i=!1;switch(b){case"deviceTab":r=d.getQuantityString("my_apps_device",n,[n]),i=!1;break;case"cloudTab":r=d.getQuantityString("my_apps_cloud",n,[n]),i=!1;break;case"updateTab":r=d.getQuantityString("my_apps_update",n,[n]),i=!0;break;default:r=d.getQuantityString("my_apps_device",n,[n])}t(o.getTotalCountTarget()).text(r),o.getTotalCountTarget().show()}),t(S).on("page.initiated",function(){g(v.page.init)}),t(S).on("page.completed",function(){g(v.page.done),C&&(g(v.myapps.done),M(),C=!1)}),t(S).on("page.failure",function(){g(v.page.fail),C&&(g(v.myapps.fail),M(),C=!1)})}}),define("views/NavigationBarView",["jquery"],function(e){var t,n=function(n){return function(i){var s=i.target;return s.parentElement.id!==n[0].id&&t!==s&&s.parentElement.id&&(t&&e(t).removeClass("active"),t=s,e(s).addClass("active"),e(n).trigger("tabSelected",[s.parentElement.id])),!1}};return function(i){var s,o,u,a;this.clearSelected=function(){for(s=0;s<u.length;s+=1)e(u[s]).hasClass("active")&&(e(u[s]).removeClass("active"),t=null)},this.setSelected=function(n){this.clearSelected(),e(u[n]).addClass("active"),t=u[n]},u=i.find("span");for(s=0;s<u.length;s+=1)e(u[s]).hasClass("active")&&(t=u[s]);i.on("tap",n(i))}}),define("views/MyAppsView",["jquery","templates","views/NavigationBarView"],function(e,t,n){return function(r){function s(t){return e(i).trigger("refresh"),!1}function o(t){return e(i).trigger("updateAll"),!1}function u(t,n){return e(i).trigger(t,n),!1}var i=this;this.render=function(){function c(){setTimeout(function(){f[0].scrollWidth<=document.body.clientWidth?f.addClass("centered"):f.removeClass("centered")},500)}var t,a,f,l;f=r.find('[data-class="my-apps-page-navigation-list"]'),t=new n(f),i.navView=t,a=r.find('[data-class="my-apps-refresh-button"]'),a.on("tap",s),l=r.find('[data-class="my-apps-update-button"]'),l.on("tap",o),f.on("tabSelected",u),c(),e.subscribe("com.amazon.venezia.android_lifecycle.onConfigChange",c)},this.getNavigationBarView=function(){return this.navView},this.getMyAppsListTarget=function(){return r.find('[data-class="my-apps-list"]')},this.getLoadingIndicator=function(){return r.find('[data-class="my-apps-loading-indicator"]')},this.getTotalCountTarget=function(){return r.find('[data-class="my-apps-count"]')},this.getRemoveDialogTarget=function(){return r.find("#myapps-remove-popover")},this.getUpdateAllTarget=function(){return r.find('[data-class="my-apps-update-button"]')},this.getRefreshTarget=function(){return r.find('[data-class="my-apps-refresh-button"]')},this.selectActiveTab=function(t){e("#"+t+" span:first-child").addClass("active")},this.unselectActiveTab=function(t){e("#"+t+" span:first-child").removeClass("active")}}}),define("controller/NativeDialogController",["require","jquery","api/navigation","api/recorder","templates","controller/DialogController","views/DialogView","controller/DetailController"],function(e){var t=e("jquery"),n=e("api/navigation"),r=e("api/recorder"),i=r.Java.getLogger("HTML5.NativeDialogController"),s=e("templates"),o=e("controller/DialogController"),u=e("views/DialogView"),a=e("controller/DetailController");return function(r){var f,l,c,h,p,d;r.render(),f=n.getExtras(),l=f.dialogType,i.log("dialogType: "+l),l==="SaveForLaterDialog"?(c={renderTarget:r.getContentTarget(),template:s.SaveForLaterDialog,getDataFn:function(){return t("#saved-show-checkbox").is(":checked")}},h={yesFn:a.onViewSaveForLaterList,noFn:a.onCloseSavedDialog,dismissFn:n.finish},p=new u(c),d=new o(p,h),d.render()):l==="Dialog"?(h={dismissFn:n.finish,title:f.title,message:f.message,noButton:f.noButton,yesButton:f.yesButton},h.noFn=function(e){n.setResult({action:"no/ok"})},h.yesFn=function(e){n.setResult({action:"yes"})},p=new u({template:s[l]}),d=new o(p,h),d.render(h)):l==="FulfillmentErrorDialog"&&(h={dismissFn:n.finish,title:f.title,message:f.message,negButton:f.negButton,posButton:f.posButton},h.noFn=function(e){n.setResult({action:"no"})},h.yesFn=function(e){n.setResult({action:"yes"})},p=new u({renderTarget:r.getContentTarget(),template:s.FulfillmentErrorDialog}),d=new o(p,h),d.render(h))}}),define("views/NativeDialogView",["require"],function(e){return function(t){this.render=function(){},this.getContentTarget=function(){return t}}}),define("controller/AppBlockListController",["require","jquery","render/AppBlockRender","views/ListView","api/locker","models/AppBlockModel","models/InstallProgressModel","coll/MappedItemCollection","handler/OneClickButtonHandler","util/AppInfoBlockUtil","api/recorder","templates"],function(t){var n=t("jquery"),r=t("render/AppBlockRender"),i=t("views/ListView"),s=t("api/locker"),o=t("models/AppBlockModel"),u=t("models/InstallProgressModel"),a=t("coll/MappedItemCollection"),f=t("handler/OneClickButtonHandler"),l=t("util/AppInfoBlockUtil"),c=t("api/recorder"),h=c.Java.getLogger("HTML.AppBlockListController"),p=t("templates");return function(t,c,d,v,m){function C(e,t){var r=b.get(e),i,s,u;r&&t&&(i=new o(n.extend({},r,t)),s=i.title||i.applicationName||i.displayTitle,u=b.getIndexOf(e),h.info("Trying to Update InstallDetails of app: "+s+" at Index: "+u),u!==undefined&&u>=0&&b.replaceInMap(u,i,l.showChange))}function k(e){var t=u.fromWorkflowEvent(e),n=u.getAsinFromWorkflowEvent(e);h.log("workflowEventReceived: "+n),t&&n&&C(n,{installDetails:t})}function L(e){var t,n,r,i;if(!e||!e.extras)return;t=e.extras.asin,h.log("localStateHandler asin: "+t),n=b.get(t),n&&(i=u.fromLocalState(e.extras,n.installDetails),i&&i.done(function(e){C(t,e)}))}var g,y,b,w,E,S,x,T,N;S=s.Instance,b=new a("asin"),g=function(e,t){var r,i,s,o,u,a,f,l,c,h;if(!e)return;c=t||d;if(!e[c])return;r=e[c],n.isArray(r)||(r=[r]),o=[],l=[],s=r.length,v&&v<s&&(s=v),o=r.slice(0,s),h=n.map(o,function(e){return e.asin}),f=S.getLocalDetailsByAsins(h),f.done(y(o)),n.when(f).done(function(){b.mapAll(o)})},y=function(e){return function(t){var n,r,i,s;t!==undefined&&h.log("localDetails: "+JSON.stringify(t));for(n=0,r=e.length;n<r;n+=1){i=e[n],t&&t[i.asin]&&(i.local=t[i.asin]);if(i.title.length>15){s=i.title.indexOf(" ");if(s<0||s>15)i.title=i.title.substring(0,10)+"-"+i.title.substring(10)}h.log("attachLocalDetails Creating AppBlockModel for: "+i.title),e[n]=new o(i)}}},this.updateLocalDetails=function(){h.log("updateLocalDetails"),b.map(function(e,t){var n=S.getLocalDetailsByAsin(e.asin);return n.done(function(n){var r=!0;r&&(n.length>0&&(e.local=n[0]),h.info("Updating model for app: "+e.title||e.applicationName||e.displayTitle),e=new o(e),b.replaceInMap(t,e,l.showChange))}),e})},m?w=new i(t,b,new r("li",p.DealsCarouselAppInfoBlock)):w=new i(t,b,new r("li",p.AppInfoBlockList)),x=new f,T=Object.keys(x),n.map(T,function(e,t){n(w).on(e,x[e])}),c.then(g),m&&(n.subscribe("com.amazon.mas.client.MACS_PDI_CHANGE",n.proxy(k,this)),n.subscribe("com.amazon.locker.APP_LOCAL_STATE_UPDATED",L))}}),define("controller/AppListController",["require","jquery","controller/AppBlockListController","controller/SoftKeysController"],function(t){var n=t("jquery"),r=t("controller/AppBlockListController"),i=t("controller/SoftKeysController");return function(t,n,s){var o,u;t.render(),o=new i(t),u=new r(t.getTarget(),n,s)}}),define("controller/NewForYouAllController",["require","jquery","api/catalog","handler/ClickStreamHandler","controller/AppListController","api/recorder","api/navigation","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("api/catalog"),i=t("handler/ClickStreamHandler"),s=t("controller/AppListController"),o=t("api/recorder"),u=o.Java.getLogger("HTML5.SearchController"),a=t("api/navigation"),f=t("zeroes/ZeroesLoader");return function(t){var n,o,l="NewForYouAll",c=new i(l);n=r.getNewForYouApps(),o=new s(t,n,"recommendationAsins"),a.getExtras("refMarker").done(function(e){u.log("ClickStream-UI-NewForYouAllController: refMarker = "+e),c.recordView("/ny",e),c.record(e)}).fail(function(e){u.log("ClickStream-UI-NewForYouAllController: failed to get refMarker; eror = "+JSON.stringify(e))}),f.initializeAsync(f.STORE_CONFIG_TYPES.Generic)}}),define("views/AppListView",["jquery"],function(e){return function(t){this.render=function(e){},this.getTarget=function(){return t.find('[data-class="apps-list"]')}}}),define("views/NewForYouAllView",["views/AppListView"],function(e){return function(n){return new e(n)}}),define("controller/NewReleasesController",["require","jquery","appstore","controller/AppBlockPagerController","controller/SoftKeysController","handler/ClickStreamHandler","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("appstore"),i=t("controller/AppBlockPagerController"),s=t("controller/SoftKeysController"),o=t("handler/ClickStreamHandler"),u=r.Recorder.Java.getLogger("HTML5.NewReleasesController"),a=t("zeroes/ZeroesLoader");return function(t){var f,l,c,h="NewReleases",p=new o(h);t.render(),r.Navigation.getExtras("refMarker").done(function(e){u.log("ClickStream-UI-NewReleasesController: refMarker = "+e),p.recordView("/nr",e),p.record(e)}).fail(function(e){u.log("ClickStream-UI-NewReleasesController: failed to get refMarker; eror = "+JSON.stringify(e))}),f=new s(t),n(t.getNewReleasesTarget()).on("page.completed",function(){r.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.NewReleases.Load.Completed"),n(t.getNewReleasesTarget()).off("page.completed")}),n(t.getNewReleasesTarget()).on("page.failure",function(){r.Recorder.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.NewReleases.Load.Failure"),n(t.getNewReleasesTarget()).off("page.failure")}),c=new i(t.getNewReleasesTarget(),{pagerKey:"apps"}),l=r.Catalog.getRankedApps(r.Catalog.RANK_TYPE_NEW_RELEASES),l.done(function(e){console.log("NewReleases debug: "+JSON.stringify(e)),c.setData(e),a.initializeAsync(a.STORE_CONFIG_TYPES.Generic)})}}),define("views/NewReleasesView",["jquery","templates"],function(e,t){return function(t){this.render=function(e){},this.getNewReleasesTarget=function(){return t.find('[data-class="new-releases-apps-list"]')}}}),define("controller/PasswordChallengeDialogController",["require","jquery","api/navigation","api/authentication"],function(t){var n=t("jquery"),r=t("api/navigation"),i=t("api/authentication");return function(t){function l(e){r.setResult({isValidated:e}),t.dismissDialog()}var s,o=null,u=null,a,f;u=r.getExtras("isIAP","showIAPNotice"),console.log("PasswordChallengeDialogController"),u.done(function(){var e=n.makeArray(arguments),r={};2<=e.length&&(r.isIAP=e[0],r.showIAPNotice=e[1]),t.render(r)}),s=function(e,n){o===null&&(o=i.authenticate(n),o.done(function(){l(!0)}).fail(function(){t.indicatePasswordInvalid()}).always(function(){o=null}))},a=function(){t.clearPassword(),l(!1)},n(t).on({validate:s,cancel:a})}}),define("views/PasswordChallengeDialogView",["require","jquery","templates","views/DialogView","api/navigation","api/resources","api/parental-controls"],function(t){var n=t("jquery"),r=t("templates"),i=t("views/DialogView"),s=t("api/navigation"),o=t("api/resources"),u=t("api/parental-controls");return function(t){var a,f,l,c,h,p,d,v,m=this;a=function(){return console.log("submitted... validating."),c.blur(),n(m).trigger("validate",c.val()),!1},this.clearPassword=function(){c.val("")},l=function(e){return e.preventDefault(),s.openInBrowser(o.getString("forgot_password_url")),m.dismissDialog(),!1},f=function(e){return e.preventDefault(),u.navigateToParentalControlsSettings(),m.dismissDialog(),!1},p=function(){h.css("display","block"),c.val(""),c.on("keypress",d)},d=function(){h.hide(),h.off("keypress")},this.dismissDialog=function(e){console.log("dismissing dialog"),s.finish()},this.indicatePasswordInvalid=function(){p()},this.render=function(e){t.empty(),v=n(r.PasswordChallengeDialog.render(e)),t.append(v),console.log("PasswordChallengeDialogView In render"),c=n("#password"),n("#password-form-continue").on("tap",a),c.keypress(function(e){e.keyCode===13&&setTimeout(function(){a()},0)}),h=n('[data-class="invalid-password-notification"]'),n("#close").on("tap",function(){n(m).trigger("cancel")}),n("#parental-controls").on("tap",f),n("#forgot-password").on("tap",l),i.handleCancel(m)}}}),define("controller/PinChallengeDialogController",["require","jquery","appstore"],function(t){var n=t("jquery"),r=t("appstore"),i=r.Recorder.Java.getLogger("HTML5.PinChallengeDialogController");return function(t){function f(e){r.Navigation.setResult({isValidated:e}),t.dismissDialog()}function l(){i.log("forgotPin"),r.Navigation.showDialog("PasswordChallengeDialog",{},function(e){i.log("callback from PasswordChallengeDialog"),e!==undefined?f(e.isValidated):(i.log("There is no result here."),f(!1))})}var s,o,u,a;s=r.Navigation.getExtras(),i.log("PinChallengeDialogController"),t.render(s),r.Settings.get(r.Settings.keys.PinValueKey).done(function(e){o=e.value}).fail(function(e){i.log("PinChallengeDialogController - failed to get pin settings. Error = "+e),f(!1)}),u=function(e,n){o===n?f(!0):t.indicatePinInvalid()},a=function(){t.clearPinDigits(),f(!1)},n(t).on({validate:u,cancel:a,forgotPin:l})}}),define("views/PinChallengeDialogView",["jquery","templates","appstore","views/DialogView"],function(e,t,n,r){return function(s){var o,u,a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T=this;o=function(){c.val(""),h.val(""),p.val(""),d.val("")},u=function(){return e(T).trigger("forgotPin"),!1},a=function(){S=c.val()+h.val()+p.val()+d.val(),e(T).trigger("validate",S)},v=function(){f.show(),o(),c.on("keypress",m)},m=function(){f.hide(),c.off("keypress")},y=function(e){l.show(),e.val("")},b=function(){l.hide()},g=function(t,n,r,i){n.val(String.fromCharCode(t.keyCode)),e.isNumeric(n.val())?i?(b(),a()):(r.focus(),b()):y(n)},this.dismissDialog=function(e){n.Navigation.finish()},this.indicatePinInvalid=function(){v(),c.focus()},this.render=function(i){i.onPinEntry=!0,i.useInputTypeNumber=n.DeviceFeatures.isNumericKeypadSupported(),i.pinChallengeDialogTitle=i.pinChallengeDialogTitle||n.Resources.getString("PinChallengeDialog_ModifyParentalControls"),i.pinFormLabel=i.pinFormLabel||n.Resources.getString("settings_pin_enter_existing"),s.empty(),E=e(t.PinChallengeDialog.render(i)),s.append(E),f=e('[data-class="pin-form-invalid-pin-notification"]'),l=e('[data-class="pin-form-invalid-input-notification"]'),c=e("#first-pin-digit"),h=e("#second-pin-digit"),p=e("#third-pin-digit"),d=e("#fourth-pin-digit"),c.on("keyup",function(e){g(e,c,h,!1)}),h.on("keyup",function(e){g(e,h,p,!1)}),p.on("keyup",function(e){g(e,p,d,!1)}),d.on("keyup",function(e){g(e,d,null,!0)}),c.focus(),e("#pin-form-forgot-pin").on("tap",u),e("#pin-form-cancel").on("tap",function(){e(T).trigger("cancel")}),r.handleCancel(T)},this.clearPinDigits=function(){o()}}}),define("controller/PinChangeDialogController",["require","jquery","appstore"],function(t){var n=t("jquery"),r=t("appstore"),i=r.Recorder.Java.getLogger("HTML5.PinChangeDialogController");return function(t){function f(e){r.Navigation.setResult({isValidated:e}),t.dismissDialog()}function l(){i.log("pinset successful")}function c(e){i.warning("PINSET Failed: "+e),f(!1)}function h(e){r.Settings.set(r.Settings.keys.PinValueKey,e,l,c),r.Navigation.setResult({isValidated:!0}),t.render({onConfirmation:!0})}var s,o,u,a;t.render({pinFormLabel:r.Resources.getString("settings_pin_enter_new"),hideForgotPin:!0}),s=function(e,n){a?n===a?h(n):(a=null,t.render({pinFormLabel:r.Resources.getString("settings_pin_enter_new"),hideForgotPin:!0}),t.indicatePinInvalid()):(a=n,t.render({pinFormLabel:r.Resources.getString("settings_pin_reenter"),hideForgotPin:!0}))},o=function(){t.clearPinDigits(),f(!1)},u=function(){f(!0)},n(t).on({validate:s,cancel:o,pinDialogConfirmed:u})}}),define("views/PinChangeDialogView",["jquery","templates","appstore","views/DialogView"],function(e,t,n,r){return function(s){var o,u,a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T,N=this;o=function(){h.val(""),p.val(""),d.val(""),v.val("")},u=function(){e(N).trigger("pinDialogConfirmed")},a=function(){return e(N).trigger("forgotPin"),!1},f=function(){x=h.val()+p.val()+d.val()+v.val(),e(N).trigger("validate",x)},m=function(){l.show(),o(),h.on("keypress",g)},g=function(){l.hide(),h.off("keypress")},b=function(e){c.show(),e.val("")},w=function(){c.hide()},y=function(t,n,r,i){n.val(String.fromCharCode(t.keyCode)),e.isNumeric(n.val())?i?(w(),f()):(r.focus(),w()):b(n)},this.dismissDialog=function(e){n.Navigation.finish()},this.indicatePinInvalid=function(){m(),h.focus()},this.render=function(i){i.onConfirmation!==!0&&(i.onPinEntry=!0),i.useInputTypeNumber=n.DeviceFeatures.isNumericKeypadSupported(),i.pinChallengeDialogTitle=i.pinChallengeDialogTitle||n.Resources.getString("PinChallengeDialog_ModifyParentalControls"),i.pinFormLabel=i.pinFormLabel||n.Resources.getString("settings_pin_enter_existing"),s.empty(),S=e(t.PinChallengeDialog.render(i)),s.append(S),l=e('[data-class="pin-form-invalid-pin-notification"]'),c=e('[data-class="pin-form-invalid-input-notification"]'),h=e("#first-pin-digit"),p=e("#second-pin-digit"),d=e("#third-pin-digit"),v=e("#fourth-pin-digit"),h.on("keyup",function(e){y(e,h,p,!1)}),p.on("keyup",function(e){y(e,p,d,!1)}),d.on("keyup",function(e){y(e,d,v,!1)}),v.on("keyup",function(e){y(e,v,null,!0)}),h.focus(),e("#pin-form-forgot-pin").on("tap",a),e("#ok-button").on("tap",u),e("#pin-form-cancel").on("tap",function(){e(N).trigger("cancel")}),r.handleCancel(N)},this.clearPinDigits=function(){o()}}}),define("controller/RecentlyViewedController",["require","jquery","api/recently-viewed","api/navigation","controller/SoftKeysController","handler/ClickStreamHandler","controller/AppBlockListController","zeroes/ZeroesLoader"],function(t){function f(e){function t(t){return n.isEmptyObject(t)&&e.showNoAppsMessage(),{recentlyViewed:t}}return function(){var i=r.get().pipe(t),s=e.getAppsListTarget();return s.on("page.empty",n.proxy(e.showNoAppsMessage,e)),new u(s,i,"recentlyViewed")}}var n=t("jquery"),r=t("api/recently-viewed"),i=t("api/navigation"),s=t("controller/SoftKeysController"),o=t("handler/ClickStreamHandler"),u=t("controller/AppBlockListController"),a=t("zeroes/ZeroesLoader");return function(t){var r=new s(t,"RecentlyViewed"),u=f(t);t.render(),n.subscribe("com.amazon.venezia.android_lifecycle.onResume",u),i.getExtras("refMarker","page").done(function(e,t){var n=new o(t);e&&n.record(e),a.initializeAsync(a.STORE_CONFIG_TYPES.Generic)})}}),define("views/RecentlyViewedView",["require","jquery","templates"],function(t){var n=t("jquery"),r=t("templates");return function(t){this.render=function(e){},this.getAppsListTarget=function(){return t.find("#recently-viewed-asin-list")},this.showNoAppsMessage=function(){n('[data-class="recently-viewed-no-results-content-block"]').show(),n("#recently-viewed-asin-list").hide()}}}),define("controller/RecommendedForYouAllController",["require","jquery","api/catalog","handler/ClickStreamHandler","controller/AppListController","api/recorder","api/navigation","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("api/catalog"),i=t("handler/ClickStreamHandler"),s=t("controller/AppListController"),o=t("api/recorder"),u=o.Java.getLogger("HTML5.SearchController"),a=t("api/navigation"),f=t("zeroes/ZeroesLoader");return function(t){var n,o,l="RecommendedForYouAll",c=new i(l);n=r.getRecommendedForYouApps(),o=new s(t,n,"recommendationAsins"),a.getExtras("refMarker").done(function(e){u.log("ClickStream-UI-RecommendedForYouAllController: refMarker = "+e),c.recordView("/ry",e),c.record(e)}).fail(function(e){u.log("ClickStream-UI-RecommendedForYouAllController: failed to get refMarker; eror = "+JSON.stringify(e))}),n.done(function(){f.initializeAsync(f.STORE_CONFIG_TYPES.Generic)})}}),define("views/RecommendedForYouAllView",["views/AppListView"],function(e){return function(n){return new e(n)}}),define("controller/ReportIssueContentController",["require","jquery","api/feedback","api/navigation","api/resources","widget/Dialog"],function(t){var n=t("jquery"),r=t("api/feedback"),i=t("api/navigation"),s=t("api/resources"),o=t("widget/Dialog");return function(t,u){function a(){i.finish()}function f(e,t){var n;t=t.replace(/(<br>|<br\/>|<\/li>)/g,"\n"),t=t.replace(/<li>/g,"\n*"),t=t.replace(/<ul>|<\/ul>/g,""),n=i.Android.getEmailIntentAndExtras(t),i.Android.startActivity(n.intent,n.extras,t)}function l(e){e.result==="OK"?(i.showToast(s.getString("Toast_Issue_Submitted")),i.finish()):o.showNative({title:"AlertDialog_title_ReportIssueError",text:"AlertDialog_message_ReportIssueError",button:"AlertDialog_button_ReportIssueError"})}function c(){var e={};e.type=t.getIssueType(),e.text="ASIN: "+u+". "+t.getIssueDescription(),e.type.length<1?o.showNative({title:"AlertDialog_title_ReportIssueInsuficientError",text:"AlertDialog_message_ReportIssueInsuficientError",button:"AlertDialog_button_ReportIssueInsuficientError"}):r.submit(e).done(l)}function h(e,t){i.openInBrowser(t)}t.render(),n(t).on("cancelReport",a),n(t).on("submitReport",c),n(t).on("sendEmail",f),n(t).on("linkClicked",h)}}),define("views/ReportIssueContentView",["require","jquery","api/navigation","api/recorder","templates"],function(t){var n=t("jquery"),r=t("api/navigation"),i=t("api/recorder"),s=i.Java.getLogger("HTML5.ReportIssueContentView"),o=t("templates"),u=0;return function(t,i){function l(){return n(f).trigger("cancelReport"),!1}function c(){return n(".checkbox-list input:checkbox:checked").length===0&&n("input:checkbox[value='Other']").prop("checked",!0),n(f).trigger("submitReport"),!1}function h(e){var t=n("#issue-description").val().trim().length,r=n("#submit-report");t>u?r.removeAttr("disabled"):r.attr("disabled","disabled")}function p(){return n(f).trigger("sendEmail",n('[data-class="copyright-note"]').html()),!1}function d(e){e?a.find("#send-email").removeAttr("disabled"):a.find("#send-email").attr("disabled","disabled")}function v(e){s.severe("activityExistsForIntent call (email) failed; error.type = "+e.type+", error.reason = "+e.reason)}var a,f=this;this.render=function(){var e;if(!i)return;i==="APP_QUALITY"?(a=n(o.ReportAppQualityContent.render()),t.replaceWith(a),n("#issue-description").on("keyup",h),n("#submit-report").on("tap",c),n("#cancel-report").on("tap",l)):i==="INAPPROP_CONTENT"?(a=n(o.ReportInappropContent.render()),t.replaceWith(a),n("#issue-description").on("keyup",h),n("#submit-report").on("tap",c),n("#cancel-report").on("tap",l)):i==="COPYRIGHT"&&(a=n(o.ReportCopyrightContent.render()),t.replaceWith(a),e=r.Android.getEmailIntentAndExtras(""),r.Android.activityExistsForIntent(e.intent,e.extras,"",e.unwanted,d,v),n("#send-email").on("tap",p),n("#cancel-report").on("tap",l)),n("a").on("tap",function(e){return n(f).trigger("linkClicked",e.target.href),!1}),n("a").on("click",function(){return!1})},this.getIssueDescription=function(){return n("#issue-description").val()},this.getIssueType=function(){return n("input[name=report-checkbox]:checked").map(function(){return this.value}).get().join(",")}}}),define("controller/ReportIssueController",["require","jquery","appstore","models/AppBlockModel","controller/AppBlockController","views/AppBlockView","controller/ReportIssueContentController","views/ReportIssueContentView","controller/SoftKeysController"],function(t){var n=t("jquery"),r=t("appstore"),i=t("models/AppBlockModel"),s=t("controller/AppBlockController"),o=t("views/AppBlockView"),u=t("controller/ReportIssueContentController"),a=t("views/ReportIssueContentView"),f=t("controller/SoftKeysController"),l=!1;return function(t){function v(e){e.asin=c,e=new i(e),e.installDetails=l,h.render(e),t.render()}var s,c,h,p,d;t.render(),s=new f(t),r.Navigation.getExtras("asin","issueType").done(function(e,i){c=e,h=new o(t.getHeaderTarget()),p=new a(t.getContentTarget(),i),d=new u(p,c),r.Catalog.getAppDetailsByAsin(c,n.proxy(v,this))})}}),define("views/ReportIssueView",["require","jquery","templates"],function(t){var n=t("jquery"),r=t("templates");return function(t){this.render=function(){},this.getHeaderTarget=function(){return t.find('[data-class="report-issue-app-header"]')},this.getContentTarget=function(){return t.find('[data-class="report-issue-content"]')}}}),define("controller/ReportIssueDialogController",["require","jquery","appstore"],function(e){function s(e,t){return r.log("onReportIssue: "+t),t==="CUSTOMER_CARE"?n.Navigation.navigate("CustomerCare"):n.Navigation.navigate("ReportIssue",{asin:i,issueType:t}),n.Navigation.finish(),!1}var t=e("jquery"),n=e("appstore"),r=n.Recorder.Java.getLogger("HTML5.ReportIssueDialogController"),i;return function(r){var o=n.Navigation.getExtras();i=o.asin,r.render(),t(r).on("onReportIssue",s),t(r).on("cancel",n.Navigation.finish)}}),define("views/ReportIssueDialogView",["require","jquery","templates","views/DialogView"],function(t){var n=t("jquery"),r=t("templates"),i=t("views/DialogView");return function(t){function u(e){return n(o).trigger("onReportIssue",[e.data.issueType]),!1}var s,o=this;this.render=function(){t.empty(),s=n(r.ReportIssueDialog.render()),t.append(s),s.find("#report-app-quality").on("tap",{issueType:"APP_QUALITY"},u),s.find("#report-content").on("tap",{issueType:"INAPPROP_CONTENT"},u),s.find("#report-copyright").on("tap",{issueType:"COPYRIGHT"},u),s.find("#customer-care").on("tap",{issueType:"CUSTOMER_CARE"},u),i.handleCancel(o)}}}),define("controller/ReviewListSortDialogController",["require","jquery","api/navigation"],function(e){var t=e("jquery"),n=e("api/navigation");return function(r){function i(e,t,r){var i={sortType:t,buttonText:r};return n.setResult(i),n.finish(),!1}r.render(),t(r).on("sortType",i),t(r).on("cancel",n.finish)}}),define("views/ReviewListSortDialogView",["require","jquery","views/DialogView"],function(t){var n=t("jquery"),r=t("views/DialogView");return function(t){var i=this;this.render=function(){n("ul li").on("tap",function(e){var t=n(this).text().trim(),r=n(this).attr("data-class");return n(i).trigger("sortType",[r,t]),!1}),r.handleCancel(i)}}}),define("controller/ReviewsListController",["require","jquery","appstore","templates","models/CustomerReviewModel","controller/SoftKeysController","controller/PagerController"],function(e){var t=e("jquery"),n=e("appstore"),r=e("templates"),i=e("models/CustomerReviewModel"),s=e("controller/SoftKeysController"),o=e("controller/PagerController"),u=n.Recorder.Java.getLogger("HTML5.ReviewsListController");return function(a,f){function v(e,t){var r=n.Review.getReviews(f,e);u.log("onUpdateReviews: "+e+" "+t),a.setSortButtonText(t),c.setData(r)}function m(){n.Navigation.showDialog("ReviewListSortDialog",{},function(e){e.sortType!==undefined&&e.buttonText!==undefined&&v(e.sortType,e.buttonText)})}function g(){n.Navigation.navigate("CreateReview",{asin:f})}function y(e,t,r){n.Review.castVote({reviewID:t,voteValue:r})}function b(e,t){n.Review.reportAbuse(t)}var l,c,h,p,d;h=n.Review.getReviews(f),d=function(){this.renderFn=function(e){var n=t(r.ReviewDetailBlock.render(e));return n}},p={Render:d,template:r.ReviewDetailBlock,mapKey:"reviewID",pagerKey:"reviews",pager:h,Model:i},a.render(),a.bindVotingButtons(),l=new s(a),c=new o(a.getReviewsListTarget(),p),t(a).on({createReview:g,sortClicked:m,castVote:y,reportAbuse:b})}}),define("views/ReviewsListView",["jquery","templates"],function(e,t){return function(r,i){function u(){return e(o).trigger("sortClicked"),!1}function a(){e(".most-helpful-reviews").on("tap",".vote-abuse",function(){var n=e(this).parent().parent(),r=n.data("id");return e(o).trigger("reportAbuse",[r]),n.html(t.ReviewThankYouStripe.render()),!1})}function f(t,n,r){e(".most-helpful-reviews").on("tap",t,function(){var t=e(this).parent().parent(),i=t.data("id");return e(o).trigger("castVote",[i,n]),t.html(r.render({reviewID:i})),!1})}var s,o;o=this,this.render=function(){s||(s=e(t.ReviewsList.render()),r.replaceWith(s),e("#review-summary-create-review-button").on("tap",function(){return e(o).trigger("createReview"),!1}),e("#review-summary-sort-button").on("tap",u))},this.getReviewsListTarget=function(){return s.find("#reviews-review-list")},this.getDialogTarget=function(){return i},this.setSortButtonText=function(t){return e("#review-summary-sort-button").text(t)},this.bindVotingButtons=function(){f(".vote-yes",1,t.ReviewThankYouStripe),f(".vote-no",-1,t.ReviewThankYouAbuseStripe),a()}}}),define("controller/ReviewsController",["require","jquery","appstore","controller/AppBlockController","controller/ReviewsListController","models/AppBlockModel","views/AppBlockView","views/ReviewsListView"],function(t){var n=t("jquery"),r=t("appstore"),i=t("controller/AppBlockController"),s=t("controller/ReviewsListController"),o=t("models/AppBlockModel"),u=t("views/AppBlockView"),a=t("views/ReviewsListView");return function(t){var f,l,c,h,p,d,v;l=function(n,r){n.asin=f,n=new o(n),p.update(n),t.render()},t.render(),f=r.Navigation.getExtras().asin,c=r.Catalog.getAppDetailsByAsin(f,n.proxy(l,this)),h=new u(t.getHeaderTarget()),p=new i(h),d=new a(t.getReviewsListTarget(),t.getDialogTarget()),v=new s(d,f)}}),define("views/ReviewsView",["require","jquery","templates"],function(t){var n=t("jquery"),r=t("templates");return function(t){this.render=function(e){},this.getHeaderTarget=function(){return t.find('[data-class="reviews-app-header"]')},this.getReviewsListTarget=function(){return t.find("#review-summary-block")},this.getDialogTarget=function(){return t.find("#dialog-placeholder")}}}),define("controller/ReviewSubmittedController",["require","jquery","appstore","models/AppBlockModel","controller/AppBlockController","views/AppBlockView","controller/SoftKeysController","controller/AppBlockListController"],function(t){var n=t("jquery"),r=t("appstore"),i=t("models/AppBlockModel"),s=t("controller/AppBlockController"),o=t("views/AppBlockView"),u=t("controller/SoftKeysController"),a=t("controller/AppBlockListController");return function(t){function d(){var e={action:"android.intent.action.VIEW"},t=r.Resources.getString("review_guidelines_url");r.Navigation.Android.startActivity(e,{},t)}function v(e){e.asin=f,e=new i(e),delete e.primaryActionButton,c.update(e)}function m(){var e=r.Catalog.getRecommendedForYouApps();return new a(t.getContentTarget(),e,"recommendationAsins")}var f,l,c,h,p;t.render(),h=new u(t),f=r.Navigation.getExtras().asin,p=r.Catalog.getAppDetailsByAsin(f,n.proxy(v,this)),l=new o(t.getHeaderTarget()),c=new s(l),n(t).on({viewGuidelines:d}),n.subscribe("com.amazon.venezia.android_lifecycle.onResume",m)}}),define("views/ReviewSubmittedView",["require","jquery","templates"],function(t){var n=t("jquery"),r=t("templates");return function(t){function i(){return n(r).trigger("viewGuidelines"),!1}var r=this;this.render=function(){n('[data-class="review-submitted-review-guidelines-button"]').on("tap",i)},this.getHeaderTarget=function(){return t.find('[data-class="review-submitted-app-header"]')},this.getContentTarget=function(){return t.find('[data-class="review-submitted-recommended-for-you-list"]')}}}),define("controller/SavedForLaterController",["require","jquery","api/wishlist","api/navigation","controller/AppBlockPagerController","controller/SoftKeysController","handler/ClickStreamHandler","templates","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("api/wishlist"),i=t("api/navigation"),s=t("controller/AppBlockPagerController"),o=t("controller/SoftKeysController"),u=t("handler/ClickStreamHandler"),a=t("templates"),f=t("zeroes/ZeroesLoader");return function(t){function v(){l=r.list(),l.done(function(t){if(d){c.mergeData(t),d=!0;return}c.setData(t)})}var l,c,h,p,d=!1;t.render(),p=new o(t,"SavedForLater"),h=t.getAppsListTarget(),h.on("page.empty",n.proxy(t.showNoAppsMessage,t)),c=new s(h,{template:a.AppInfoBlockSearchResults}),n.subscribe("com.amazon.venezia.android_lifecycle.onResume",v),i.getExtras("refMarker","page").done(function(e,t){var n=new u(t);e&&n.record(e),f.initializeAsync(f.STORE_CONFIG_TYPES.Generic)})}}),define("views/SavedForLaterView",["require","jquery","templates"],function(t){var n=t("jquery"),r=t("templates");return function(t){this.render=function(e){},this.getAppsListTarget=function(){return t.find('[data-class="saved-for-later-app-list"]')},this.showNoAppsMessage=function(){n('[data-class="saved-for-later-no-results-content-block"]').show(),n('[data-class="saved-for-later-app-list"]').hide()}}}),define("controller/SearchRefineController",["jquery"],function(e){return function(n,r,i){function f(t,n){o=n,s=r.sortsAvailable[o],i(s,e.map(u,function(e){return e||null}))}function l(t,o,f){f==="all"?u[o]=!1:u[o]=r.filtersAvailable[o].values[f],a[o]=f,setTimeout(function(){i(s,e.map(u,function(e){return e||null}))},10),setTimeout(n.dismissDialog,500)}var s,o,u,a;o=0,s=r.sortsAvailable[o],u=[],a=[],e.map(r.filtersAvailable,function(e,t){u[t]=!1,a[t]="all"}),this.toggleDropdown=function(){n.toggleDropdown(r,o,a)},this.dismissDropdown=function(){n.dismissDialog()},e(n).on({refineSort:f,refineFilter:l})}}),define("views/SearchRefineView",["jquery","templates","appstore"],function(e,t,n){return function(i){function c(t){var n=e(t.target).attr("id");setTimeout(function(){e(l).trigger("refineSort",n.slice(n.lastIndexOf("-")+1))}),setTimeout(l.dismissDialog,800)}function h(t){var n,r,i,s;n=e(t.target).attr("id"),s=n.lastIndexOf("-"),i=n.slice(s+1),r=n.slice(n.lastIndexOf("-",s-1)+1,s),setTimeout(function(){e(l).trigger("refineFilter",[r,i])}),setTimeout(l.dismissDialog,500)}function p(r,i,u){var a;u[i]==="all"?a=n.Resources.getString("search_refine_radio_label_show_all"):a=r.values[u[i]].displayName,o.append(t.SearchRefineSection.render({displayName:r.displayName,selectedFilterName:a,name:"outer-search-refine",id:"outer-search-refine-"+i})),s=o.find("#checkbox-list-outer-search-refine-"+i),s.addClass("search-refine-filter-selector"),s.append(t.SearchRefineRadio.render({id:"search-refine-"+i+"-all",name:"search-refine-"+i,displayName:n.Resources.getString("search_refine_radio_label_show_all")})),e.map(r.values,function(e,n){s.append(t.SearchRefineRadio.render({id:"search-refine-"+i+"-"+n,name:"search-refine-"+i,displayName:e.displayName}))})}var s,o,u,a,f=!1,l=this;this.dismissDialog=function(){i.hide(),f=!1,e("body").off("tap")},this.toggleDropdown=function(e,t,n){f?this.dismissDialog():this.render(e,t,n)},this.render=function(r,u,a){i.empty();if(!r){console.log("SearchRefineView.render - no data.");return}if(typeof u=="undefined"){console.log("SearchRefineView.render - no current sort selection.");return}if(!a){console.log("SearchRefineView.render - no current filter selection.");return}i.show(),s=e(t.SearchRefineDialog.render()),i.append(s),o=e("#search-refine-dialog-interior"),o.append(t.SearchRefineSection.render({displayName:n.Resources.getString("search_refine_radio_label_sort"),selectedFilterName:n.Resources.getString("search_refine_radio_label_sort_by_"+r.sortsAvailable[u]),name:"outer-search-refine",id:"outer-search-refine-search-by"})),s=o.find("#checkbox-list-outer-search-refine-search-by"),s.prop("id","search-refine-sort-select"),e.map(r.sortsAvailable,function(e,r){s.append(t.SearchRefineRadio.render({id:"sort-by-"+r,name:"sort-by",displayName:n.Resources.getString("search_refine_radio_label_sort_by_"+e)}))}),e("#sort-by-"+u).prop("checked",!0),e.map(r.filtersAvailable,function(e,t){p(e,t,a)}),e.map(a,function(t,n){e("#search-refine-"+n+"-"+t).prop("checked",!0)}),o.children("label").on("tap",function(e){return!1}),o.children("h3").on("tap",function(t){var n=o.children("h3").not(e(this));return n.removeClass("on"),e(this).toggleClass("on"),!1}),e("#search-refine-sort-select").on("change","input",c),e(".search-refine-filter-selector").on("change","input",h),e("body").on("tap",function(t){var n=e(t.target),r=!1;if(f){while(!n.is("body")){if(n.is(o)){r=!0;break}n=n.parent()}r||l.dismissDialog()}}),f=!0}}}),define("controller/SubcategoryDropdownController",["require","jquery","models/CategoriesModel","api/search","api/recorder"],function(t){var n=t("jquery"),r=t("models/CategoriesModel"),i=t("api/search"),s=t("api/recorder"),o=s.Java.getLogger("HTML5.SubcategoryDropdownController");return function(t,s,u,a){function h(e){l=n.map(e.categories,function(e,t){var i=new r(e);return a&&i.id&&i.id===a&&(c=t),n(f).trigger("subCategoriesDataAvailable"),i}),typeof c=="undefined"&&(c="all")}function p(e,t){t==="all"?u({},s):u(l[t],s),c=t}var f=this,l,c;i.getNavigationCategories(s).done(h).fail(function(e){o.warning("Failed to get subcategories of "+JSON.stringify(s)+"; error = "+JSON.stringify(e)),h({categories:[]})}),this.toggleDropdown=function(){t.toggleDropdown(l,c)},this.dismissDropdown=function(){t.dismissDialog()},n(t).on({refineCategory:p})}}),define("views/SubcategoryDropdownView",["jquery","templates","appstore"],function(e,t,n){return function(i){function f(t){var n=e(t.target).attr("id");return n=n!==undefined?n:e(t.target).find("input").attr("id"),setTimeout(function(){e(a).trigger("refineCategory",n.slice(n.lastIndexOf("-")+1))}),setTimeout(a.dismissDialog,800),!1}var s,o,u=!1,a=this;this.dismissDialog=function(){i.hide(),u=!1,e("body").off("tap.outsideDialog")},this.toggleDropdown=function(e,t){u?this.dismissDialog():this.render(e,t)},this.render=function(r,l){i.empty();if(!r){console.log("SubcategoryDropdownView.render - no subcategories.");return}if(typeof l=="undefined"){console.log("SubcategoryDropdownView.render - no current subcategory selection.");return}i.show(),s=e(t.SubcategoryDropdownDialog.render()),i.append(s),o=e("#search-subcategory-dialog-interior"),s=t.SubcategoryDropdownRadio.render({id:"subcategory-all",name:"subcategory",displayName:n.Resources.getString("search_subcategory_radio_label_all_categories")}),e.map(r,function(e,n){s+=t.SubcategoryDropdownRadio.render({id:"subcategory-"+n,displayName:e.description})}),o.append(s),e("#subcategory-"+l).prop("checked",!0),e("#search-subcategory-dialog-interior").on("tap","li, input",f),e("body").on("tap.outsideDialog",function(t){u&&!e(t.target).parent().is(o)&&a.dismissDialog()}),u=!0}}}),define("controller/SearchController",["require","jquery","api/search","api/navigation","api/catalog","api/device-features","controller/SoftKeysController","widget/SearchResults","models/CategoriesModel","controller/SearchRefineController","views/SearchRefineView","controller/SubcategoryDropdownController","views/SubcategoryDropdownView","widget/Billboard","api/recorder","handler/ClickStreamHandler","api/resources","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("api/search"),i=t("api/navigation"),s=t("api/catalog"),o=t("api/device-features"),u=t("controller/SoftKeysController"),a=t("widget/SearchResults"),f=t("models/CategoriesModel"),l=t("controller/SearchRefineController"),c=t("views/SearchRefineView"),h=t("controller/SubcategoryDropdownController"),p=t("views/SubcategoryDropdownView"),d=t("widget/Billboard"),v=t("api/recorder"),m=t("handler/ClickStreamHandler"),g=t("api/resources"),y=t("zeroes/ZeroesLoader"),b=v.Java.getLogger("HTML5.SearchController");return function(t){function U(){return R&&(_&&_.dismissDropdown(),O&&O.toggleDropdown()),!1}function z(){return O&&O.dismissDropdown(),_&&_.toggleDropdown(),!1}function W(){b.log("orientationChanged"),o.getCurrentScreenOrientation().done(function(e){b.log("orientation: "+e),t.repositionPopovers(e)})}function X(e,r){var i="";e&&n.each(e,function(e,t){i+=t.displayName+P}),i+=g.getString("search_refine_label_sorted_by",[g.getString("search_refine_radio_label_sort_by_"+r)]),t.setSortedBy(i)}function V(){S=r.createQuery(E,k,C,T),k=k||S.sortsAvailable[0],console.log("PAGE: "+F),X(C,k),A?A.update(S):(A=new a(t.getSearchContentTarget(),S,{hostDomNode:n('ul[data-class="search-list"]'),parentPage:F}),A.setup())}function J(e,r,i,s){console.log("refine - sortBy: "+JSON.stringify(e)),console.log("refine - filterBy: "+JSON.stringify(r)),console.log("refine - subcategory: "+JSON.stringify(i)),console.log("refine - parentCat: "+JSON.stringify(s)),k=e,C=r,T=i,t.getNoResultsLabelTarget().empty(),t.getNoResultsLabelContainerTarget().hide(),n(t.getSearchContentTarget()).one("page.empty",function(){B=!0,g.getStrings("search_results_label_no_refine_results").done(function(e){t.getNoResultsLabelTarget().text(e),t.getNoResultsLabelContainerTarget().show()}),n(t.getSearchContentTarget()).off("page.completed")}),n(t.getSearchContentTarget()).one("page.completed",function(){B=!1,n(t.getSearchContentTarget()).off("page.empty")}),S=S.refineQuery(k,C,T),N=s,X(C,k),A&&A.update(S)}function K(e,t){J(e,t,T,N)}function Q(e,n){Object.keys(e).length===0?(t.setCategoryButtonText(H),r.setSearchHint(g.getString("search_category_hint",[n.description])),e=n):(t.setCategoryButtonText(e.description),r.setSearchHint(g.getString("search_category_hint",[e.description]))),J(k,C,e,n)}function G(e,t,n){return b.log("Received Search Page Navigate event: "+t+" "+n),t?(b.log("navigating to: "+t),n?i.navigate(t,n):i.navigate(t)):b.log("navigateString undefined"),!1}function Y(e){return e=new f(e),e.isValid()&&(e.name==="b_games"||e.description.toLowerCase()==="games")}function Z(){s.getDynamicWidgets("games","mobile").done(function(e){b.log("getDynamicWidgets final: "+JSON.stringify(e));var r=n("#featured-asins"),i=new d(r,e);n(i).on("navigate",G),t.getDealsLoading().hide()}).fail(t.hideBillboard)}function et(e){t.render(e.data)}function tt(e){var r,i;T=new f(e),i={pageTitle:T.description},T.isGroupBillboardCategory()&&(i.hideRefine=!0),t.render(i),t.getStage().removeClass("search-search").addClass("category-search"),Y(T)?Z():t.hideBillboard(),D=new p(t.getSubcategoryPopoverTarget()),N?(_=new h(D,N,Q,T.id),r={pageTitle:N.description},n(_).on("subCategoriesDataAvailable",n.extend(r,{categoryButtonText:T.description}),et)):(_=new h(D,T,Q),r={pageTitle:T.description},n(_).on("subCategoriesDataAvailable",n.extend(r,{categoryButtonText:H}),et)),V()}function nt(e){console.log("Received event doSearch: "+e),T&&!T.isGroupBillboardCategory()?N?i.navigate("Search",{q:e,category:T,parentCategory:N}):i.navigate("Search",{q:e,category:T}):i.navigate("Search",{q:e})}var w,E,S,x,T,N,C,k,L,A,O,M,_,D,P=g.getString("word_separation_comma"),H=g.getString("search_subcategory_radio_label_all_categories"),B=!1,j=!1,F="Search",I,q=new m(F),R=!1;x=new u(t),w=i.getExtras(),E=w.q,k=w.sort,C=w.refinement,F=w.page||F,I=w.refMarker,w.parentCategory&&(N=new f(w.parentCategory)),w.category?(T=new f(w.category),T.isValid()?(T.isGroupBillboardCategory()&&r.setSearchHint(g.getString("search_hint")),tt(T)):r.getCategoryByName(T.name,tt)):(t.hideBillboard(),t.render(),V()),b.log("ClickStream-UI-SearchController: refMarker = "+I),q.record(I),q.recordView("/sr",I),n(t.getSearchContentTarget()).one("page.loading",function(){L=S.info||L}),n(t.getSearchContentTarget()).on("page.completed",function(){var e;L&&(e=L.suggestion);if(B&&e&&!j&&n.trim(E).toLowerCase()!==n.trim(e).toLowerCase()){g.getStrings({search_results_label_no_results:[E,e,e]}).done(function(e){t.getNoResultsLabelTarget().text(e),t.getNoResultsLabelContainerTarget().show()}),E=e,B=!1,V(),j=!0;return}B&&g.getStrings({search_results_label_no_results_no_suggestion:[E]}).done(function(e){t.getNoResultsLabelTarget().text(e),t.getNoResultsLabelContainerTarget().show()}),M=new c(t.getRefinePopoverTarget()),O=new l(M,S,K),t.enableRefineButton(),w.category?v.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Category.Load.Completed",{categoryName:w.category.name}):v.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Search.Completed",{pageNumber:1}),n(t.getSearchContentTarget()).off("page.completed"),n(t.getSearchContentTarget()).off("page.empty"),y.initializeAsync(y.STORE_CONFIG_TYPES.Generic)}),n(t.getSearchContentTarget()).one("page.empty",function(){B=!0}),n(t.getSearchContentTarget()).one("page.completed",function(e,n){n.itemCount===0||n.itemCount===1&&n.pageStatus?(R=!1,t.disableRefineButton()):(R=!0,t.enableRefineButton())}),n(t).on({refineButtonClicked:U,categoryButtonClicked:z}),n.subscribe("com.amazon.venezia.doSearch",nt),n.subscribe("com.amazon.venezia.android_lifecycle.onOrientationChange",function(){setTimeout(W,250)})}}),define("rules/PopoverPositionHelper",["require","jquery","appstore"],function(t){var n=t("jquery"),r=t("appstore"),i=r.Recorder.Java.getLogger("HTML5.PopoverPositionHelper"),s=1.927*localStorage.baseFont,o;return o=function(){function e(e,t){var n,r;i.log("target top and height: "+t.position().top+" "+t.height()),n=t.offset().top+t.height(),e.css("top",n),r=s,e.css("top","+="+r),i.log("updated popover css top value with offset: "+e.css("top")+" "+r)}function t(e,t){var r,s,o="-1.25rem";i.log("target left and width, popover width: "+t.offset().left+" "+t.innerWidth()+" "+e.innerWidth()),r=t.offset().left+t.innerWidth()/2-e.innerWidth()/2,s=n(window).width()-e.innerWidth(),r>s&&(r=s,o="0rem"),e.css("left",r),setTimeout(function(){n(".popover-beak",e).css({left:"50%",right:"auto",marginLeft:o,display:"block"})},500),i.log("updated popover css left to: "+r)}function r(e,t){var r,s,o=20*window.devicePixelRatio,u=0;i.log("target left and width, popover width: "+t.offset().left+" "+t.offsetWidth+" "+e.offsetWidth),r=t.offset().left+t.innerWidth(),s=r-e.innerWidth(),e.css("left",Math.max(s,o)+"px"),s<o&&(u=o-s),setTimeout(function(){n(".popover-beak",e).css({right:Math.ceil(t.innerWidth()/2+u)+"px",left:"auto",marginLeft:"0px",display:"block"})},500),i.log("updated popover css left to: "+r)}this.adjustPopoverCSSProperties=function(n,s,o,u,a){i.log("Aligning popovers..."+n+", "+s+", "+o+", "+u+", "+a);if(n===undefined||s===undefined){i.log("Invalid popover and target args passed.");return}o&&e(n,s),u&&t(n,s),a&&r(n,s)}},new o}),define("views/SearchView",["require","jquery","api/device-features","api/recorder","rules/PopoverPositionHelper"],function(t){var n=t("jquery"),r=t("api/device-features"),i=t("api/recorder"),s=t("rules/PopoverPositionHelper"),o=i.Java.getLogger("HTML5.SearchView");return function(t){function m(e){var t=n(e.target);return a==="port"?s.adjustPopoverCSSProperties(l,t,!0,!1,!0):s.adjustPopoverCSSProperties(l,t,!0,!1,!0),n(i).trigger("refineButtonClicked"),!1}function g(e){var t=n(e.target);return a==="port"?v?s.adjustPopoverCSSProperties(f,c,!0,!1,!0):s.adjustPopoverCSSProperties(f,c,!0,!1,!0):s.adjustPopoverCSSProperties(f,c,!0,!0,!1),n(i).trigger("categoryButtonClicked"),!1}function y(){u||(o.log("Registering for events"),h.on("tap",m),c.on("tap",g),l=t.find("#search-refine-popover"),f=t.find("#search-subcategory-popover"),u=!0)}var i=this,u=!1,a,f,l,c=t.find('[data-class="search-page-category-button"]'),h=t.find('[data-class="search-page-refine-button"]'),p=t.find(".search-refine-dropdown-button"),d=t.find(".search-refine-dropdown-button-clone"),v=!1;r.getScreenSize().done(function(e){switch(e.screenSize){case r.ScreenSize.NORMAL:v=!0;break;case r.ScreenSize.SMALL:v=!0;break;default:v=!1}}).fail(function(e){v=!1}),this.repositionPopovers=function(e){o.log("repositionPopovers: orientation "+e),y(),e==="port"?(v?s.adjustPopoverCSSProperties(f,c,!0,!1,!0):s.adjustPopoverCSSProperties(f,c,!0,!0,!1),s.adjustPopoverCSSProperties(l,v?d:p,!0,!1,!0)):(s.adjustPopoverCSSProperties(f,c,!0,!0,!1),s.adjustPopoverCSSProperties(l,p,!0,!1,!0)),n("body").css("border-bottom","1px solid transparent"),setTimeout(function(){n("body").css("border-bottom","none")},10),a=e},this.enableRefineButton=function(){p.prop("disabled",!1),d.prop("disabled",!1)},this.disableRefineButton=function(){p.prop("disabled",!0),d.prop("disabled",!0)},this.render=function(e){var r=t.find('[data-class="search-page-heading-text"]'),i=0,s=n(".search-refine-dropdown-button"),o=n(".search-refine-dropdown-button-clone"),u=n('[data-class="search-page-category-button"]'),a=n('[data-class="search-page-heading-text-container"]'),f=n('[data-class="search-page-heading-text"]'),l=n('[data-class="search-info-text"]');e&&(e.categoryButtonText&&u.text(e.categoryButtonText).show(),e.pageTitle&&f.text(e.pageTitle),u.is(":visible")&&(i+=u[0].offsetWidth),e.hideRefine?(h.hide(),l.parent().parent().hide()):s.is(":visible")&&(i+=s[0].offsetWidth),f.width()>document.body.offsetWidth-i?f.css("white-space","normal"):a.css({width:"auto"})),y()},this.getBillboardTarget=function(){return t.find("#deals-stripe")},this.hideBillboard=function(){i.getBillboardTarget().parent().hide()},this.getDealsLoading=function(){return t.find("#deals-stripe .loading-frame")},this.getSearchContentTarget=function(){return t.find('[data-class="search-list"]')},this.getRefinePopoverTarget=function(){return l===undefined&&(l=t.find("#search-refine-popover")),l},this.getSubcategoryPopoverTarget=function(){return f===undefined&&(f=t.find("#search-subcategory-popover")),f},this.getNoResultsLabelTarget=function(){return t.find('[data-class="search-no-results-message"]')},this.getNoResultsLabelContainerTarget=function(){return t.find('[data-class="search-results-no-results-content-block"]')},this.getStage=function(){return t.find("#stage")},this.setSortedBy=function(e){t.find('[data-class="search-info-text"]').html(e)},this.setCategoryButtonText=function(e){t.find('[data-class="search-page-category-button"]').text(e)}}}),define("controller/SelectSubscriptionPeriodController",["require","jquery","api/navigation"],function(e){var t=e("jquery"),n=e("api/navigation");return function(r){var i=n.getExtras(),s=function(e,t){console.log("returning: "+JSON.stringify(t)),n.setResult({item:t}),n.finish()};t(r).on("itemSelected",s),t(r).on("cancel",n.finish),r.render(i)}}),define("views/SelectSubscriptionPeriodView",["jquery","templates","api/appstore","views/DialogView"],function(e,t,n,r){return function(s){var o=this,u=[n.Resources.getString("IAPSubscriptions_Weekly"),n.Resources.getString("IAPSubscriptions_Biweekly"),n.Resources.getString("IAPSubscriptions_Monthly"),n.Resources.getString("IAPSubscriptions_Bimonthly"),n.Resources.getString("IAPSubscriptions_Quarterly"),n.Resources.getString("IAPSubscriptions_Semiannually"),n.Resources.getString("IAPSubscriptions_Annually")],a=function(t){var n=e("input[name='term']:checked").val();return console.log("selected item = "+n),setTimeout(function(){e(o).trigger("itemSelected",[n])},300),!1};this.render=function(n){s.empty(),s.append(t.SelectSubscriptionPeriod.render());if(n.termItems!==undefined){var i=[],f;e.each(n.termItems,function(t,n){console.log("Term frequency: "+JSON.stringify(n.frequency)),f=e.inArray(n.frequency,u),f>-1&&(i[f]=n)}),console.log("Ordered term items are: "+JSON.stringify(i)),e.map(i,function(t,r){if(t){var i=e("<label>").addClass("radio-label").attr("for",t.universalFrequency),s=e("<input />").attr("type","radio").attr("name","term").attr("id",t.universalFrequency).attr("value",t.id).prop("checked",t.id===n.selectedItem),o=t.frequency+": "+t.price;e("#periods").append(i.append(s).append(o))}}),e("input[name='term']").change(a)}r.handleCancel(o)}}}),define("models/SettingsModel",["require","jquery","api/resources","api/device","api/device-features","api/recorder","api/settings","util/AppInfoBlockUtil","api/feature-config"],function(e){var t=e("jquery"),n=e("api/resources"),r=e("api/device"),i=e("api/device-features"),s=e("api/recorder"),o=e("api/settings"),u=e("util/AppInfoBlockUtil"),a=e("api/feature-config"),f=s.Java.getLogger("HTML5.SettingsModel");return function(){var t={giftcard:!0,iap:!0,version:!0};return t.giftCardsTitle=n.getString("Settings_title_GiftCardstitle_GiftCard"),i.getValueOf(i.Keys.PARENTAL_SETTINGS)||(t.parentalControls=!0),i.getValueOf(i.Keys.AUTO_APP_UPDATES)&&(t.autoUpdate=!0),i.getValueOf(i.Keys.HANDLE_MARKET_INTENT)&&(t.marketLinks=!0),i.getValueOf(i.Keys.IS_WIFI_ONLY)||(t.wifi=!0),i.getValueOf(i.Keys.BACKGROUND_INSTALL)||(t.notifications=!0),i.getValueOf(i.Keys.SSO)||(t.account=!0),i.getValueOf(i.Keys.GLOBAL_SETTINGS)&&(t.globalSettings=!0),a.isCollectAppUsagePrefFeatureEnabled()&&!window.appPreloadState.isAmazonDevice&&(t.personalizedSettings=!0),t}}),define("controller/SettingsController",["require","jquery","api/account","models/SettingsModel","api/navigation","api/device","api/giftcard","api/resources","controller/SoftKeysController","handler/ClickStreamHandler","api/settings","api/recorder","api/device-features"],function(e){var t=e("jquery"),n=e("api/account"),r=e("models/SettingsModel"),i=e("api/navigation"),s=e("api/device"),o=e("api/giftcard"),u=e("api/resources"),a=e("controller/SoftKeysController"),f=e("handler/ClickStreamHandler"),l=e("api/settings"),c=e("api/recorder"),h=c.Java.getLogger("HTML5.SettingsController"),p=e("api/device-features"),d={chrome:{showSettingsHeader:!0,menu:{showBack:!0,showMenu:!1,showSearch:!1}}};return function(v){function g(e,n){var r={settingsPage:n};h.log("SettingsController: handleSettingsSelection: "+n),n==="SettingsVersion"&&c.Metrics.recordEvent("Recorder.Metrics.Event.Settings.Version.Load.Initiated"),p.getValueOf(p.Keys.GLOBAL_SETTINGS)&&(r=t.extend(r,d)),i.navigate("SettingsPage",r)}function y(){function a(t){h.log("SettingsController: Obtained gift-card balance"),h.log("Balance: "+JSON.stringify([t])),v.showGiftCardBalance(e.giftCardsTitle,t)}function f(e){var t=u.getString("settings_fail");h.warning("SettingsController: Error obtaining giftCardBalance: "+e),v.showGiftCardBalance(t)}function c(e){v.showWifiLimit(e.value/1024/1024)}function d(e){v.showWifiLimitFailed()}function m(e){e?(h.log("parentalControlsSuccess data: "+e.value),e.value?v.showParentalControlsEnabled():v.showParentalControlsDisabled()):(h.warning("parentalControlsSuccess but data undefined, hiding parentalControls"),v.showParentalControlsFailed())}function g(e){h.warning("parentalControlsFailure: error"+e),v.showParentalControlsFailed()}function y(e){e&&e.value?v.showIapEnabled():v.showIapDisabled()}function b(e){h.warning("iapFailed: "+JSON.stringify(e)),v.showIapFailed()}function w(e){e&&e.value?v.showAppUsageCollectionEnabled():v.showAppUsageCollectionDisabled()}function E(e){h.warning("Failed getting 3P App usage data collection settings: "+JSON.stringify(e)),v.showAppUsageCollectionFailed()}function S(e){h.log("notificationsTextSuccess: "+JSON.stringify(e)),e&&e.value&&(i+=1),t+=1,t===3&&(i===3?v.showNotificationsEnabled():i===0?v.showNotificationsDisabled():v.showNotificationsSomeEnabled(),t=0,i=0)}function x(e){h.warning("notificationsTextFailure: "+JSON.stringify(e)),v.showNotificationsFailed()}function T(e){e&&e.value?v.showAutoUpdatesEnabled():v.showAutoUpdatesDisabled()}function N(e){v.showAutoUpdatesFailed()}function C(){v.showMarketLinksAsk(),l.set(l.keys.MarketLinkStateKey,l.keys.MarketLinkStateKey.defaultValue)}function k(e){h.log("MarketLinks: "+JSON.stringify(e));if(e)switch(e.value){case l.marketLinkState.AUTO_FORWARD:v.showMarketLinksOpen();break;case l.marketLinkState.DONT_FORWARD:v.showMarketLinksDontOpen();break;case l.marketLinkState.ASK_BEFORE_FORWARD:v.showMarketLinksAsk();break;default:C()}else C()}function L(e){C()}function A(e){v.showSignedInAs(e.name)}function O(e){v.showSignedInAsFailed()}h.log("SettingsController. SetupDataAndModel");var e=new r,t=0,i=0;v.render(e),o.getBalance(!0,a,f),p.getValueOf(p.Keys.IS_WIFI_ONLY)||l.getCellularDownloadLimit().done(c).fail(d),p.getValueOf(p.Keys.PARENTAL_SETTINGS)||l.get(l.keys.ParentalControlKey,m,g),l.get(l.keys.IapEnabledKey,y,b),l.get(l.keys.Collect3pAppUsageEnabledKey,w,E),p.isNotificationSettingsEnabled().done(function(e){e&&(l.get(l.keys.ProgressNotificationKey,S,x),l.get(l.keys.AppUpdatesNotificationKey,S,x),l.get(l.keys.FlashInNotificationBarKey,S,x))}),p.getValueOf(p.Keys.AUTO_APP_UPDATES)&&l.get(l.keys.AutoUpdateKey,T,N),p.getValueOf(p.Keys.HANDLE_MARKET_INTENT)&&l.get(l.keys.MarketLinkStateKey,k,L),s.getAppstoreVersion(function(e){v.showVersion(e)},function(e){v.showVersionDisabled()}),p.getValueOf(p.Keys.SSO)||n.getAccountDetails(A,O)}var m;t(v).on("settingsSelected",g),t.subscribe("com.amazon.venezia.android_lifecycle.onResume",y),m=new a(v,"Settings"),i.getExtras("refMarker","page").done(function(e,t){var n=new f(t);e&&n.record(e)})}}),define("plugins/FormatAndShower",["require","jquery","api/resources"],function(t){var n=t("jquery"),r=t("api/resources");return n.fn.formatAndShowText=function(e,t){function s(t){n.find(e).text(t.result),n.find(e).show()}var n=this,i=n.find(e).text();return r.formatString(i,t).done(s),n},{}}),define("views/SettingsView",["require","jquery","api/resources","templates","api/recorder","plugins/FormatAndShower"],function(e){var t=e("jquery"),n=e("api/resources"),r=e("templates"),i=e("api/recorder"),s=i.Java.getLogger("HTML5.SettingsView"),o=e("plugins/FormatAndShower");return function(i){function u(e){var n=t(e.target).attr("page");n||(n=t(e.target).closest("li").attr("page")),t(o).trigger("settingsSelected",n)}var o=this;this.render=function(e){i.empty(),i.append(r.Settings.render(e)),i.find('[data-class="settings-list"]').on("tap","li.clickable",u),i.find("#version").on("click",function(){return s.log("Return false for version text, we dont want the OS to convert it to phone number and try to launch phone dialer !!"),!1})},this.showGiftCardBalance=function(e,t){function s(e){i.find("#gift-card-balance").html(e.result),i.find("#gift-card-balance").show()}var r=i.find("#gift-card-balance").text();n.formatString(r,e,t).done(s)},this.showWifiLimit=function(e){i.formatAndShowText("#wifi-limit",e)},this.showWifiLimitFailed=function(){i.find("#wifi-limit-failed").show()},this.showParentalControlsEnabled=function(){i.find("#parental-controls-enabled").show()},this.showParentalControlsDisabled=function(){i.find("#parental-controls-disabled").show()},this.showParentalControlsFailed=function(){i.find("#parental-controls-failed").show()},this.showIapEnabled=function(){i.find("#iap-enabled").show()},this.showIapDisabled=function(){i.find("#iap-disabled").show()},this.showIapFailed=function(){i.find("#iap-failed").show()},this.showAppUsageCollectionEnabled=function(){i.find("#appUsage-enabled").show()},this.showAppUsageCollectionDisabled=function(){i.find("#appUsage-disabled").show()},this.showAppUsageCollectionFailed=function(){i.find("#appUsage-failed").show()},this.showNotificationsSomeEnabled=function(){i.find("#notifications-some-enabled").show()},this.showNotificationsEnabled=function(){i.find("#notifications-enabled").show()},this.showNotificationsDisabled=function(){i.find("#notifications-disabled").show()},this.showNotificationsFailed=function(){i.find("#notifications-failed").show()},this.showAutoUpdatesEnabled=function(){i.find("#auto-updates-enabled").show()},this.showAutoUpdatesDisabled=function(){i.find("#auto-updates-disabled").show()},this.showAutoUpdatesFailed=function(){i.find("#auto-updates-failed").show()},this.showMarketLinksOpen=function(){i.find("#market-links-open").show()},this.showMarketLinksDontOpen=function(){i.find("#market-links-dont-open").show()},this.showMarketLinksAsk=function(){i.find("#market-links-ask").show()},this.showVersionDisabled=function(){i.find("#version-disabled").show()},this.showVersion=function(e){i.formatAndShowText("#version",e)},this.showSignedInAs=function(e){i.formatAndShowText("#signed-in-as",e)},this.showSignedInAsFailed=function(){i.find("#signed-in-as-failed").show()}}}),define("controller/SettingsMarketLinksDialogController",["require","jquery","appstore"],function(e){var t=e("jquery"),n=e("appstore"),r=n.Recorder.Java.getLogger("HTML5.SettingsMarketLinksChoiceDialogController");return function(i){function f(){n.Navigation.navigate(u.page,u),n.Navigation.finish()}function l(){return{title:n.Resources.getString("market_link_disabled_title"),description:n.Resources.getString("market_link_disabled_msg")}}function c(){return{title:n.Resources.getString("market_link_choice_title"),description:n.Resources.getString("market_link_choice_msg"),positiveButton:n.Resources.getString("market_link_btn_continue"),negativeButton:n.Resources.getString("market_link_btn_cancel"),checkbox:n.Resources.getString("market_link_check_msg")}}function h(){n.Settings.set(n.Settings.keys.MarketLinkStateKey,n.Settings.marketLinkState.AUTO_FORWARD)}function p(){n.Settings.set(n.Settings.keys.MarketLinkStateKey,n.Settings.marketLinkState.DONT_FORWARD)}function d(){n.Settings.set(n.Settings.keys.MarketLinkStateKey,n.Settings.marketLinkState.ASK_BEFORE_FORWARD)}function v(e){r.log("Cancel");var t=i.getCheckboxValue();t&&p(),n.Navigation.finish()}function m(e){var t=i.getCheckboxValue();r.log("Continue"),t&&h(),f()}function g(){n.Navigation.navigate("SettingsPage",{settingsPage:"SettingsMarketLinks"}),n.Navigation.finish()}var s,o,u,a;o=n.Navigation.getExtras(),u=o.redirect,a=o.state;switch(a){case n.Settings.marketLinkState.AUTO_FORWARD:f();break;case n.Settings.marketLinkState.DONT_FORWARD:s=l();break;case n.Settings.marketLinkState.ASK_BEFORE_FORWARD:s=c();break;default:d(),s=c(),r.log("Could not match market link state: "+a)}i.render(s),t(i).on({negative:v,positive:m,redirect:g,cancel:v})}}),define("views/SettingsMarketLinksDialogView",["require","jquery","api/navigation","templates","views/DialogView"],function(e){var t=e("jquery"),n=e("api/navigation"),r=e("templates"),i=e("views/DialogView");return function(n){var s=this,o,u;this.render=function(e){console.log("Dialog: "+JSON.stringify(e)),n.empty(),o=t(r.SettingsMarketLinksDialog.render(e)),n.append(o),t("#settings_redirect")&&t("#settings_redirect").on("tap",function(){return t(s).trigger("redirect"),!1}),e.checkbox&&(u=t("#checkbox"),s.getCheckboxValue=function(){return u.prop("checked")}),e.positiveButton&&t("#negative").on("tap",function(){return t(s).trigger("negative"),!1}),e.negativeButton&&t("#positive").on("tap",function(){return t(s).trigger("positive"),!1}),i.handleCancel(s)}}}),define("controller/SettingsAutoUpdateController",["require","jquery","appstore","api/device-features"],function(t){var n=t("jquery"),r=t("appstore"),i=t("api/device-features");return function(t){function i(e){t.setUpdateNotificationsChecked(e.value)}function s(e){t.setAutoUpdateViaMobileConnectionChecked(e.value)}function o(e){e?(t.enableUpdateNotificationsCheckbox(),t.enableAutoUpdateViaMobileConnectionCheckbox(),r.Settings.get(r.Settings.keys.AutomaticUpdatesNotificationKey,i),r.Settings.get(r.Settings.keys.AutomaticUpdatesViaMobileConnKey,s)):(t.disableUpdateNotificationsCheckbox(),t.disableAutoUpdateViaMobileConnectionCheckbox())}function u(e){t.setAutoUpdateChecked(e.value),o(e.value)}function a(){r.Navigation.finish()}function f(){var e=t.getAllowAutoUpdateCheckboxValue();r.Settings.set(r.Settings.keys.AutoUpdateKey,e),o(e)}function l(){r.Settings.set(r.Settings.keys.AutomaticUpdatesNotificationKey,t.getUpdateNotificationsCheckboxValue())}function c(){r.Settings.set(r.Settings.keys.AutomaticUpdatesViaMobileConnKey,t.getAutoUpdateViaMobileConnectionCheckboxValue())}t.render({}),r.Settings.get(r.Settings.keys.AutoUpdateKey,u),n(t).on({done:a,checkAutoUpdate:f,checkUpdateNotifications:l,checkAutoUpdateViaMobileConnection:c})}}),define("controller/SettingsGiftCardsController",["require","jquery","api/giftcard","api/navigation","api/resources","api/recorder","handler/ClickStreamHandler","controller/SoftKeysController"],function(e){var t=e("jquery"),n=e("api/giftcard"),r=e("api/navigation"),i=e("api/resources"),s=e("api/recorder"),o=e("handler/ClickStreamHandler"),u=s.Java.getLogger("HTML5.SettingsGiftCardsController"),a=e("controller/SoftKeysController");return function(u,f){function d(e){n.getBalance(!0).done(function(t){u.updateGiftCardText(t),e&&e.resolve()}).fail(function(t){u.updateGiftCardText(i.getString("settings_fail")),e&&e.reject()})}function v(){h&&clearTimeout(h),h=null,u.redeemReturn()}function m(e,t){s.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Settings.GiftCard.Redeem.Initiated"),n.redeemCode(t).done(function(e){console.log("SettingsGiftCardsController: code = "+t),console.log("SettingsGiftCardsController: redeemed = "+e),s.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Settings.GiftCard.Redeem.Completed"),e.toString()==="false"?(r.showToast(u.getFailMessage()),h=setTimeout(v,p)):(r.showToast(u.getSuccessMessage()),d(),v())}).fail(function(e){s.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Settings.GiftCard.Redeem.Failure"),r.showToast(u.getErrorMessage()),h=setTimeout(v,p)})}function g(e){var n={giftCardName:e};u.render(n),l=t.Deferred(),d(l),t.when(l).done(function(){s.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Settings.GiftCard.Load.Completed")}).fail(function(){s.Metrics.recordEvent("Appstore.Recorder.Metrics.Event.Settings.GiftCard.Load.Failure")}),t(u).on({redeem:m})}var l,c,h,p=1e3;f!=="SettingsPage"&&(c=new a(u,"SettingsGiftCards")),i.getStrings("Settings_title_GiftCardstitle_GiftCard").done(g),r.getExtras("refMarker","page").done(function(e,t){var n=new o(t);e&&n.record(e)})}}),define("controller/SettingsIapController",["require","jquery","appstore"],function(t){var n=t("jquery"),r=t("appstore");return function(t){function i(e){t.setIapChecked(e.value)}function s(e){e?r.Settings.set(r.Settings.keys.IapEnabledKey,t.getAllowIapCheckboxValue()):t.toggleAllowIapCheckboxValue()}function o(){r.Navigation.finish()}function u(){r.Navigation.showDialog("PasswordChallengeDialog",{},function(e){console.log("callback from PasswordChallengeDialog"),e!==undefined?s(e.isValidated):s(!1)})}t.render(),r.Settings.get(r.Settings.keys.IapEnabledKey,i),n(t).on({done:o,check:u})}}),define("controller/SettingsPersonalizedController",["require","jquery","api/settings","api/navigation","api/recorder","controller/SoftKeysController"],function(t){var n=t("jquery"),r=t("api/settings"),i=t("api/navigation"),s=t("api/recorder"),o=t("controller/SoftKeysController"),u=s.Java.getLogger("HTML5.SettingsPersonalized"),a=s.Metrics.recordCount;return function(t){function s(e){e===undefined||e.value===undefined?t.setAppUsageChecked(!0):t.setAppUsageChecked(e.value===!0?!0:!1)}function o(){var e=t.getAllowAppUsageCheckboxValue();u.log("Enabling 3p App usage collection: "+e),r.get(r.keys.Collect3pAppUsageEnabledKey,function(t){if(t!==undefined&&t.value===e)return;r.set(r.keys.Collect3pAppUsageEnabledKey,e),e===!0?a("Appstore.Metrics.Settings.Personalized.Collect3pAppUsage",1):a("Appstore.Metrics.Settings.Personalized.DoNotCollect3PAppUsage",1)})}function f(e,t){return t.indexOf("http")===0&&i.openInBrowser(t),!1}function l(){r.get(r.keys.Collect3pAppUsageEnabledKey,s)}t.render(),n.subscribe("com.amazon.venezia.android_lifecycle.onResume",l),n(t).on({check:o,linkClicked:f})}}),define("controller/SettingsMarketLinksController",["require","jquery","appstore"],function(t){var n=t("jquery"),r=t("appstore");return function(t){function i(){r.Navigation.finish()}function s(e){console.log("getMarketLinksEnabledCallback response: "+JSON.stringify(e)),t.setMarketLinksChecked(e.value)}function o(e,t){console.log("MarketLinkState: "+t),r.Settings.set(r.Settings.keys.MarketLinkStateKey,t)}t.render(),r.Settings.get(r.Settings.keys.MarketLinkStateKey,s),n(t).on({done:i,select:o}),n.subscribe("com.amazon.venezia.android_lifecycle.onResume",function(){r.Settings.get(r.Settings.keys.MarketLinkStateKey,s)})}}),define("models/SettingsNotificationsModel",["require","jquery","appstore"],function(e){var t=e("jquery"),n=e("appstore"),r=n.Recorder.Java.getLogger("HTML5.SettingsNotificationsModel");return function(){function o(e,t){r.log(": updateInternalProperty: "+e+" "+t),s[e]!==t&&(s[e]=t,i.trigger(e,[e,t]))}function u(){var e=s.downloadProgress||s.appUpdates||s.flashBar;o("enableNotifications",e)}function a(e,t){o(e,t),u()}function f(e){r.info(": downloadProgress: "+e.value),a("downloadProgress",e.value)}function l(e){r.info(": appUpdates: "+e.value),a("appUpdates",e.value)}function c(e){r.info(": flashBar: "+e.value),a("flashBar",e.value)}function h(e){r.warning(": onProgressError: "+e),a("downloadProgress",!1)}function p(e){r.warning(": onAppUpdatesError: "+e),a("appUpdates",!1)}function d(e){r.warning(": onFlashInBarError: "+e),a("flashBar",!1)}function v(){r.info("SETTINGS SET SUCCCESS")}function m(){r.warning("SETTINGS SET FAILED")}function g(e,t){n.Settings.set(e,t,v,m)}var i=t(this),s={enableNotifications:!1,downloadProgress:!1,appUpdates:!1,flashBar:!1};this.getEnableNotifications=function(){return s.enableNotifications},this.getDownloadProgress=function(){return s.downloadProgress},this.getAppUpdates=function(){return s.appUpdates},this.getFlashBar=function(){return s.flashBar},this.setNotification=function(e,t){r.log("SettingsNotificationsModel.SetNotification: "+e+" "+t),s[e]=t;switch(e){case"enableNotifications":o("downloadProgress",t),g(n.Settings.keys.ProgressNotificationKey,t),o("appUpdates",t),g(n.Settings.keys.AppUpdatesNotificationKey,t),o("flashBar",t),g(n.Settings.keys.FlashInNotificationBarKey,t);break;case"downloadProgress":g(n.Settings.keys.ProgressNotificationKey,t),u();break;case"appUpdates":g(n.Settings.keys.AppUpdatesNotificationKey,t),u();break;case"flashBar":g(n.Settings.keys.FlashInNotificationBarKey,t),u()}},n.Settings.get(n.Settings.keys.ProgressNotificationKey,f,h),n.Settings.get(n.Settings.keys.AppUpdatesNotificationKey,l,p),n.Settings.get(n.Settings.keys.FlashInNotificationBarKey,c,d)}}),define("controller/SettingsNotificationsController",["require","jquery","appstore","models/SettingsNotificationsModel"],function(e){var t=e("jquery"),n=e("appstore"),r=e("models/SettingsNotificationsModel"),i=n.Recorder.Java.getLogger("HTML5.SettingsNotificationsController");return function(n){function o(e,t,n){i.log(": handleCheckBoxSettingsChanged: event: "+JSON.stringify(t)+JSON.stringify(n)),s.setNotification(t,n)}var s=new r;n.render(s),t(n).on("notificationChanged",o)}}),define("controller/SettingsParentalController",["require","jquery","appstore"],function(t){var n=t("jquery"),r=t("appstore"),i=r.Recorder.Java.getLogger("HTML5.SettingsParentalController");return function(t){function f(e){var n;e?(n=e.value,n!==a.parentalControlsEnabled&&(a.parentalControlsEnabled=n,t.render(a))):i.warning("onParentalControlsSuccess but data undefined. Unexpected!!")}function l(e){i.warning("onParentalControlsFailure: error"+e)}function c(e){i.log("onPinValueSuccess"),e&&e.value&&(o=!0)}function h(e){i.warning("onPinValueFailure: error"+e)}function p(e){var n;e?(n=e.value,n!==a.isPinEnabled&&(a.isPinEnabled=n,t.render(a)),n&&r.Settings.get(r.Settings.keys.PinValueKey,c,h)):i.warning("onPinEnabledSuccess but data undefined, should not happen !!")}function d(e){i.warning("onPinEnabledFailure: error"+e)}function v(e){i.log("pinChangeDialogCallback: "+e),e&&(o=!0)}function m(e){i.log("checkBoxChangeSetPinChangeDialogCallback: "+e),e?o=!0:(t.toggleUsePinCheckboxValue(),r.Settings.set(r.Settings.keys.PinEnabledKey,t.getUsePinCheckboxValue()))}function g(e){i.log("setNewPin"),r.Navigation.showDialog("PinChangeDialog",{pinChallengeDialogTitle:u},function(t){i.log("callback from PinChangeDialog"),t!==undefined?e(t.isValidated):e(!1)})}function y(){var e=t.getUsePinCheckboxValue();i.log("pincheckboxValue , isPinSet: "+e+" "+o),r.Settings.set(r.Settings.keys.PinEnabledKey,e),e&&!o&&g(m)}function b(e){i.log("pinChallengeDialogCallback: "+e),e&&g(v)}function w(e){i.log("passwordDialogCallbackForPin validated: "+e),e?(y(),s=!0):t.toggleUsePinCheckboxValue()}function E(e){i.log("passwordDialogCallbackForPC validated: "+e),e?(r.Settings.set(r.Settings.keys.ParentalControlKey,t.getEnableParentalControlsCheckboxValue()),s=!0,t.enableOrDisablePinCheckBox()):t.toggleEnableParentalControlsCheckboxValue()}function S(){i.log("checkParentalControls: "+s),s?(r.Settings.set(r.Settings.keys.ParentalControlKey,t.getEnableParentalControlsCheckboxValue()),t.enableOrDisablePinCheckBox()):r.Navigation.showDialog("PasswordChallengeDialog",{},function(e){i.log("callback from PasswordChallengeDialog"),e!==undefined?E(e.isValidated):E(!1)})}function x(e){i.log("checkPIN: "+s),s?y():r.Navigation.showDialog("PasswordChallengeDialog",{},function(e){i.log("callback from PasswordChallengeDialog"),e!==undefined?w(e.isValidated):w(!1)})}function T(){i.log("changePin"),r.Navigation.showDialog("PinChallengeDialog",{},function(e){i.log("callback from PinChallengeDialog is "+e),e!==undefined?b(e.isValidated):b(!1)})}var s=!1,o=!1,u=r.Resources.getString("PinChallengeDialog_ModifyParentalControls"),a={parentalControlsEnabled:!1,isPinEnabled:!1};t.render(a),r.Settings.get(r.Settings.keys.ParentalControlKey,f,l),r.Settings.get(r.Settings.keys.PinEnabledKey,p,d),n(t).on({checkParentalControls:S,checkPIN:x,changePin:T}),n.subscribe("com.amazon.venezia.android_lifecycle.onResume",function(){i.log("in OnResume: "+s+" "+o)})}}),define("controller/SettingsVersionController",["require","jquery","appstore","api/device","api/device-features","api/navigation","api/recorder","api/resources","api/datetime","util/AppInfoBlockUtil"],function(e){var t=e("jquery"),n=e("appstore"),r=e("api/device"),i=e("api/device-features"),s=e("api/navigation"),o=e("api/recorder"),u=e("api/resources"),a=e("api/datetime"),f=e("util/AppInfoBlockUtil"),l={page:{init:"Appstore.Recorder.Metrics.Event.Settings.Version.Load.Initiated",done:"Appstore.Recorder.Metrics.Event.Settings.Version.Load.Completed",fail:"Appstore.Recorder.Metrics.Event.Settings.Version.Load.Failure"}};return function(n){function c(){t(n).off("checkForUpdate"),s.showDialog("SettingsVersionDialog")}var u={globalSettings:i.getValueOf(i.Keys.GLOBAL_SETTINGS)};n.render(u),r.getAppstoreVersion(function(e){console.log("update the version text"),n.updateVersionText(f.trimVersionText(e)),o.Metrics.recordEvent(l.page.done)},function(e){console.log(e),o.Metrics.recordEvent(l.page.fail)}),r.getAppstoreResourcesUpdateVersion(function(e,t){var r=new a("SHORT",!0),i="";e&&(t&&(i=r.formatDateMs(t)),n.updateResourcesUpdatedVersionText(i,e))},function(e){console.log("error retrieving AppstoreResourcesUpdateVersion: "+e)}),i.getValueOf(i.Keys.SELF_UPDATE)?(n.showCheckForUpdate(),t(n).on({checkForUpdate:c})):n.hideCheckForUpdate()}}),define("controller/SettingsWiFiController",["jquery","appstore"],function(e,t){var n=52428800;return function(i){var s,o=function(e){return e/1024/1024};t.Settings.getCellularDownloadLimit().done(function(e){i.render(),i.setCellularDownloadLimitButton(o(e.value)+"MB")}).fail(function(e){i.render(),i.setCellularDownloadLimitButton(o(n)+"MB")}),s=function(){t.Navigation.showDialog("CellularDownloadLimitDialog",{},function(e){e.limit!==undefined&&e.text!==undefined&&(i.setCellularDownloadLimitButton(e.text),t.Settings.setCellularDownloadLimit(e.limit*1024*1024))})},e(i).on({selectCellularDownloadLimit:s})}}),define("views/SettingsAutoUpdateView",["jquery","templates"],function(e,t){return function(r){function a(t,n,r){e(t).on(n,function(t){e(u).trigger(r);if(n==="tap")return!1})}var i,s,o,u=this;this.render=function(n){r.empty(),r.append(t.SettingsAutoUpdate.render(n)),i=e("#enable-autoUpdate"),s=e("#enable-updateNotifications"),o=e("#enable-autoUpdateViaMobileConnection"),a("#enable-autoUpdate","change","checkAutoUpdate"),a("#enable-updateNotifications","change","checkUpdateNotifications"),a("#enable-autoUpdateViaMobileConnection","change","checkAutoUpdateViaMobileConnection")},this.toggleAllowAutoUpdateCheckboxValue=function(){i.prop("checked",!i.prop("checked"))},this.setAutoUpdateChecked=function(e){i.prop("checked",e)},this.setUpdateNotificationsChecked=function(e){s.prop("checked",e)},this.setAutoUpdateViaMobileConnectionChecked=function(e){o.prop("checked",e)},this.getAllowAutoUpdateCheckboxValue=function(){return i.prop("checked")},this.getUpdateNotificationsCheckboxValue=function(){return s.prop("checked")},this.getAutoUpdateViaMobileConnectionCheckboxValue=function(){return o.prop("checked")},this.enableUpdateNotificationsCheckbox=function(){s.prop("disabled",!1)},this.enableAutoUpdateViaMobileConnectionCheckbox=function(){o.prop("disabled",!1)},this.disableUpdateNotificationsCheckbox=function(){s.prop("checked",!1),s.prop("disabled",!0)},this.disableAutoUpdateViaMobileConnectionCheckbox=function(){o.prop("checked",!1),o.prop("disabled",!0)}}}),define("views/SettingsGiftCardsView",["require","jquery","templates","plugins/FormatAndShower"],function(e){var t=e("jquery"),n=e("templates"),r=e("plugins/FormatAndShower");return function(r){function f(){u.prop("disabled",!1),a.off("change")}function l(){u.prop("disabled",!0);var e=a.val();return console.log("SettingsGiftCardsView: code = "+e),a.blur(),a.on("change",f),t(i).trigger("redeem",[e]),!1}var i=this,s,o="",u,a;this.getErrorMessage=function(){return t("#gift-card-error").text()},this.getFailMessage=function(){return t("#gift-card-fail").text()},this.getSuccessMessage=function(){return t("#gift-card-success").text()},this.render=function(e){r.empty(),s=t(n.SettingsGiftCards.render(e)),o=e.giftCardName,r.append(s),s.formatAndShowText("#redeem-message",o),s.formatAndShowText("#legal-message",o),u=t('[data-class="redeem-button"]'),u.on("tap",l),a=t('[data-class="gift-card-code"]')},this.updateGiftCardText=function(e){s.formatAndShowText("#gift-card-balance",[o,e])},this.redeemReturn=function(){f()}}}),define("views/SettingsIapView",["jquery","templates"],function(e,t){return function(n){function o(t,n,r){e(t).on(n,function(t){e(s).trigger(r);if(n==="tap")return!1})}var r,i,s=this;this.render=function(){n.empty(),r=e(t.SettingsIAP.render()),n.append(r),i=e("#enable-iap"),o("#enable-iap","change","check")},this.getDialogTarget=function(){return r.find("#dialog-placeholder")},this.toggleAllowIapCheckboxValue=function(){i.prop("checked",!i.prop("checked"))},this.setIapChecked=function(e){i.prop("checked",e)},this.getAllowIapCheckboxValue=function(){return i.prop("checked")}}}),define("views/SettingsPersonalizedView",["require","jquery","templates","api/recorder"],function(e){var t=e("jquery"),n=e("templates"),r=e("api/recorder");return function(r){function u(e,n,r){t(e).on(n,function(e){t(o).trigger(r);if(n==="tap")return!1})}function a(e){return t(o).trigger("linkClicked",e.target.href),!1}var i,s,o=this;this.render=function(){r.empty(),i=t(n.SettingsPersonalized.render()),r.append(i),s=t("#enable-appUsageCollection"),s.on("change",function(){t(o).trigger("check")}),t("a").on("click",a)},this.toggleAllowAppUsageCheckboxValue=function(){s.prop("checked",!s.prop("checked"))},this.setAppUsageChecked=function(e){s.prop("checked",e)},this.getAllowAppUsageCheckboxValue=function(){return s.prop("checked")}}}),define("views/SettingsMarketLinksView",["require","jquery","api/settings","templates"],function(e){var t=e("jquery"),n=e("api/settings"),r=e("templates");return function(i){function u(e,n){return function(r){return console.log("Selected marketLinkState: "+n),t(e).trigger("select",n),!1}}var s,o=this;this.render=function(){i.empty(),s=t(r.SettingsMarketLinks.render()),i.append(s),t("#enable-auto-selection").on("tap",u(o,n.marketLinkState.AUTO_FORWARD)),t("#enable-dont-selection").on("tap",u(o,n.marketLinkState.DONT_FORWARD)),t("#enable-ask-selection").on("tap",u(o,n.marketLinkState.ASK_BEFORE_FORWARD))},this.setMarketLinksChecked=function(e){console.log("setMarketLinksChecked: "+e);switch(e){case n.marketLinkState.AUTO_FORWARD:t("#enable-auto").prop("checked",!0),console.log("setMarketLinksChecked: Auto");break;case n.marketLinkState.DONT_FORWARD:t("#enable-dont").prop("checked",!0),console.log("setMarketLinksChecked: Don't");break;case n.marketLinkState.ASK_BEFORE_FORWARD:t("#enable-ask").prop("checked",!0),console.log("setMarketLinksChecked: Forward");break;default:t("#enable-ask").prop("checked",!0),console.log("setMarketLinksChecked: default")}}}}),define("views/SettingsNotificationsView",["require","jquery","templates","appstore"],function(e){var t=e("jquery"),n=e("templates"),r=e("appstore"),i=r.Recorder.Java.getLogger("HTML5.SettingsNotificationsView");return function(r){function p(e,t,n){i.fine("handleNotificationsChanged: args: "+JSON.stringify(t)+" "+JSON.stringify(n));switch(t){case"enableNotifications":a.prop("checked",n);break;case"downloadProgress":f.prop("checked",n);break;case"appUpdates":l.prop("checked",n);break;case"flashBar":c.prop("checked",n)}}function d(){var e=t(o);e.on("enableNotifications",p),a=t("#enableNotifications"),a.prop("checked",o.getEnableNotifications()),e.on("downloadProgress",p),f=t("#downloadProgress"),f.prop("checked",o.getDownloadProgress()),e.on("appUpdates",p),l=t("#appUpdates"),l.prop("checked",o.getAppUpdates()),e.on("flashBar",p),c=t("#flashBar"),c.prop("checked",o.getFlashBar())}function v(e){u=t(s.find("#"+e.target.id)),t(h).trigger("notificationChanged",[e.target.id,u.prop("checked")])}var s,o,u,a,f,l,c,h=this;this.render=function(e){r.empty(),s=t(n.SettingsNotifications.render()),r.append(s),o=e,d(),s.find("input:checkbox").on("change",v)}}}),define("views/SettingsParentalView",["require","jquery","templates","appstore"],function(e){var t=e("jquery"),n=e("templates"),r=e("appstore"),i=r.Recorder.Java.getLogger("HTML5.SettingsParentalView");return function(r){var s,o,u,a,f,l,c,h,p,d=this;s=function(){i.log("checkboxPC, checkboxPin "+o.prop("checked")+" "+u.prop("checked")),o.prop("checked")?(u.prop("disabled",!1),u.prop("checked")?f.show():f.hide()):(u.prop("disabled",!0),u.prop("checked",!1),a.hide())},l=function(){i.log("Triggering checkParentalControls"),t(d).trigger("checkParentalControls")},c=function(){i.log("Triggering checkPIN"),u.prop("checked")?f.show():f.hide(),t(d).trigger("checkPIN")},h=function(){return i.log("Triggering changePin"),t(d).trigger("changePin"),!1},this.registerEvents=function(){i.log("registering for events"),o=t("#enable-parental-controls"),o.on("change",l),u=t("#use-pin"),u.on("change",c),a=t("#change-pin"),f=a.parent(),a.on("tap",h)},this.render=function(e){r.empty(),p=t(n.SettingsParental.render()),r.append(p),i.log("In Render"),this.registerEvents(),e&&(i.log("Updating UI with data: "+JSON.stringify(e)),o.prop("checked",e.parentalControlsEnabled),u.prop("checked",e.isPinEnabled)),s()},this.getDialogTarget=function(){return p.find("#dialog-placeholder")},this.toggleEnableParentalControlsCheckboxValue=function(){o.prop("checked",!o.prop("checked")),s()},this.getEnableParentalControlsCheckboxValue=function(){return o.prop("checked")},this.getUsePinCheckboxValue=function(){return u.prop("checked")},this.toggleUsePinCheckboxValue=function(){u.prop("checked",!u.prop("checked")),s()}}}),define("views/SettingsVersionView",["require","jquery","templates","plugins/FormatAndShower"],function(e){var t=e("jquery"),n=e("templates"),r=e("plugins/FormatAndShower");return function(r){var i,s=this,o,u,a;this.render=function(e){r.empty(),i=t(n.SettingsVersion.render(e)),r.append(i),o=t('[data-class="check-for-update"]'),u=t("#loading"),o.on("tap",function(){o.prop("disabled",!0),t(s).trigger("checkForUpdate")})},this.updateVersionText=function(e){console.log("updating version text"),console.log(i.find('[data-class="appstore-version"]')),t(i.find('[data-class="appstore-version"]')).text(e)},this.updateResourcesUpdatedVersionText=function(e,t){i.formatAndShowText('[data-class="appstore-resources-update-version"]',[e,t])},this.hideResourcesUpdatedVersionTarget=function(){t(i.find('[data-class="appstore-resources-update-version"]')).hide()},this.showCheckForUpdate=function(){o.show()},this.hideCheckForUpdate=function(){o.hide()}}}),define("views/SettingsWiFiView",["jquery","templates"],function(e,t){return function(r){var i,s=this;this.render=function(n){r.empty(),i=e(t.SettingsWiFi.render()),r.append(i),e("#cellular-download-limit-button").on("tap",function(){return e(s).trigger("selectCellularDownloadLimit"),!1})},this.setCellularDownloadLimitButton=function(t){return e("#cellular-download-limit-button").text(t)}}}),define("controller/SettingsPageController",["require","jquery","api/navigation","handler/ClickStreamHandler","controller/SoftKeysController","api/recorder","controller/SettingsAutoUpdateController","controller/SettingsGiftCardsController","controller/SettingsIapController","controller/SettingsPersonalizedController","controller/SettingsMarketLinksController","controller/SettingsNotificationsController","controller/SettingsParentalController","controller/SettingsVersionController","controller/SettingsWiFiController","views/SettingsAutoUpdateView","views/SettingsGiftCardsView","views/SettingsIapView","views/SettingsPersonalizedView","views/SettingsMarketLinksView","views/SettingsNotificationsView","views/SettingsParentalView","views/SettingsVersionView","views/SettingsWiFiView"],function(e){var t=e("jquery"),n=e("api/navigation"),r=e("handler/ClickStreamHandler"),i=e("controller/SoftKeysController"),s=e("api/recorder"),o=s.Java.getLogger("HTML5.SettingsPageController");return function(u){function h(){a.done(function(e,t,n){var i,s,a,f,h="Settings",p=new r(h);if(!e){o.severe("missing settingsPage extra!");return}i=c[e],s=l[e],a=new i(u.getPageTarget()),f=new s(a,"SettingsPage"),t&&!n&&p.record(t)})}var a,f,l,c;l={},c={},l.SettingsAutoUpdate=e("controller/SettingsAutoUpdateController"),l.SettingsGiftCards=e("controller/SettingsGiftCardsController"),l.SettingsIAP=e("controller/SettingsIapController"),l.SettingsPersonalized=e("controller/SettingsPersonalizedController"),l.SettingsMarketLinks=e("controller/SettingsMarketLinksController"),l.SettingsNotifications=e("controller/SettingsNotificationsController"),l.SettingsParental=e("controller/SettingsParentalController"),l.SettingsVersion=e("controller/SettingsVersionController"),l.SettingsWiFi=e("controller/SettingsWiFiController"),c.SettingsAutoUpdate=e("views/SettingsAutoUpdateView"),c.SettingsGiftCards=e("views/SettingsGiftCardsView"),c.SettingsIAP=e("views/SettingsIapView"),c.SettingsPersonalized=e("views/SettingsPersonalizedView"),c.SettingsMarketLinks=e("views/SettingsMarketLinksView"),c.SettingsNotifications=e("views/SettingsNotificationsView"),c.SettingsParental=e("views/SettingsParentalView"),c.SettingsVersion=e("views/SettingsVersionView"),c.SettingsWiFi=e("views/SettingsWiFiView"),f=new i(u,"SettingsPage"),a=n.getExtras("settingsPage","refMarker","forwardRefMarker"),t.subscribe("com.amazon.venezia.android_lifecycle.onResume",h)}}),define("views/SettingsPageView",["require"],function(e){return function(t){this.getPageTarget=function(){return t.find("#stage")}}}),define("util/network",["require","jquery","widget/Dialog","api/navigation","api/device-features"],function(e){function u(e){s.add(e)}function a(e){s.remove(e)}function f(){return o}function l(e,t,u){var a,f,l;return typeof e=="function"&&(u=t,t=e,e=!1),l=i.isNetworkConnected(),l.done(t).fail(u),l.fail(function(){o=!1,window.appPreloadState.isAmazonDevice||(a=function(){var t={action:"android.settings.WIFI_SETTINGS"};e?r.finish():r.restart(),r.Android.startActivityForResult(t,{})},n.showNative({isNetworkDialog:!0,title:"AlertDialog_title_Offline",text:"AlertDialog_message_Offline",noButton:"AlertDialog_button_Offline_WirelessSettings",noButtonFn:a,yesButton:"AlertDialog_button_Offline_Cancel",yesButtonFn:r.finishToRootOrKickStart,noActionFn:r.restart}))}).done(function(){o=!0}).always(function(){s.fire(o)}),l}function c(){o=!0,s.fire(o)}var t=e("jquery"),n=e("widget/Dialog"),r=e("api/navigation"),i=e("api/device-features"),s=t.Callbacks("unique"),o=!0;return t.subscribe("com.amazon.venezia.network_event.onConnected",c),t.subscribe("com.amazon.venezia.network_event.onDisconnected",l),{listen:u,unlisten:a,isOnline:f,checkOffline:l}}),define("controller/SettingsVersionDialogController",["require","jquery","api/device","api/navigation","util/network","api/recorder"],function(e){var t=e("jquery"),n=e("api/device"),r=e("api/navigation"),i=e("util/network"),s=e("api/recorder"),o={checkUpdate:{init:"Appstore.Recorder.Metrics.Event.Settings.Version.CheckUpdate.Initiated",done:"Appstore.Recorder.Metrics.Event.Settings.Version.CheckUpdate.Completed",fail:"Appstore.Recorder.Metrics.Event.Settings.Version.CheckUpdate.Failure"},download:{selected:"Appstore.Metrics.Settings.Version.Download.Selected",cancel:"Appstore.Metrics.Settings.Version.Download.Cancel"}};return function(u){function a(e){e?(console.log("it is already downloaded"),r.finish(),r.showDialog("InstallUpdateDialog","InstallUpdateDialog")):(console.log("show the dialog to download the update"),u.showDownloadDialog(),u.hideLoading())}function f(e){console.log("failed to check if already downloaded, just download it again"),u.showDownloadDialog()}function l(e){s.Metrics.recordEvent(o.checkUpdate.done),e.updateExists?(console.log("check to see if it is already downloaded"),a(e.alreadyDownloaded)):(u.showNoUpdate(),console.log("no update"))}function c(e){s.Metrics.recordEvent(o.checkUpdate.fail),console.log("check for update failed"),i.checkOffline(!0,function(){u.showError()})}function h(){s.Metrics.recordEvent(o.download.selected),n.performUpdate(),u.hideDownloadDialog(),console.log("start downloading update"),u.showDownloadingDialog()}function p(){s.Metrics.recordEvent(o.download.cancel),u.hideDownloadDialog(),r.finish()}function d(){console.log("hideLoading"),u.hideLoading()}function v(){u.hideNoUpdate(),r.finish()}function m(){u.hideDownloadingDialog(),r.finish()}function g(){s.Metrics.recordEvent(o.checkUpdate.init),console.log("Starting check for update."),n.clearNotifiedAboutUpdate().done(function(){console.log("cleared last notify time, now checking"),n.checkForClientUpdate(l,c).always(d)})}t(u).on({ok:v,download:h,cancel:p,confirmDownloadStarted:m}),u.render(),g()}}),define("views/SettingsVersionDialogView",["require","jquery","appstore","views/DialogView"],function(t){var n=t("jquery"),r=t("appstore"),i=t("views/DialogView");return function(t){var r=this,s=n("#error-checking"),o=n("#no-update"),u=n("#loading-dialog"),a=n("#downloading-dialog"),f=n("#download-dialog");this.render=function(){s.on("tap",function(){n(r).trigger("cancel")}),o.on("tap",function(){n(r).trigger("ok")}),a.on("tap",".grey",function(){n(r).trigger("confirmDownloadStarted")}),f.on("tap",".orange",function(){n(r).trigger("download")}),f.on("tap",".grey",function(){n(r).trigger("cancel")}),i.handleCancel(r)},this.hideError=function(){s.hide()},this.hideLoading=function(){u.hide()},this.hideDownloadDialog=function(){f.hide()},this.hideDownloadingDialog=function(){a.hide()},this.hideNoUpdate=function(){o.hide()},this.showError=function(){s.show()},this.showLoading=function(){u.show()},this.showDownloadDialog=function(){f.show()},this.showDownloadingDialog=function(){a.show()},this.showNoUpdate=function(){o.show()}}}),define("controller/ShareDialogController",["require","jquery","appstore"],function(t){var n=t("jquery"),r=t("appstore"),i=r.Recorder.Java.getLogger("HTML5.ShareThisAppDialogController");return function(t){function h(e,t){return s="http://www.amazon.com/gp/product/"+e+t,r.Bridge.invoke(function(e){e.args.URI="http://api.bitly.com/v3/shorten?login=amazonservicessocialmedia&apiKey=R_e36e24cfbaa0152350c01e3d13e763e1&longUrl="+s+"&format=json",e.args.body={},e.args.retryCount=5,e.args.backoffRetry=5e3,e.args.timeout=2e3,e.args.httpMethodType="GET",console.log("ShareThisAppDialogController - about to invoke "+JSON.stringify(e)),window.WebInvokerBridge.webInvoke(JSON.stringify(e))},o),o}function p(e){return h(e,"/ref=cm_sw_r_sms_app_fad_m")}function d(e){return h(e,"/ref=cm_sw_em_r_app_fad_m")}function v(){return d(f).done(function(e){var n=JSON.parse(e.message),s=n.data.url,o;i=r.Resources.getString("share_message",[a,s]),o=r.Navigation.Android.getEmailIntentAndExtras(i),r.Navigation.Android.startActivity(o.intent,o.extras,i),t.dismissDialog()}).fail(function(e){console.log("ShareThisAppDialogController - call to shortenUrl failed with error = "+JSON.stringify(e)),t.dismissDialog()}),!1}function m(){return p(f).done(function(e){var n=JSON.parse(e.message),s=n.data.url,o;i=r.Resources.getString("share_message",[a,s]),o=r.Navigation.Android.getSmsIntentAndExtras(i),r.Navigation.Android.startActivity(o.intent,o.extras),t.dismissDialog()}).fail(function(e){console.log("ShareThisAppDialogController - call to shortenUrl failed with error = "+JSON.stringify(e)),t.dismissDialog()}),!1}var i,s,o=new n.Deferred,u=r.Navigation.getExtras(),a=u.applicationName,f=u.asin,l=u.emailAvailable,c=u.smsAvailable;t.render(),l?(t.getShareByEmail().show(),t.getShareByEmail().on("tap",v)):t.getShareByEmail().remove(),c?(t.getShareBySms().show(),t.getShareBySms().on("tap",m)):t.getShareBySms().remove(),n(t).on("cancel",t.dismissDialog)}}),define("views/ShareDialogView",["require","jquery","templates","appstore","views/DialogView"],function(t){var n=t("jquery"),r=t("templates"),i=t("appstore"),s=t("views/DialogView"),o=i.Recorder.Java.getLogger("HTML5.ShareThisAppDialogView");return function(t){var u,a=this;this.dismissDialog=function(){o.log("dimissDialog. Calling Navigation.finish"),i.Navigation.finish()},this.getShareByEmail=function(){return u.find('[data-class="share-by-email-option"]')},this.getShareBySms=function(){return u.find('[data-class="share-by-sms-option"]')},this.render=function(){t.empty(),u=n(r.ShareDialog.render()),t.append(u),s.handleCancel(a)}}}),define("controller/SignInController",["require","jquery","api/appstore","api/recorder","api/navigation","api/resources","api/testdrive","api/authentication"],function(e){var t=e("jquery"),n=e("api/appstore"),r=e("api/recorder"),i=e("api/navigation"),s=e("api/resources"),o=e("api/testdrive"),u=e("api/authentication"),a=r.Java.getLogger("HTML5.SignInController");return function(f){function v(e){i.showDialog("SignInDialogs",{message:e})}function m(){a.log("onRegisterSuccess"),r.Metrics.recordEvent("Recorder.Metrics.Event.Register.Completed"),f.showAuthenticatingTarget(!1),o.initializeTestDrive(),i.finish();var e={extras:{URL_TO_LOAD:i.GATEWAY_URL},className:"com.amazon.venezia.HtmlWebviewActivity"};window.appPreloadState.apiVersion>10?e.flags=268468224:e.flags=335544320,window.IntentBridge.startActivity(n.toUri(e))}function g(e){var t;a.log("onRegisterError; error.type = "+e.type+", error.reason = "+e.reason),f.showAuthenticatingTarget(!1),e.type===u.Error.INVALID_CREDENTIALS?t=s.getString("label_EnterValidCredentials"):e.type===u.Error.INVALID_COUNTRY||e.type===u.Error.UNSUPPORTED_LOCALE?t=s.getString("label_badCountry"):e.type===u.Error.MAX_REGISTERED_DEVICES?t=s.getString("AlertDialog_message_AuthFailureMaxDevices"):e.type===u.Error.IDENTITY_EXCEPTION?t=s.getString("label_noCountry_code"):(r.Metrics.recordEvent("Recorder.Metrics.Event.Register.Failure"),t=s.getString("label_TempSigninError")),v(t)}var l,c,h,p,d;u.isRegistered()?(a.log("User already registered. Exiting login page."),i.finish()):a.log("User not yet registered."),f.render(),r.Metrics.recordEvent("Recorder.Metrics.Event.Landing.CTCF"),l=function(e,t,n){if(!t){i.showToast(s.getString("auth_error_email"));return}if(!n){i.showToast(s.getString("auth_error_password"));return}r.Metrics.recordEvent("Recorder.Metrics.Event.Register.Initiated"),f.showAuthenticatingTarget(!0),a.log("calling Authentication.register"),u.register({uid:t,password:n},m,g)},c=function(){a.log("onforgotPassword"),i.showDialog("SignInLinksDialog",{type:"forgotPassword"})},h=function(){a.log("onCreateAccount"),i.showDialog("SignInLinksDialog",{type:"createAccount"})},p=function(){a.log("onShowTermsOfUse"),i.showDialog("SignInLinksDialog",{type:"terms"})},d=function(){a.log("onShowEnableOneClick"),i.showDialog("SignInLinksDialog",{type:"1-click"})},t(f).on({signIn:l,forgotPassword:c,createAccount:h,showTermsOfUse:p,showEnableOneClick:d})}}),define("views/SignInView",["require","jquery","templates","appstore"],function(t){var n=t("jquery"),r=t("templates"),i=t("appstore"),s=i.Recorder.Java.getLogger("HTML5.SignInView");return function(t){var r,i,s,o,u,a,f,l,c,h=this;r=function(){return a.blur(),f.blur(),n(h).trigger("signIn",[n("#email-address").val(),n("#password").val()]),!1},i=function(){return n(h).trigger("forgotPassword"),!1},s=function(){return n(h).trigger("createAccount"),!1},l=function(){return n(h).trigger("showTermsOfUse"),!1},c=function(){return n(h).trigger("showEnableOneClick"),!1},this.render=function(){u=n("#sign-in"),o=n("#authenticating-div"),a=n("#email-address"),f=n("#password"),o.hide(),u.on("tap",r),n(":input").keyup(function(e){if(e.keyCode===13)return r(),!1}),n("#forgot-password").on("tap",i),n("#create-account").on("tap",s),n('[data-class="show-terms-of-use"]').on("tap",l),n('[data-class="show-enable-one-click"]').on("tap",c),n("#login-action-form").submit(r)},this.showAuthenticatingTarget=function(e){e?(o.show(),u.hide(),a.prop("disabled",!0),f.prop("disabled",!0)):(o.hide(),u.show(),a.prop("disabled",!1),f.prop("disabled",!1))}}}),define("controller/SignInDialogsController",["require","appstore"],function(e){var t=e("appstore"),n=t.Recorder.Java.getLogger("HTML5.SignInDialogsController");return function(r){var i=t.Navigation.getExtras();n.log("in SignInDialogsController: "+i.message),r.render({message:i.message})}}),define("views/SignInDialogsView",["require","templates","appstore"],function(t){var n=t("templates"),r=t("appstore"),i=r.Recorder.Java.getLogger("HTML5.SignInDialogView");return function(t){function s(e){return i.log("closeDialog"),r.Navigation.finish(),!1}this.render=function(e){t.empty(),t.html(n.SignInDialogs.render(e)),t.find("#signon-failed-ok").on("tap",s)}}}),define("controller/StandaloneDialogController",["require","jquery","api/navigation","widget/Dialog","api/locker","models/AppBlockModel","api/install","api/entitlements","api/recorder","api/resources"],function(e){var t=e("jquery"),n=e("api/navigation"),r=e("widget/Dialog"),i=e("api/locker"),s=e("models/AppBlockModel"),o=e("api/install"),u=e("api/entitlements"),a=e("api/recorder"),f=e("api/resources"),l=a.Java.getLogger("HTML5.StandaloneDialogController");return function(t){n.getExtras("dialogType","asin").done(function(e,t){function a(e,t){return function(){e.getAppByAsin(t,function(e){var t=new s(e[0]);l.log("AppDelete-UI-deleteApp: fetched app from locker, app = "+JSON.stringify(t)),u.archiveApp(t),n.finish()},function(e){l.severe("AppDelete-UI-deleteApp: Error could not find asin "+t+" in locker. Error = "+JSON.stringify(e)),n.finish()})}}function c(){return function(){var t={action:"android.settings.WIFI_SETTINGS"};n.Android.startActivity(t,{}),n.finish()}}function h(e,t){return function(){e.getAppByAsin(t,function(e){var r=new s(e[0]),i={action:"com.amazon.mas.client.pdiservice.PdiService.installAsin",className:"com.amazon.mas.client.pdiservice.PdiService",extras:{"com.amazon.mas.client.purchaseservice.PurchaseRequest.asin":t}},o={action:"com.amazon.mas.client.install.ENQUEUE",className:"com.amazon.mas.client.install.service.InstallService",extras:{"com.amazon.mas.client.install.uninstall_package_name":r.packageName}};window.IntentBridge&&(console.log("About to uninstall and then install :: "+r.packageName),window.IntentBridge.startService(JSON.stringify(o)),window.IntentBridge.startService(JSON.stringify(i))),n.finish()},function(e){l.severe("StandaloneDialogController: Error could not find asin "+t+" in locker. Error = "+JSON.stringify(e)),n.finish()})}}var o={};console.log("StandaloneDialogController: about to show standalone dialogType="+e);if(e==="DeleteFromCloudDialogType")t||l.severe("AppDelete-UI-DeleteFromCloudDialogType: Error valid asin required"),l.log("AppDelete-UI-DeleteFromCloudDialogType: Displaying dialog for asin = "+t),o.title="AlertDialog_title_DeleteFromCloud",o.text="AlertDialog_message_DeleteFromCloud",o.noButton="CopyAlertDialog_button_Cancel",o.noButtonFn=n.finish,o.yesButton="AlertDialog_button_DeleteFromCloud",o.yesButtonFn=a(i.Instance,t),o.noActionFn=n.finish;else if(e==="WanDownloadLimitDialogType")console.log("Displayng dialog for WanDownloadLimitDialogType"),o.title="AlertDialog_title_MobileNetworkData",o.text="AlertDialog_message_MobileNetworkData",o.noButton="CopyAlertDialog_button_Cancel",o.noButtonFn=n.finish,o.yesButton="AlertDialog_button_Offline_WirelessSettings",o.yesButtonFn=c(),o.noActionFn=n.finish;else{if(e!=="UpdateFailedDiffSignatureDialogType"){console.log("StandaloneDialogController: Error, unknown dialogType="+e);return}console.log("Displayng dialog for UpdateFailedDiffSignatureDialogType"),o.title="replace_amazon_app_title",o.text="replace_amazon_app_message",o.translatedText=f.getString("replace_amazon_app_message",["This app"]),o.noButton="replace_amazon_app_cancel_text",o.yesButton="replace_amazon_app_ok_text",o.yesButtonFn=h(i.Instance,t),o.noButtonFn=n.finish,o.noActionFn=n.finish}r.showNative(o)})}}),define("views/StandaloneDialogView",["jquery","templates"],function(e,t){return function(){}}),define("controller/GenericController",[],function(){return function(t){t.render(),this.update=function(e){t.render(e)}}}),define("controller/SubscriptionInfoController",["require","jquery","appstore","controller/SoftKeysController","models/SubscriptionModel"],function(t){var n=t("jquery"),r=t("appstore"),i=t("controller/SoftKeysController"),s=t("models/SubscriptionModel");return function(t){var o,u,a,f,l,c=this;u=function(e){if(e.value){var t={asin:r.Navigation.getExtras().asin,version:r.Navigation.getExtras().version};r.Subscriptions.getSubscriptionDetails(t,function(e){var t=new s(e);c.update(t)})}},a=function(e,t){console.log("extras coming from view are: "+JSON.stringify(t)),r.Navigation.showDialog("SubscriptionAutoRenewal",t,u)},f=function(e,t){console.log("extras coming from view are: "+JSON.stringify(t)),r.Navigation.showDialog("ChangeSubscriptionPeriod",t,u)},l=function(e,t){console.log("extras coming from view are: "+JSON.stringify(t)),r.Navigation.showDialog("SubscriptionPrivacyPreferences",{subscription:t},u)},t.render(),o=new i(t),this.update=function(e){t.render(e)},n(t).on({autoRenewal:a,subscriptionPeriod:f,privacyPreferences:l})}}),define("views/SubscriptionInfoView",["jquery","templates"],function(e,t){return function(r){var i,s,o=this;s=function(t,n,r){e(t).on("tap",function(){return e(o).trigger(n,r),!1})},this.render=function(n){if(!n)return;r.empty(),i=e(t.SubscriptionInfo.render(n)),r.append(i),s("#auto-renewal","autoRenewal",n),s("#subscription-period","subscriptionPeriod",n),s("#privacy-preferences","privacyPreferences",n)}}}),define("controller/SubscriptionDetailController",["jquery","appstore","controller/GenericController","controller/SubscriptionInfoController","views/AppBlockView","views/SubscriptionInfoView","models/SubscriptionModel"],function(e,t,n,r,i,s,o){return function(a){var f,l,c,h,p,d,v;l=function(t){var n=new o(t);p.update(t.details),v.update(n)},a.render(),f={asin:t.Navigation.getExtras().asin,version:t.Navigation.getExtras().version},c=t.Subscriptions.getSubscriptionDetails(f,e.proxy(l,this)),h=new i(a.getHeaderTarget()),p=new n(h),d=new s(a.getSubscriptionInfoTarget()),v=new r(d)}}),define("views/SubscriptionDetailView",["jquery","templates"],function(e,t){return function(t){this.render=function(){},this.getHeaderTarget=function(){return t.find('[data-class="subscription-app-header"]')},this.getSubscriptionInfoTarget=function(){return t.find('[data-class="subscription-info"]')}}}),define("controller/SubscriptionAutoRenewalController",["require","jquery","appstore","controller/DialogController"],function(e){var t=e("jquery"),n=e("appstore"),r=e("controller/DialogController");return function(t){console.log(JSON.stringify(n.Navigation.getExtras()));var i=n.Navigation.getExtras(),s=function(){console.log("successfully set autorenew settings."),n.Navigation.setResult({value:!0})},o=function(){console.log("did not set autorenew settings."),n.Navigation.setResult({value:!1})},u={yesFn:function(e){return n.Subscriptions.setAutoRenewal({asin:i.asin,version:i.version},!i.autorenew,s)},noFn:o,dismissFn:n.Navigation.finish},a=t.getDialogView(),f=new r(a,u);console.log("About to render SubsAutorenewalContoller... with "+JSON.stringify(i)),f.render(i)}}),define("views/SubscriptionAutoRenewalView",["jquery","templates","views/DialogView"],function(e,t,n){return function(r){this.dialogView=new n({renderTarget:r,template:t.SubscriptionAutoRenewal}),this.render=function(e){console.log("Rendering SubscriptionAutoRenewView..."),this.dialogView.render(e)},this.getDialogView=function(){return this.dialogView}}}),define("controller/SubscriptionsController",["require","jquery","api/navigation","api/subscriptions","api/recorder","controller/SoftKeysController","handler/ClickStreamHandler","controller/PagerController","models/SubscriptionModel"],function(e){var t=e("jquery"),n=e("api/navigation"),r=e("api/subscriptions"),i=e("api/recorder"),s=e("controller/SoftKeysController"),o=e("handler/ClickStreamHandler"),u=e("controller/PagerController"),a=e("models/SubscriptionModel"),f=i.Java.getLogger("HTML5.SubscriptionsController"),l=function(){return{subscriptionSelected:function(e,t){n.navigate("SubscriptionDetail",t.getAsinWithVersion())}}},c={Render:function(){return{renderFn:function(e){return t("<li class='action-panel-list-item' version='"+e.version+"' id='"+e.asin+"'><h2 class='action-panel-list-item-heading'>"+e.title+"</h2><h3 class='action-panel-list-item-subheading'>"+e.developer+"</h3>")},eventFn:function(e,t,n){e.unbind("tap"),e.on("tap","li",function(){var e=this.id;return t.trigger("subscriptionSelected",n(e)),!1})},mapKey:"asin"}},Handlers:[new l],pagerKey:"subscriptionItems",Model:a};return function(i){var a,f,l,h,p;f=new s(i,"Subscriptions"),p=i.getSubscriptionsListTarget(),i.showLoadingScreen(),p.on("page.empty",i.showNoSubsMessage),t.subscribe("Appstore.Subscriptions.getSubscriptions",function(){i.render()}),t.subscribe("com.amazon.venezia.android_lifecycle.onResume",function(){i.showLoadingScreen(),a=r.getSubscriptions(),h=t.extend({pager:a},c),l=new u(p,h)}),n.getExtras("refMarker","page").done(function(e,t){var n=new o(t);e&&n.record(e)})}}),define("views/SubscriptionsView",["jquery","templates"],function(e,t){return function(n){this.render=function(){e('[data-class="subscriptions-no-results-content-block"]').hide(),e('[data-class="subscriptions-list"]').show(),e('[data-class="subscriptions-loading"]').hide()},this.getSubscriptionsListTarget=function(){return n.find('[data-class="subscriptions-list"]')},this.showNoSubsMessage=function(){e('[data-class="subscriptions-no-results-content-block"]').show(),e('[data-class="subscriptions-list"]').hide(),e('[data-class="subscriptions-loading"]').hide()},this.showLoadingScreen=function(){e('[data-class="subscriptions-no-results-content-block"]').hide(),e('[data-class="subscriptions-list"]').hide(),e('[data-class="subscriptions-loading"]').show()}}}),define("controller/SignInLinksDialogController",["require","jquery","appstore"],function(e){function s(e,t){return r.log("onCountrySelected: "+t),t&&n.Navigation.openInBrowser(n.Resources.getString("legal_use_terms_"+t+"_url")),n.Navigation.finish(),!1}function o(e,t){var i=n.Resources.getString("enable_one_click_"+t+"_url");return i?n.Navigation.openInBrowser(i):r.log("1-click URL is empty for country "+t+": "+i),n.Navigation.finish(),!1}function u(e,t){return r.log("onAccountCreationCountrySelected, country: -"+t+"-"),t?n.Navigation.startAccountManagementExperience(t):r.log("Country undefined in account creation"),n.Navigation.finish(),!1}function a(e,t){var i=n.Resources.getString("forgot_password_"+t+"_url");return r.log("onForgotPasswordCountrySelected, country: -"+t+"-"),i?n.Navigation.openInBrowser(i):r.log("'Forgot password' URL undefined"),n.Navigation.finish(),!1}function f(e){var t=n.Resources.getString("faq_which_store_to_use_url");t?n.Navigation.openInBrowser(t):r.log("Which store to use URL is empty"),n.Navigation.finish()}var t=e("jquery"),n=e("appstore"),r=n.Recorder.Java.getLogger("HTML5.SignInLinksDialogController"),i;return i=function(r){var i=n.Navigation.getExtras(),l={},c=s;i||(i={}),i.type==="1-click"?(l.headerTitle=n.Resources.getString("text_1Click_DialogTitle"),c=o):i.type==="createAccount"?(l.headerTitle=n.Resources.getString("text_CreateAccount_DialogTitle"),c=u):i.type==="forgotPassword"?(l.headerTitle=n.Resources.getString("text_ForgotPassword_DialogTitle"),c=a):(l.headerTitle=n.Resources.getString("text_TermsOfUse_DialogTitle_SelectYourStore"),l.subHeaderTitle=n.Resources.getString("text_TermsOfUse_WhichStore"),c=s),r.render(l),t(r).on("onCountrySelected",c),t(r).on("onFAQClicked",f),t(r).on("cancel",n.Navigation.finish)},i}),define("views/SignInLinksDialogView",["require","jquery","templates","views/DialogView"],function(t){var n=t("jquery"),r=t("templates"),i=t("views/DialogView");return function(t){function u(e){return n(o).trigger("onFAQClicked"),!1}function a(e){return n(o).trigger("onCountrySelected",[e.data.country]),!1}var s,o=this;this.render=function(e){t.empty(),s=n(r.SignInLinksDialog.render(e)),t.append(s),s.find("#country-us").on("tap",{country:"us"},a),s.find("#country-ca").on("tap",{country:"ca"},a),s.find("#country-uk").on("tap",{country:"uk"},a),s.find("#country-fr").on("tap",{country:"fr"},a),s.find("#country-de").on("tap",{country:"de"},a),s.find("#country-it").on("tap",{country:"it"},a),s.find("#country-es").on("tap",{country:"es"},a),s.find("#country-jp").on("tap",{country:"jp"},a),s.find("#country-cn").on("tap",{country:"cn"},a),s.find("#dialog-box-sub-heading").on("tap",u),i.handleCancel(o)}}}),define("controller/UriPageController",["require","controller/SoftKeysController"],function(t){var n=t("controller/SoftKeysController");return function(t){var r=new n(t)}}),define("views/UriPageView",["require"],function(t){return function(){}}),define("controller/TestDriveHeaderController",["require","jquery","handler/OneClickButtonHandler","api/navigation","api/purchase","appstore","models/AppBlockModel","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("handler/OneClickButtonHandler"),i=t("api/navigation"),s=t("api/purchase"),o=t("appstore"),u=t("models/AppBlockModel"),a=t("zeroes/ZeroesLoader");return function(t){function f(){o.TestDrive.exitTestDrive()}function l(e){var n,r;e.lights>=4?n=s[4]:e.lights<=0?n=s[0]:n=s[e.lights],r=t.getLatencyLights(),r&&r.attr("src",n)}function c(e){var n=t.getTimeText();n&&n.text(e.time)}function h(e){var t={dialogType:e.dialogType,AppName:e.AppName},n=e.dialogType;o.Navigation.showDialog("MSTDialogs",t,function(e){(n===o.TestDrive.DialogTypes.ERROR_DIALOG_IN_SESSION||n===o.TestDrive.DialogTypes.INTERRUPTED_DIALOG||n===o.TestDrive.DialogTypes.BAD_CONNECTION_DIALOG)&&f()})}function p(e){f()}function d(){console.log("TestDriveHeader	 initCallbacks"),n.subscribe(o.TestDrive.SubscribeTopics.PUBLISH_JS_LATENCY,l),n.subscribe(o.TestDrive.SubscribeTopics.PUBLISH_JS_TIMER,c),n.subscribe(o.TestDrive.SubscribeTopics.PUBLISH_JS_DIALOG,h),n.subscribe("com.amazon.mas.client.MACS_PDI_CHANGE",n.proxy(p))}function v(e){var r=n.extend({latencySquig:o.Resources.getAssetUrl("icon_chrome_latency_portrait"),timeClock:o.Resources.getAssetUrl("icon_chrome_clock_portrait"),latencyIcon:s[0],asin:o.Navigation.getExtras().asin},e);e&&(r=new u(r)),t.render(r)}function m(){var e;d(),e=o.Navigation.getExtras().asin,o.Catalog.getAppDetailsByAsin(e,v,v)}function g(){o.TestDrive.isFirstRunExperience(function(e){e.isFirstRun===!0&&o.Navigation.showDialog("MSTDialogs",{dialogType:o.TestDrive.DialogTypes.FRE_DIALOG},function(){o.TestDrive.saveFirstRunFlag()})})}function y(){var e=o.DeviceFeatures.isNetworkConnected();e.fail(function(){f()})}var i,s;s=[o.Resources.getAssetUrl("icon_latency_indicator_0_gray_portrait"),o.Resources.getAssetUrl("icon_latency_indicator_1_red_portrait"),o.Resources.getAssetUrl("icon_latency_indicator_2_red_portrait"),o.Resources.getAssetUrl("icon_latency_indicator_3_yellow_portrait"),o.Resources.getAssetUrl("icon_latency_indicator_4_green_portrait")],console.log("TestDriveHeaderController"),a.disable(),v(null),m(),g(),n.subscribe("com.amazon.venezia.network_event.onDisconnected",y),i=new r(!1),n(t).on("quitSelected",f),n(t).on("primarySelected",i.primarySelected),n(t).on("secondarySelected",i.secondarySelected)}}),define("render/TestDriveHeaderRender",["require","jquery","render/ImageStyler","templates","api/currency"],function(e){var t=e("jquery"),n=e("render/ImageStyler"),r=e("templates"),i=e("api/currency"),s=new i;return function(n,r){var i;i=function(e,t,n){return function(r){return e.trigger(n,{app:t(),target:r.target}),!1}},this.eventFn=function(e,t,n){e.unbind("tap"),e.on("tap","button.grey",i(t,n,"quitSelected")),e.on("tap",'[data-class="oneclick-orange"]',i(t,n,"primarySelected")),e.on("tap",'[data-class="oneclick-green"]',i(t,n,"secondarySelected"))},this.formatData=function(e){var n,r={};return r=t.extend(r,e),(r.currentPrice>=r.listPrice||r.local&&r.local.isPurchased)&&delete r.listPrice,r.listPrice!==undefined&&(r.listPrice=s.format(r.listPrice,r.listPriceCurrencyCode,!1)),r.ourPrice=s.format(r.currentPrice,r.currentPriceCode,!0),r},this.mapKey="asin"}}),define("views/TestDriveHeaderView",["jquery","render/TestDriveHeaderRender","templates"],function(e,t,n){return function(i){var s,o,u=new t;this.render=function(r){i.empty(),i.append(n.TestDriveHeader.render(u.formatData(r))),u.eventFn(i,e(this),function(){return r}),s=i.find("#tdLatency"),o=i.find("#tdTime")},this.getLatencyLights=function(){return s},this.getTimeText=function(){return o}}}),define("controller/TopFreeGamesController",["require","jquery","api/catalog","api/search","controller/AppListController","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("api/catalog"),i=t("api/search"),s=t("controller/AppListController"),o=t("zeroes/ZeroesLoader"),u="b_games";return function(t){function n(e){var n,i;n=r.getRankedApps(r.RANK_TYPE_TOP_FREE,e).pipe(function(t){return t.results}),i=new s(t,n,"rankedAsins"),n.done(function(){o.initializeAsync(o.STORE_CONFIG_TYPES.Generic)})}i.getGamesCategoryForCurrentMarketplace(function(t){n(t)},function(){n(u)})}}),define("views/TopFreeGamesView",["views/AppListView"],function(e){return function(n){return new e(n)}}),define("controller/TopPaidGamesController",["require","jquery","api/catalog","api/search","controller/AppListController","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("api/catalog"),i=t("api/search"),s=t("controller/AppListController"),o=t("zeroes/ZeroesLoader"),u="b_games";return function(t){function n(e){var n,i;n=r.getRankedApps(r.RANK_TYPE_TOP_SELLERS,e).pipe(function(t){return t.results}),i=new s(t,n,"rankedAsins"),n.done(function(){o.initializeAsync(o.STORE_CONFIG_TYPES.Generic)})}i.getGamesCategoryForCurrentMarketplace(function(t){n(t)},function(){n(u)})}}),define("views/TopPaidGamesView",["views/AppListView"],function(e){return function(n){return new e(n)}}),define("controller/NewReleasesInGamesController",["require","jquery","api/catalog","api/search","controller/AppListController","zeroes/ZeroesLoader"],function(t){var n=t("jquery"),r=t("api/catalog"),i=t("api/search"),s=t("controller/AppListController"),o=t("zeroes/ZeroesLoader"),u="b_games";return function(t){function n(e){var n,i;n=r.getRankedApps(r.RANK_TYPE_NEW_RELEASES,e).pipe(function(t){return t.results}),i=new s(t,n,"rankedAsins"),n.done(function(){o.initializeAsync(o.STORE_CONFIG_TYPES.Generic)})}i.getGamesCategoryForCurrentMarketplace(function(t){n(t)},function(){n(u)})}}),define("views/NewReleasesInGamesView",["views/AppListView"],function(e){return function(n){return new e(n)}}),define("zeroes/config/iap",["require"],function(t){return{events:{PageReady:"Appstore.Loaded",PageResumed:"com.amazon.venezia.android_lifecycle.onResume",PurchaseChoiceInjectorReady:"Zeroes.purchaseChoiceInjectorAvailable",InjectZeroesElements:"Zeroes.injectZeroesElements",ExternalPurchaseTrigger:"Zeroes.triggerPurchase",ExternalPurchaseCancel:"Zeroes.cancelPurchase",AsinDetailsLoaded:"IAP.onDataLoad",PurchaseMade:"IAP.onPurchaseMade",ForceEarnBannerUpdate:"Zeroes.updateEarnBanner"},widgets:["BuyZeroesDialog","SemaphoreMask",{type:"ChooseZeroesInjector",context:{selector:"[data-zeroes-app-info]"}}]}}),define("zeroes/config/appstore",["require"],function(t){return{events:{PageReady:"Appstore.Loaded",PageResumed:"com.amazon.venezia.android_lifecycle.onResume"},widgets:["BuyZeroesDialog","SemaphoreMask","Tab","WelcomeOverlay"]}}),define("zeroes/config/appstore-detail",["require"],function(t){return{events:{PageReady:"Appstore.Loaded",PageResumed:"com.amazon.venezia.android_lifecycle.onResume",ShowPurchaseDialog:"Zeroes.showPurchaseChoiceDialog",ExternalPurchaseTrigger:"Zeroes.triggerPurchase",AsinDetailsLoaded:"Appstore.onDataLoad",PurchaseWorkflowEvent:"com.amazon.workflow.persistent.WORKFLOW"},widgets:["BuyZeroesDialog","ChooseZeroesPurchaseDialog","SemaphoreMask","Tab","WelcomeOverlay",{type:"EarnBanner",context:{containerSelector:"#stage"}}]}})